"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Spacing = exports.Custom = exports.Disabled = exports.WithTooltip = exports.Sizes = exports.Variants = exports.BasicUsage = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var Flex_1 = __importDefault(require("@impargo/components/Flex"));
var Sheet_1 = __importDefault(require("@impargo/components/Sheet"));
var impargo_1 = __importDefault(require("../Themes/impargo"));
var storybook_1 = require("../utils/storybook");
var _1 = __importDefault(require("."));
var theme = impargo_1.default;
var faPen = free_solid_svg_icons_1.faPen;
exports.default = {
    title: 'Components/General/ActionButton',
    component: _1.default,
    argTypes: {
        color: { control: 'color' },
        bgColor: { control: 'color' },
        variant: { control: { type: 'select' } },
        place: { control: { type: 'select' } },
        size: { control: { type: 'select' } },
        type: { control: { type: 'select' } },
        onClick: { control: false },
        mt: { control: false },
        mr: { control: false },
        mb: { control: false },
        ml: { control: false },
    },
    args: {
        // Now all Button stories will be primary.
        variant: 'primary',
    },
};
var BasicUsage = function (args) { return ((0, jsx_runtime_1.jsx)(_1.default, __assign({}, args, { children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faPen }) }))); };
exports.BasicUsage = BasicUsage;
exports.BasicUsage.args = {
    variant: 'primary',
};
var Variants = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(_1.default, { variant: 'primary', onClick: function () { return null; }, children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faPen }) }), (0, jsx_runtime_1.jsx)(_1.default, { variant: 'secondary', onClick: function () { return null; }, children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faPen }) }), (0, jsx_runtime_1.jsx)(_1.default, { variant: 'success', onClick: function () { return null; }, children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faPen }) }), (0, jsx_runtime_1.jsx)(_1.default, { variant: 'warning', onClick: function () { return null; }, children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faPen }) }), (0, jsx_runtime_1.jsx)(_1.default, { variant: 'danger', onClick: function () { return null; }, children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faPen }) }), (0, jsx_runtime_1.jsx)(Sheet_1.default, { variant: 'small', bgColor: theme.colorSurfaceInverse, children: (0, jsx_runtime_1.jsx)(_1.default, { variant: 'inverse', onClick: function () { return null; }, children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faPen }) }) })] })); };
exports.Variants = Variants;
(0, storybook_1.addDescription)(exports.Variants, "Variant defines the color of the `ActionButton`. Default value: `primary`. ");
var Sizes = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(_1.default, { onClick: function () { return null; }, children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faPen }) }), (0, jsx_runtime_1.jsx)(_1.default, { size: 'l', onClick: function () { return null; }, children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faPen }) }), (0, jsx_runtime_1.jsx)(_1.default, { size: 'm', onClick: function () { return null; }, children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faPen }) })] })); };
exports.Sizes = Sizes;
(0, storybook_1.addDescription)(exports.Sizes, "Determines the size of the `ActionButton`, does not change the size of the icon. Default value: `l`.");
var WithTooltip = function () { return ((0, jsx_runtime_1.jsxs)(Flex_1.default, { width: '100%', height: '80px', justify: 'center', alignItems: 'center', children: [(0, jsx_runtime_1.jsx)(_1.default, { onClick: function () { return null; }, "data-tooltip-content": 'Edit this from default place', children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faPen }) }), (0, jsx_runtime_1.jsx)(_1.default, { onClick: function () { return null; }, "data-tooltip-content": 'Edit this from the top', "data-tooltip-place": 'top', children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faPen }) }), (0, jsx_runtime_1.jsx)(_1.default, { onClick: function () { return null; }, "data-tooltip-content": 'Edit this from the right', "data-tooltip-place": 'right', children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faPen }) }), (0, jsx_runtime_1.jsx)(_1.default, { onClick: function () { return null; }, "data-tooltip-content": 'Edit this from the bottom', "data-tooltip-place": 'bottom', children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faPen }) }), (0, jsx_runtime_1.jsx)(_1.default, { onClick: function () { return null; }, "data-tooltip-content": 'Edit this from the left', "data-tooltip-place": 'left', children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faPen }) })] })); };
exports.WithTooltip = WithTooltip;
(0, storybook_1.addDescription)(exports.WithTooltip, "\nA tooltip some times is needed to give more context to the action.\nAdditional `place` pro can be passed to specify the intended position of the tooltip, `place` default value: `bottom`.\n");
var Disabled = function () { return ((0, jsx_runtime_1.jsx)(_1.default, { onClick: function () { return null; }, "data-tooltip-content": 'Accept invitation to be able to edit this', disabled: true, children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faPen }) })); };
exports.Disabled = Disabled;
(0, storybook_1.addDescription)(exports.Disabled, "\nA disabled `ActionButton` should contain a tooltip to specify wht the button is disabled.\n");
var Custom = function () { return ((0, jsx_runtime_1.jsx)(_1.default, { onClick: function () { return null; }, bgColor: theme.colorAccentLight3, children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faPen }) })); };
exports.Custom = Custom;
(0, storybook_1.addDescription)(exports.Custom, "\nSome use cases require a custom `ActionButton`, although this is not recommended, a `bgColor` and `color` props are provided to customize the component.\nIf this use case is repeated in multiple places and across projects, a new `variant` can be added to cover these commonly used custom component.\n");
var Spacing = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(_1.default, { onClick: function () { return null; }, children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faPen }) }), (0, jsx_runtime_1.jsx)(_1.default, { onClick: function () { return null; }, ml: theme.spacingMedium, children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faPen }) })] })); };
exports.Spacing = Spacing;
(0, storybook_1.addDescription)(exports.Spacing, "Margin props are provided to add spacing around `ActionButton`s.");
