"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActionButton = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var styles_1 = require("./styles");
/**
  `ActionButton` communicate actions that users can take. They are typically placed throughout your UI, together with other `ActionButton` or alone.
  `ActionButton`s are similar to buttons, but their behavior and styling varies slightly.

  ### Import

  ```
  import ActionButton from '@impargo/components/ActionButton'
  ```
 */
var ActionButton = function (_a) {
    var className = _a.className, onClick = _a.onClick, _b = _a.disabled, disabled = _b === void 0 ? false : _b, children = _a.children, _c = _a.variant, variant = _c === void 0 ? 'primary' : _c, _d = _a.type, type = _d === void 0 ? 'button' : _d, _e = _a.size, size = _e === void 0 ? 'l' : _e, bgColor = _a.bgColor, color = _a.color, mt = _a.mt, mr = _a.mr, mb = _a.mb, ml = _a.ml, small = _a.small, dataTestid = _a["data-testid"], rest = __rest(_a, ["className", "onClick", "disabled", "children", "variant", "type", "size", "bgColor", "color", "mt", "mr", "mb", "ml", "small", 'data-testid']);
    var isCustom = color || bgColor;
    return ((0, jsx_runtime_1.jsx)("div", __assign({ className: className }, rest, { css: (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n          display: inline-block;\n          width: min-content;\n          height: min-content;\n          line-height: 0px;\n\n        /* Button styles */\n\n          margin-top: ", ";\n          margin-right: ", ";\n          margin-bottom: ", ";\n          margin-left: ", ";\n      "], ["\n          display: inline-block;\n          width: min-content;\n          height: min-content;\n          line-height: 0px;\n\n        /* Button styles */\n\n          margin-top: ", ";\n          margin-right: ", ";\n          margin-bottom: ", ";\n          margin-left: ", ";\n      "])), mt && mt, mr && mr, mb && mb, ml && ml), children: (0, jsx_runtime_1.jsx)("button", { disabled: disabled, onClick: onClick, type: type, className: "action-button action-button--".concat(isCustom ? 'custom' : variant, " action-button--").concat(size), "data-testid": dataTestid, css: function (theme) { return (0, styles_1.styles)(theme, !!small, color, bgColor); }, children: (0, jsx_runtime_1.jsx)("span", { className: 'action-button__content', css: (0, react_1.css)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n            position: relative;\n            display: flex;\n            justify-content: center;\n            align-items: center;\n            height: 100%;\n            width: 100%;\n            color: inherit;\n          "], ["\n            position: relative;\n            display: flex;\n            justify-content: center;\n            align-items: center;\n            height: 100%;\n            width: 100%;\n            color: inherit;\n          "]))), children: children }) }) })));
};
exports.ActionButton = ActionButton;
exports.default = exports.ActionButton;
var templateObject_1, templateObject_2;
