"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RichText = exports.OnClick = exports.CallToActions = exports.WithTitle = exports.WithIcon = exports.Variants = exports.BasicUsage = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var ActionButton_1 = __importDefault(require("@impargo/components/ActionButton"));
var Button_1 = __importDefault(require("@impargo/components/Button"));
var Icon_1 = __importDefault(require("@impargo/components/Icon"));
var Text_1 = __importDefault(require("@impargo/components/Text"));
var impargo_1 = __importDefault(require("../Themes/impargo"));
var storybook_1 = require("../utils/storybook");
var _1 = __importDefault(require("."));
var theme = impargo_1.default;
var faInfoCircle = free_solid_svg_icons_1.faInfoCircle;
var faCheck = free_solid_svg_icons_1.faCheck;
var faSearch = free_solid_svg_icons_1.faSearch;
var faBirthdayCake = free_solid_svg_icons_1.faBirthdayCake;
var faTimes = free_solid_svg_icons_1.faTimes;
var faExclamation = free_solid_svg_icons_1.faExclamation;
exports.default = {
    title: 'Components/Feedback/Alert',
    component: _1.default,
    argTypes: {
        variant: { control: { type: 'select' } },
        onClick: { control: false },
        icon: { control: false },
        callToAction: { control: false },
        slotRight: { control: false },
        theme: { table: { disable: true } },
    },
    args: {
        variant: 'primary',
    },
    parameters: {
        layout: 'padded',
    },
};
var BasicUsage = function (args) { return ((0, jsx_runtime_1.jsx)(_1.default, __assign({}, args))); };
exports.BasicUsage = BasicUsage;
exports.BasicUsage.args = {
    variant: 'primary',
    text: 'You successfully achieved time travel!',
};
var Variants = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(_1.default, { variant: 'primary', text: 'You are now part of the Galactic Federation!' }), (0, jsx_runtime_1.jsx)(_1.default, { variant: 'info', text: 'Hey look at me', mt: theme.spacingMedium }), (0, jsx_runtime_1.jsx)(_1.default, { variant: 'success', text: 'You have enter hyperspace successfully', mt: theme.spacingMedium }), (0, jsx_runtime_1.jsx)(_1.default, { variant: 'warning', text: 'Your hyperdrive is overcharging', mt: theme.spacingMedium }), (0, jsx_runtime_1.jsx)(_1.default, { variant: 'danger', text: 'Some one has denied your requests', mt: theme.spacingMedium })] })); };
exports.Variants = Variants;
(0, storybook_1.addDescription)(exports.Variants, "Variant defines the color and use case of the `Alert`. Default value: `primary`.");
var WithIcon = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(_1.default, { variant: 'primary', text: 'You are now part of the Galactic Federation!', icon: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faBirthdayCake }), color: theme.colorPrimaryDark }) }), (0, jsx_runtime_1.jsx)(_1.default, { variant: 'info', text: 'You can now do a more accurate search in the galaxy', mt: theme.spacingMedium, icon: (0, jsx_runtime_1.jsx)(Icon_1.default, { color: theme.colorTextLink, icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }) }) })] })); };
exports.WithIcon = WithIcon;
(0, storybook_1.addDescription)(exports.WithIcon, "An icon can be added to emphasize a message giving extra context. Icons are passed with the `FontAwesomeIcon` component. A color prop is needed to set the correct color to the `FontAwesomeIcon` component.");
var WithTitle = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(_1.default, { variant: 'primary', title: 'Permission granted', alignIcon: 'start', text: 'You are now part of the Galactic Federation!', icon: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faBirthdayCake }), color: theme.colorPrimaryDark }), slotRight: (0, jsx_runtime_1.jsx)(Button_1.default, { children: "See party coordinates" }) }), (0, jsx_runtime_1.jsx)(_1.default, { mt: theme.spacingMedium, alignIcon: 'start', variant: 'danger', title: 'Permission denied', text: 'Reason: you have not registered for inspection at the central inspection office. This means your application will be delayed until you complete the inspection in the next appointment.', icon: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faExclamation }), variant: 'danger' }), slotRight: (0, jsx_runtime_1.jsx)(Button_1.default, { variant: 'danger', shape: 'flat', children: "Book inspection" }) })] })); };
exports.WithTitle = WithTitle;
(0, storybook_1.addDescription)(exports.WithIcon, "An optional title cna be added to the component to create a bit more structure.");
var CallToActions = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(_1.default, { variant: 'primary', text: 'Important message! The Emperor is Dead!.', callToAction: (0, jsx_runtime_1.jsx)(Button_1.default, { children: "Get directions to the party" }), icon: (0, jsx_runtime_1.jsx)(Icon_1.default, { color: theme.colorPrimaryDark, icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faCheck }) }) }), (0, jsx_runtime_1.jsx)(_1.default, { variant: 'success', text: 'Check me out', mt: theme.spacingLarge, icon: (0, jsx_runtime_1.jsx)(Icon_1.default, { color: theme.colorTextSuccess, icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faCheck }) }), slotRight: (0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(Button_1.default, { shape: 'flat', variant: 'success', children: "Reload dressing" }), (0, jsx_runtime_1.jsx)(ActionButton_1.default, { variant: 'success', children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faTimes }) })] }) })] })); };
exports.CallToActions = CallToActions;
(0, storybook_1.addDescription)(exports.CallToActions, "A call to action button can be added to the alert component for actions related to the message displayed. There are two ways to add call to actions, with the `callToAction` prop, or with the `slotRight` prop.");
var OnClick = function () { return ((0, jsx_runtime_1.jsx)(_1.default, { variant: 'primary', text: 'Touch me to get message.', icon: (0, jsx_runtime_1.jsx)(Icon_1.default, { color: theme.colorPrimaryDark, icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faCheck }) }), onClick: function () { return alert('Help me you are my only hope.'); } })); };
exports.OnClick = OnClick;
(0, storybook_1.addDescription)(exports.OnClick, "A function can be passed via the `onclick` prop that allows the `Alert` component to allow the component to be clicked and perform certain actions.");
var RichText = function () { return ((0, jsx_runtime_1.jsx)(_1.default, { variant: 'primary', alignIcon: 'start', py: theme.spacingMedium, icon: (0, jsx_runtime_1.jsx)(Icon_1.default, { color: theme.colorPrimaryDark, icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faInfoCircle }) }), text: (0, jsx_runtime_1.jsx)(Text_1.default, { variant: 'small', children: "Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industrys standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged. It was popularised in the 1960s with the release of Letraset sheets containing Lorem Ipsum passages, and more recently with desktop publishing software like Aldus PageMaker including versions of Lorem Ipsum." }) })); };
exports.RichText = RichText;
(0, storybook_1.addDescription)(exports.RichText, "A `Alert` can also contain rich text and be used as a permanent message in a specific part of the application.");
