"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Alert = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var Flex_1 = __importDefault(require("../Flex"));
var Text_1 = __importDefault(require("../Text"));
var mixins_1 = require("../Themes/mixins");
/**
  `Alert`s are used to communicate feedback and to draw user attention to a specific topic. They can be used to communicate updates, top level app messages and feedback to users actions.

  ### Import

  ```
  import Alert from '@impargo/components/Alert'
  ```
 */
var Alert = function (_a) {
    var className = _a.className, icon = _a.icon, _b = _a.variant, variant = _b === void 0 ? 'primary' : _b, title = _a.title, text = _a.text, callToAction = _a.callToAction, slotRight = _a.slotRight, whiteSpace = _a.whiteSpace, onClick = _a.onClick, mt = _a.mt, mr = _a.mr, mb = _a.mb, ml = _a.ml, px = _a.px, py = _a.py, width = _a.width, inline = _a.inline, alignIcon = _a.alignIcon, alignAction = _a.alignAction, rest = __rest(_a, ["className", "icon", "variant", "title", "text", "callToAction", "slotRight", "whiteSpace", "onClick", "mt", "mr", "mb", "ml", "px", "py", "width", "inline", "alignIcon", "alignAction"]);
    var theme = (0, react_1.useTheme)();
    var textColor = {
        primary: theme.colorText,
        info: theme.colorTextLink,
        success: theme.colorTextSuccess,
        danger: theme.colorTextDanger,
        warning: theme.colorTextWarning,
    };
    var bgColor = {
        primary: theme.colorPrimaryLight,
        info: theme.colorAccentLight2,
        success: theme.colorGreenLight2,
        danger: theme.colorRedLight2,
        warning: theme.colorOrangeLight2,
    };
    var borderBackground = {
        primary: theme.colorPrimaryLight2,
        info: theme.colorAccentLight4,
        success: theme.colorGreenLight3,
        danger: theme.colorRedLight3,
        warning: theme.colorOrangeLight3,
    };
    return ((0, jsx_runtime_1.jsxs)("div", __assign({ className: className, onClick: onClick }, rest, { css: (0, react_1.css)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n        min-height: ", ";\n        width: ", ";\n        padding: ", " ", ";\n        background-color: ", ";\n        display: ", ";\n        align-items: center;\n        border-radius: ", ";\n        position: relative;\n        border-left: ", " solid ", ";\n\n        ", "\n\n        ", "\n\n        ", "\n\n        margin-top: ", ";\n        margin-right: ", ";\n        margin-bottom: ", ";\n        margin-left: ", ";\n      "], ["\n        min-height: ", ";\n        width: ", ";\n        padding: ", " ", ";\n        background-color: ", ";\n        display: ", ";\n        align-items: center;\n        border-radius: ", ";\n        position: relative;\n        border-left: ", " solid ", ";\n\n        ", "\n\n        ", "\n\n        ", "\n\n        margin-top: ", ";\n        margin-right: ", ";\n        margin-bottom: ", ";\n        margin-left: ", ";\n      "])), theme.spacingXxxLarge, width || 'auto', theme.spacingSmall, theme.spacingMedium, bgColor[variant], inline ? 'inline-flex' : 'flex', theme.spacingXSmall, theme.spacingXSmall, borderBackground[variant], onClick && (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n          cursor: pointer;\n          position: relative;\n          ", "\n        "], ["\n          cursor: pointer;\n          position: relative;\n          ", "\n        "])), (0, mixins_1.overlayHoverMixin)(theme, 'colorHover', 'colorActive', 'borderRadius')), py && (0, react_1.css)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n          padding-top: ", ";\n          padding-bottom: ", ";\n        "], ["\n          padding-top: ", ";\n          padding-bottom: ", ";\n        "])), py, py), px && (0, react_1.css)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n          padding-right: ", ";\n          padding-left: ", ";\n        "], ["\n          padding-right: ", ";\n          padding-left: ", ";\n        "])), px, px), mt && mt, mr && mr, mb && mb, ml && ml), children: [(0, jsx_runtime_1.jsxs)("div", { css: (0, react_1.css)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n          display: flex;\n          align-items: center;\n        "], ["\n          display: flex;\n          align-items: center;\n        "]))), children: [icon &&
                        (0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n              height: ", ";\n              width: ", ";\n              min-width: ", ";\n              font-size: ", ";\n              display: flex;\n              align-items: center;\n              justify-content: center;\n              margin-right: ", ";\n              align-self: ", ";\n            "], ["\n              height: ", ";\n              width: ", ";\n              min-width: ", ";\n              font-size: ", ";\n              display: flex;\n              align-items: center;\n              justify-content: center;\n              margin-right: ", ";\n              align-self: ", ";\n            "])), theme.fontLineHeight, theme.spacingMedium, theme.spacingMedium, theme.fontSizeBody, theme.spacingSmall, alignIcon || 'center'), children: icon }), (0, jsx_runtime_1.jsxs)(Flex_1.default, { direction: 'column', gap: 'tiny', children: [title &&
                                (0, jsx_runtime_1.jsx)(Text_1.default, { color: textColor[variant], el: 'div', whiteSpace: whiteSpace, bold: true, children: title }), (0, jsx_runtime_1.jsx)(Text_1.default, { color: textColor[variant], el: 'div', whiteSpace: whiteSpace, children: text })] }), callToAction &&
                        (0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n              margin-left: ", ";\n            "], ["\n              margin-left: ", ";\n            "])), theme.spacingMedium), children: callToAction })] }), slotRight &&
                (0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_8 || (templateObject_8 = __makeTemplateObject(["\n            display: flex;\n            align-items: center;\n            margin-left: auto;\n            padding-left: ", ";\n            align-self: ", ";\n          "], ["\n            display: flex;\n            align-items: center;\n            margin-left: auto;\n            padding-left: ", ";\n            align-self: ", ";\n          "])), theme.spacingMedium, alignAction || 'center'), children: slotRight })] })));
};
exports.Alert = Alert;
exports.default = exports.Alert;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8;
