"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Custom = exports.Overlap = exports.Shape = exports.Variants = exports.BasicUsage = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var Badge_1 = __importDefault(require("@impargo/components/Badge"));
var ActionButton_1 = require("../ActionButton");
var Tag_1 = __importDefault(require("../Tag"));
var impargo_1 = __importDefault(require("../Themes/impargo"));
var storybook_1 = require("../utils/storybook");
var faSearch = free_solid_svg_icons_1.faSearch;
var theme = impargo_1.default;
exports.default = {
    title: 'Components/Feedback/Badge',
    component: Badge_1.default,
    argTypes: {
        children: { control: false },
        color: { control: 'color' },
        bgColor: { control: 'color' },
        variant: { control: 'select' },
        shape: { control: 'select' },
        overlap: { control: 'select' },
        shadow: { control: 'select' },
    },
    args: {
        badgeCount: 7,
        overlap: 'circle',
    },
};
var BasicUsage = function (args) { return ((0, jsx_runtime_1.jsx)(Badge_1.default, __assign({}, args, { children: (0, jsx_runtime_1.jsx)(ActionButton_1.ActionButton, { onClick: function () { return alert('Action!'); }, children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }) }) }))); };
exports.BasicUsage = BasicUsage;
exports.BasicUsage.args = {
    variant: 'primary',
};
var Variants = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(Badge_1.default, { badgeCount: 2, shape: 'default', variant: 'primary', overlap: 'inline' }), (0, jsx_runtime_1.jsx)(Badge_1.default, { ml: theme.spacingMedium, badgeCount: 2, shape: 'default', variant: 'secondary', overlap: 'inline' })] })); };
exports.Variants = Variants;
(0, storybook_1.addDescription)(exports.Variants, "The `primary` variant should be used to draw more attention to the element where the user should focus. The `secondary` variant should be used for secondary elements to display additional information.");
var Shape = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(Badge_1.default, { badgeCount: 2, shape: 'default', overlap: 'inline' }), (0, jsx_runtime_1.jsx)(Badge_1.default, { ml: theme.spacingMedium, badgeCount: 2, shape: 'dot', overlap: 'inline' })] })); };
exports.Shape = Shape;
(0, storybook_1.addDescription)(exports.Shape, "The `shape` prop specifies how the badge looks. The `default` will display a number badge and the `dot` values will display a simple dot badge.");
var Overlap = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(Badge_1.default, { badgeCount: 2, shape: 'default', overlap: 'inline' }), (0, jsx_runtime_1.jsx)(Badge_1.default, { ml: theme.spacingXLarge, badgeCount: 2, shape: 'dot', overlap: 'inline' }), (0, jsx_runtime_1.jsx)(Badge_1.default, { ml: theme.spacingXLarge, badgeCount: 2, shape: 'default', overlap: 'rectangle', children: (0, jsx_runtime_1.jsx)(Tag_1.default, { label: 'Primary' }) }), (0, jsx_runtime_1.jsx)(Badge_1.default, { ml: theme.spacingXLarge, badgeCount: 2, shape: 'default', overlap: 'circle', children: (0, jsx_runtime_1.jsx)(ActionButton_1.ActionButton, { onClick: function () { return alert('Action!'); }, children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }) }) })] })); };
exports.Overlap = Overlap;
(0, storybook_1.addDescription)(exports.Overlap, "The `overlap` prop can change the position of the badge. There are three values that can be used. The `inline` value sets the badge inside the flow of the document, being able to be set next to other elements. The `circle` and the `rectangle` values set the badge at the top right of the wrapped element with the `circle` value moving the badge closer to the middle of the wrapped element. It is recommended to use `circle` value with round elements such as `ActionButton`s. If both, the `dot` value and the `badgeCount` props are passed, the latter will take no effect and a dot badge will be displayed.");
var Custom = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(Badge_1.default, { badgeCount: 2, shape: 'dot', overlap: 'circle', bgColor: theme.colorPrimary, color: theme.colorText, children: (0, jsx_runtime_1.jsx)(ActionButton_1.ActionButton, { onClick: function () { return alert('Action!'); }, variant: 'secondary', children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }) }) }), (0, jsx_runtime_1.jsx)(Badge_1.default, { ml: theme.spacingLarge, badgeCount: 10, bgColor: theme.colorPrimary, color: theme.colorText, children: (0, jsx_runtime_1.jsx)(Tag_1.default, { label: 'Primary' }) }), (0, jsx_runtime_1.jsx)(Badge_1.default, { ml: theme.spacingLarge, badgeCount: 10, bgColor: theme.colorSurfaceHc, color: theme.colorText, borderColor: theme.colorDividerHc, shadow: 'medium', children: (0, jsx_runtime_1.jsx)(Tag_1.default, { label: 'Primary' }) })] })); };
exports.Custom = Custom;
(0, storybook_1.addDescription)(exports.Custom, "To set a custom badge, although this is not recommended, a `bgColor`, `color`, `borderColor` and `shadow` props are provided to customize the component.\nIf this use case is repeated in multiple places and across projects, a new `variant` can be added to cover this commonly used custom component. An additional class name is provided to further customize the badge: `badge`.");
