"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Badge = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var formatNotificationsCount = function (badgeCount, max) {
    if (badgeCount < 0)
        return 0;
    else if (badgeCount > max)
        return max + '+';
    else
        return badgeCount;
};
/**
 * Badge generates a small badge to the top-right of its child(ren).
 * It can also be used as an inline element in `ListItem`s or in a table row. The badge is used to represent unread states.

  ### Import

  ```
  import Badge from '@impargo/components/Badge'
  ```

  ### Class names
  A class name is available to customize the badge. See more customization in [Custom](#custom).

  - `badge`
 */
var Badge = function (_a) {
    var className = _a.className, children = _a.children, _b = _a.shape, shape = _b === void 0 ? 'default' : _b, _c = _a.variant, variant = _c === void 0 ? 'primary' : _c, badgeCount = _a.badgeCount, _d = _a.max, max = _d === void 0 ? 99 : _d, _e = _a.showBadge, showBadge = _e === void 0 ? true : _e, _f = _a.showZero, showZero = _f === void 0 ? false : _f, _g = _a.overlap, overlap = _g === void 0 ? 'rectangle' : _g, bgColor = _a.bgColor, color = _a.color, borderColor = _a.borderColor, shadow = _a.shadow, dataTestId = _a["data-testid"], _h = _a.inline, inline = _h === void 0 ? true : _h, my = _a.my, mx = _a.mx, mt = _a.mt, mr = _a.mr, mb = _a.mb, ml = _a.ml, rest = __rest(_a, ["className", "children", "shape", "variant", "badgeCount", "max", "showBadge", "showZero", "overlap", "bgColor", "color", "borderColor", "shadow", 'data-testid', "inline", "my", "mx", "mt", "mr", "mb", "ml"]);
    var theme = (0, react_1.useTheme)();
    var formattedCount = typeof badgeCount === 'number' ? formatNotificationsCount(badgeCount, max) : '';
    var zeroVisible = showZero || formattedCount !== 0;
    var badgeVisible = showBadge && zeroVisible;
    return ((0, jsx_runtime_1.jsxs)("div", __assign({ className: className }, rest, { css: (0, react_1.css)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n      display: ", ";\n      position: relative;\n    \n      /* spacing */\n      ", "\n      ", "\n      margin-top: ", ";\n      margin-right: ", ";\n      margin-bottom: ", ";\n      margin-left: ", ";\n\n    "], ["\n      display: ", ";\n      position: relative;\n    \n      /* spacing */\n      ", "\n      ", "\n      margin-top: ", ";\n      margin-right: ", ";\n      margin-bottom: ", ";\n      margin-left: ", ";\n\n    "])), inline ? 'inline-flex' : 'flex', mx && (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n        margin-right: ", ";\n        margin-left: ", ";\n      "], ["\n        margin-right: ", ";\n        margin-left: ", ";\n      "])), mx, mx), my && (0, react_1.css)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n        margin-top: ", ";\n        margin-bottom: ", ";\n      "], ["\n        margin-top: ", ";\n        margin-bottom: ", ";\n      "])), my, my), mt && mt, mr && mr, mb && mb, ml && ml), children: [badgeVisible &&
                (0, jsx_runtime_1.jsx)("span", { className: 'badge', "data-testid": dataTestId, css: (0, react_1.css)(templateObject_16 || (templateObject_16 = __makeTemplateObject(["\n            position: absolute;\n            z-index: 1;\n            display: flex;\n            justify-content: center;\n            align-items: center;\n            font-family: ", ";\n            font-size: ", ";\n            padding: ", ";\n        \n            min-height: ", ";\n            max-height: ", ";\n            min-width: ", ";\n            border-radius: ", ";\n            background-color: ", ";\n            color: ", ";\n\n            top: 0;\n            right: 0;\n            transform: scale(1) translate(50%, -50%);\n            transform-origin: 100% 0%;\n        \n            /* shape */\n            ", "\n            ", "\n        \n            /* variant */\n            ", "\n            ", "\n\n            /* custom */\n            ", "\n            ", "\n            ", "\n            ", "\n            ", "\n            ", "\n            \n            /* overlap */ \n            ", "\n            ", "\n          "], ["\n            position: absolute;\n            z-index: 1;\n            display: flex;\n            justify-content: center;\n            align-items: center;\n            font-family: ", ";\n            font-size: ", ";\n            padding: ", ";\n        \n            min-height: ", ";\n            max-height: ", ";\n            min-width: ", ";\n            border-radius: ", ";\n            background-color: ", ";\n            color: ", ";\n\n            top: 0;\n            right: 0;\n            transform: scale(1) translate(50%, -50%);\n            transform-origin: 100% 0%;\n        \n            /* shape */\n            ", "\n            ", "\n        \n            /* variant */\n            ", "\n            ", "\n\n            /* custom */\n            ", "\n            ", "\n            ", "\n            ", "\n            ", "\n            ", "\n            \n            /* overlap */ \n            ", "\n            ", "\n          "])), theme.fontFamily, theme.fontSizeSmall, (badgeCount && shape !== 'dot') ? "".concat(theme.spacingXSmall, " ").concat(theme.spacingSmall) : '0', theme.spacingMedium, theme.fontLineHeight, theme.spacingMedium, theme.spacingMedium, theme.colorRed, theme.colorTextInverse, shape === 'default' && (0, react_1.css)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n              min-height: ", ";\n              min-width: ", ";\n              border-radius: ", ";\n            "], ["\n              min-height: ", ";\n              min-width: ", ";\n              border-radius: ", ";\n            "])), theme.spacingMedium, theme.spacingMedium, theme.spacingMedium), shape === 'dot' && (0, react_1.css)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n              height: ", ";\n              min-height: ", ";\n              min-width: ", ";\n              border-radius: ", ";\n            "], ["\n              height: ", ";\n              min-height: ", ";\n              min-width: ", ";\n              border-radius: ", ";\n            "])), theme.spacingSmall, theme.spacingSmall, theme.spacingSmall, theme.spacingSmall), variant === 'primary' && (0, react_1.css)(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n              background-color: ", ";\n              color: ", ";      \n              background-color: ", ";\n              color: ", ";\n            "], ["\n              background-color: ", ";\n              color: ", ";      \n              background-color: ", ";\n              color: ", ";\n            "])), theme.colorRed, theme.colorTextInverse, bgColor, color), variant === 'secondary' && (0, react_1.css)(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n              background-color: ", ";\n              color: ", ";\n            "], ["\n              background-color: ", ";\n              color: ", ";\n            "])), theme.colorSurfaceLc, theme.colorText), bgColor && (0, react_1.css)(templateObject_8 || (templateObject_8 = __makeTemplateObject(["background-color: ", ";"], ["background-color: ", ";"])), bgColor), color && (0, react_1.css)(templateObject_9 || (templateObject_9 = __makeTemplateObject(["color: ", ";"], ["color: ", ";"])), color), borderColor && (0, react_1.css)(templateObject_10 || (templateObject_10 = __makeTemplateObject(["border: 1px solid ", ";"], ["border: 1px solid ", ";"])), borderColor), shadow === 'small' && (0, react_1.css)(templateObject_11 || (templateObject_11 = __makeTemplateObject(["box-shadow: ", ";"], ["box-shadow: ", ";"])), theme.shadowSmall), shadow === 'medium' && (0, react_1.css)(templateObject_12 || (templateObject_12 = __makeTemplateObject(["box-shadow: ", ";"], ["box-shadow: ", ";"])), theme.shadowMedium), shadow === 'large' && (0, react_1.css)(templateObject_13 || (templateObject_13 = __makeTemplateObject(["box-shadow: ", ";"], ["box-shadow: ", ";"])), theme.shadowLarge), overlap === 'circle' && (0, react_1.css)(templateObject_14 || (templateObject_14 = __makeTemplateObject(["\n              top: 14%;\n              right: 14%;\n            "], ["\n              top: 14%;\n              right: 14%;\n            "]))), overlap === 'inline' && (0, react_1.css)(templateObject_15 || (templateObject_15 = __makeTemplateObject(["\n              position: relative;\n              z-index: auto;\n              top: auto;\n              right: auto;\n              transform: scale(1) translate(0%, -0%);\n            "], ["\n              position: relative;\n              z-index: auto;\n              top: auto;\n              right: auto;\n              transform: scale(1) translate(0%, -0%);\n            "])))), children: (formattedCount && shape !== 'dot') && formattedCount }), (children && overlap !== 'inline') && children] })));
};
exports.Badge = Badge;
exports.default = exports.Badge;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8, templateObject_9, templateObject_10, templateObject_11, templateObject_12, templateObject_13, templateObject_14, templateObject_15, templateObject_16;
