"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WithTooltip = exports.Inverse = exports.Slots = exports.IconOnly = exports.Wide = exports.Sizes = exports.Variants = exports.Shape = exports.BasicUsage = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var Flex_1 = require("@impargo/components/Flex");
var Text_1 = require("@impargo/components/Text");
var Sheet_1 = __importDefault(require("../Sheet"));
var impargo_1 = __importDefault(require("../Themes/impargo"));
var Tooltip_1 = __importDefault(require("../Tooltip"));
var storybook_1 = require("../utils/storybook");
var _1 = require(".");
var faSearch = free_solid_svg_icons_1.faSearch;
var theme = impargo_1.default;
exports.default = {
    title: 'Components/General/Button/Button',
    component: _1.Button,
    argTypes: {
        onClick: { control: false },
        variant: { control: 'select' },
        size: { control: 'select' },
        type: { control: 'select' },
        shape: { control: 'select' },
        slotLeft: { control: false },
        slotRight: { control: false },
        iconOnly: { control: false },
        place: { control: 'select' },
        theme: { table: { disable: true } },
    },
    args: {
        onClick: function () { return window.alert('clicked'); },
    },
};
var BasicUsage = function (args) { return ((0, jsx_runtime_1.jsx)(_1.Button, __assign({}, args, { children: "Click me" }))); };
exports.BasicUsage = BasicUsage;
var Shape = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(_1.Button, { shape: 'default', children: "Default" }), (0, jsx_runtime_1.jsx)(_1.Button, { ml: theme.spacingSmall, shape: 'flat', children: "Flat" })] })); };
exports.Shape = Shape;
(0, storybook_1.addDescription)(exports.Shape, "The `shape` prop specifies if the button component has a background fill or not. The `default` value specifies a button with higher higher hierarchy than the `flat` value. The `flat` value is mostly used for quick interactions and links.");
var Variants = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsxs)(Sheet_1.default, { variant: 'medium', css: (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n        margin-top: 16px;\n      "], ["\n        margin-top: 16px;\n      "]))), children: [(0, jsx_runtime_1.jsx)(_1.Button, { shape: 'default', variant: 'primary', children: "Primary" }), (0, jsx_runtime_1.jsx)(_1.Button, { ml: theme.spacingSmall, shape: 'default', variant: 'secondary', children: "Secondary" }), (0, jsx_runtime_1.jsx)(_1.Button, { ml: theme.spacingSmall, shape: 'default', variant: 'success', children: "Success" }), (0, jsx_runtime_1.jsx)(_1.Button, { ml: theme.spacingSmall, shape: 'default', variant: 'warning', children: "Warning" }), (0, jsx_runtime_1.jsx)(_1.Button, { ml: theme.spacingSmall, shape: 'default', variant: 'danger', children: "Danger" })] }), (0, jsx_runtime_1.jsxs)(Sheet_1.default, { variant: 'medium', css: (0, react_1.css)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n        margin-top: 16px;\n      "], ["\n        margin-top: 16px;\n      "]))), children: [(0, jsx_runtime_1.jsx)(_1.Button, { shape: 'flat', variant: 'primary', children: "Primary" }), (0, jsx_runtime_1.jsx)(_1.Button, { ml: theme.spacingSmall, shape: 'flat', variant: 'secondary', children: "Secondary" }), (0, jsx_runtime_1.jsx)(_1.Button, { ml: theme.spacingSmall, shape: 'flat', variant: 'success', children: "Success" }), (0, jsx_runtime_1.jsx)(_1.Button, { ml: theme.spacingSmall, shape: 'flat', variant: 'warning', children: "Warning" }), (0, jsx_runtime_1.jsx)(_1.Button, { ml: theme.spacingSmall, shape: 'flat', variant: 'danger', children: "Danger" })] })] })); };
exports.Variants = Variants;
(0, storybook_1.addDescription)(exports.Variants, "The `variant` prop specifies the different use cases for the `shape` prop. Each variant should be used consciously and thinking about the user needs and overall visual hierarchy.");
var Sizes = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(_1.Button, { size: 's', children: "Small" }), (0, jsx_runtime_1.jsx)(_1.Button, { ml: theme.spacingSmall, size: 'm', children: "Medium" }), (0, jsx_runtime_1.jsx)(_1.Button, { ml: theme.spacingSmall, size: 'l', children: "Large" })] })); };
exports.Sizes = Sizes;
(0, storybook_1.addDescription)(exports.Sizes, "The `Button` component provides a `size` prop that can be used to to give more structure and highlight an action or to increase the hit area on mobile devices. The most common use case is the `medium` size button.");
var Wide = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(_1.Button, { wide: true, children: "Wide" }), (0, jsx_runtime_1.jsx)(_1.Button, { mt: theme.spacingSmall, shape: 'flat', wide: true, children: "Flat & wide" }), (0, jsx_runtime_1.jsx)(_1.Button, { mt: theme.spacingSmall, size: 'l', wide: true, children: "Large and wide" })] })); };
exports.Wide = Wide;
(0, storybook_1.addDescription)(exports.Wide, "The `wide` prop is used to change the layout of a button. Mostly used in mobile interfaces or inside a vertical layout with reduced horizontal space.");
var IconOnly = function () { return ((0, jsx_runtime_1.jsxs)("div", { css: (0, react_1.css)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n    display: flex;\n    align-items: center;"], ["\n    display: flex;\n    align-items: center;"]))), children: [(0, jsx_runtime_1.jsx)(_1.Button, { shape: 'default', size: 's', iconOnly: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }) }), (0, jsx_runtime_1.jsx)(_1.Button, { shape: 'default', ml: theme.spacingSmall, iconOnly: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }) }), (0, jsx_runtime_1.jsx)(_1.Button, { shape: 'default', ml: theme.spacingSmall, iconOnly: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), size: 'l' })] })); };
exports.IconOnly = IconOnly;
(0, storybook_1.addDescription)(exports.IconOnly, "The `iconOnly` prop is used to to specify a single icon displayed inside the button. This prop also adds additional styling to the button.");
var Slots = function () { return ((0, jsx_runtime_1.jsxs)("div", { css: (0, react_1.css)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n    display: flex;\n    align-items: center;"], ["\n    display: flex;\n    align-items: center;"]))), children: [(0, jsx_runtime_1.jsx)(_1.Button, { shape: 'default', slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), children: "Search this" }), (0, jsx_runtime_1.jsx)(_1.Button, { shape: 'default', slotRight: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), ml: theme.spacingMedium, children: "Search this" })] })); };
exports.Slots = Slots;
(0, storybook_1.addDescription)(exports.Slots, "The `slotLeft` and the `slotRight` are used to add icons to buttons. It is recommended to use only one icon to avoid confusion.");
var Inverse = function () { return ((0, jsx_runtime_1.jsxs)("div", { css: (0, react_1.css)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n    background-color: ", ";\n    padding: 24px;\n    display: flex;\n    width: min-content;\n  "], ["\n    background-color: ", ";\n    padding: 24px;\n    display: flex;\n    width: min-content;\n  "])), theme.colorSurfaceInverse), children: [(0, jsx_runtime_1.jsx)(_1.Button, { shape: 'flat', inverse: true, children: "Flat" }, 0), (0, jsx_runtime_1.jsx)(_1.Button, { shape: 'flat', variant: 'secondary', ml: theme.spacingSmall, inverse: true, children: "Flat" }, 1)] })); };
exports.Inverse = Inverse;
(0, storybook_1.addDescription)(exports.Inverse, "The `inverse` prop is used sparingly throughout the application on top of a dark background. This prop does not add dark theme, it only provides the option to add buttons when a dark background is present.");
var WithTooltip = function () { return ((0, jsx_runtime_1.jsxs)(Flex_1.Flex, { gap: 'medium', children: [(0, jsx_runtime_1.jsx)(Tooltip_1.default, { id: 'custom-tooltip', clickable: true, children: (0, jsx_runtime_1.jsxs)(Text_1.Text, { color: theme.colorTextInverse, children: ["Hello ", (0, jsx_runtime_1.jsx)(Text_1.Text, { textDecoration: 'underline', color: theme.colorTextInverse, el: 'a', href: '', children: "Link me" }), " "] }) }), (0, jsx_runtime_1.jsx)(_1.Button, { shape: 'default', slotRight: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), ml: theme.spacingMedium, "data-tooltip-id": 'custom-tooltip', alwaysShowTooltip: true, children: "Search this" }), (0, jsx_runtime_1.jsx)(_1.Button, { shape: 'default', slotRight: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), ml: theme.spacingMedium, disabled: true, "data-tooltip-content": 'Sorry action not allowed', children: "Search this" })] })); };
exports.WithTooltip = WithTooltip;
(0, storybook_1.addDescription)(exports.WithTooltip, 'A tooltip will be shown if the button is disabled. The tooltip is also shown if the `alwaysShowTooltip`  prop is passed regardless of if the button is disabled or not. Additionally a `tooltipProps` object can be used to pass props to the tooltip.');
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5;
