import { FC } from 'react';
import { ButtonProps } from './index';
export interface SubmitButtonProps extends Omit<ButtonProps, 'type'> {
    /**
     * Optional special tooltip if the button is disabled because
     * the form values are pristine.
     */
    tooltipPristine?: string;
    /**
     * Optional special tooltip if the button is disabled because
     * the form validation contains errors.
     */
    tooltipInvalid?: string;
}
/**
 * A special interface for submit buttons used within formik forms.

  ### Import

  ```
  import { SubmitButton } from '@impargo/components/Button/SubmitButton'
  ```
 */
export declare const SubmitButton: FC<SubmitButtonProps>;
//# sourceMappingURL=SubmitButton.d.ts.map