"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SubmitButton = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var formik_1 = require("formik");
var index_1 = __importDefault(require("./index"));
/**
 * A special interface for submit buttons used within formik forms.

  ### Import

  ```
  import { SubmitButton } from '@impargo/components/Button/SubmitButton'
  ```
 */
var SubmitButton = function (_a) {
    var disabled = _a.disabled, tooltipPristine = _a.tooltipPristine, tooltipInvalid = _a.tooltipInvalid, props = __rest(_a, ["disabled", "tooltipPristine", "tooltipInvalid"]);
    var _b = (0, formik_1.useFormikContext)(), dirty = _b.dirty, isValid = _b.isValid;
    var canSubmit = dirty && isValid;
    var tooltip = dirty ? (isValid ? '' : tooltipInvalid) : tooltipPristine;
    return ((0, jsx_runtime_1.jsx)(index_1.default, __assign({ "data-tooltip-content": tooltip }, props, { disabled: disabled || !canSubmit, type: 'submit' })));
};
exports.SubmitButton = SubmitButton;
