"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Button = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var styled_1 = __importDefault(require("@emotion/styled"));
var Spinner_1 = __importDefault(require("../Spinner"));
var mixins_1 = require("../Themes/mixins");
var Component = function (_a) {
    var onClick = _a.onClick, _b = _a.disabled, disabled = _b === void 0 ? false : _b, children = _a.children, className = _a.className, _c = _a.shape, shape = _c === void 0 ? 'default' : _c, _d = _a.variant, variant = _d === void 0 ? 'primary' : _d, _e = _a.wide, wide = _e === void 0 ? false : _e, _f = _a.loading, loading = _f === void 0 ? false : _f, _g = _a.type, type = _g === void 0 ? 'button' : _g, _h = _a.iconOnly, iconOnly = _h === void 0 ? false : _h, _j = _a.size, size = _j === void 0 ? 'm' : _j, slotLeft = _a.slotLeft, slotRight = _a.slotRight, _k = _a.toggled, toggled = _k === void 0 ? false : _k, _mt = _a.mt, _mr = _a.mr, _mb = _a.mb, _ml = _a.ml, _inverse = _a.inverse, alwaysShowTooltip = _a.alwaysShowTooltip, dataTooltipId = _a["data-tooltip-id"], dataTooltipVariant = _a["data-tooltip-variant"], dataTooltipPlace = _a["data-tooltip-place"], dataTooltipContent = _a["data-tooltip-content"], props = __rest(_a, ["onClick", "disabled", "children", "className", "shape", "variant", "wide", "loading", "type", "iconOnly", "size", "slotLeft", "slotRight", "toggled", "mt", "mr", "mb", "ml", "inverse", "alwaysShowTooltip", 'data-tooltip-id', 'data-tooltip-variant', 'data-tooltip-place', 'data-tooltip-content']);
    var computedProps = {
        disabled: disabled || loading,
        className: "button ".concat(wide ? 'button--wide' : '', " button--").concat(shape, "-").concat(variant, " button--").concat(size, " ").concat(toggled ? 'button--toggled' : ''),
        type: type,
        onClick: onClick,
    };
    return ((0, jsx_runtime_1.jsx)("div", { className: "".concat(className, " ").concat(wide ? 'wide' : ''), "data-tooltip-hidden": (!disabled && !alwaysShowTooltip) ? true : undefined, "data-tooltip-id": dataTooltipId, "data-tooltip-content": dataTooltipContent, "data-tooltip-variant": dataTooltipVariant, "data-tooltip-place": dataTooltipPlace, children: (0, jsx_runtime_1.jsxs)("button", __assign({}, props, computedProps, { children: [(slotLeft && !iconOnly) &&
                    (0, jsx_runtime_1.jsx)("span", { className: 'button__slot button__slot--left', children: slotLeft }), !iconOnly &&
                    (0, jsx_runtime_1.jsx)("span", { className: 'button__content', children: children }), (slotRight && !iconOnly) &&
                    (0, jsx_runtime_1.jsx)("span", { className: 'button__slot button__slot--right', children: slotRight }), iconOnly &&
                    (0, jsx_runtime_1.jsx)("span", { className: 'button__slot', children: iconOnly }), loading && ((0, jsx_runtime_1.jsx)(Spinner_1.default, { className: 'loader', variant: 'dark', size: 4 }))] })) }));
};
/**
 * Generic button component.
 * For more specific use-cases consider using `ActionButton`, `Tag`, `ListItem`, `SubmitButton` or `ResetButton`.

  ### Import

  ```
  import Button from '@impargo/components/Button'
  ```
 */
exports.Button = (0, styled_1.default)(Component)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  display: inline-flex;\n\n  margin-top: ", ";\n  margin-right: ", ";\n  margin-bottom: ", ";\n  margin-left: ", ";\n\n  &.wide {\n    width: 100%;\n  }\n\n/* Button styles */\n.button {\n  position: relative;\n  cursor: pointer;\n  outline-width: 0;\n  font-size: ", ";\n  height: ", ";\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  padding: 0;\n  border: 0;\n  border-radius: ", ";\n  transition: background-color 0.3s ease-in-out 0s, color 0.2s ease-in-out 0s,\n    opacity 0.2s ease-in-out 0s;\n  font-family: ", ";\n  &:focus {\n    outline: none;\n  }\n\n  &--wide {\n    width: 100%;\n  }\n\n/* shape */\n\n  &--default {\n    background-color: ", ";\n    color: ", ";\n    ", "\n\n    /* variant */\n    &-primary {\n      background-color: ", ";\n      color: ", ";\n      ", "\n    }\n    &-secondary {\n      background-color: ", ";\n      color: ", ";\n      ", "\n    }\n    &-success {\n      background-color: ", ";\n      color: ", ";\n      ", "\n    }\n    &-warning {\n      background-color: ", ";\n      color: ", ";\n      ", "\n    }\n    &-danger {\n      background-color: ", ";\n      color: ", ";\n      ", "\n    }\n  }\n\n  &--flat {\n    background-color: transparent;\n    color: ", ";\n    ", "\n\n    /* variant */\n    &-primary {\n      background-color: transparent;\n      color: ", ";\n      ", "\n    }\n\n    &-secondary {\n      background-color: transparent;\n      color: ", ";\n      ", "\n    }\n\n    &-success {\n      background-color: transparent;\n      color: ", ";\n      ", "\n    }\n\n    &-warning {\n      background-color: transparent;\n      color: ", ";\n      ", "\n    }\n\n    &-danger {\n      background-color: transparent;\n      color: ", ";\n      ", "\n    }\n  }\n\n  /* size */\n  &--s {\n    height: ", ";\n    padding: 0 ", ";\n    ", "\n  }\n  &--m {\n    height: ", ";\n    padding: 0 ", ";\n    ", "\n  }\n  &--l {\n    height: ", ";\n    padding: 0 ", ";\n    ", "\n  }\n\n  &--toggled {\n    filter: brightness(90%);\n  }\n\n  /* children / content */\n  &__content {\n    position: relative;\n    display: flex;\n    align-items: center;\n    justify-content: center;\n    width: 100%;\n    height: 100%;\n    white-space: nowrap;\n    ", "\n    pointer-events:none;\n  }\n\n  &__slot { \n    font-size: ", ";\n    margin: 0;\n    display: flex;\n    align-items: center;\n    justify-content: center;\n    ", "\n\n    &--left {\n      margin-right: ", "\n    }\n    &--right {\n      margin-left: ", "\n    }\n  }\n}\n\n  && .button {\n    &:disabled {\n      opacity: 0.65;\n      cursor: not-allowed;\n      &:hover,\n      &:active {\n        &::before {\n          opacity: 0;\n        }\n      }\n    }\n  }\n\n  & .loader {\n    position: absolute;\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 100%;\n    display: flex;\n    align-items: center;\n    justify-content: center;\n  }\n"], ["\n  display: inline-flex;\n\n  margin-top: ", ";\n  margin-right: ", ";\n  margin-bottom: ", ";\n  margin-left: ", ";\n\n  &.wide {\n    width: 100%;\n  }\n\n/* Button styles */\n.button {\n  position: relative;\n  cursor: pointer;\n  outline-width: 0;\n  font-size: ", ";\n  height: ", ";\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  padding: 0;\n  border: 0;\n  border-radius: ", ";\n  transition: background-color 0.3s ease-in-out 0s, color 0.2s ease-in-out 0s,\n    opacity 0.2s ease-in-out 0s;\n  font-family: ", ";\n  &:focus {\n    outline: none;\n  }\n\n  &--wide {\n    width: 100%;\n  }\n\n/* shape */\n\n  &--default {\n    background-color: ", ";\n    color: ", ";\n    ", "\n\n    /* variant */\n    &-primary {\n      background-color: ", ";\n      color: ", ";\n      ", "\n    }\n    &-secondary {\n      background-color: ", ";\n      color: ", ";\n      ", "\n    }\n    &-success {\n      background-color: ", ";\n      color: ", ";\n      ", "\n    }\n    &-warning {\n      background-color: ", ";\n      color: ", ";\n      ", "\n    }\n    &-danger {\n      background-color: ", ";\n      color: ", ";\n      ", "\n    }\n  }\n\n  &--flat {\n    background-color: transparent;\n    color: ", ";\n    ", "\n\n    /* variant */\n    &-primary {\n      background-color: transparent;\n      color: ", ";\n      ", "\n    }\n\n    &-secondary {\n      background-color: transparent;\n      color: ", ";\n      ", "\n    }\n\n    &-success {\n      background-color: transparent;\n      color: ", ";\n      ", "\n    }\n\n    &-warning {\n      background-color: transparent;\n      color: ", ";\n      ", "\n    }\n\n    &-danger {\n      background-color: transparent;\n      color: ", ";\n      ", "\n    }\n  }\n\n  /* size */\n  &--s {\n    height: ", ";\n    padding: 0 ", ";\n    ", "\n  }\n  &--m {\n    height: ", ";\n    padding: 0 ", ";\n    ", "\n  }\n  &--l {\n    height: ", ";\n    padding: 0 ", ";\n    ", "\n  }\n\n  &--toggled {\n    filter: brightness(90%);\n  }\n\n  /* children / content */\n  &__content {\n    position: relative;\n    display: flex;\n    align-items: center;\n    justify-content: center;\n    width: 100%;\n    height: 100%;\n    white-space: nowrap;\n    ", "\n    pointer-events:none;\n  }\n\n  &__slot { \n    font-size: ", ";\n    margin: 0;\n    display: flex;\n    align-items: center;\n    justify-content: center;\n    ", "\n\n    &--left {\n      margin-right: ", "\n    }\n    &--right {\n      margin-left: ", "\n    }\n  }\n}\n\n  && .button {\n    &:disabled {\n      opacity: 0.65;\n      cursor: not-allowed;\n      &:hover,\n      &:active {\n        &::before {\n          opacity: 0;\n        }\n      }\n    }\n  }\n\n  & .loader {\n    position: absolute;\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 100%;\n    display: flex;\n    align-items: center;\n    justify-content: center;\n  }\n"])), function (_a) {
    var mt = _a.mt;
    return mt && mt;
}, function (_a) {
    var mr = _a.mr;
    return mr && mr;
}, function (_a) {
    var mb = _a.mb;
    return mb && mb;
}, function (_a) {
    var ml = _a.ml;
    return ml && ml;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontSizeBody;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingXLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.borderRadius;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontFamily;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorPrimary;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorText;
}, function (_a) {
    var theme = _a.theme;
    return (0, mixins_1.overlayHoverMixin)(theme, 'colorHover', 'colorActive');
}, function (_a) {
    var theme = _a.theme;
    return theme.colorPrimary;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorText;
}, function (_a) {
    var theme = _a.theme;
    return (0, mixins_1.overlayHoverMixin)(theme, 'colorHover', 'colorActive');
}, function (_a) {
    var theme = _a.theme;
    return theme.colorSurfaceLc;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorText;
}, function (_a) {
    var theme = _a.theme;
    return (0, mixins_1.overlayHoverMixin)(theme, 'colorHover', 'colorActive');
}, function (_a) {
    var theme = _a.theme;
    return theme.colorGreenLight2;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorTextSuccess;
}, function (_a) {
    var theme = _a.theme;
    return (0, mixins_1.overlayHoverMixin)(theme, 'colorHover', 'colorActive');
}, function (_a) {
    var theme = _a.theme;
    return theme.colorOrangeLight2;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorTextWarning;
}, function (_a) {
    var theme = _a.theme;
    return (0, mixins_1.overlayHoverMixin)(theme, 'colorHover', 'colorActive');
}, function (_a) {
    var theme = _a.theme;
    return theme.colorRedLight2;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorTextDanger;
}, function (_a) {
    var theme = _a.theme;
    return (0, mixins_1.overlayHoverMixin)(theme, 'colorHover', 'colorActive');
}, function (_a) {
    var inverse = _a.inverse, theme = _a.theme;
    return inverse ? theme.colorTextInverseLink : theme.colorTextLink;
}, function (_a) {
    var inverse = _a.inverse, theme = _a.theme;
    return inverse
        ? (0, mixins_1.overlayHoverMixin)(theme, 'colorAccentLightA4', 'colorAccentLightA10')
        : (0, mixins_1.overlayHoverMixin)(theme, 'colorHoverAccent', 'colorActiveAccent');
}, function (_a) {
    var inverse = _a.inverse, theme = _a.theme;
    return inverse ? theme.colorTextInverseLink : theme.colorTextLink;
}, function (_a) {
    var inverse = _a.inverse, theme = _a.theme;
    return inverse
        ? (0, mixins_1.overlayHoverMixin)(theme, 'colorAccentLightA4', 'colorAccentLightA10')
        : (0, mixins_1.overlayHoverMixin)(theme, 'colorHoverAccent', 'colorActiveAccent');
}, function (_a) {
    var inverse = _a.inverse, theme = _a.theme;
    return inverse ? theme.colorTextInverse : theme.colorText;
}, function (_a) {
    var inverse = _a.inverse, theme = _a.theme;
    return inverse
        ? (0, mixins_1.overlayHoverMixin)(theme, 'colorHoverInverse', 'colorActiveInverse')
        : (0, mixins_1.overlayHoverMixin)(theme, 'colorHover', 'colorActive');
}, function (_a) {
    var theme = _a.theme;
    return theme.colorGreen;
}, function (_a) {
    var theme = _a.theme;
    return (0, mixins_1.overlayHoverMixin)(theme, 'colorGreenA4', 'colorGreenA10');
}, function (_a) {
    var theme = _a.theme;
    return theme.colorOrange;
}, function (_a) {
    var theme = _a.theme;
    return (0, mixins_1.overlayHoverMixin)(theme, 'colorOrangeA4', 'colorOrangeA10');
}, function (_a) {
    var theme = _a.theme;
    return theme.colorRed;
}, function (_a) {
    var theme = _a.theme;
    return (0, mixins_1.overlayHoverMixin)(theme, 'colorRedA4', 'colorRedA10');
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingSmall;
}, function (_a) {
    var iconOnly = _a.iconOnly, theme = _a.theme;
    return iconOnly && "\n      width: ".concat(theme.spacingLarge, ";\n      padding: 0;\n    ");
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingXLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingMedium;
}, function (_a) {
    var iconOnly = _a.iconOnly, theme = _a.theme;
    return iconOnly && "\n      width: ".concat(theme.spacingXLarge, ";\n      padding: 0;\n    ");
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingXxLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingLarge;
}, function (_a) {
    var iconOnly = _a.iconOnly, theme = _a.theme;
    return iconOnly && "\n      width: ".concat(theme.spacingXxLarge, ";\n      padding: 0;\n    ");
}, function (_a) {
    var loading = _a.loading;
    return loading && "opacity: 0;";
}, function (_a) {
    var theme = _a.theme;
    return theme.fontSizeSmall;
}, function (_a) {
    var loading = _a.loading;
    return loading && "display: none;";
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingSmall;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingSmall;
});
exports.default = exports.Button;
var templateObject_1;
