"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.confirm = exports.ConfirmationModal = exports.Confirm = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var Button_1 = __importDefault(require("@impargo/components/Button"));
var Flex_1 = __importDefault(require("@impargo/components/Flex"));
var Icon_1 = __importDefault(require("@impargo/components/Icon"));
var Modal_1 = __importDefault(require("@impargo/components/Modal"));
var ModalBody_1 = __importDefault(require("@impargo/components/Modal/ModalBody"));
var ModalFooter_1 = __importDefault(require("@impargo/components/Modal/ModalFooter"));
var Text_1 = __importDefault(require("@impargo/components/Text"));
var react_2 = require("react");
var buttonPropsMap = {
    'danger': {
        shape: 'flat',
        variant: 'danger',
    },
    'default': {
        shape: 'default',
        variant: 'primary',
    },
};
var Confirm = function (_a) {
    var className = _a.className, resolve = _a.resolve, onClose = _a.onClose, confirmationMessage = _a.confirmationMessage, confirmationButtonText = _a.confirmationButtonText, declinationButtonText = _a.declinationButtonText, _b = _a.variant, variant = _b === void 0 ? 'default' : _b, icon = _a.icon, explainationText = _a.explainationText, _c = _a.shouldCloseOnOverlayClick, shouldCloseOnOverlayClick = _c === void 0 ? true : _c;
    var theme = (0, react_1.useTheme)();
    return ((0, jsx_runtime_1.jsxs)(Modal_1.default, { isOpen: true, onClose: onClose, shouldCloseOnOverlayClick: shouldCloseOnOverlayClick, small: true, className: className, children: [(0, jsx_runtime_1.jsx)(ModalBody_1.default, { withPadding: true, children: (0, jsx_runtime_1.jsxs)(Flex_1.default, { gap: 'small', children: [(0, jsx_runtime_1.jsx)(Icon_1.default, { variant: 'default', icon: icon, size: 's' }), (0, jsx_runtime_1.jsxs)(Flex_1.default, { direction: 'column', gap: 'small', children: [(0, jsx_runtime_1.jsx)(Text_1.default, { "data-testid": 'message-text', children: confirmationMessage }), typeof explainationText === 'string'
                                    ? (0, jsx_runtime_1.jsx)(Text_1.default, { "data-testid": 'explaination-text', className: 'explaination-text', secondary: true, children: explainationText })
                                    : explainationText] })] }) }), (0, jsx_runtime_1.jsxs)(ModalFooter_1.default, { children: [(0, jsx_runtime_1.jsx)(Button_1.default, { shape: 'flat', "data-testid": 'cancel-button', onClick: function () {
                            resolve && resolve(false);
                            onClose && onClose();
                        }, type: 'button', children: declinationButtonText }), (0, jsx_runtime_1.jsx)(Button_1.default, { ml: theme.spacingMedium, "data-testid": 'confirm-button', onClick: function () {
                            resolve && resolve(true);
                            onClose && onClose();
                        }, type: 'button', variant: buttonPropsMap[variant].variant, children: confirmationButtonText })] })] }));
};
exports.Confirm = Confirm;
var initialState = {
    isOpen: false,
    confirmationMessage: '',
    resolve: function () { return null; },
    confirmationButtonText: '',
    declinationButtonText: '',
    icon: (0, jsx_runtime_1.jsx)("span", {}),
};
// Confirmation component singleton
var sShow = null;
/**
 * `ConfirmationModal` should be rendered before using the `confirm` function.
 * It can be renderer anywhere in the DOM.
 * Note: There should always only be one instance of the `ConfirmationModal`.
 */
var ConfirmationModal = function () {
    var _a = (0, react_2.useState)(initialState), modalState = _a[0], setModalState = _a[1];
    (0, react_2.useEffect)(function () {
        if (sShow) {
            throw new Error('There should be only one instance of ConfirmationModal in the app.');
        }
        sShow = function (state) {
            setModalState(__assign(__assign({}, state), { isOpen: true }));
        };
        return function () {
            sShow = null;
        };
    }, []);
    if (!modalState.isOpen) {
        return null;
    }
    return ((0, jsx_runtime_1.jsx)(exports.Confirm, __assign({}, modalState, { onClose: function () { return setModalState(initialState); } })));
};
exports.ConfirmationModal = ConfirmationModal;
/**
 * The `ConfirmationModal` is a modal meant for requesting users a confirmation before cetain actions, such as delete an item or accept an invitation, take place.
 * The `ConfirmationModal` is open with a `confirm` function with passed arguamnts.
 * The `confirm` function has to be used with the `ConfirmationModal` component which has to be rendered anywhere in the DOM.
 * `ConfirmationModal` should be rendered before using the `confirm` function.
 * It can be renderer anywhere in the DOM.
 * Note: There should always only be one instance of the `ConfirmationModal`.

  ### Import

  ```
  import { ConfirmationModal } from '@impargo/components/ConfirmationModal'
  import confirm from '@impargo/components/ConfirmationModal'
  ```
 *
 * @param props Specifying the content of the modal.
 * @returns Boolean that indicated if the user has confirmed or declined the request.
 */
var confirm = function (_a) {
    var confirmationMessage = _a.confirmationMessage, confirmationButtonText = _a.confirmationButtonText, declinationButtonText = _a.declinationButtonText, _b = _a.variant, variant = _b === void 0 ? 'default' : _b, explainationText = _a.explainationText, icon = _a.icon;
    return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0: return [4 /*yield*/, new Promise(function (resolve) {
                        if (sShow) {
                            sShow({
                                confirmationMessage: confirmationMessage,
                                resolve: resolve,
                                declinationButtonText: declinationButtonText,
                                confirmationButtonText: confirmationButtonText,
                                variant: variant,
                                icon: icon,
                                explainationText: explainationText,
                            });
                        }
                        else {
                            resolve(false);
                        }
                    })];
                case 1: return [2 /*return*/, _c.sent()];
            }
        });
    });
};
exports.confirm = confirm;
exports.default = exports.confirm;
