"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Width = exports.Orientation = exports.Variants = exports.BasicUsage = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var ActionButton_1 = __importDefault(require("@impargo/components/ActionButton"));
var index_1 = __importDefault(require("@impargo/components/Sheet/index"));
var Text_1 = __importDefault(require("@impargo/components/Text"));
var impargo_1 = __importDefault(require("../Themes/impargo"));
var storybook_1 = require("../utils/storybook");
var _1 = require(".");
var theme = impargo_1.default;
var faClipboard = free_solid_svg_icons_1.faSearch;
var faShare = free_solid_svg_icons_1.faShare;
var faPen = free_solid_svg_icons_1.faPen;
exports.default = {
    title: 'Components/Layout/Divider',
    component: _1.Divider,
    argTypes: {
        variant: { control: { type: 'select' } },
        el: { control: { type: 'select' } },
        orientation: { control: { type: 'select' } },
        theme: { table: { disable: true } },
    },
    parameters: {
        layout: 'padded',
    },
};
var BasicUsage = function (args) { return ((0, jsx_runtime_1.jsx)(_1.Divider, __assign({}, args))); };
exports.BasicUsage = BasicUsage;
exports.BasicUsage.args = {
    variant: 'default',
};
var Variants = function () { return ((0, jsx_runtime_1.jsxs)(index_1.default, { variant: 'medium', css: {
        width: '200px',
    }, children: [(0, jsx_runtime_1.jsx)(_1.Divider, { my: theme.spacingLarge, el: 'hr' }), (0, jsx_runtime_1.jsx)(_1.Divider, { my: theme.spacingLarge, el: 'hr', variant: 'light' }), (0, jsx_runtime_1.jsx)(_1.Divider, { my: theme.spacingLarge, el: 'hr', variant: 'dark' }), (0, jsx_runtime_1.jsx)(_1.Divider, { my: theme.spacingLarge, el: 'hr', variant: 'inverse' })] })); };
exports.Variants = Variants;
(0, storybook_1.addDescription)(exports.Variants, "Variant defines the color of the `Divider`. Default value: `default`. ");
var Orientation = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsxs)(index_1.default, { variant: 'large', css: {
                marginBottom: '16px',
            }, children: [(0, jsx_runtime_1.jsx)(Text_1.default, { children: "First element." }), (0, jsx_runtime_1.jsx)(_1.Divider, { my: theme.spacingMedium }), (0, jsx_runtime_1.jsx)(Text_1.default, { children: "Second element." })] }), (0, jsx_runtime_1.jsxs)(index_1.default, { variant: 'small', css: {
                display: 'flex',
            }, children: [(0, jsx_runtime_1.jsx)(ActionButton_1.default, { children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faClipboard }) }), (0, jsx_runtime_1.jsx)(ActionButton_1.default, { children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faShare }) }), (0, jsx_runtime_1.jsx)(_1.Divider, { orientation: 'vertical', flexItem: true, el: 'div', my: theme.spacingSmall, mx: theme.spacingSmall }), (0, jsx_runtime_1.jsx)(ActionButton_1.default, { children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faPen }) })] })] })); };
exports.Orientation = Orientation;
(0, storybook_1.addDescription)(exports.Orientation, "The divider can be used to set a visual separation on elements horizontally or vertically. When used vertically and as a flex child the `flexItem` prop should be used, otherwise the divider won't be display since it will have a height of `0px`. ");
var Width = function () { return ((0, jsx_runtime_1.jsxs)(index_1.default, { variant: 'large', css: {
        marginRight: '16px',
    }, children: [(0, jsx_runtime_1.jsx)(Text_1.default, { children: "First element." }), (0, jsx_runtime_1.jsx)(_1.Divider, { my: theme.spacingMedium, mx: "-".concat(theme.spacingLarge), width: "calc(100% + ".concat(theme.spacingXxxLarge, ")") }), (0, jsx_runtime_1.jsx)(Text_1.default, { children: "Second element." })] })); };
exports.Width = Width;
(0, storybook_1.addDescription)(exports.Width, "The `width` prop in combination with the `mx` prop, can be set to change the how the layout behaves.");
