"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomParent = exports.Place = exports.CustomWidth = exports.BasicUsage = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var react_2 = require("react");
var ActionButton_1 = require("../ActionButton");
var Button_1 = __importDefault(require("../Button"));
var SheetBody_1 = __importDefault(require("../Sheet/SheetBody"));
var SheetHeader_1 = __importDefault(require("../Sheet/SheetHeader"));
var Text_1 = __importDefault(require("../Text"));
var storybook_1 = require("../utils/storybook");
var _1 = require(".");
exports.default = {
    title: 'Components/Overlay/Drawer',
    component: _1.Drawer,
    argTypes: {
        isOpen: { control: false },
        onClose: { control: false },
        place: { control: 'select' },
        theme: { table: { disable: true } },
    },
    args: {
        place: 'right',
    },
};
var BasicUsage = function (args) {
    var _a = (0, react_2.useState)(false), isOpen = _a[0], setIsOpen = _a[1];
    return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(Button_1.default, { onClick: function () { return setIsOpen(!isOpen); }, children: "Open drawer" }), (0, jsx_runtime_1.jsxs)(_1.Drawer, __assign({}, args, { isOpen: isOpen, onClose: function () { return setIsOpen(!isOpen); }, children: [(0, jsx_runtime_1.jsx)(SheetHeader_1.default, { title: 'Sheet header', hasBorder: true, slotRight: (0, jsx_runtime_1.jsx)(ActionButton_1.ActionButton, { variant: 'secondary', onClick: function () { return setIsOpen(!isOpen); }, children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faTimes }) }), variant: 'large' }), (0, jsx_runtime_1.jsx)(SheetBody_1.default, { variant: 'large', children: "this is a drawer" })] }))] }));
};
exports.BasicUsage = BasicUsage;
exports.BasicUsage.args = {};
var CustomWidth = function () {
    var _a = (0, react_2.useState)(false), isOpen = _a[0], setIsOpen = _a[1];
    return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(Button_1.default, { onClick: function () { return setIsOpen(!isOpen); }, children: "Open drawer" }), (0, jsx_runtime_1.jsxs)(_1.Drawer, { shouldCloseOnOverlayClick: true, hasOverlay: true, width: '400px', isOpen: isOpen, onClose: function () { return setIsOpen(!isOpen); }, place: 'right', children: [(0, jsx_runtime_1.jsx)(SheetHeader_1.default, { title: 'Sheet header', hasBorder: true, slotRight: (0, jsx_runtime_1.jsx)(ActionButton_1.ActionButton, { variant: 'secondary', onClick: function () { return setIsOpen(!isOpen); }, children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faTimes }) }), variant: 'large' }), (0, jsx_runtime_1.jsx)(SheetBody_1.default, { variant: 'large', css: (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n            height: 1500px;\n          "], ["\n            height: 1500px;\n          "]))), children: (0, jsx_runtime_1.jsx)(Text_1.default, { children: "Content here" }) })] })] }));
};
exports.CustomWidth = CustomWidth;
(0, storybook_1.addDescription)(exports.CustomWidth, "A custom width can be specified to the component.");
var Place = function () {
    var _a = (0, react_2.useState)(false), bottomIsOpen = _a[0], setBottomIsOpen = _a[1];
    var _b = (0, react_2.useState)(false), rightIsOpen = _b[0], setRightIsOpen = _b[1];
    var _c = (0, react_2.useState)(false), leftIsOpen = _c[0], setLeftIsOpen = _c[1];
    return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(Button_1.default, { onClick: function () { return setLeftIsOpen(!leftIsOpen); }, children: "Left drawer" }), (0, jsx_runtime_1.jsxs)(_1.Drawer, { shouldCloseOnOverlayClick: true, hasOverlay: true, isOpen: leftIsOpen, onClose: function () { return setLeftIsOpen(!leftIsOpen); }, place: 'left', children: [(0, jsx_runtime_1.jsx)(SheetHeader_1.default, { title: 'Sheet header', hasBorder: true, slotRight: (0, jsx_runtime_1.jsx)(ActionButton_1.ActionButton, { variant: 'secondary', onClick: function () { return setLeftIsOpen(!leftIsOpen); }, children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faTimes }) }), variant: 'large' }), (0, jsx_runtime_1.jsx)(SheetBody_1.default, { variant: 'large', children: (0, jsx_runtime_1.jsx)(Text_1.default, { children: "Content here" }) })] }), (0, jsx_runtime_1.jsx)(Button_1.default, { onClick: function () { return setBottomIsOpen(!bottomIsOpen); }, ml: '24px', children: "Bottom drawer" }), (0, jsx_runtime_1.jsxs)(_1.Drawer, { isOpen: bottomIsOpen, shouldCloseOnOverlayClick: true, hasOverlay: true, onClose: function () { return setBottomIsOpen(!bottomIsOpen); }, place: 'bottom', children: [(0, jsx_runtime_1.jsx)(SheetHeader_1.default, { title: 'Sheet header', hasBorder: true, css: (0, react_1.css)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n            position: sticky;\n            top: 0;\n            z-index: 1;\n          "], ["\n            position: sticky;\n            top: 0;\n            z-index: 1;\n          "]))), slotRight: (0, jsx_runtime_1.jsx)(ActionButton_1.ActionButton, { variant: 'secondary', onClick: function () { return setBottomIsOpen(!bottomIsOpen); }, children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faTimes }) }), variant: 'large' }), (0, jsx_runtime_1.jsx)(SheetBody_1.default, { variant: 'large', children: (0, jsx_runtime_1.jsx)(Text_1.default, { children: "What is Lorem Ipsum? Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry's standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged. It was popularised in the 1960s with the release of Letraset sheets containing Lorem Ipsum passages, and more recently with desktop publishing software like Aldus PageMaker including versions of Lorem Ipsum. It is a long established fact that a reader will be distracted by the readable content of a page when looking at its layout. The point of using Lorem Ipsum is that it has a more-or-less normal distribution of letters, as opposed to using 'Content here, content here', making it look like readable English. Many desktop publishing packages and web page editors now use Lorem Ipsum as their default model text, and a search for 'lorem ipsum' will uncover many web sites still in their infancy. Various versions have evolved over the years, sometimes by accident, sometimes on purpose (injected humour and the like). Where does it come from?" }) })] }), (0, jsx_runtime_1.jsx)(Button_1.default, { onClick: function () { return setRightIsOpen(!rightIsOpen); }, ml: '24px', children: "Right drawer" }), (0, jsx_runtime_1.jsxs)(_1.Drawer, { shouldCloseOnOverlayClick: true, hasOverlay: true, isOpen: rightIsOpen, onClose: function () { return setRightIsOpen(!rightIsOpen); }, place: 'right', children: [(0, jsx_runtime_1.jsx)(SheetHeader_1.default, { title: 'Sheet header', hasBorder: true, slotRight: (0, jsx_runtime_1.jsx)(ActionButton_1.ActionButton, { variant: 'secondary', onClick: function () { return setRightIsOpen(!rightIsOpen); }, children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faTimes }) }), variant: 'large' }), (0, jsx_runtime_1.jsx)(SheetBody_1.default, { variant: 'large', children: (0, jsx_runtime_1.jsx)(Text_1.default, { children: "Content here" }) })] })] }));
};
exports.Place = Place;
(0, storybook_1.addDescription)(exports.Place, "The placement of the drawer can be controlled with the `place` prop. The possible values are `left` ,  `bottom` and `right`.");
var CustomParent = function () {
    var _a = (0, react_2.useState)(false), isOpen = _a[0], setIsOpen = _a[1];
    return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)("div", { id: 'parent', style: {
                    overflow: 'hidden',
                    position: 'relative',
                    margin: 'auto',
                    width: '400px',
                    height: '600px',
                    border: 'solid',
                } }), (0, jsx_runtime_1.jsx)(Button_1.default, { onClick: function () { return setIsOpen(!isOpen); }, mt: '24px', ml: '35%', children: "Open drawer" }), (0, jsx_runtime_1.jsxs)(_1.Drawer, { shouldCloseOnOverlayClick: true, hasOverlay: true, width: '300px', isOpen: isOpen, onClose: function () { return setIsOpen(!isOpen); }, place: 'right', parentSelector: function () { var _a; return (_a = document.querySelector('#parent')) !== null && _a !== void 0 ? _a : document.body; }, children: [(0, jsx_runtime_1.jsx)(SheetHeader_1.default, { title: 'Sheet header', hasBorder: true, slotRight: (0, jsx_runtime_1.jsx)(ActionButton_1.ActionButton, { variant: 'secondary', onClick: function () { return setIsOpen(!isOpen); }, children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faTimes }) }), variant: 'large' }), (0, jsx_runtime_1.jsx)(SheetBody_1.default, { variant: 'large', css: (0, react_1.css)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n            height: 1500px;\n          "], ["\n            height: 1500px;\n          "]))), children: (0, jsx_runtime_1.jsx)(Text_1.default, { children: "Content here" }) })] })] }));
};
exports.CustomParent = CustomParent;
(0, storybook_1.addDescription)(exports.CustomParent, "A custom parent can be specified to the Drawer. The parent must have styles`position: relative`, `overflow: hidden` ");
var templateObject_1, templateObject_2, templateObject_3;
