"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Drawer = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var styled_1 = __importDefault(require("@emotion/styled"));
var no_scroll_1 = __importDefault(require("no-scroll"));
var react_modal_1 = __importDefault(require("react-modal"));
var styles_1 = require("./styles");
var Component = function (_a) {
    var isOpen = _a.isOpen, onClose = _a.onClose, children = _a.children, className = _a.className, _b = _a.shouldCloseOnOverlayClick, shouldCloseOnOverlayClick = _b === void 0 ? false : _b, shouldReturnFocusAfterClose = _a.shouldReturnFocusAfterClose, _c = _a.hasOverlay, hasOverlay = _c === void 0 ? false : _c, width = _a.width, place = _a.place, parentSelector = _a.parentSelector;
    return ((0, jsx_runtime_1.jsx)(react_1.ClassNames, { children: function (_a) {
            var css = _a.css;
            return ((0, jsx_runtime_1.jsx)(react_modal_1.default, { isOpen: isOpen, ariaHideApp: false, onRequestClose: onClose, shouldCloseOnOverlayClick: shouldCloseOnOverlayClick, shouldReturnFocusAfterClose: shouldReturnFocusAfterClose, onAfterOpen: no_scroll_1.default.on, onAfterClose: no_scroll_1.default.off, closeTimeoutMS: 200, className: {
                    base: className,
                    afterOpen: 'drawer--after-open',
                    beforeClose: 'drawer--before-close',
                }, overlayClassName: (0, styles_1.drawerOverlayStyle)({
                    hasOverlay: hasOverlay,
                    width: width,
                    place: place,
                    parentSelector: parentSelector,
                    css: css,
                }), parentSelector: parentSelector, children: children }));
        } }));
};
/**
 * Drawers are surfaces that contain supplementary content that are anchored to the right or to the bottom of the screen.

  ### Import

  ```
  import Drawer from '@impargo/components/Drawer'
  ```
 */
exports.Drawer = (0, styled_1.default)(Component)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  --width: ", "; \n  --min-width: ", "; \n  \n  --height: ", "; \n  --max-height: ", "; \n  \n  --overflow: ", ";\n\n  --translate-close: ", "; \n  --translate-open: ", "; \n  \n  \n\n  position: absolute;\n  overflow: var(--overflow);\n  background-color: ", ";\n  box-shadow: ", ";\n  display: flex;\n  flex-direction: column;\n\n  width: var(--width);\n  min-width: var(--min-width);\n  height: var(--height);\n  max-height: var(--max-height);\n\n  ", "\n\n  transform: var(--translate-close);\n  transition: opacity 500ms ease-in-out, transform 300ms ease-in-out;\n\n  &.drawer--after-open {\n    opacity: 1;\n    transform: var(--translate-open);\n  }\n  &.drawer--before-close {\n    opacity: 0;\n    transform: var(--translate-close);\n  }\n\n  &&:focus {\n    outline: none;\n  }\n"], ["\n  --width: ", "; \n  --min-width: ", "; \n  \n  --height: ", "; \n  --max-height: ", "; \n  \n  --overflow: ", ";\n\n  --translate-close: ", "; \n  --translate-open: ", "; \n  \n  \n\n  position: absolute;\n  overflow: var(--overflow);\n  background-color: ", ";\n  box-shadow: ", ";\n  display: flex;\n  flex-direction: column;\n\n  width: var(--width);\n  min-width: var(--min-width);\n  height: var(--height);\n  max-height: var(--max-height);\n\n  ", "\n\n  transform: var(--translate-close);\n  transition: opacity 500ms ease-in-out, transform 300ms ease-in-out;\n\n  &.drawer--after-open {\n    opacity: 1;\n    transform: var(--translate-open);\n  }\n  &.drawer--before-close {\n    opacity: 0;\n    transform: var(--translate-close);\n  }\n\n  &&:focus {\n    outline: none;\n  }\n"])), function (_a) {
    var width = _a.width, place = _a.place;
    return width || (place === 'bottom' ? '100vw' : '288px');
}, function (_a) {
    var place = _a.place;
    return place === 'bottom' ? '100vw' : '288px';
}, function (_a) {
    var place = _a.place;
    return place === 'bottom' ? 'auto' : '100%';
}, function (_a) {
    var place = _a.place;
    return place === 'bottom' ? 'calc(100vh - 48px)' : '100%';
}, function (_a) {
    var overflow = _a.overflow;
    return overflow || 'auto';
}, function (_a) {
    var place = _a.place;
    return place === 'bottom'
        ? "translateY(100%)"
        : place === 'right' ? "translateX(100%)" : "translateX(-100%)";
}, function (_a) {
    var place = _a.place;
    return place === 'bottom' ? "translateY(0)" : "translateX(0)";
}, function (_a) {
    var theme = _a.theme;
    return theme.colorSurfaceHc;
}, function (_a) {
    var theme = _a.theme;
    return theme.shadowLarge;
}, function (_a) {
    var place = _a.place;
    switch (place) {
        case 'right':
            return "\n          top: 0;\n          right: 0;\n        ";
        case 'bottom':
            return "\n          bottom: 0;\n          left: 0;\n        ";
        case 'left':
            return "\n          top: 0;\n          left: 0;\n        ";
        default:
            return "\n          top: 0;\n          left: 0;\n        ";
    }
});
exports.default = exports.Drawer;
var templateObject_1;
