"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Dropdown = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var react_2 = require("react");
var Context_1 = require("./Context");
/**
 * The dropdown component displays a list of choices inside a floating surface.
 * The dropdown generally uses three components.
 *
 * - `Toggle` component to open and close the dropdown
 * - `Menu` component to wrap the different items
 * - `ListItem` components to display the actual items
 *
 * The `ListItem` component is configured to behave correctly as a `Dropdown` menu item,
 * simply pass an `onClick` handler to the `ListItem` instantiated under the `Menu` component,
 * and it will also handle closing the menu on click. Refer to [ListItem](https://impargo.github.io/impargo-design-system/?path=/docs/components-data-list-listitem--basic-usage) props for more info.

  ### Import

  ```
  import { Dropdown, Toggle, Menu } from '@impargo/components/Dropdown'
  import ListItem from '@impargo/components/List/ListItem'
  ```
 */
var Dropdown = function (_a) {
    var children = _a.children, pullRight = _a.pullRight, onToggle = _a.onToggle, props = __rest(_a, ["children", "pullRight", "onToggle"]);
    var _b = (0, react_2.useState)(false), toggled = _b[0], setToggled = _b[1];
    var onToggleRef = (0, react_2.useRef)(onToggle);
    onToggleRef.current = onToggle;
    var value = (0, react_2.useMemo)(function () { return ({
        toggled: toggled,
        toggle: function () {
            var _a;
            (_a = onToggleRef.current) === null || _a === void 0 ? void 0 : _a.call(onToggleRef, !toggled);
            setToggled(!toggled);
        },
        isMounted: true,
    }); }, [toggled]);
    return ((0, jsx_runtime_1.jsx)("div", __assign({}, props, { css: (0, react_1.css)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n        position: relative;\n        display: inline-block;\n\n        ", "\n      "], ["\n        position: relative;\n        display: inline-block;\n\n        ", "\n      "])), pullRight && (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n          .dropdown__menu {\n            right: 0px;\n          }\n        "], ["\n          .dropdown__menu {\n            right: 0px;\n          }\n        "])))), onClick: function (e) { return e.stopPropagation(); }, children: (0, jsx_runtime_1.jsx)(Context_1.DropdownContext.Provider, { value: value, children: children }) })));
};
exports.Dropdown = Dropdown;
var templateObject_1, templateObject_2;
