"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AutoPlacement = exports.CustomMenu = exports.Complex = exports.mobileDropDownAsRightDrawer = exports.mobileDropDownAsBottomDrawer = exports.BasicUsage = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var Button_1 = __importDefault(require("@impargo/components/Button"));
var Divider_1 = __importDefault(require("@impargo/components/Divider"));
var Flex_1 = __importDefault(require("@impargo/components/Flex"));
var Icon_1 = __importDefault(require("@impargo/components/Icon"));
var TextInput_1 = require("@impargo/components/Input/TextInput");
var ListItem_1 = __importDefault(require("@impargo/components/List/ListItem"));
var List_1 = __importDefault(require("../List"));
var impargo_1 = __importDefault(require("../Themes/impargo"));
var storybook_1 = require("../utils/storybook");
var Dropdown_1 = require("./Dropdown");
var Menu_1 = require("./Menu");
var Toggle_1 = require("./Toggle");
var theme = impargo_1.default;
var faSave = free_solid_svg_icons_1.faSave;
var faAngleDown = free_solid_svg_icons_1.faAngleDown;
exports.default = {
    title: 'Components/Overlay/Dropdown',
    component: Dropdown_1.Dropdown,
    argTypes: {
        theme: { table: { disable: true } },
    },
    args: {},
};
var BasicUsage = function (args) { return ((0, jsx_runtime_1.jsx)("div", { css: { height: '200px' }, children: (0, jsx_runtime_1.jsxs)(Dropdown_1.Dropdown, __assign({}, args, { children: [(0, jsx_runtime_1.jsx)(Toggle_1.Toggle, { componentClass: function (props) {
                    return (0, jsx_runtime_1.jsx)(Button_1.default, __assign({ slotRight: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faAngleDown }) }, props, { children: "Select an option" }));
                } }), (0, jsx_runtime_1.jsxs)(Menu_1.Menu, { useDrawerOnMobile: true, children: [(0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Edit item', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Share item', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Download', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Import', onClick: function () { return undefined; } })] })] })) })); };
exports.BasicUsage = BasicUsage;
(0, storybook_1.addDescription)(exports.BasicUsage, "A more complex example wil `ListItem` and `Divider` component.");
exports.BasicUsage.args = {};
var mobileDropDownAsBottomDrawer = function (args) { return ((0, jsx_runtime_1.jsx)("div", { css: { height: '200px' }, children: (0, jsx_runtime_1.jsxs)(Dropdown_1.Dropdown, __assign({}, args, { children: [(0, jsx_runtime_1.jsx)(Toggle_1.Toggle, { componentClass: function (props) {
                    return (0, jsx_runtime_1.jsx)(Button_1.default, __assign({ slotRight: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faAngleDown }) }, props, { children: "Select an option" }));
                } }), (0, jsx_runtime_1.jsx)(Menu_1.Menu, { useDrawerOnMobile: true, drawerPlace: 'bottom', children: (0, jsx_runtime_1.jsxs)(List_1.default, { children: [(0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Edit item', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Share item', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Download', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Import', onClick: function () { return undefined; } })] }) })] })) })); };
exports.mobileDropDownAsBottomDrawer = mobileDropDownAsBottomDrawer;
(0, storybook_1.addDescription)(exports.mobileDropDownAsBottomDrawer, "DropDown Menu can be transformed into `Drawer` just by passing `useDrawerOnMobile` prop along side with `drawerPlace = 'bottom'`.");
var mobileDropDownAsRightDrawer = function (args) { return ((0, jsx_runtime_1.jsx)("div", { css: { height: '200px' }, children: (0, jsx_runtime_1.jsxs)(Dropdown_1.Dropdown, __assign({}, args, { children: [(0, jsx_runtime_1.jsx)(Toggle_1.Toggle, { componentClass: function (props) {
                    return (0, jsx_runtime_1.jsx)(Button_1.default, __assign({ slotRight: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faAngleDown }) }, props, { children: "Select an option" }));
                } }), (0, jsx_runtime_1.jsx)(Menu_1.Menu, { useDrawerOnMobile: true, drawerPlace: 'right', children: (0, jsx_runtime_1.jsxs)(List_1.default, { children: [(0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Edit item', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Share item', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Download', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Import', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Edit item', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Share item', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Download', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Import', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Edit item', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Share item', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Download', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Import', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Edit item', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Share item', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Download', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Import', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Download', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Import', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Download', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Import', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Download', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Import', onClick: function () { return undefined; } })] }) })] })) })); };
exports.mobileDropDownAsRightDrawer = mobileDropDownAsRightDrawer;
(0, storybook_1.addDescription)(exports.mobileDropDownAsRightDrawer, "DropDown Menu can be transformed into `Drawer` just by passing `useDrawerOnMobile` prop along side with `drawerPlace = 'right'`.");
var Complex = function () { return ((0, jsx_runtime_1.jsx)("div", { css: { height: '400px' }, children: (0, jsx_runtime_1.jsxs)(Dropdown_1.Dropdown, { children: [(0, jsx_runtime_1.jsx)(Toggle_1.Toggle, { componentClass: function (props) {
                    return (0, jsx_runtime_1.jsx)(Button_1.default, __assign({ slotRight: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faAngleDown }) }, props, { children: "Select an option" }));
                } }), (0, jsx_runtime_1.jsxs)(Menu_1.Menu, { children: [(0, jsx_runtime_1.jsx)(ListItem_1.default, { hasBorder: false, slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { size: 's', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSave }) }), label: 'Save item', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(Divider_1.default, {}), (0, jsx_runtime_1.jsx)(ListItem_1.default, { subtitle: true, label: 'white space' }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { hasBorder: false, label: 'Long label with white space set to `nowrap` so the label will not wrap', whiteSpace: 'nowrap', slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { size: 's', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSave }) }), onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { hasBorder: false, label: 'Label with default white space prop passed to the list item component so the label will wrap', slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { size: 's', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSave }) }), onClick: function () { return undefined; }, slotLeftAlign: 'flex-start' }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { subtitle: true, label: 'Slots and secondary labels' }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { hasBorder: false, label: 'Download', slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { size: 's', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSave }) }), slotRight: 'crtl+D', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { hasBorder: false, label: 'Download', slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { size: 's', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSave }) }), secondaryLabel: 'PDF, CSV', onClick: function () { return undefined; }, slotLeftAlign: 'flex-start' })] })] }) })); };
exports.Complex = Complex;
(0, storybook_1.addDescription)(exports.Complex, "A more complex example wil `ListItem` and `Divider` component.");
var CustomMenu = function () { return ((0, jsx_runtime_1.jsx)("div", { css: {
        height: '240px',
    }, children: (0, jsx_runtime_1.jsxs)(Dropdown_1.Dropdown, { children: [(0, jsx_runtime_1.jsx)(Toggle_1.Toggle, { componentClass: function (props) {
                    return (0, jsx_runtime_1.jsx)(Button_1.default, __assign({ slotRight: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faAngleDown }) }, props, { children: "Select an option" }));
                } }), (0, jsx_runtime_1.jsxs)(Menu_1.Menu, { children: [(0, jsx_runtime_1.jsx)(Flex_1.default, { py: theme.spacingSmall, px: theme.spacingSmall, children: (0, jsx_runtime_1.jsx)(TextInput_1.TextInput, { placeholder: 'Search people...', smallLabel: true, label: '', value: '', css: (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n              width: 100%;\n              &&& .field__container {\n                padding: 0;\n              }\n            "], ["\n              width: 100%;\n              &&& .field__container {\n                padding: 0;\n              }\n            "]))) }) }), (0, jsx_runtime_1.jsx)(Divider_1.default, {}), (0, jsx_runtime_1.jsx)(ListItem_1.default, { onClick: function () { return null; }, label: 'John Doe', slotLeftAlign: 'center', labelAlign: 'center', badgeAlign: 'center', slotLeft: (0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n                width: 40px;\n                height: 40px;\n                background-color: ", ";\n                border-radius: ", ";\n              "], ["\n                width: 40px;\n                height: 40px;\n                background-color: ", ";\n                border-radius: ", ";\n              "])), theme.colorSurfaceLc, theme.borderRadiusCircular) }) }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { onClick: function () { return null; }, label: 'John Doe', slotLeftAlign: 'center', labelAlign: 'center', badgeAlign: 'center', slotLeft: (0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n                width: 40px;\n                height: 40px;\n                background-color: ", ";\n                border-radius: ", ";\n              "], ["\n                width: 40px;\n                height: 40px;\n                background-color: ", ";\n                border-radius: ", ";\n              "])), theme.colorSurfaceLc, theme.borderRadiusCircular) }) })] })] }) })); };
exports.CustomMenu = CustomMenu;
(0, storybook_1.addDescription)(exports.CustomMenu, "Other elements can be added inside the `Menu` component to crete a more complex dropdown.");
var AutoPlacement = function () { return ((0, jsx_runtime_1.jsxs)(Flex_1.default, { gap: 'massive', direction: 'column', children: [(0, jsx_runtime_1.jsxs)(Flex_1.default, { gap: 'massive', justify: 'space-between', children: [(0, jsx_runtime_1.jsxs)(Dropdown_1.Dropdown, { children: [(0, jsx_runtime_1.jsx)(Toggle_1.Toggle, { componentClass: function (props) {
                                return (0, jsx_runtime_1.jsx)(Button_1.default, __assign({ slotRight: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faAngleDown }) }, props, { children: "Select an option" }));
                            } }), (0, jsx_runtime_1.jsxs)(Menu_1.Menu, { useDrawerOnMobile: true, children: [(0, jsx_runtime_1.jsx)(ListItem_1.default, { hasBorder: false, slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { size: 's', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSave }) }), label: 'Save item', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { hasBorder: false, slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { size: 's', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSave }) }), label: 'Save item', onClick: function () { return undefined; } })] })] }), (0, jsx_runtime_1.jsxs)(Dropdown_1.Dropdown, { children: [(0, jsx_runtime_1.jsx)(Toggle_1.Toggle, { componentClass: function (props) {
                                return (0, jsx_runtime_1.jsx)(Button_1.default, __assign({ slotRight: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faAngleDown }) }, props, { children: "Select an option" }));
                            } }), (0, jsx_runtime_1.jsxs)(Menu_1.Menu, { useDrawerOnMobile: true, children: [(0, jsx_runtime_1.jsx)(ListItem_1.default, { hasBorder: false, slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { size: 's', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSave }) }), label: 'Save item', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { hasBorder: false, slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { size: 's', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSave }) }), label: 'Save item', onClick: function () { return undefined; } })] })] })] }), (0, jsx_runtime_1.jsxs)(Flex_1.default, { gap: 'massive', justify: 'space-between', children: [(0, jsx_runtime_1.jsxs)(Dropdown_1.Dropdown, { children: [(0, jsx_runtime_1.jsx)(Toggle_1.Toggle, { componentClass: function (props) {
                                return (0, jsx_runtime_1.jsx)(Button_1.default, __assign({ slotRight: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faAngleDown }) }, props, { children: "Select an option" }));
                            } }), (0, jsx_runtime_1.jsxs)(Menu_1.Menu, { useDrawerOnMobile: true, children: [(0, jsx_runtime_1.jsx)(ListItem_1.default, { hasBorder: false, slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { size: 's', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSave }) }), label: 'Save item', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { hasBorder: false, slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { size: 's', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSave }) }), label: 'Save item', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { hasBorder: false, slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { size: 's', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSave }) }), label: 'Save item', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { hasBorder: false, slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { size: 's', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSave }) }), label: 'Save item', onClick: function () { return undefined; } })] })] }), (0, jsx_runtime_1.jsxs)(Dropdown_1.Dropdown, { children: [(0, jsx_runtime_1.jsx)(Toggle_1.Toggle, { componentClass: function (props) {
                                return (0, jsx_runtime_1.jsx)(Button_1.default, __assign({ slotRight: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faAngleDown }) }, props, { children: "Select an option" }));
                            } }), (0, jsx_runtime_1.jsxs)(Menu_1.Menu, { useDrawerOnMobile: true, children: [(0, jsx_runtime_1.jsx)(ListItem_1.default, { hasBorder: false, slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { size: 's', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSave }) }), label: 'Save item', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { hasBorder: false, slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { size: 's', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSave }) }), label: 'Save item', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { hasBorder: false, slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { size: 's', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSave }) }), label: 'Save item', onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.default, { hasBorder: false, slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { size: 's', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSave }) }), label: 'Save item', onClick: function () { return undefined; } })] })] })] })] })); };
exports.AutoPlacement = AutoPlacement;
(0, storybook_1.addDescription)(exports.AutoPlacement, "The dropdown component will open to the top or bottom, right or left, based on it's location compared to the window. `Note:` resize the screen so that the bottom dropdowns open to the top or to the left.");
var templateObject_1, templateObject_2, templateObject_3;
