import { FC } from 'react';
import { DrawerPlace } from '../Drawer';
import { PositionMode } from './useSmartPlacement';
export interface MenuProps extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLDivElement>, HTMLDivElement> {
    /**
     * If true and the window width is less than `breakpointMobile`,
     * it will render the menu as a `Drawer` instead of a dropdown.
     * @default false
     */
    useDrawerOnMobile?: boolean;
    /**
      * Sets the position of the drawer menu, either bottom or right.
      * @default bottom
      */
    drawerPlace?: DrawerPlace;
    /**
      * Sets the position of the drawer menu, either to be default or fixed, used to handle the overflow of the menu.
      * Set to `fixed` to avoid overflow issues in restrained containers.
      * @default default
      */
    positionMode?: PositionMode;
}
/**
 * Wrapper component to render the elements of a dropdown (e.g. `ListItem`s).
 */
export declare const Menu: FC<MenuProps>;
//# sourceMappingURL=Menu.d.ts.map