"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Menu = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var react_2 = require("react");
var react_dom_1 = require("react-dom");
var Drawer_1 = __importDefault(require("../Drawer"));
var Context_1 = require("./Context");
var useOutsideParentClick_1 = require("./useOutsideParentClick");
var useSmartPlacement_1 = require("./useSmartPlacement");
/**
 * Wrapper component to render the elements of a dropdown (e.g. `ListItem`s).
 */
var Menu = function (_a) {
    var _b;
    var children = _a.children, _c = _a.useDrawerOnMobile, useDrawerOnMobile = _c === void 0 ? false : _c, _d = _a.drawerPlace, drawerPlace = _d === void 0 ? 'bottom' : _d, _e = _a.positionMode, positionMode = _e === void 0 ? 'default' : _e, props = __rest(_a, ["children", "useDrawerOnMobile", "drawerPlace", "positionMode"]);
    var theme = (0, react_1.useTheme)();
    var _f = (0, react_2.useContext)(Context_1.DropdownContext), toggled = _f.toggled, toggle = _f.toggle;
    var useDrawer = useDrawerOnMobile && window.innerWidth <= 479;
    var floatingRef = (0, react_2.useRef)(null);
    var anchorRef = (0, react_2.useRef)(null);
    (0, useOutsideParentClick_1.useOutsideParentClick)(function () {
        if (toggled) {
            toggle();
        }
    }, floatingRef, anchorRef);
    (0, useSmartPlacement_1.useSmartPlacement)(floatingRef, positionMode === 'default' ? floatingRef : anchorRef, positionMode, [toggled]);
    if (useDrawer) {
        return ((0, jsx_runtime_1.jsx)(Drawer_1.default, __assign({ isOpen: toggled, place: drawerPlace, hasOverlay: true, shouldCloseOnOverlayClick: true, onClose: function () { return toggle(); }, css: (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n          padding: ", " 0;\n        "], ["\n          padding: ", " 0;\n        "])), theme.spacingSmall), overflow: 'auto' }, props, { children: children })));
    }
    if (!toggled) {
        return null;
    }
    var menu = (0, jsx_runtime_1.jsx)("div", __assign({}, props, { ref: floatingRef, css: function (theme) { return (0, react_1.css)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n    display: block;\n    background-color: ", ";\n    box-shadow: ", ";\n    padding: ", " 0;\n    position: ", ";\n    min-width: 200px;\n    // Below tooltips, above everything else\n    z-index: 999;\n    border-radius: ", ";\n    @keyframes animate-open {\n      from {\n        visibility: hidden;\n        transform: translateY(-4px);\n        opacity: 0;\n      }\n      to {\n        visibility: visible;\n        transform: translateY(0);\n        opacity: 1;\n      }\n    }        \n    animation: animate-open .2s;\n    .divider-component {\n      margin: ", " 0px;\n    }\n  "], ["\n    display: block;\n    background-color: ", ";\n    box-shadow: ", ";\n    padding: ", " 0;\n    position: ", ";\n    min-width: 200px;\n    // Below tooltips, above everything else\n    z-index: 999;\n    border-radius: ", ";\n    @keyframes animate-open {\n      from {\n        visibility: hidden;\n        transform: translateY(-4px);\n        opacity: 0;\n      }\n      to {\n        visibility: visible;\n        transform: translateY(0);\n        opacity: 1;\n      }\n    }        \n    animation: animate-open .2s;\n    .divider-component {\n      margin: ", " 0px;\n    }\n  "])), theme.colorSurfaceHc, theme.shadowMedium, theme.spacingSmall, positionMode === 'default' ? 'absolute' : 'fixed', theme.borderRadius, theme.spacingSmall); }, className: "dropdown__menu ".concat((_b = props.className) !== null && _b !== void 0 ? _b : ''), children: children }));
    if (positionMode === 'default') {
        return menu;
    }
    return ((0, jsx_runtime_1.jsx)("span", { ref: anchorRef, children: (0, react_dom_1.createPortal)(menu, document.body) }));
};
exports.Menu = Menu;
var templateObject_1, templateObject_2;
