import { FC, ReactElement } from 'react';
import { ButtonProps } from '../Button';
export interface ToggleProps extends Partial<ButtonProps> {
    /**
     * A custom element for the toggle.
     * @default Button
     */
    componentClass?: ({ onClick }: {
        onClick: () => void;
    }) => ReactElement;
}
/**
 * Component to open and close a `Dropdown`.
 *
 * If using the default `componentClass` Button,
 * any props you pass will be directly passed to the underlying `Button`.
 */
export declare const Toggle: FC<ToggleProps>;
//# sourceMappingURL=Toggle.d.ts.map