"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useOutsideParentClick = void 0;
var react_1 = require("react");
var useOutsideParentClick = function (onClickOutside, floatingRef, anchorRef) {
    var clickOutsideRef = (0, react_1.useRef)(onClickOutside);
    clickOutsideRef.current = onClickOutside;
    (0, react_1.useEffect)(function () {
        var handleClickOutside = function (event) {
            var _a;
            var parentElement = anchorRef.current
                ? anchorRef === null || anchorRef === void 0 ? void 0 : anchorRef.current.parentElement
                : (_a = floatingRef.current) === null || _a === void 0 ? void 0 : _a.parentElement;
            var floatingElement = floatingRef.current;
            if (!parentElement || !floatingElement) {
                return;
            }
            var target = event.target;
            if (parentElement.contains(target) || floatingElement.contains(target)) {
                return;
            }
            clickOutsideRef.current();
        };
        document.addEventListener('mousedown', handleClickOutside);
        document.addEventListener('touchstart', handleClickOutside);
        return function () {
            document.removeEventListener('mousedown', handleClickOutside);
            document.removeEventListener('touchstart', handleClickOutside);
        };
    }, [floatingRef, anchorRef]);
};
exports.useOutsideParentClick = useOutsideParentClick;
