"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSmartPlacement = void 0;
var dom_1 = require("@floating-ui/dom");
var react_1 = require("react");
var useSmartPlacement = function (ref, anchorElementRef, positionMode, deps) {
    (0, react_1.useLayoutEffect)(function () {
        var _a;
        var element = ref.current;
        if (!element) {
            return;
        }
        var parent = (_a = anchorElementRef.current) === null || _a === void 0 ? void 0 : _a.parentElement;
        if (!parent) {
            return;
        }
        var reassess = function () {
            var parentRect = parent.getBoundingClientRect();
            var rect = element.getBoundingClientRect();
            var windowWidth = window.innerWidth;
            var windowHeight = window.innerHeight;
            var hasSpaceDown = windowHeight - (parentRect.bottom + rect.height) > 0;
            var hasSpaceUp = parentRect.top - rect.height > 0;
            var hasSpaceRight = windowWidth - (parentRect.right + rect.width) > 0;
            var hasSpaceLeft = parentRect.left - rect.width > 0;
            if (positionMode === 'fixed') {
                (0, dom_1.computePosition)(parent, element, {
                    strategy: 'fixed',
                    placement: "".concat(!hasSpaceDown && hasSpaceUp ? 'top' : 'bottom', "-").concat(!hasSpaceRight && hasSpaceLeft ? 'end' : 'start'),
                    middleware: [(0, dom_1.hide)()],
                }).then(function (_a) {
                    var _b;
                    var x = _a.x, y = _a.y, middlewareData = _a.middlewareData;
                    element.style.transition = 'opacity 200ms';
                    element.style.opacity = ((_b = middlewareData.hide) === null || _b === void 0 ? void 0 : _b.referenceHidden) ? '0' : '1';
                    element.style.left = "".concat(x, "px");
                    element.style.top = "".concat(y, "px");
                });
            }
            else {
                element.style.right = !hasSpaceRight && hasSpaceLeft ? '0px' : 'auto';
                element.style.bottom = !hasSpaceDown && hasSpaceUp ? '100%' : 'auto';
            }
        };
        return (0, dom_1.autoUpdate)(parent, element, reassess);
    }, __spreadArray([ref.current, anchorElementRef.current, positionMode], (deps !== null && deps !== void 0 ? deps : []), true));
};
exports.useSmartPlacement = useSmartPlacement;
