import { TagProps } from '../Tag';
export interface FeatureIndicatorProps extends Omit<TagProps, 'variant'> {
    /**
     * Class name assigned to the component. Should be used sparingly.
     */
    className?: string;
    /**
     * Sets the type of the tier indicator.
     * @default beta
     */
    type?: 'beta' | 'new';
    /**
     * Sets the type of the tier indicator.
     * @default primary
     */
    variant?: 'primary' | 'secondary';
    /**
     * Text displayed inside the tag component.
     */
    label: string;
}
/**
 *  Specialized tag to indicate if the feature is in Beta stage or when a new feature is new.
 *  Additionally, accepts all props from `Tag` component.

  ### Import

  ```
  import FeatureIndicator from '@impargo/components/FeatureIndicator'
  ```
 */
export declare const FeatureIndicator: import("@emotion/styled").StyledComponent<FeatureIndicatorProps & {
    theme?: import("@emotion/react").Theme | undefined;
}, {}, {}>;
export default FeatureIndicator;
//# sourceMappingURL=index.d.ts.map