"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FeatureIndicator = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var styled_1 = __importDefault(require("@emotion/styled"));
var Tag_1 = __importDefault(require("../Tag"));
var Component = function (_a) {
    var className = _a.className, _b = _a.type, type = _b === void 0 ? 'beta' : _b, _c = _a.variant, variant = _c === void 0 ? 'primary' : _c, label = _a.label, rest = __rest(_a, ["className", "type", "variant", "label"]);
    var theme = (0, react_1.useTheme)();
    var bgColorTypeVariantRecord = {
        'beta': {
            'primary': theme.colorPrimary,
            'secondary': theme.colorRed,
        },
        'new': {
            'primary': theme.colorRedLight2,
            'secondary': theme.colorRed,
        },
    };
    var betaColorTypeVariantRecord = {
        'beta': {
            'primary': theme.colorText,
            'secondary': theme.colorTextInverse,
        },
        'new': {
            'primary': theme.colorTextDanger,
            'secondary': theme.colorTextInverse,
        },
    };
    var bgColorVariant = bgColorTypeVariantRecord[type][variant];
    var colorVariant = betaColorTypeVariantRecord[type][variant];
    return ((0, jsx_runtime_1.jsx)(Tag_1.default, __assign({ className: className, size: 's', bgColor: bgColorVariant, color: colorVariant, label: label }, rest)));
};
/**
 *  Specialized tag to indicate if the feature is in Beta stage or when a new feature is new.
 *  Additionally, accepts all props from `Tag` component.

  ### Import

  ```
  import FeatureIndicator from '@impargo/components/FeatureIndicator'
  ```
 */
exports.FeatureIndicator = (0, styled_1.default)(Component)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  ", "\n"], ["\n  ", "\n"])), function (_a) {
    var tooltip = _a["data-tooltip-content"];
    return tooltip && (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n    &:hover {\n      cursor: help;\n    }\n  "], ["\n    &:hover {\n      cursor: help;\n    }\n  "])));
});
exports.default = exports.FeatureIndicator;
var templateObject_1, templateObject_2;
