"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Wrap = exports.Alignment = exports.Gap = exports.Direction = exports.BasicUsage = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var Button_1 = __importDefault(require("@impargo/components/Button"));
var index_1 = __importDefault(require("@impargo/components/Sheet/index"));
var Text_1 = __importDefault(require("@impargo/components/Text"));
var impargo_1 = __importDefault(require("../Themes/impargo"));
var storybook_1 = require("../utils/storybook");
var _1 = require(".");
var theme = impargo_1.default;
exports.default = {
    title: 'Components/Layout/Flex',
    component: _1.Flex,
};
var BasicUsage = function (args) { return ((0, jsx_runtime_1.jsxs)(_1.Flex, __assign({}, args, { children: [(0, jsx_runtime_1.jsx)(_1.Flex, { children: (0, jsx_runtime_1.jsx)(Button_1.default, { children: "1" }) }), (0, jsx_runtime_1.jsx)(_1.Flex, { children: (0, jsx_runtime_1.jsx)(Button_1.default, { children: "2" }) }), (0, jsx_runtime_1.jsx)(_1.Flex, { children: (0, jsx_runtime_1.jsx)(Button_1.default, { children: "3" }) })] }))); };
exports.BasicUsage = BasicUsage;
exports.BasicUsage.args = {
    gap: 'small',
};
var Direction = function () { return ((0, jsx_runtime_1.jsxs)(_1.Flex, { direction: 'column', gap: 'medium', children: [(0, jsx_runtime_1.jsx)(index_1.default, { variant: 'medium', children: (0, jsx_runtime_1.jsxs)(_1.Flex, { gap: 'medium', direction: 'column', children: [(0, jsx_runtime_1.jsx)(Text_1.default, { bold: true, children: "Row" }), (0, jsx_runtime_1.jsxs)(_1.Flex, { direction: 'row', gap: 'small', children: [(0, jsx_runtime_1.jsx)(Button_1.default, { children: "1" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "2" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "3" })] })] }) }), (0, jsx_runtime_1.jsx)(index_1.default, { variant: 'medium', children: (0, jsx_runtime_1.jsxs)(_1.Flex, { gap: 'medium', direction: 'column', children: [(0, jsx_runtime_1.jsx)(Text_1.default, { bold: true, children: "Column" }), (0, jsx_runtime_1.jsxs)(_1.Flex, { direction: 'column', gap: 'small', children: [(0, jsx_runtime_1.jsx)(Button_1.default, { children: "1" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "2" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "3" })] })] }) })] })); };
exports.Direction = Direction;
(0, storybook_1.addDescription)(exports.Direction, "The `Flex` component accommodates different layouts with the `direction` prop. ");
var Gap = function () { return ((0, jsx_runtime_1.jsxs)(_1.Flex, { direction: 'column', gap: 'medium', children: [(0, jsx_runtime_1.jsx)(index_1.default, { variant: 'medium', children: (0, jsx_runtime_1.jsxs)(_1.Flex, { direction: 'column', gap: 'medium', children: [(0, jsx_runtime_1.jsx)(Text_1.default, { bold: true, children: "Small" }), (0, jsx_runtime_1.jsxs)(_1.Flex, { direction: 'row', gap: 'small', children: [(0, jsx_runtime_1.jsx)(Button_1.default, { children: "1" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "2" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "3" })] })] }) }), (0, jsx_runtime_1.jsx)(index_1.default, { variant: 'medium', children: (0, jsx_runtime_1.jsxs)(_1.Flex, { direction: 'column', gap: 'medium', children: [(0, jsx_runtime_1.jsx)(Text_1.default, { bold: true, children: "Medium" }), (0, jsx_runtime_1.jsxs)(_1.Flex, { direction: 'row', gap: 'medium', children: [(0, jsx_runtime_1.jsx)(Button_1.default, { children: "1" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "2" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "3" })] })] }) }), (0, jsx_runtime_1.jsx)(index_1.default, { variant: 'medium', children: (0, jsx_runtime_1.jsxs)(_1.Flex, { direction: 'column', gap: 'medium', children: [(0, jsx_runtime_1.jsx)(Text_1.default, { bold: true, children: "Large" }), (0, jsx_runtime_1.jsxs)(_1.Flex, { direction: 'row', gap: 'large', children: [(0, jsx_runtime_1.jsx)(Button_1.default, { children: "1" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "2" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "3" })] })] }) })] })); };
exports.Gap = Gap;
(0, storybook_1.addDescription)(exports.Gap, "With the `gap` prop we can space the items inside of the `Flex` component. ");
var Alignment = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsxs)(_1.Flex, { direction: 'row', gap: 'medium', justify: 'space-between', children: [(0, jsx_runtime_1.jsx)(index_1.default, { variant: 'medium', css: (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n          margin-top: ", ";\n          height: 400px;\n          width: min-content;\n        "], ["\n          margin-top: ", ";\n          height: 400px;\n          width: min-content;\n        "])), theme.spacingMedium), children: (0, jsx_runtime_1.jsxs)(_1.Flex, { height: '100%', direction: 'column', gap: 'medium', children: [(0, jsx_runtime_1.jsx)(Text_1.default, { bold: true, children: "Row" }), (0, jsx_runtime_1.jsxs)(_1.Flex, { direction: 'row', gap: 'medium', children: [(0, jsx_runtime_1.jsx)(Button_1.default, { children: "1" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "2" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "3" })] })] }) }), (0, jsx_runtime_1.jsx)(index_1.default, { variant: 'medium', css: (0, react_1.css)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n          margin-top: ", ";\n          height: 400px;\n          width: min-content;\n        "], ["\n          margin-top: ", ";\n          height: 400px;\n          width: min-content;\n        "])), theme.spacingMedium), children: (0, jsx_runtime_1.jsxs)(_1.Flex, { height: '100%', direction: 'column', gap: 'medium', children: [(0, jsx_runtime_1.jsx)(Text_1.default, { bold: true, children: "Row" }), (0, jsx_runtime_1.jsxs)(_1.Flex, { direction: 'row', gap: 'medium', alignItems: 'center', height: '100%', children: [(0, jsx_runtime_1.jsx)(Button_1.default, { children: "1" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "2" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "3" })] })] }) }), (0, jsx_runtime_1.jsx)(index_1.default, { variant: 'medium', css: (0, react_1.css)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n          margin-top: ", ";\n          height: 400px;\n          width: min-content;\n        "], ["\n          margin-top: ", ";\n          height: 400px;\n          width: min-content;\n        "])), theme.spacingMedium), children: (0, jsx_runtime_1.jsxs)(_1.Flex, { height: '100%', direction: 'column', gap: 'medium', children: [(0, jsx_runtime_1.jsx)(Text_1.default, { bold: true, children: "Row" }), (0, jsx_runtime_1.jsxs)(_1.Flex, { direction: 'row', gap: 'medium', alignItems: 'flex-end', height: '100%', children: [(0, jsx_runtime_1.jsx)(Button_1.default, { children: "1" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "2" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "3" })] })] }) }), (0, jsx_runtime_1.jsx)(index_1.default, { variant: 'medium', css: (0, react_1.css)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n          margin-top: ", ";\n          height: 400px;\n          width: min-content;\n        "], ["\n          margin-top: ", ";\n          height: 400px;\n          width: min-content;\n        "])), theme.spacingMedium), children: (0, jsx_runtime_1.jsxs)(_1.Flex, { height: '100%', direction: 'column', gap: 'medium', children: [(0, jsx_runtime_1.jsx)(Text_1.default, { bold: true, children: "Row" }), (0, jsx_runtime_1.jsxs)(_1.Flex, { direction: 'row', gap: 'medium', alignItems: 'flex-start', height: '100%', children: [(0, jsx_runtime_1.jsx)(_1.Flex, { children: (0, jsx_runtime_1.jsx)(Button_1.default, { children: "1" }) }), (0, jsx_runtime_1.jsx)(_1.Flex, { alignSelf: 'center', children: (0, jsx_runtime_1.jsx)(Button_1.default, { children: "2" }) }), (0, jsx_runtime_1.jsx)(_1.Flex, { alignSelf: 'flex-end', children: (0, jsx_runtime_1.jsx)(Button_1.default, { children: "3" }) })] })] }) })] }), (0, jsx_runtime_1.jsxs)(_1.Flex, { gap: 'medium', children: [(0, jsx_runtime_1.jsx)(index_1.default, { variant: 'medium', css: (0, react_1.css)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n          margin-top: ", ";\n          width: 100%;\n        "], ["\n          margin-top: ", ";\n          width: 100%;\n        "])), theme.spacingMedium), children: (0, jsx_runtime_1.jsxs)(_1.Flex, { height: '100%', direction: 'column', gap: 'medium', children: [(0, jsx_runtime_1.jsx)(Text_1.default, { bold: true, children: "Column" }), (0, jsx_runtime_1.jsxs)(_1.Flex, { direction: 'column', gap: 'medium', children: [(0, jsx_runtime_1.jsx)(Button_1.default, { children: "1" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "2" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "3" })] })] }) }), (0, jsx_runtime_1.jsx)(index_1.default, { variant: 'medium', css: (0, react_1.css)(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n          margin-top: ", ";\n          width: 100%;\n        "], ["\n          margin-top: ", ";\n          width: 100%;\n        "])), theme.spacingMedium), children: (0, jsx_runtime_1.jsxs)(_1.Flex, { height: '100%', direction: 'column', gap: 'medium', children: [(0, jsx_runtime_1.jsx)(Text_1.default, { bold: true, children: "Column" }), (0, jsx_runtime_1.jsxs)(_1.Flex, { direction: 'column', gap: 'medium', alignItems: 'center', children: [(0, jsx_runtime_1.jsx)(Button_1.default, { children: "1" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "2" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "3" })] })] }) }), (0, jsx_runtime_1.jsx)(index_1.default, { variant: 'medium', css: (0, react_1.css)(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n          margin-top: ", ";\n          width: 100%;\n        "], ["\n          margin-top: ", ";\n          width: 100%;\n        "])), theme.spacingMedium), children: (0, jsx_runtime_1.jsxs)(_1.Flex, { height: '100%', direction: 'column', gap: 'medium', children: [(0, jsx_runtime_1.jsx)(Text_1.default, { bold: true, children: "Column" }), (0, jsx_runtime_1.jsxs)(_1.Flex, { direction: 'column', gap: 'medium', alignItems: 'flex-end', children: [(0, jsx_runtime_1.jsx)(Button_1.default, { children: "1" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "2" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "3" })] })] }) }), (0, jsx_runtime_1.jsx)(index_1.default, { variant: 'medium', css: (0, react_1.css)(templateObject_8 || (templateObject_8 = __makeTemplateObject(["\n          margin-top: ", ";\n          width: 100%;\n        "], ["\n          margin-top: ", ";\n          width: 100%;\n        "])), theme.spacingMedium), children: (0, jsx_runtime_1.jsxs)(_1.Flex, { height: '100%', direction: 'column', gap: 'medium', children: [(0, jsx_runtime_1.jsx)(Text_1.default, { bold: true, children: "Column" }), (0, jsx_runtime_1.jsxs)(_1.Flex, { direction: 'column', gap: 'medium', alignItems: 'flex-end', children: [(0, jsx_runtime_1.jsx)(_1.Flex, { children: (0, jsx_runtime_1.jsx)(Button_1.default, { children: "1" }) }), (0, jsx_runtime_1.jsx)(_1.Flex, { order: 3, children: (0, jsx_runtime_1.jsx)(Button_1.default, { children: "2" }) }), (0, jsx_runtime_1.jsx)(_1.Flex, { mr: 'auto', order: 2, children: (0, jsx_runtime_1.jsx)(Button_1.default, { children: "3" }) })] })] }) })] })] })); };
exports.Alignment = Alignment;
(0, storybook_1.addDescription)(exports.Alignment, "Aligning elements inside the `Flex` is done via the `justify`, `alignItems`, `alignContent`, `order`. ");
var Wrap = function () { return ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: (0, jsx_runtime_1.jsx)(index_1.default, { variant: 'medium', css: (0, react_1.css)(templateObject_9 || (templateObject_9 = __makeTemplateObject(["\n        width: 200px;\n        max-width: 200px;\n      "], ["\n        width: 200px;\n        max-width: 200px;\n      "]))), children: (0, jsx_runtime_1.jsxs)(_1.Flex, { direction: 'column', gap: 'xlarge', children: [(0, jsx_runtime_1.jsx)(Text_1.default, { bold: true, children: "Row" }), (0, jsx_runtime_1.jsxs)(_1.Flex, { direction: 'row', gap: 'small', wrap: true, children: [(0, jsx_runtime_1.jsx)(Button_1.default, { children: "1" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "2" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "3" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "4" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "5" })] }), (0, jsx_runtime_1.jsxs)(_1.Flex, { direction: 'row', gap: 'medium', wrap: true, children: [(0, jsx_runtime_1.jsx)(Button_1.default, { children: "1" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "2" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "3" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "4" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "5" })] }), (0, jsx_runtime_1.jsxs)(_1.Flex, { direction: 'row', gap: 'large', wrap: true, children: [(0, jsx_runtime_1.jsx)(Button_1.default, { children: "1" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "2" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "3" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "4" }), (0, jsx_runtime_1.jsx)(Button_1.default, { children: "5" })] })] }) }) })); };
exports.Wrap = Wrap;
(0, storybook_1.addDescription)(exports.Wrap, "Using the `wrap` property will make elements inside the `Flex` component wrap into a new line.");
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8, templateObject_9;
