"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Flex = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
/**
 * The `Flex` component can be used for flex layouts, specially when we want the same spacing between components (see `gap` prop).

  ### Import

  ```
  import Flex from '@impargo/components/Flex'
  ```
 */
var Flex = function (_a) {
    var className = _a.className, children = _a.children, _b = _a.height, height = _b === void 0 ? 'auto' : _b, _c = _a.direction, direction = _c === void 0 ? 'row' : _c, width = _a.width, wrap = _a.wrap, flex = _a.flex, _d = _a.justify, justify = _d === void 0 ? 'flex-start' : _d, _e = _a.alignItems, alignItems = _e === void 0 ? 'stretch' : _e, alignContent = _a.alignContent, alignSelf = _a.alignSelf, order = _a.order, _f = _a.gap, gap = _f === void 0 ? '0' : _f, dataTestid = _a["data-testid"], mt = _a.mt, mr = _a.mr, mb = _a.mb, ml = _a.ml, mx = _a.mx, my = _a.my, pt = _a.pt, pr = _a.pr, pb = _a.pb, pl = _a.pl, px = _a.px, py = _a.py, onClick = _a.onClick, rest = __rest(_a, ["className", "children", "height", "direction", "width", "wrap", "flex", "justify", "alignItems", "alignContent", "alignSelf", "order", "gap", 'data-testid', "mt", "mr", "mb", "ml", "mx", "my", "pt", "pr", "pb", "pl", "px", "py", "onClick"]);
    var theme = (0, react_1.useTheme)();
    var gapMap = {
        '0': theme.spacingZero,
        'tiny': theme.spacingTiny,
        'xsmall': theme.spacingXSmall,
        'small': theme.spacingSmall,
        'medium': theme.spacingMedium,
        'large': theme.spacingLarge,
        'xlarge': theme.spacingXLarge,
        'xxlarge': theme.spacingXxLarge,
        'xxxlarge': theme.spacingXxxLarge,
        'huge': theme.spacingHuge,
        'massive': theme.spacingMassive,
    };
    return ((0, jsx_runtime_1.jsx)("div", __assign({ className: className, "data-testid": dataTestid, css: (0, react_1.css)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n        --gap: ", ";\n\n\n        display: flex;\n        flex-direction: ", ";\n        flex-wrap: ", ";\n        height: ", ";\n        width: ", ";\n        flex: ", ";\n        justify-content: ", ";\n        align-items: ", ";\n        align-content: ", ";\n        align-self: ", ";\n        flex: ", ";\n        order: ", ";\n\n        /* gap */\n        gap: var(--gap);\n\n        /* spacing */\n        ", "\n        ", "\n        ", "\n        ", "\n\n        margin-top: ", ";\n        margin-right: ", ";\n        margin-bottom: ", ";\n        margin-left: ", ";\n\n        padding-top: ", ";\n        padding-right: ", ";\n        padding-bottom: ", ";\n        padding-left: ", ";\n      "], ["\n        --gap: ", ";\n\n\n        display: flex;\n        flex-direction: ", ";\n        flex-wrap: ", ";\n        height: ", ";\n        width: ", ";\n        flex: ", ";\n        justify-content: ", ";\n        align-items: ", ";\n        align-content: ", ";\n        align-self: ", ";\n        flex: ", ";\n        order: ", ";\n\n        /* gap */\n        gap: var(--gap);\n\n        /* spacing */\n        ", "\n        ", "\n        ", "\n        ", "\n\n        margin-top: ", ";\n        margin-right: ", ";\n        margin-bottom: ", ";\n        margin-left: ", ";\n\n        padding-top: ", ";\n        padding-right: ", ";\n        padding-bottom: ", ";\n        padding-left: ", ";\n      "])), gapMap[gap], direction, wrap && 'wrap', height, width && width, flex && flex, justify, alignItems, alignContent && alignContent, alignSelf, flex && flex, order && order, py && (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n          padding-top: ", ";\n          padding-bottom: ", ";\n        "], ["\n          padding-top: ", ";\n          padding-bottom: ", ";\n        "])), py, py), px && (0, react_1.css)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n          padding-right: ", ";\n          padding-left: ", ";\n        "], ["\n          padding-right: ", ";\n          padding-left: ", ";\n        "])), px, px), my && (0, react_1.css)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n          margin-top: ", ";\n          margin-bottom: ", ";\n        "], ["\n          margin-top: ", ";\n          margin-bottom: ", ";\n        "])), my, my), mx && (0, react_1.css)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n          margin-right: ", ";\n          margin-left: ", ";\n        "], ["\n          margin-right: ", ";\n          margin-left: ", ";\n        "])), mx, mx), mt && mt, mr && mr, mb && mb, ml && ml, pt && pt, pr && pr, pb && pb, pl && pl), onClick: onClick }, rest, { children: children })));
};
exports.Flex = Flex;
exports.default = exports.Flex;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5;
