"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FormSpacing = exports.WithSlots = exports.Disabled = exports.VerticalOnMobile = exports.Vertical = exports.Variants = exports.BasicUsage = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var Flex_1 = __importDefault(require("@impargo/components/Flex"));
var Icon_1 = __importDefault(require("@impargo/components/Icon"));
var ActionButton_1 = __importDefault(require("../ActionButton"));
var Button_1 = __importDefault(require("../Button"));
var ResetButton_1 = require("../Button/ResetButton");
var SubmitButton_1 = require("../Button/SubmitButton");
var CheckboxInput_1 = require("../Input/CheckboxInput");
var FormikDateInput_1 = require("../Input/DateInput/FormikDateInput");
var NumberInput_1 = require("../Input/NumberInput");
var Select_1 = require("../Input/Select");
var SliderInput_1 = require("../Input/SliderInput");
var Switch_1 = require("../Input/Switch");
var TextareaInput_1 = require("../Input/TextareaInput");
var TextInput_1 = require("../Input/TextInput");
var TimerangeInput_1 = require("../Input/Time/TimerangeInput");
var Sheet_1 = __importDefault(require("../Sheet"));
var SheetBody_1 = __importDefault(require("../Sheet/SheetBody"));
var SheetHeader_1 = __importDefault(require("../Sheet/SheetHeader"));
var impargo_1 = __importDefault(require("../Themes/impargo"));
var Toast_1 = require("../Toast");
var storybook_1 = require("../utils/storybook");
var _1 = require(".");
var theme = impargo_1.default;
var faSearch = free_solid_svg_icons_1.faSearch;
exports.default = {
    title: 'Components/Form/Form',
    component: _1.Form,
    argTypes: {
        theme: { table: { disable: true } },
    },
    args: {},
    parameters: {
        layout: 'padded',
    },
};
var BasicUsage = function (args) { return ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: (0, jsx_runtime_1.jsxs)(_1.Form, __assign({ initialValues: {
            company: 'IMPARGO GmbH',
            name: { first: 'first', last: 'last' },
            timerangecomposite: { from: '', to: '' },
            timerange: { from: '', to: '' },
            slider: 0,
        }, onSubmit: function () {
            (0, Toast_1.success)('Submitted!');
        } }, args, { children: [(0, jsx_runtime_1.jsx)(TextInput_1.FormikTextInput, { label: 'Company', name: 'company', required: true, requiredDecorator: true }), (0, jsx_runtime_1.jsx)(TextInput_1.FormikTextInput, { label: 'Firstname', name: 'name.first', optionalDecorator: '(optional)' }), (0, jsx_runtime_1.jsx)(TextInput_1.FormikTextInput, { label: 'Lastname', name: 'name.last' }), (0, jsx_runtime_1.jsx)(Select_1.FormikSelect, { label: 'Select', options: [
                    { label: 'German', value: 'DE' },
                    { label: 'English', value: 'EN' },
                ], name: 'language', required: true, requiredDecorator: true }), (0, jsx_runtime_1.jsx)(Select_1.FormikSelect, { multi: true, label: 'Multi-select', options: [
                    { label: 'Cars', value: 'cars' },
                    { label: 'Trucks', value: 'trucks' },
                    { label: 'Busses', value: 'busses' },
                    { label: 'Trains', value: 'trains' },
                ], name: 'vehicles' }), (0, jsx_runtime_1.jsx)(NumberInput_1.FormikNumberInput, { label: 'Price', name: 'price', step: 0.1, suffix: '\u20AC', required: true }), (0, jsx_runtime_1.jsx)(SliderInput_1.FormikSliderInput, { label: 'Slider', name: 'slider', slotRight: (0, jsx_runtime_1.jsx)(ActionButton_1.default, { variant: 'primary', size: 's', children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }) }) }), (0, jsx_runtime_1.jsx)(FormikDateInput_1.FormikDateInput, { label: 'Datetime', name: 'datetime', type: 'datetime' }), (0, jsx_runtime_1.jsx)(FormikDateInput_1.FormikDateInput, { label: 'Daterange', name: 'daterange', type: 'daterange' }), (0, jsx_runtime_1.jsx)(CheckboxInput_1.FormikCheckboxInput, { label: 'Checkbox', name: 'check.check', required: true }), (0, jsx_runtime_1.jsx)(Switch_1.FormikSwitchInput, { label: 'Switch', name: 'switch.check', required: true }), (0, jsx_runtime_1.jsx)(TimerangeInput_1.FormikTimerangeInput, { label: 'Timerange', name: 'timerange', sliderInput: true }), (0, jsx_runtime_1.jsxs)(Flex_1.default, { width: '100%', justify: 'flex-end', gap: 'medium', mt: theme.spacingLarge, children: [(0, jsx_runtime_1.jsx)(ResetButton_1.ResetButton, { shape: 'flat', children: "Reset" }), (0, jsx_runtime_1.jsx)(SubmitButton_1.SubmitButton, { shape: 'default', "data-tooltip-content": 'This button is disabled', "data-tooltip-place": 'left', children: "Submit" })] })] })) })); };
exports.BasicUsage = BasicUsage;
exports.BasicUsage.args = {};
var Variants = function () { return ((0, jsx_runtime_1.jsxs)(_1.Form, { initialValues: {
        name: 'Jon Doe',
        Mates: [],
        price: 120,
        range: [10, 20],
    }, onSubmit: console.log, children: [(0, jsx_runtime_1.jsxs)(Sheet_1.default, { css: { marginBottom: theme.spacingMedium }, children: [(0, jsx_runtime_1.jsx)(SheetHeader_1.default, { title: 'Primary' }), (0, jsx_runtime_1.jsxs)(SheetBody_1.default, { variant: 'medium', children: [(0, jsx_runtime_1.jsx)(TextInput_1.FormikTextInput, { label: 'First', isVertical: true, placeholder: 'Primary', name: 'primary', infoText: 'Name of the person', slotRight: (0, jsx_runtime_1.jsx)(ActionButton_1.default, { variant: 'primary', size: 's', children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }) }), secondaryLabel: true }), (0, jsx_runtime_1.jsx)(TextInput_1.FormikTextInput, { isVertical: true, label: 'Second', name: 'second', placeholder: 'Primary', infoText: 'Name of the person', secondaryLabel: true, disabled: true }), (0, jsx_runtime_1.jsx)(CheckboxInput_1.FormikCheckboxInput, { label: 'Checkbox', name: 'checkbox', required: true, secondaryLabel: true, reversed: true }), (0, jsx_runtime_1.jsx)(Switch_1.FormikSwitchInput, { label: 'Switch', name: 'switch.check', reversed: true, required: true })] })] }), (0, jsx_runtime_1.jsxs)(Sheet_1.default, { bgColor: theme.colorSurfaceMc, children: [(0, jsx_runtime_1.jsx)(SheetHeader_1.default, { title: 'Secondary' }), (0, jsx_runtime_1.jsxs)(SheetBody_1.default, { variant: 'medium', children: [(0, jsx_runtime_1.jsx)(TextInput_1.FormikTextInput, { type: 'text', isVertical: true, name: 'third', label: 'Third', placeholder: 'Secondary', infoText: 'Name of the person', variant: 'secondary', slotRight: (0, jsx_runtime_1.jsx)(ActionButton_1.default, { variant: 'primary', size: 's', children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }) }), secondaryLabel: true }), (0, jsx_runtime_1.jsx)(TextInput_1.FormikTextInput, { disabled: true, isVertical: true, name: 'fourth', label: 'Fourth', placeholder: 'Secondary', infoText: 'Name of the person', variant: 'secondary', slotRight: (0, jsx_runtime_1.jsx)(ActionButton_1.default, { variant: 'primary', size: 's', children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }) }), secondaryLabel: true }), (0, jsx_runtime_1.jsx)(CheckboxInput_1.FormikCheckboxInput, { label: 'Checkbox', name: 'checkbox2', required: true, variant: 'secondary', secondaryLabel: true, reversed: true }), (0, jsx_runtime_1.jsx)(Switch_1.FormikSwitchInput, { secondaryLabel: true, label: 'Switch', name: 'switch.check', variant: 'secondary', required: true, reversed: true })] })] })] })); };
exports.Variants = Variants;
(0, storybook_1.addDescription)(exports.Variants, 'Example with the `variant` prop. The `primary` variant is used when placed on top of a high contrast surface while the `secondary` variant is used when placed on top of a medium contrast surface. The `primary` variant is the default variant.');
var Vertical = function () { return ((0, jsx_runtime_1.jsxs)(_1.Form, { initialValues: {
        name: 'Jon Doe',
        Mates: [],
    }, onSubmit: console.log, children: [(0, jsx_runtime_1.jsx)(TextInput_1.FormikTextInput, { name: 'name', label: 'Name', type: 'text', isVertical: true, infoText: 'Name of the person', rightDecorator: (0, jsx_runtime_1.jsx)(Button_1.default, { shape: 'flat', size: 's', children: "Click" }), slotRight: (0, jsx_runtime_1.jsx)(ActionButton_1.default, { variant: 'primary', size: 's', children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }) }), secondaryLabel: true }), (0, jsx_runtime_1.jsx)(Select_1.FormikSelect, { label: 'Mates', isVertical: true, options: [
                { label: 'Jimmy Page', value: 'PAGE' },
                { label: 'Robert Plant', value: 'PLANT' },
                { label: 'John Paul Jones', value: 'JONES' },
                { label: 'John Bonham', value: 'JONES' },
            ], name: 'ledZe', secondaryLabel: true }), (0, jsx_runtime_1.jsx)(TextareaInput_1.FormikTextareaInput, { label: 'Comment', name: 'comment', secondaryLabel: true }), (0, jsx_runtime_1.jsx)(NumberInput_1.FormikNumberInput, { label: 'Price (step 0.01)', name: 'price', suffix: '\u20AC', step: '0.01', required: true, isVertical: true, secondaryLabel: true })] })); };
exports.Vertical = Vertical;
(0, storybook_1.addDescription)(exports.Vertical, 'Example with vertical layout inputs. `Note:` the `isVertical` prop is only passed to the inputs components and not to the Form component.');
var VerticalOnMobile = function () { return ((0, jsx_runtime_1.jsxs)(_1.Form, { initialValues: {
        name: 'Jon Doe',
        Mates: [],
        price: 120,
        range: [10, 20],
    }, onSubmit: console.log, children: [(0, jsx_runtime_1.jsx)(SheetHeader_1.default, { title: 'Resize to see it', css: { padding: '0px' } }), (0, jsx_runtime_1.jsx)(TextInput_1.FormikTextInput, { label: 'Label', isVerticalMobile: true, name: 'text', infoText: 'Name of the person', slotRight: (0, jsx_runtime_1.jsx)(ActionButton_1.default, { variant: 'primary', size: 's', children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }) }), secondaryLabel: true, helperText: 'Helping with flex' }), (0, jsx_runtime_1.jsx)(Select_1.FormikSelect, { label: 'Mates', isVerticalMobile: true, options: [
                { label: 'Jimmy Page', value: 'PAGE' },
                { label: 'Robert Plant', value: 'PLANT' },
                { label: 'John Paul Jones', value: 'JONES' },
                { label: 'John Bonham', value: 'JONES' },
            ], name: 'ledZe', secondaryLabel: true }), (0, jsx_runtime_1.jsx)(TextareaInput_1.FormikTextareaInput, { label: 'Comment', name: 'comment', secondaryLabel: true }), (0, jsx_runtime_1.jsx)(NumberInput_1.FormikNumberInput, { label: 'Price (step 0.01)', name: 'price', suffix: '\u20AC', step: '0.01', required: true, isVerticalMobile: true, secondaryLabel: true }), (0, jsx_runtime_1.jsx)(SliderInput_1.FormikSliderInput, { label: 'Range', isVerticalMobile: true, name: 'range', slotRight: (0, jsx_runtime_1.jsx)(ActionButton_1.default, { variant: 'primary', size: 's', children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }) }) })] })); };
exports.VerticalOnMobile = VerticalOnMobile;
(0, storybook_1.addDescription)(exports.VerticalOnMobile, 'The `isVerticalMobile` prop which will change the input layout to vertical on small screen sizes. `Note:` the `isVerticalMobile` prop is only passed to the inputs components and not to the Form component.');
var Disabled = function () { return ((0, jsx_runtime_1.jsxs)(_1.Form, { initialValues: {
        name: 'Jon Doe',
        Mates: [],
        price: 120,
        range: [10, 20],
    }, onSubmit: console.log, children: [(0, jsx_runtime_1.jsx)(TextInput_1.FormikTextInput, { disabled: true, label: 'Label', isVertical: true, name: 'text', infoText: 'Name of the person', slotRight: (0, jsx_runtime_1.jsx)(ActionButton_1.default, { variant: 'primary', size: 's', children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }) }), secondaryLabel: true }), (0, jsx_runtime_1.jsx)(Select_1.FormikSelect, { disabled: true, label: 'Mates', isVertical: true, options: [
                { label: 'Jimmy Page', value: 'PAGE' },
                { label: 'Robert Plant', value: 'PLANT' },
                { label: 'John Paul Jones', value: 'JONES' },
                { label: 'John Bonham', value: 'JONES' },
            ], name: 'ledZe', secondaryLabel: true }), (0, jsx_runtime_1.jsx)(TextareaInput_1.FormikTextareaInput, { disabled: true, label: 'Comment', name: 'comment', secondaryLabel: true }), (0, jsx_runtime_1.jsx)(NumberInput_1.FormikNumberInput, { disabled: true, label: 'Price (step 0.01)', name: 'price', suffix: '\u20AC', step: '0.01', required: true, isVertical: true, secondaryLabel: true }), (0, jsx_runtime_1.jsx)(CheckboxInput_1.FormikCheckboxInput, { disabled: true, label: 'Admin', reversed: true, name: 'admin' })] })); };
exports.Disabled = Disabled;
(0, storybook_1.addDescription)(exports.Disabled, 'Form example with disabled style.');
var WithSlots = function () { return ((0, jsx_runtime_1.jsxs)(_1.Form, { initialValues: {}, onSubmit: console.log, children: [(0, jsx_runtime_1.jsx)(TextInput_1.FormikTextInput, { label: 'Label', isVertical: true, name: 'text', infoText: 'Name of the person', slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { size: 's', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faUser }) }), slotRight: (0, jsx_runtime_1.jsx)(ActionButton_1.default, { variant: 'primary', size: 's', children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }) }), secondaryLabel: true }), (0, jsx_runtime_1.jsx)(Select_1.FormikSelect, { label: 'Select', options: [
                { label: 'German', value: 'DE' },
                { label: 'English', value: 'EN' },
            ], name: 'language', slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }) }), (0, jsx_runtime_1.jsx)(Select_1.FormikSelect, { multi: true, label: 'Multiselect', placeholder: 'Please select one or more options.', options: [
                { label: 'Rick', value: 'RICK' },
                { label: 'Morty', value: 'MORTY' },
                { label: 'Snuffles', value: 'SNUFFLES' },
                { label: 'Bird Person', value: 'BIRDPERSON' },
                { label: 'Bird Person', value: 'BIRDPERSON1' },
                { label: 'Bird Person', value: 'BIRDPERSON2' },
                { label: 'Bird Person', value: 'BIRDPERSON3' },
                { label: 'Bird Person', value: 'BIRDPERSON4' },
            ], name: 'multiselect', noOptionsMessage: function (_a) {
                var inputValue = _a.inputValue;
                return "No options for search ".concat(inputValue);
            }, defaultEmptyValue: null, slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }) })] })); };
exports.WithSlots = WithSlots;
(0, storybook_1.addDescription)(exports.WithSlots, 'A `slotLeft` and `slotRight` prop can be passed to add icons or actions at the start or end of the input. Use the `Icon` component to pass icons using the `FontAwesomeIcon` component in the `icon` prop. To check if the input component accept the `slotLeft` or `slotRight` prop, check the desired input story.');
var FormSpacing = function () { return ((0, jsx_runtime_1.jsxs)(_1.Form, { initialValues: {
        name: 'Jon Doe',
        Mates: [],
        price: 120,
        range: [10, 20],
    }, onSubmit: console.log, children: [(0, jsx_runtime_1.jsx)(TextInput_1.FormikTextInput, { label: 'Label', isVertical: true, name: 'text', infoText: 'Name of the person', slotRight: (0, jsx_runtime_1.jsx)(ActionButton_1.default, { variant: 'primary', size: 's', children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }) }), secondaryLabel: true, css: (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n        &&& {\n          margin-top: 0;\n        }\n      "], ["\n        &&& {\n          margin-top: 0;\n        }\n      "]))) }), (0, jsx_runtime_1.jsx)(Select_1.FormikSelect, { label: 'Mates', isVertical: true, options: [
                { label: 'Jimmy Page', value: 'PAGE' },
                { label: 'Robert Plant', value: 'PLANT' },
                { label: 'John Paul Jones', value: 'JONES' },
                { label: 'John Bonham', value: 'JONES' },
            ], name: 'ledZe', secondaryLabel: true }), (0, jsx_runtime_1.jsx)(TextareaInput_1.FormikTextareaInput, { label: 'Comment', name: 'comment', secondaryLabel: true }), (0, jsx_runtime_1.jsx)(NumberInput_1.FormikNumberInput, { label: 'Price (step 0.01)', name: 'price', suffix: '\u20AC', step: '0.01', required: true, isVertical: true, secondaryLabel: true, css: (0, react_1.css)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n        &&& {\n          margin-bottom: 0;\n        }\n      "], ["\n        &&& {\n          margin-bottom: 0;\n        }\n      "]))) })] })); };
exports.FormSpacing = FormSpacing;
(0, storybook_1.addDescription)(exports.FormSpacing, 'By default the inputs have a margin top and bottom of 16px which is equivalent to `spacingMedium` of the theme. Some cases requires the default margins to be removed. Although not ideal and this default behavior might change in the future, a way to remove the extra spacing is by adding extra styling using the css prop. Click on `Show code` to see the examples.');
var templateObject_1, templateObject_2;
