"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Custom = exports.WithText = exports.Variants = exports.BasicUsage = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var Sheet_1 = __importDefault(require("@impargo/components/Sheet"));
var impargo_1 = __importDefault(require("../Themes/impargo"));
var storybook_1 = require("../utils/storybook");
var _1 = __importDefault(require("."));
var theme = impargo_1.default;
var faUser = free_solid_svg_icons_1.faUser;
exports.default = {
    title: 'Components/General/Icon',
    component: _1.default,
    argTypes: {
        icon: { control: false },
        text: { control: 'text' },
        color: { control: 'color' },
        bgColor: { control: 'color' },
        borderColor: { control: 'color' },
        size: { control: 'select' },
        theme: { table: { disable: true } },
        'data-testid': { table: { disable: true } },
    },
    args: {
        variant: 'default',
    },
};
var BasicUsage = function (args) { return ((0, jsx_runtime_1.jsx)(_1.default, __assign({}, args))); };
exports.BasicUsage = BasicUsage;
exports.BasicUsage.args = {
    variant: 'default',
    icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faUser }),
};
var Variants = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faUser, size: 'sm' }) }), (0, jsx_runtime_1.jsx)(_1.default, { variant: 'primary', ml: theme.spacingMedium, icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faUser }) }), (0, jsx_runtime_1.jsx)(_1.default, { variant: 'secondary', ml: theme.spacingMedium, icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faUser }) }), (0, jsx_runtime_1.jsx)(_1.default, { variant: 'accent', ml: theme.spacingMedium, icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faUser }) }), (0, jsx_runtime_1.jsx)(_1.default, { variant: 'success', ml: theme.spacingMedium, icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faUser }) }), (0, jsx_runtime_1.jsx)(_1.default, { variant: 'warning', ml: theme.spacingMedium, icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faUser }) }), (0, jsx_runtime_1.jsx)(_1.default, { variant: 'danger', ml: theme.spacingMedium, icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faUser }) })] })); };
exports.Variants = Variants;
(0, storybook_1.addDescription)(exports.Variants, "With the `variant` prop, we can give our components and design a bit more live and color.");
var WithText = function () { return ((0, jsx_runtime_1.jsxs)(Sheet_1.default, { variant: 'medium', css: {
        fontFamily: theme.fontFamily,
    }, children: [(0, jsx_runtime_1.jsx)(_1.default, { variant: 'primary', ml: theme.spacingMedium, text: 'P', borderColor: theme.colorPrimaryLight2 }), (0, jsx_runtime_1.jsx)(_1.default, { variant: 'secondary', ml: theme.spacingMedium, text: 'o' }), (0, jsx_runtime_1.jsx)(_1.default, { variant: 'accent', ml: theme.spacingMedium, text: 'O' }), (0, jsx_runtime_1.jsx)(_1.default, { variant: 'success', ml: theme.spacingMedium, text: 'F' }), (0, jsx_runtime_1.jsx)(_1.default, { variant: 'warning', ml: theme.spacingMedium, text: 'P' }), (0, jsx_runtime_1.jsx)(_1.default, { variant: 'danger', size: 'l', ml: theme.spacingMedium, text: 'o' })] })); };
exports.WithText = WithText;
(0, storybook_1.addDescription)(exports.WithText, "We can also use the `text` prop to add letters as icons. This is mostly used as apps icons. It is recommended to use the `text` prop in combination with the `variant` prop.");
var Custom = function () { return ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: (0, jsx_runtime_1.jsx)(_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faUser }), color: theme.colorTextSuccess, bgColor: theme.colorGreenLight2, borderColor: theme.colorGreenLight3 }) })); };
exports.Custom = Custom;
(0, storybook_1.addDescription)(exports.Custom, "Some use cases require a custom `Icon`, although this is not recommended, a `bgColor`, `color` and `borderColor` props are provided to customize the component.\nIf this use case is repeated in multiple places and across projects, a new `variant` can be added to cover these commonly used custom component.");
