"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Icon = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var styled_1 = __importDefault(require("@emotion/styled"));
var Component = function (_a) {
    var className = _a.className, icon = _a.icon, text = _a.text, _b = _a.variant, variant = _b === void 0 ? 'default' : _b, _c = _a.size, size = _c === void 0 ? 'm' : _c, dataTestid = _a["data-testid"], color = _a.color, bgColor = _a.bgColor, _borderColor = _a.borderColor, rest = __rest(_a, ["className", "icon", "text", "variant", "size", 'data-testid', "color", "bgColor", "borderColor"]);
    var isCustom = color || bgColor;
    return ((0, jsx_runtime_1.jsxs)("span", __assign({ className: "".concat(className, " ").concat(isCustom ? 'custom' : variant, " ").concat(size), "data-testid": dataTestid }, rest, { children: [icon && !text && icon, text && (0, jsx_runtime_1.jsx)("span", { className: 'icon__text', children: text })] })));
};
/**
 * `Icon` component can be used to display different icons either with font-awesome icons or just plain text. Icons can be used to give extra context to the user realated to an action or specific information.

  ### Import

  ```
  import Icon from '@impargo/components/Icon'
  ```
 */
exports.Icon = (0, styled_1.default)(Component)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  display: inline-flex;\n  justify-content: center;\n  align-items: center;\n  border-radius: ", ";\n  color: ", ";\n  overflow: hidden;\n  ", "\n\n  ", "\n  ", "\n\n  ", "\n  ", "\n  margin-top: ", ";\n  margin-right: ", ";\n  margin-bottom: ", ";\n  margin-left: ", ";\n\n\n\n  /* styling: variants */\n  &.default {\n    background-color: transparent;\n  }\n  &.secondary {\n    background-color: ", ";\n  }\n  &.primary {\n    background-color: ", ";\n    color: ", ";\n  }\n  &.accent {\n    background-color: ", ";\n    color: ", ";\n  }\n  &.danger {\n    background-color: ", ";\n    color: ", ";\n  }\n  &.success {\n    background-color: ", ";\n    color: ", ";\n  }\n  &.warning {\n    background-color: ", ";\n    color: ", ";\n  }\n  &.custom {\n    background-color: ", ";\n    color: ", ";\n  }\n\n  /* styling: size */\n  &.xs {\n    width: ", ";\n    height: ", ";\n    min-width: ", ";\n    min-height: ", ";\n  }\n  &.s {\n    width: ", ";\n    height: ", ";\n    min-width: ", ";\n    min-height: ", ";\n  }\n  &.m {\n    width: ", ";\n    height: ", ";\n    min-width: ", ";\n    min-height: ", ";\n  }\n  &.l {\n    width: ", ";\n    height: ", ";\n    min-width: ", ";\n    min-height: ", ";\n  }\n  &.xl {\n    width: ", ";\n    height: ", ";\n    min-width: ", ";\n    min-height: ", ";\n  }\n\n  /* styling: children */\n  .icon__text {\n    font: inherit;\n    color: inherit;\n  }\n"], ["\n  display: inline-flex;\n  justify-content: center;\n  align-items: center;\n  border-radius: ", ";\n  color: ", ";\n  overflow: hidden;\n  ", "\n\n  ", "\n  ", "\n\n  ", "\n  ", "\n  margin-top: ", ";\n  margin-right: ", ";\n  margin-bottom: ", ";\n  margin-left: ", ";\n\n\n\n  /* styling: variants */\n  &.default {\n    background-color: transparent;\n  }\n  &.secondary {\n    background-color: ", ";\n  }\n  &.primary {\n    background-color: ", ";\n    color: ", ";\n  }\n  &.accent {\n    background-color: ", ";\n    color: ", ";\n  }\n  &.danger {\n    background-color: ", ";\n    color: ", ";\n  }\n  &.success {\n    background-color: ", ";\n    color: ", ";\n  }\n  &.warning {\n    background-color: ", ";\n    color: ", ";\n  }\n  &.custom {\n    background-color: ", ";\n    color: ", ";\n  }\n\n  /* styling: size */\n  &.xs {\n    width: ", ";\n    height: ", ";\n    min-width: ", ";\n    min-height: ", ";\n  }\n  &.s {\n    width: ", ";\n    height: ", ";\n    min-width: ", ";\n    min-height: ", ";\n  }\n  &.m {\n    width: ", ";\n    height: ", ";\n    min-width: ", ";\n    min-height: ", ";\n  }\n  &.l {\n    width: ", ";\n    height: ", ";\n    min-width: ", ";\n    min-height: ", ";\n  }\n  &.xl {\n    width: ", ";\n    height: ", ";\n    min-width: ", ";\n    min-height: ", ";\n  }\n\n  /* styling: children */\n  .icon__text {\n    font: inherit;\n    color: inherit;\n  }\n"])), function (_a) {
    var theme = _a.theme;
    return theme.borderRadiusCircular;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorTextMc;
}, function (_a) {
    var borderColor = _a.borderColor;
    return borderColor &&
        "\n    border: 1px solid ".concat(borderColor, ";\n  ");
}, function (_a) {
    var icon = _a.icon, theme = _a.theme;
    return icon && (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n      font-size: ", ";\n    "], ["\n      font-size: ", ";\n    "])), theme.fontSizeSmall);
}, function (_a) {
    var text = _a.text, theme = _a.theme;
    return text && (0, react_1.css)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n      font-size: ", ";\n      line-height: ", ";\n      font-weight: ", ";\n      text-transform: uppercase;\n    "], ["\n      font-size: ", ";\n      line-height: ", ";\n      font-weight: ", ";\n      text-transform: uppercase;\n    "])), theme.fontSizeBody, theme.fontLineHeight, theme.fontWeightSemibold);
}, function (_a) {
    var mx = _a.mx;
    return mx && (0, react_1.css)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n      margin-right: ", ";\n      margin-left: ", ";\n    "], ["\n      margin-right: ", ";\n      margin-left: ", ";\n    "])), mx, mx);
}, function (_a) {
    var my = _a.my;
    return my && (0, react_1.css)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n      margin-top: ", ";\n      margin-bottom: ", ";\n    "], ["\n      margin-top: ", ";\n      margin-bottom: ", ";\n    "])), my, my);
}, function (_a) {
    var mt = _a.mt;
    return mt && mt;
}, function (_a) {
    var mr = _a.mr;
    return mr && mr;
}, function (_a) {
    var mb = _a.mb;
    return mb && mb;
}, function (_a) {
    var ml = _a.ml;
    return ml && ml;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorSurfaceLc;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorPrimaryLight;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorPrimaryDark;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorAccentLight2;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorTextLink;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorRedLight2;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorTextDanger;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorGreenLight2;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorTextSuccess;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorOrangeLight2;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorTextWarning;
}, function (_a) {
    var bgColor = _a.bgColor;
    return bgColor;
}, function (_a) {
    var color = _a.color;
    return color;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingMedium;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingMedium;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingMedium;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingMedium;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontLineHeight;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontLineHeight;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontLineHeight;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontLineHeight;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingXLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingXLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingXLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingXLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingXxxLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingXxxLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingXxxLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingXxxLarge;
});
exports.default = exports.Icon;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5;
