import { FC } from 'react';
import { TooltipProps } from '../Tooltip';
export interface InfoIconProps {
    /**
     * Class name assigned to the component. Should be used sparingly.
     */
    className?: string;
    /**
     * Contains the message shown on the tooltip.
     * Note: tooltip shows on hover over the info icon.
     */
    infoText: string;
    /**
     * Designates the tooltip placement.
     * @default 'bottom'
     */
    place?: TooltipProps['place'];
    /**
     * Indicates if the info icon has warning style.
     * @default false
     */
    isWarning?: boolean;
}
/**
 * The `InfoIcon` component is used to add extra context or explanation to certial UI component. Mostly used with a form field.

  ### Import

  ```
  import { InfoIcon } from '@impargo/components/InfoIcon'
  ```
 */
export declare const InfoIcon: FC<InfoIconProps>;
export default InfoIcon;
//# sourceMappingURL=index.d.ts.map