"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InfoIcon = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var Icons_1 = require("../Icons");
/**
 * The `InfoIcon` component is used to add extra context or explanation to certial UI component. Mostly used with a form field.

  ### Import

  ```
  import { InfoIcon } from '@impargo/components/InfoIcon'
  ```
 */
var InfoIcon = function (_a) {
    var infoText = _a.infoText, _b = _a.place, place = _b === void 0 ? 'bottom' : _b, className = _a.className, isWarning = _a.isWarning;
    var theme = (0, react_1.useTheme)();
    return ((0, jsx_runtime_1.jsx)("span", { css: (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n        margin-left: ", ";\n        vertical-align: text-bottom;\n        display: inline-flex;\n        justify-content: center;\n        align-items: center;\n        color: ", ";\n        & .info__icon {\n          font-size: inherit;\n          pointer-events: none;\n        }\n        & svg {\n          vertical-align: middle;\n        }\n      "], ["\n        margin-left: ", ";\n        vertical-align: text-bottom;\n        display: inline-flex;\n        justify-content: center;\n        align-items: center;\n        color: ", ";\n        & .info__icon {\n          font-size: inherit;\n          pointer-events: none;\n        }\n        & svg {\n          vertical-align: middle;\n        }\n      "])), (theme.spacingSmall), isWarning ? theme.colorRed : theme.colorTextLink), className: className, "data-tooltip-place": place, "data-tooltip-content": infoText, "data-tooltip-variant": 'info', children: (0, jsx_runtime_1.jsx)(Icons_1.InfoCircle, { className: 'info__icon' }) }));
};
exports.InfoIcon = InfoIcon;
exports.default = exports.InfoIcon;
var templateObject_1;
