import { FC } from 'react';
import { InputContainerProps } from '../InputContainer';
export type CheckboxInputProps = Omit<InputContainerProps, 'type' | 'slotLeft' | 'helperText' | 'slotRight' | 'suffix'> & Omit<React.InputHTMLAttributes<HTMLInputElement>, 'type'> & {
    /**
     * The value of the checkbox.
     * @default false
    */
    checked: boolean;
    /**
     * Sets the indeterminate state to the input.
     * @default false
    */
    indeterminate?: boolean;
    /**
     * As default show the tooltip, even when the user is not hovering over it.
     * @default false
     * @deprecated no longer easily supported by the underlying tooltip implementation.
     */
    autoOpenTip?: boolean;
};
/**
 * Checkbox input component with built in support for tooltips, info icons, slots, ...

  ### Import using Formik

  ```
  import { FormikCheckboxInput } from '@impargo/components/Input/CheckboxInput'
  ```

  ### Import

  ```
  import { CheckboxInput } from '@impargo/components/Input/CheckboxInput'
  ```
 */
export declare const CheckboxInput: FC<CheckboxInputProps>;
//# sourceMappingURL=CheckboxInput.d.ts.map