"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DateInput = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
require("react-datepicker/dist/react-datepicker.css");
var dom_1 = require("@floating-ui/dom");
var en_GB_1 = __importDefault(require("date-fns/locale/en-GB"));
var react_datepicker_1 = __importDefault(require("react-datepicker"));
var helpers_1 = require("../helpers");
var InputContainer_1 = require("../InputContainer");
var helpers_2 = require("./helpers");
var styles_1 = require("./styles");
var datetimeConfig = {
    showTimeSelect: true,
    timeFormat: helpers_2.TIME_FORMAT,
    dateFormat: helpers_2.DATE_TIME_FORMAT,
    timeIntervals: 15,
    selectsRange: undefined,
};
var dateConfig = {
    dateFormat: helpers_2.DATE_FORMAT,
    selectsRange: undefined,
};
var daterangeConfig = {
    selectsRange: true,
    shouldCloseOnSelect: false,
};
var configProps = {
    date: dateConfig,
    datetime: datetimeConfig,
    daterange: daterangeConfig,
};
/**
  ### Import using Formik

  ```
  import { FormikDateInput } from '@impargo/components/Input/DateInput'
  ```

  ### Import

  ```
  import { DateInput } from '@impargo/components/Input/DateInput'
  ```
 */
var DateInput = function (_a) {
    var _b = _a.type, type = _b === void 0 ? 'date' : _b, unnormalizedValue = _a.value, _c = _a.locale, locale = _c === void 0 ? en_GB_1.default : _c, onChange = _a.onChange, normalizeToUTC = _a.normalizeToUTC, props = __rest(_a, ["type", "value", "locale", "onChange", "normalizeToUTC"]);
    var _d = (0, helpers_1.pickContainerProps)(props), containerProps = _d.containerProps, inputProps = __rest(_d, ["containerProps"]);
    var slot = containerProps.slotRight;
    var value = normalizeToUTC && unnormalizedValue
        ? (0, helpers_2.denormalizeDateValue)(unnormalizedValue)
        : unnormalizedValue;
    var rangeValue = (!(0, helpers_2.isDate)(value) && ((value === null || value === void 0 ? void 0 : value.from) || (value === null || value === void 0 ? void 0 : value.to)))
        ? "".concat((0, helpers_2.formatDate)(value === null || value === void 0 ? void 0 : value.from, locale) || '', " - ").concat((0, helpers_2.formatDate)(value === null || value === void 0 ? void 0 : value.to, locale) || '')
        : undefined;
    return ((0, jsx_runtime_1.jsx)(InputContainer_1.InputContainer, __assign({}, containerProps, { type: type, css: function (theme) { return (0, styles_1.getStyle)(theme, !!slot); }, children: (0, jsx_runtime_1.jsx)(react_datepicker_1.default, __assign({ showPopperArrow: false, popperPlacement: 'bottom-start', popperModifiers: [(0, dom_1.offset)(-10)] }, configProps[type], inputProps, { locale: locale, customInput: (0, jsx_runtime_1.jsx)("input", { "data-testid": props['data-testid'] }), startDate: (0, helpers_2.isDate)(value) ? undefined : value === null || value === void 0 ? void 0 : value.from, endDate: (0, helpers_2.isDate)(value) ? undefined : value === null || value === void 0 ? void 0 : value.to, value: rangeValue, selected: (0, helpers_2.isDate)(value) ? value : value === null || value === void 0 ? void 0 : value.from, onChange: function (v) {
                var newValue = (0, helpers_2.parseDateValue)(v);
                onChange(normalizeToUTC ? (0, helpers_2.normalizeDateValue)(newValue) : newValue);
            } })) })));
};
exports.DateInput = DateInput;
