import { FieldValidator } from 'formik';
import { FC } from 'react';
import { WithoutFieldInputProps } from '../helpers';
import { DateInputProps } from './DateInput';
import { DateInputValueType } from './helpers';
export interface FormikDateInputProps extends WithoutFieldInputProps<DateInputProps, DateInputValueType> {
    /**
     * Name of the underlying input component.
     */
    name: string;
    /**
     * [Formik Field Validation](https://formik.org/docs/guides/validation#field-level-validation),
     * if a string is returned by this function, validation errors will be shown below the field.
     */
    validate?: FieldValidator;
}
export declare const FormikDateInput: FC<FormikDateInputProps>;
//# sourceMappingURL=FormikDateInput.d.ts.map