export type DaterangeValueType = {
    from: Date | null;
    to: Date | null;
};
export type DateInputValueType = Date | DaterangeValueType | null;
export declare const DATE_FORMAT = "P";
export declare const TIME_FORMAT = "HH:mm";
export declare const DATE_TIME_FORMAT = "P HH:mm";
export declare const formatDate: (date: Date | null, locale?: Locale) => string;
export declare const isDate: (value?: DateInputValueType) => value is Date;
/**
 * Takes local time and converts it to the same UTC time.
 */
export declare const normalizeDateToUTC: (value: Date) => Date;
/**
 * Takes a UTC time and converts it to the same local time.
 */
export declare const denormalizeDateFromUTC: (value: Date) => Date;
export declare const normalizeDateValue: (value: DateInputValueType) => DateInputValueType;
export declare const denormalizeDateValue: (value: DateInputValueType) => DateInputValueType;
export declare const parseDateValue: (v: [Date | null, Date | null] | Date | null) => DateInputValueType;
//# sourceMappingURL=helpers.d.ts.map