"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InputContainer = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var Flex_1 = __importDefault(require("@impargo/components/Flex"));
var Icon_1 = __importDefault(require("@impargo/components/Icon"));
var Text_1 = __importDefault(require("../../Text"));
var LabelContainer_1 = require("./LabelContainer");
var styles_1 = require("./styles");
var getNavigatorLanguage = function () {
    if (typeof window !== 'undefined' && 'navigator' in window) {
        // eslint-disable-next-line dot-notation
        return (navigator.languages && navigator.languages.length) ? navigator.languages[0] : navigator.language || 'en';
    }
};
var InputContainer = function (_a) {
    var className = _a.className, label = _a.label, slotRight = _a.slotRight, slotLeft = _a.slotLeft, reversed = _a.reversed, name = _a.name, infoText = _a.infoText, tooltipPlace = _a.tooltipPlace, suffix = _a.suffix, error = _a.error, touched = _a.touched, helperText = _a.helperText, optionalDecorator = _a.optionalDecorator, requiredDecorator = _a.requiredDecorator, leftDecorator = _a.leftDecorator, rightDecorator = _a.rightDecorator, _b = _a.forceShowError, forceShowError = _b === void 0 ? false : _b, children = _a.children, secondaryLabel = _a.secondaryLabel, dataTestId = _a["data-testid"], rest = __rest(_a, ["className", "label", "slotRight", "slotLeft", "reversed", "name", "infoText", "tooltipPlace", "suffix", "error", "touched", "helperText", "optionalDecorator", "requiredDecorator", "leftDecorator", "rightDecorator", "forceShowError", "children", "secondaryLabel", 'data-testid']);
    var hasError = (touched || forceShowError) && error;
    var theme = (0, react_1.useTheme)();
    return ((0, jsx_runtime_1.jsx)("div", { className: className, css: (0, styles_1.getStyle)(theme, __assign({ rightDecorator: rightDecorator, label: label, reversed: reversed }, rest)), "data-testid": dataTestId && "".concat(dataTestId, "-container"), children: (0, jsx_runtime_1.jsxs)("label", { htmlFor: name, children: [!reversed && label && ((0, jsx_runtime_1.jsx)(LabelContainer_1.LabelContainer, { label: label, secondaryLabel: secondaryLabel, rightDecorator: rightDecorator, leftDecorator: leftDecorator, requiredDecorator: requiredDecorator, optionalDecorator: optionalDecorator, infoText: infoText, tooltipPlace: tooltipPlace })), (0, jsx_runtime_1.jsxs)("div", { className: 'field__container', children: [(0, jsx_runtime_1.jsxs)("div", { lang: getNavigatorLanguage(), className: "container ".concat(hasError ? 'has-error' : '', " ").concat(helperText ? 'has-helper-text' : ''), children: [children, slotLeft && (0, jsx_runtime_1.jsxs)("div", { className: 'icon_slot_left', children: [" ", (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: slotLeft, size: 's' }), " "] }), (slotRight || suffix) && (0, jsx_runtime_1.jsxs)(Flex_1.default, { className: 'icon_slot', direction: 'row', gap: 'tiny', alignItems: 'center', children: [suffix, slotRight] }), reversed && label && ((0, jsx_runtime_1.jsx)(LabelContainer_1.LabelContainer, { label: label, secondaryLabel: secondaryLabel, isReversed: true, rightDecorator: rightDecorator, leftDecorator: leftDecorator, requiredDecorator: requiredDecorator, optionalDecorator: optionalDecorator, infoText: infoText, tooltipPlace: tooltipPlace }))] }), (helperText && !hasError) && (0, jsx_runtime_1.jsx)(Text_1.default, { className: 'input-helper', variant: 'small', secondary: true, children: helperText }), hasError && (0, jsx_runtime_1.jsx)(Text_1.default, { className: 'input-helper', variant: 'small', color: theme.colorTextDanger, children: error })] })] }) }));
};
exports.InputContainer = InputContainer;
