"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NumberInput = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var mixins_1 = require("../../Themes/mixins");
var helpers_1 = require("../helpers");
var InputContainer_1 = require("../InputContainer");
var isProperNumber = function (value) { return typeof value === 'number' && !isNaN(value); };
var roundToSignificantDigits = function (value, fractionDigits) {
    var splitted = value.split(/[,.]/);
    return parseFloat(splitted[1] ? [splitted[0], splitted[1].slice(0, fractionDigits)].join('.') : splitted[0]);
};
/**
 * Number input component with built in support for:
 *
 * - Rounding to `fractionDigits`
 * - Lower and upper bounds [`min`, `max`]

  ### Import using Formik

  ```
  import { FormikNumberInput } from '@impargo/components/Input/NumberInput'
  ```

  ### Import

  ```
  import { NumberInput } from '@impargo/components/Input/NumberInput'
  ```
 */
var NumberInput = function (_a) {
    var value = _a.value, onValueChange = _a.onValueChange, min = _a.min, max = _a.max, fractionDigits = _a.fractionDigits, props = __rest(_a, ["value", "onValueChange", "min", "max", "fractionDigits"]);
    var v = isProperNumber(value) ? roundToSignificantDigits(value.toString(), fractionDigits) : '';
    var _b = (0, helpers_1.pickContainerProps)(props), containerProps = _b.containerProps, inputProps = __rest(_b, ["containerProps"]);
    var slotRight = containerProps.slotRight, slotLeft = containerProps.slotLeft, suffix = containerProps.suffix;
    return ((0, jsx_runtime_1.jsx)(InputContainer_1.InputContainer, __assign({}, containerProps, { type: 'number', children: (0, jsx_runtime_1.jsx)("input", __assign({ css: function (theme) { return (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n          appearance: none;\n          &&::-webkit-outer-spin-button,\n          &&::-webkit-inner-spin-button {\n              -webkit-appearance: none;\n          }\n          -moz-appearance: textfield;\n          height: ", ";\n          color: ", ";\n          width: 100%;\n          border: 1px solid ", ";\n          border-radius: ", ";\n          font-family: ", ";\n          box-sizing: border-box;\n          align-self: right;\n          font-size: ", ";\n          outline: 0;\n          padding: ", ";\n          ", ";\n          ", ";\n        "], ["\n          appearance: none;\n          &&::-webkit-outer-spin-button,\n          &&::-webkit-inner-spin-button {\n              -webkit-appearance: none;\n          }\n          -moz-appearance: textfield;\n          height: ", ";\n          color: ", ";\n          width: 100%;\n          border: 1px solid ", ";\n          border-radius: ", ";\n          font-family: ", ";\n          box-sizing: border-box;\n          align-self: right;\n          font-size: ", ";\n          outline: 0;\n          padding: ", ";\n          ", ";\n          ", ";\n        "])), (0, mixins_1.height)(theme), theme.colorText, theme.colorDivider, theme.borderRadius, theme.fontFamily, theme.fontSizeBody, theme.spacingSmall, (slotRight || suffix) ? "padding-right: ".concat(theme.spacingLarge) : '', slotLeft ? "padding-left: ".concat(theme.spacingXLarge) : ''); }, step: 'any' }, inputProps, { onChange: function (e) {
                var _a;
                if (onValueChange) {
                    var value_1 = !e.target.value ? null : roundToSignificantDigits(e.target.value, fractionDigits);
                    if (typeof min === 'number' && typeof value_1 === 'number' && value_1 < min) {
                        onValueChange(min);
                    }
                    else if (typeof max === 'number' && typeof value_1 === 'number' && value_1 > max) {
                        onValueChange(max);
                    }
                    else {
                        onValueChange(value_1);
                    }
                }
                (_a = inputProps.onChange) === null || _a === void 0 ? void 0 : _a.call(inputProps, e);
            }, type: 'number', value: v !== null && v !== void 0 ? v : '', autoComplete: 'off' })) })));
};
exports.NumberInput = NumberInput;
var templateObject_1;
