import { TooltipAnchorProps } from '@impargo/components/Tooltip';
import { FC, ReactNode, SyntheticEvent } from 'react';
export interface SegmentedButtonsOption extends TooltipAnchorProps {
    value: string;
    label?: ReactNode;
    icon?: JSX.Element;
    'data-testid'?: string;
}
export interface SegmentedButtonsPropsBase {
    options: SegmentedButtonsOption[];
    /**
     * Whether the input should stretch to fill the whole width.
     * @default false
     */
    wide?: boolean;
    /**
     * Size of the input. Mainly affects the vertical padding.
     * @default medium
     */
    size?: 'small' | 'medium';
}
export interface SegmentedButtonsPropsSingle extends SegmentedButtonsPropsBase {
    /**
     * Only one value can be selected at a time.
     */
    selectType: 'single';
    value: string;
    onChange: (value: string, event: SyntheticEvent) => void;
}
export interface SegmentedButtonsPropsMulti extends SegmentedButtonsPropsBase {
    /**
     * Multiple values can be selected and unselected.
     */
    selectType: 'multi';
    value: string[];
    onChange: (value: string[], event: SyntheticEvent) => void;
}
export type SegmentedButtonsProps = SegmentedButtonsPropsSingle | SegmentedButtonsPropsMulti;
export declare const SegmentedButtons: FC<SegmentedButtonsProps>;
//# sourceMappingURL=SegmentedButtons.d.ts.map