"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SegmentedButtons = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var Icon_1 = __importDefault(require("@impargo/components/Icon"));
var Text_1 = __importDefault(require("@impargo/components/Text"));
var Flex_1 = require("../../Flex");
var styles_1 = require("./styles");
var SegmentedButtons = function (props) {
    var _a;
    var theme = (0, react_1.useTheme)();
    var height = {
        small: theme.spacingLarge,
        medium: theme.spacingXLarge,
    }[(_a = props.size) !== null && _a !== void 0 ? _a : 'medium'];
    return ((0, jsx_runtime_1.jsx)(Flex_1.Flex, { direction: 'row', gap: 'tiny', css: styles_1.getContainerStyle, width: props.wide ? '100%' : 'fit-content', children: props.options.map(function (option) {
            var value = option.value, icon = option.icon, label = option.label, optionProps = __rest(option, ["value", "icon", "label"]);
            var onCLick = function (event) {
                if (props.selectType === 'single') {
                    props.onChange(value, event);
                }
                else {
                    props.onChange(props.value.includes(value)
                        ? props.value.filter(function (singleValue) { return singleValue !== value; })
                        : __spreadArray(__spreadArray([], props.value.filter(function (singleValue) { return singleValue !== value; }), true), [value], false), event);
                }
            };
            var isActive = props.selectType === 'single' ? props.value === value : props.value.includes(value);
            return ((0, jsx_runtime_1.jsxs)(Flex_1.Flex, __assign({ direction: 'row', gap: 'small', onClick: onCLick, css: isActive
                    ? props.selectType === 'single' ? styles_1.getSegmentStyleActiveSingle : styles_1.getSegmentStyleActiveMulti
                    : styles_1.getSegmentStyleBase, flex: '1', px: theme.spacingMedium, height: height }, optionProps, { children: [icon && (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: icon }), label && (0, jsx_runtime_1.jsx)(Text_1.default, { whiteSpace: 'nowrap', children: label })] }), value));
        }) }));
};
exports.SegmentedButtons = SegmentedButtons;
