"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Sizes = exports.SelectType = exports.Wide = exports.TextOnly = exports.IconOnly = exports.BasicUsage = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var Flex_1 = __importDefault(require("@impargo/components/Flex"));
var Form_1 = __importDefault(require("../../Form"));
var _1 = require(".");
exports.default = {
    title: 'Components/Form/Input/SegmentedButtons',
    component: _1.SegmentedButtons,
    argTypes: {
        wide: { control: 'boolean' },
        selectType: { control: 'select' },
        size: { control: 'select' },
        theme: { table: { disable: true } },
    },
    args: {},
    parameters: {
        layout: 'padded',
    },
};
var BasicUsage = function (args) { return ((0, jsx_runtime_1.jsx)(_1.SegmentedButtons, __assign({}, args))); };
exports.BasicUsage = BasicUsage;
var args = {
    options: [
        { label: 'Truck', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faTruck }), value: 'truck' },
        { label: 'Trailer', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faTrailer }), value: 'trailer' },
        { label: 'Driver', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faUser }), value: 'driver' },
    ],
    selectType: 'single',
    value: 'truck',
    onChange: console.log,
    wide: false,
};
exports.BasicUsage.args = args;
var IconOnly = function () { return ((0, jsx_runtime_1.jsx)(Form_1.default, { initialValues: { 'icon-only': 'table' }, onSubmit: console.log, children: (0, jsx_runtime_1.jsx)(_1.FormikSegmentedButtons, { options: [
            { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faTable }), value: 'table', 'data-tooltip-content': 'Table' },
            {
                icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faList }),
                value: 'list',
                'data-tooltip-content': 'List',
                'data-tooltip-place': 'right',
            },
        ], selectType: 'single', name: 'icon-only' }) })); };
exports.IconOnly = IconOnly;
var TextOnly = function () { return ((0, jsx_runtime_1.jsx)(Form_1.default, { initialValues: { 'text-only': 'truck' }, onSubmit: console.log, children: (0, jsx_runtime_1.jsx)(_1.FormikSegmentedButtons, { options: [
            { label: 'Truck', value: 'truck' },
            { label: 'Trailer', value: 'trailer' },
            { label: 'Driver', value: 'driver' },
        ], selectType: 'single', name: 'text-only' }) })); };
exports.TextOnly = TextOnly;
var Wide = function () { return ((0, jsx_runtime_1.jsx)(Form_1.default, { initialValues: { wide: 'assets', multi: ['monday', 'wednesday', 'thursday'] }, onSubmit: console.log, children: (0, jsx_runtime_1.jsxs)(Flex_1.default, { direction: 'column', gap: 'medium', children: [(0, jsx_runtime_1.jsx)(_1.FormikSegmentedButtons, { options: [
                    { label: 'My assets', value: 'assets' },
                    { label: 'Subcontractors', value: 'subcontractor' },
                ], selectType: 'single', wide: true, name: 'wide' }), (0, jsx_runtime_1.jsx)(_1.FormikSegmentedButtons, { options: [
                    { label: 'Monday', value: 'monday' },
                    { label: 'Tuesday', value: 'tuesday' },
                    { label: 'Wednesday', value: 'wednesday' },
                    { label: 'Thursday', value: 'thursday' },
                    { label: 'Friday', value: 'friday' },
                ], selectType: 'multi', name: 'multi', wide: true })] }) })); };
exports.Wide = Wide;
var SelectType = function () { return ((0, jsx_runtime_1.jsx)(Form_1.default, { initialValues: { single: 'wednesday', multi: ['monday', 'wednesday', 'thursday'] }, onSubmit: console.log, children: (0, jsx_runtime_1.jsxs)(Flex_1.default, { direction: 'column', gap: 'medium', children: [(0, jsx_runtime_1.jsx)(_1.FormikSegmentedButtons, { options: [
                    { label: 'Monday', value: 'monday' },
                    { label: 'Tuesday', value: 'tuesday' },
                    { label: 'Wednesday', value: 'wednesday' },
                    { label: 'Thursday', value: 'thursday' },
                    { label: 'Friday', value: 'friday' },
                ], selectType: 'single', name: 'single' }), (0, jsx_runtime_1.jsx)(_1.FormikSegmentedButtons, { options: [
                    { label: 'Monday', value: 'monday' },
                    { label: 'Tuesday', value: 'tuesday' },
                    { label: 'Wednesday', value: 'wednesday' },
                    { label: 'Thursday', value: 'thursday' },
                    { label: 'Friday', value: 'friday' },
                ], selectType: 'multi', name: 'multi' })] }) })); };
exports.SelectType = SelectType;
var Sizes = function () { return ((0, jsx_runtime_1.jsx)(Form_1.default, { initialValues: { multi: ['monday', 'wednesday', 'thursday'] }, onSubmit: console.log, children: (0, jsx_runtime_1.jsxs)(Flex_1.default, { direction: 'column', gap: 'medium', children: [(0, jsx_runtime_1.jsx)(_1.FormikSegmentedButtons, { options: [
                    { label: 'Monday', value: 'monday' },
                    { label: 'Tuesday', value: 'tuesday' },
                    { label: 'Wednesday', value: 'wednesday' },
                    { label: 'Thursday', value: 'thursday' },
                    { label: 'Friday', value: 'friday' },
                ], selectType: 'multi', name: 'multi', size: 'medium' }), (0, jsx_runtime_1.jsx)(_1.FormikSegmentedButtons, { options: [
                    { label: 'Monday', value: 'monday' },
                    { label: 'Tuesday', value: 'tuesday' },
                    { label: 'Wednesday', value: 'wednesday' },
                    { label: 'Thursday', value: 'thursday' },
                    { label: 'Friday', value: 'friday' },
                ], selectType: 'multi', name: 'multi', size: 'small' })] }) })); };
exports.Sizes = Sizes;
