"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AsyncSelect = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("react");
var react_select_1 = require("react-select");
var async_1 = __importDefault(require("react-select/async"));
var helpers_1 = require("../helpers");
var InputContainer_1 = require("../InputContainer");
var DropdownIndicator_1 = require("./DropdownIndicator");
var styles_1 = require("./styles");
/**
  ### When to use
  Use AsyncSelect when you want to search results via an async API, for example when fetching results from the backend or a third party.

  The prop `loadOptions` should be a function that takes the search value and returns a promise of an array of options.

  ### Import using Formik

  ```
  import { FormikAsyncSelect } from '@impargo/components/Input/Select/AsyncSelect'
  ```

  ### Import

  ```
  import { AsyncSelect } from '@impargo/components/Input/Select/AsyncSelect'
  ```
 */
function AsyncSelect(_a) {
    var value = _a.value, _b = _a.dropup, dropup = _b === void 0 ? false : _b, components = _a.components, innerRef = _a.innerRef, onChange = _a.onChange, props = __rest(_a, ["value", "dropup", "components", "innerRef", "onChange"]);
    var _c = (0, helpers_1.pickContainerProps)(props), containerProps = _c.containerProps, rest = __rest(_c, ["containerProps"]);
    var input = (0, react_1.useCallback)(function (props) {
        // Memoize the input so that it doesn't lose its state between rerenders
        return (0, jsx_runtime_1.jsx)(react_select_1.components.Input, __assign({}, props, { "data-testid": containerProps['data-testid'] }));
    }, [containerProps['data-testid']]);
    var Component = async_1.default;
    return ((0, jsx_runtime_1.jsx)(InputContainer_1.InputContainer, __assign({}, containerProps, { type: 'select', children: (0, jsx_runtime_1.jsx)(Component, __assign({ isSearchable: true }, rest, { ref: function (ref) {
                if (innerRef) {
                    innerRef.current = ref;
                }
            }, css: function (theme) {
                return (0, styles_1.getStyle)(theme, !!containerProps.disabled, containerProps.variant, dropup, !!containerProps.slotLeft);
            }, isDisabled: containerProps.disabled, value: value, components: __assign({ DropdownIndicator: DropdownIndicator_1.DropdownIndicator, Input: input }, components), classNamePrefix: 'select', onChange: onChange })) })));
}
exports.AsyncSelect = AsyncSelect;
