import { FieldValidator } from 'formik';
import { ReactElement } from 'react';
import { WithoutFieldInputProps } from '../helpers';
import { AsyncSelectProps } from './AsyncSelect';
import type { SelectOptionType } from './Select';
export interface FormikAsyncSelectProps<OptionType extends {}> extends WithoutFieldInputProps<AsyncSelectProps<OptionType>, AsyncSelectProps<OptionType>['value']> {
    /**
     * Name of the underlying input component.
     */
    name: string;
    /**
     * [Formik Field Validation](https://formik.org/docs/guides/validation#field-level-validation),
     * if a string is returned by this function, validation errors will be shown below the field.
     */
    validate?: FieldValidator;
}
export declare function FormikAsyncSelect<OptionType extends SelectOptionType>({ name, validate, ...props }: FormikAsyncSelectProps<OptionType>): ReactElement;
//# sourceMappingURL=FormikAsyncSelect.d.ts.map