import { FieldValidator } from 'formik';
import { ReactElement } from 'react';
import { WithoutFieldInputProps } from '../helpers';
import { SelectOptionType, SelectProps } from './Select';
export interface FormikSelectProps<OptionType extends {}, IsMulti extends boolean = false> extends WithoutFieldInputProps<SelectProps<OptionType, IsMulti>, SelectProps<OptionType, IsMulti>['value']> {
    /**
     * Name of the underlying input component.
     */
    name: string;
    /**
     * [Formik Field Validation](https://formik.org/docs/guides/validation#field-level-validation),
     * if a string is returned by this function, validation errors will be shown below the field.
     */
    validate?: FieldValidator;
}
export declare function FormikSelect<OptionType extends SelectOptionType, IsMulti extends boolean = false>({ name, validate, ...props }: FormikSelectProps<OptionType, IsMulti>): ReactElement;
//# sourceMappingURL=FormikSelect.d.ts.map