"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Select = exports.Components = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("react");
var react_select_1 = __importStar(require("react-select"));
var creatable_1 = __importDefault(require("react-select/creatable"));
var helpers_1 = require("../helpers");
var InputContainer_1 = require("../InputContainer");
var DropdownIndicator_1 = require("./DropdownIndicator");
var RequiredHandler_1 = require("./RequiredHandler");
var styles_1 = require("./styles");
/**
 * Deprecated. Import from '@impargo/components/Input/Select/Components' instead.
 */
exports.Components = react_select_1.components;
function valuesToOptions(v, multi, optionsMap, onMissingOption) {
    if (onMissingOption === void 0) { onMissingOption = function (value) { return ({ value: value, label: value }); }; }
    if (v === null || v === undefined) {
        return null;
    }
    if (Array.isArray(v)) {
        if (!multi) {
            return null;
        }
        return v.map(function (value) {
            // If newly created option use value as label.
            return optionsMap[value] || onMissingOption(value);
        });
    }
    else {
        return optionsMap[v] || onMissingOption(v);
    }
}
var optionsToValues = function (v, multi, defaultEmptyValue) {
    if (multi) {
        if (Array.isArray(v) && v.length > 0) {
            return v.map(function (v) { return v.value; });
        }
        else {
            return defaultEmptyValue;
        }
    }
    else {
        if (!v) {
            return null;
        }
        if (!Array.isArray(v)) {
            // The type cast here is needed because of a bug with Array.isArray type guard in typescript
            // https://github.com/microsoft/TypeScript/issues/17002
            return v.value;
        }
    }
    return null;
};
function isGroupTypeOption(option) {
    return 'options' in option;
}
/**
  ### When to use
  Use Select when you want the users to choose from a predefined list of options.
  The prop `options` should be an array of options in the shape `[{ label: string, value: string }]`.

  Refer to AsyncSelect if you don't have a predefined list of options, and instead want to fetch the options via an API.

  ### Import using Formik

  ```
  import { FormikSelect } from '@impargo/components/Input/Select'
  ```

  ### Import

  ```
  import { Select } from '@impargo/components/Input/Select'
  ```
 */
function Select(_a) {
    var onChange = _a.onChange, value = _a.value, _b = _a.dropup, dropup = _b === void 0 ? false : _b, options = _a.options, _c = _a.defaultEmptyValue, defaultEmptyValue = _c === void 0 ? [] : _c, _d = _a.multi, multi = _d === void 0 ? false : _d, _e = _a.creatable, creatable = _e === void 0 ? false : _e, components = _a.components, innerRef = _a.innerRef, styles = _a.styles, onMissingOption = _a.onMissingOption, props = __rest(_a, ["onChange", "value", "dropup", "options", "defaultEmptyValue", "multi", "creatable", "components", "innerRef", "styles", "onMissingOption"]);
    var SelectComponent = (creatable ? creatable_1.default : react_select_1.default);
    var optionsMap = (0, react_1.useMemo)(function () {
        var map = {};
        options.forEach(function (option) {
            if (isGroupTypeOption(option)) {
                option.options.forEach(function (option) {
                    map[option.value] = option;
                });
            }
            else {
                map[option.value] = option;
            }
        });
        return map;
    }, [options]);
    var selectValue = (0, react_1.useMemo)(function () {
        return valuesToOptions(value, multi, optionsMap, onMissingOption);
    }, [value, multi, optionsMap]);
    var _f = (0, helpers_1.pickContainerProps)(props), containerProps = _f.containerProps, rest = __rest(_f, ["containerProps"]);
    var input = (0, react_1.useCallback)(function (props) {
        // Memoize the input so that it doesn't lose its state between rerenders
        return (0, jsx_runtime_1.jsx)(react_select_1.components.Input, __assign({}, props, { "data-testid": containerProps['data-testid'] }));
    }, [containerProps['data-testid']]);
    return ((0, jsx_runtime_1.jsxs)(InputContainer_1.InputContainer, __assign({}, containerProps, { type: 'select', children: [(0, jsx_runtime_1.jsx)(SelectComponent, __assign({ isSearchable: creatable }, rest, { ref: function (ref) {
                    if (innerRef) {
                        innerRef.current = ref;
                    }
                }, css: function (theme) {
                    return (0, styles_1.getStyle)(theme, !!containerProps.disabled, containerProps.variant, dropup, !!containerProps.slotLeft);
                }, isMulti: multi, closeMenuOnSelect: !multi, isDisabled: containerProps.disabled, options: options, value: selectValue, components: __assign({ DropdownIndicator: DropdownIndicator_1.DropdownIndicator, Input: input }, components), classNamePrefix: 'select', onChange: function (v) {
                    var val = optionsToValues(v, multi, defaultEmptyValue);
                    onChange(val);
                }, styles: styles })), props.required
                ? (0, jsx_runtime_1.jsx)(RequiredHandler_1.RequiredHandler, { value: value, name: props.name })
                : null] })));
}
exports.Select = Select;
