"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MissingOption = exports.Validation = exports.SlotLeft = exports.CreatableMultiSelect = exports.MultiSelect = exports.CreatableSelect = exports.RegularSelect = exports.BasicUsage = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var Flex_1 = __importDefault(require("@impargo/components/Flex"));
var Form_1 = __importDefault(require("../../Form"));
var _1 = require(".");
exports.default = {
    title: 'Components/Form/Input/Select/Select',
    component: _1.Select,
    argTypes: {
        variant: { control: 'select' },
        tooltipPlace: { control: 'select' },
        multi: { control: 'boolean' },
        options: { control: false },
        theme: { table: { disable: true } },
    },
    args: {},
    parameters: {
        layout: 'padded',
    },
};
var BasicUsage = function (args) { return ((0, jsx_runtime_1.jsx)(Form_1.default, { initialValues: {}, onSubmit: console.log, children: (0, jsx_runtime_1.jsx)(_1.FormikSelect, __assign({}, args)) })); };
exports.BasicUsage = BasicUsage;
var args = {
    label: 'Select',
    name: 'value',
    helperText: 'A helper text',
    infoText: 'An info text',
    options: [{
            value: 'option1',
            label: 'Option 1',
        }, {
            value: 'option2',
            label: 'Option 2',
        }],
    multi: false,
};
exports.BasicUsage.args = args;
var RegularSelect = function () { return ((0, jsx_runtime_1.jsxs)(Form_1.default, { initialValues: {}, onSubmit: console.log, children: [(0, jsx_runtime_1.jsx)(_1.FormikSelect, { label: 'Select', options: [
                { label: 'German', value: 'DE' },
                { label: 'English', value: 'EN' },
            ], name: 'language' }), (0, jsx_runtime_1.jsx)(_1.FormikSelect, { label: 'Dropup Select', options: [
                { label: 'German', value: 'DE' },
                { label: 'English', value: 'EN' },
            ], dropup: true, name: 'language-dropup' }), (0, jsx_runtime_1.jsx)(_1.FormikSelect, { label: 'Grouped Select', options: [
                { label: 'Languages', options: [{ label: 'German', value: 'DE' }, { label: 'English', value: 'EN' }] },
                { label: 'regions', options: [{ label: 'Europe', value: 'EUR' }, { label: 'Africa', value: 'AFR' }] },
            ], dropup: true, name: 'language-dropup' }), (0, jsx_runtime_1.jsx)(_1.FormikSelect, { label: 'Select with react nodes as labels', options: [
                { label: (0, jsx_runtime_1.jsxs)("span", { children: [(0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faFlag }), " German"] }), value: 'DE' },
                { label: (0, jsx_runtime_1.jsxs)("span", { children: [(0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faFlag }), " English"] }), value: 'EN' },
            ], name: 'language' })] })); };
exports.RegularSelect = RegularSelect;
var CreatableSelect = function () { return ((0, jsx_runtime_1.jsx)(Flex_1.default, { height: '200px', children: (0, jsx_runtime_1.jsx)(Form_1.default, { initialValues: {}, onSubmit: console.log, children: (0, jsx_runtime_1.jsx)(_1.FormikSelect, { creatable: true, label: 'Creatable select', placeholder: 'Please select one options.', options: [
                { label: 'Rick', value: 'RICK' },
                { label: 'Morty', value: 'MORTY' },
                { label: 'Snuffles', value: 'SNUFFLES' },
                { label: 'Bird Person', value: 'BIRDPERSON' },
            ], name: 'creatableselect', formatCreateLabel: function (value) { return "Create new character: '".concat(value, "'"); } }) }) })); };
exports.CreatableSelect = CreatableSelect;
var MultiSelect = function () { return ((0, jsx_runtime_1.jsx)(Flex_1.default, { height: '320px', children: (0, jsx_runtime_1.jsx)(Form_1.default, { initialValues: {}, onSubmit: console.log, children: (0, jsx_runtime_1.jsx)(_1.FormikSelect, { multi: true, label: 'Multiselect', placeholder: 'Please select one or more options.', options: [
                { label: 'Rick', value: 'RICK' },
                { label: 'Morty', value: 'MORTY' },
                { label: 'Snuffles', value: 'SNUFFLES' },
                { label: 'Bird Person', value: 'BIRDPERSON' },
                { label: 'Bird Person', value: 'BIRDPERSON1' },
                { label: 'Bird Person', value: 'BIRDPERSON2' },
                { label: 'Bird Person', value: 'BIRDPERSON3' },
                { label: 'Bird Person', value: 'BIRDPERSON4' },
            ], name: 'multiselect', noOptionsMessage: function (_a) {
                var inputValue = _a.inputValue;
                return "No options for search ".concat(inputValue);
            }, defaultEmptyValue: null }) }) })); };
exports.MultiSelect = MultiSelect;
var CreatableMultiSelect = function () { return ((0, jsx_runtime_1.jsx)(Flex_1.default, { height: '200px', children: (0, jsx_runtime_1.jsx)(Form_1.default, { initialValues: {}, onSubmit: console.log, children: (0, jsx_runtime_1.jsx)(_1.FormikSelect, { multi: true, creatable: true, label: 'Creatable multiselect', placeholder: 'Please select one or more options.', options: [
                { label: 'Rick', value: 'RICK' },
                { label: 'Morty', value: 'MORTY' },
                { label: 'Snuffles', value: 'SNUFFLES' },
                { label: 'Bird Person', value: 'BIRDPERSON' },
            ], name: 'creatablemultiselect', formatCreateLabel: function (value) { return "Create new character: '".concat(value, "'"); } }) }) })); };
exports.CreatableMultiSelect = CreatableMultiSelect;
var SlotLeft = function () { return ((0, jsx_runtime_1.jsx)(Flex_1.default, { height: '300px', children: (0, jsx_runtime_1.jsxs)(Form_1.default, { initialValues: {}, onSubmit: console.log, children: [(0, jsx_runtime_1.jsx)(_1.FormikSelect, { label: 'Select', options: [
                    { label: 'German', value: 'DE' },
                    { label: 'English', value: 'EN' },
                ], name: 'language', slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faSearch }) }), (0, jsx_runtime_1.jsx)(_1.FormikSelect, { multi: true, label: 'Multiselect', placeholder: 'Please select one or more options.', options: [
                    { label: 'Rick', value: 'RICK' },
                    { label: 'Morty', value: 'MORTY' },
                    { label: 'Snuffles', value: 'SNUFFLES' },
                    { label: 'Bird Person', value: 'BIRDPERSON' },
                    { label: 'Bird Person', value: 'BIRDPERSON1' },
                    { label: 'Bird Person', value: 'BIRDPERSON2' },
                    { label: 'Bird Person', value: 'BIRDPERSON3' },
                    { label: 'Bird Person', value: 'BIRDPERSON4' },
                ], name: 'multiselect', noOptionsMessage: function (_a) {
                    var inputValue = _a.inputValue;
                    return "No options for search ".concat(inputValue);
                }, defaultEmptyValue: null, slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faSearch }) })] }) })); };
exports.SlotLeft = SlotLeft;
var Validation = function () { return ((0, jsx_runtime_1.jsx)(Flex_1.default, { height: '160px', children: (0, jsx_runtime_1.jsx)(Form_1.default, { initialValues: {}, onSubmit: console.log, children: (0, jsx_runtime_1.jsx)(_1.FormikSelect, { label: 'Select Bird Person', options: [
                { label: 'Rick', value: 'RICK' },
                { label: 'Morty', value: 'MORTY' },
                { label: 'Snuffles', value: 'SNUFFLES' },
                { label: 'Bird Person', value: 'BIRDPERSON' },
            ], name: 'rickandmorty', validate: function (v) {
                if (v !== 'BIRDPERSON') {
                    return 'You did not select Bird Person...';
                }
            } }) }) })); };
exports.Validation = Validation;
var MissingOption = function () { return ((0, jsx_runtime_1.jsx)(Flex_1.default, { height: '160px', children: (0, jsx_runtime_1.jsx)(Form_1.default, { initialValues: { missing: 'Rick' }, onSubmit: console.log, children: (0, jsx_runtime_1.jsx)(_1.FormikSelect, { label: 'Missing option', options: [
                { label: 'Morty', value: 'MORTY' },
                { label: 'Snuffles', value: 'SNUFFLES' },
                { label: 'Bird Person', value: 'BIRDPERSON' },
            ], onMissingOption: function (value) { return ({ value: value, label: "Value \"".concat(value, "\" is missing from the options") }); }, name: 'missing' }) }) })); };
exports.MissingOption = MissingOption;
