"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SliderInput = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var Slider_1 = __importDefault(require("@material-ui/core/Slider"));
var react_2 = require("react");
var helpers_1 = require("../helpers");
var InputContainer_1 = require("../InputContainer");
var isValidValue = function (value) {
    return typeof value === 'number' || Array.isArray(value);
};
/**
 * Slider input, uses Material slider behind the scene.
 *
 * For performance reasons, this component can't be used as a fully controlled input.
 * The only way to tap into its value is by using the onChangeCommitted handler,
 * which only triggers after the user stops sliding. Passing a changing value
 * to the input will work though, to enable the slider to be used in forms

  ### Import using Formik

  ```
  import { FormikSliderInput } from '@impargo/components/Input/SliderInput'
  ```

  ### Import

  ```
  import { SliderInput } from '@impargo/components/Input/SliderInput'
  ```
 */
var SliderInput = function (_a) {
    var _b;
    var sliderLabel = _a.sliderLabel, props = __rest(_a, ["sliderLabel"]);
    var theme = (0, react_1.useTheme)();
    var _c = (0, helpers_1.pickContainerProps)(props), containerProps = _c.containerProps, inputProps = __rest(_c, ["containerProps"]);
    var _d = (0, react_2.useState)(props.value), value = _d[0], setValue = _d[1];
    (0, react_2.useEffect)(function () {
        setValue(props.value);
    }, [props.value]);
    var formattedSliderLabel = "".concat(sliderLabel
        ? (isValidValue(value) ? sliderLabel(value) : '')
        : Array.isArray(value) ? value.join(' - ') : value).concat((_b = containerProps.suffix) !== null && _b !== void 0 ? _b : '');
    return ((0, jsx_runtime_1.jsx)(InputContainer_1.InputContainer, __assign({}, containerProps, { type: 'range', children: (0, jsx_runtime_1.jsxs)("div", { css: (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n          width: 100%;\n          text-align: left;\n          && span.MuiSlider-valueLabel {\n            transform: scale(1) translateY(-4px);\n            > span {\n              background: transparent;\n            }\n            * {\n              color: ", ";\n            }\n          }\n          .slider-values {\n            color: ", ";\n            font-family: ", ";\n          }\n          .MuiSlider-rail {\n            background-color: ", ";\n          }\n          .MuiSlider-track {\n            background-color: ", ";\n            opacity: .5;\n          }\n          .MuiSlider-thumb {\n            background-color: ", ";\n            &:hover {\n              box-shadow: 0px 0px 0px 8px ", ";\n            }\n            &.Mui-focusVisible {\n              box-shadow: 0px 0px 0px 8px ", ";\n            }\n            &.MuiSlider-active {\n              box-shadow: 0px 0px 0px 14px ", ";\n            }\n          }"], ["\n          width: 100%;\n          text-align: left;\n          && span.MuiSlider-valueLabel {\n            transform: scale(1) translateY(-4px);\n            > span {\n              background: transparent;\n            }\n            * {\n              color: ", ";\n            }\n          }\n          .slider-values {\n            color: ", ";\n            font-family: ", ";\n          }\n          .MuiSlider-rail {\n            background-color: ", ";\n          }\n          .MuiSlider-track {\n            background-color: ", ";\n            opacity: .5;\n          }\n          .MuiSlider-thumb {\n            background-color: ", ";\n            &:hover {\n              box-shadow: 0px 0px 0px 8px ", ";\n            }\n            &.Mui-focusVisible {\n              box-shadow: 0px 0px 0px 8px ", ";\n            }\n            &.MuiSlider-active {\n              box-shadow: 0px 0px 0px 14px ", ";\n            }\n          }"])), theme.colorTextMc, theme.colorTextMc, theme.fontFamily, theme.colorDivider, theme.colorPrimary, theme.colorPrimary, theme.colorPrimaryA4, theme.colorPrimaryA10, theme.colorPrimaryA10), children: [(0, jsx_runtime_1.jsx)("div", { className: 'slider-values-wrapper', children: (0, jsx_runtime_1.jsx)("span", { className: 'slider-values', children: formattedSliderLabel }) }), (0, jsx_runtime_1.jsx)(Slider_1.default, __assign({}, inputProps, { 
                    // Ignore the first param (e), it doesn't hold the value anyway
                    onChangeCommitted: inputProps.onChangeCommitted
                        ? function (_, v) { var _a; return (_a = inputProps.onChangeCommitted) === null || _a === void 0 ? void 0 : _a.call(inputProps, v); }
                        : undefined, onChange: function (_, v) { return setValue(v); }, value: value }))] }) })));
};
exports.SliderInput = SliderInput;
var templateObject_1;
