import { FC } from 'react';
import { InputContainerProps } from '../InputContainer';
export type SwitchInputProps = Omit<InputContainerProps, 'type' | 'slotLeft' | 'helperText' | 'slotRight' | 'suffix'> & Omit<React.InputHTMLAttributes<HTMLInputElement>, 'type'> & {
    /**
     * The value of the switch.
     * @default false
    */
    checked: boolean;
    /**
     * Sets the indeterminate state to the input.
     * @default false
    */
    indeterminate?: boolean;
    /**
     * As default show the tooltip, even when the user is not hovering over it.
     * @default false
     * @deprecated no longer easily supported by the underlying tooltip implementation.
     */
    autoOpenTip?: boolean;
};
/**
 * Switch input component with built in support for tooltips, info icons, slots, ...

  ### Import using Formik

  ```
  import { FormikSwitchInput } from '@impargo/components/Input/SwitchInput'
  ```

  ### Import

  ```
  import { SwitchInput } from '@impargo/components/Input/SwitchInput'
  ```
 */
export declare const SwitchInput: FC<SwitchInputProps>;
//# sourceMappingURL=SwitchInput.d.ts.map