"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SwitchInput = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var mixins_1 = require("../../Themes/mixins");
var helpers_1 = require("../helpers");
var InputContainer_1 = require("../InputContainer");
/**
 * Switch input component with built in support for tooltips, info icons, slots, ...

  ### Import using Formik

  ```
  import { FormikSwitchInput } from '@impargo/components/Input/SwitchInput'
  ```

  ### Import

  ```
  import { SwitchInput } from '@impargo/components/Input/SwitchInput'
  ```
 */
var SwitchInput = function (_a) {
    var indeterminate = _a.indeterminate, props = __rest(_a, ["indeterminate"]);
    var theme = (0, react_1.useTheme)();
    var _b = (0, helpers_1.pickContainerProps)(props), containerProps = _b.containerProps, rest = __rest(_b, ["containerProps"]);
    var _c = containerProps.variant, variant = _c === void 0 ? 'primary' : _c, disabled = containerProps.disabled;
    return ((0, jsx_runtime_1.jsx)(InputContainer_1.InputContainer, __assign({}, containerProps, { type: 'checkbox', children: (0, jsx_runtime_1.jsxs)("span", { css: (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n        height: ", ";\n        width: 44px;\n        border-radius:  ", ";\n        display: flex;\n        align-items: center;\n        position: relative;\n        padding-left: ", ";\n        -webkit-user-select: none;\n        -moz-user-select: none;\n        -ms-user-select: none;\n        user-select: none;\n        z-index: 0;\n        ", "\n        &::before {\n          height: ", ";\n          width: 44px;\n          top: 4px;\n          border-radius:  ", ";\n          z-index: 1;\n          pointer-events: ", ";\n        }\n        &:hover,\n        &:focus {\n          &::before {\n            background-color: ", ";\n          }\n        }\n      \n        &:disabled {\n          &:hover,\n          &:active {\n            &::before {\n              opacity: 0;\n            }\n          }\n        }\n      \n        /* Hide the browser's default checkbox */\n        & input {\n          opacity: 0;\n          position: absolute;\n          left: 0%;\n\n          &::disabled {\n            opacity: 0;\n          }\n        }\n      \n        /* Create a custom checkbox */\n        & .slider {\n          position: absolute;\n          left: 0;\n          height: ", ";\n          width: 44px;\n          border-radius:  ", ";\n          border: 1px solid ", ";\n          ", ";\n          background-color: ", ";\n          transition: ease-in-out .2s;\n\n        }\n      \n        /* When the checkbox is checked, add a background color */\n        & input:checked ~ .slider, & input:indeterminate ~ .slider {\n          background-color: ", ";\n          border-color: ", ";\n        }\n      \n        & input:focus ~ .slider {\n          ", "\n        }\n      \n        /* Create the slider/indicator (hidden when not checked) */\n        & .slider::after, .slider::before {\n          content: '';\n          position: absolute;\n        }\n      \n        /* Show the slider when checked */\n        & input:checked ~ .slider::before, input:indeterminate ~ .slider::before {\n          display: block;\n          transform: translateX(18px);\n        }\n      \n        /* Style the slider/indicator */\n\n        & .slider::before {\n          left: 2px;\n          top: calc(50% - 10px);\n          height: ", ";\n          width: ", ";\n          border-radius: 50%;\n          background-color: ", ";\n          box-shadow: ", ";\n          transition: ease-in-out .2s;\n        }\n\n      "], ["\n        height: ", ";\n        width: 44px;\n        border-radius:  ", ";\n        display: flex;\n        align-items: center;\n        position: relative;\n        padding-left: ", ";\n        -webkit-user-select: none;\n        -moz-user-select: none;\n        -ms-user-select: none;\n        user-select: none;\n        z-index: 0;\n        ", "\n        &::before {\n          height: ", ";\n          width: 44px;\n          top: 4px;\n          border-radius:  ", ";\n          z-index: 1;\n          pointer-events: ", ";\n        }\n        &:hover,\n        &:focus {\n          &::before {\n            background-color: ", ";\n          }\n        }\n      \n        &:disabled {\n          &:hover,\n          &:active {\n            &::before {\n              opacity: 0;\n            }\n          }\n        }\n      \n        /* Hide the browser's default checkbox */\n        & input {\n          opacity: 0;\n          position: absolute;\n          left: 0%;\n\n          &::disabled {\n            opacity: 0;\n          }\n        }\n      \n        /* Create a custom checkbox */\n        & .slider {\n          position: absolute;\n          left: 0;\n          height: ", ";\n          width: 44px;\n          border-radius:  ", ";\n          border: 1px solid ", ";\n          ", ";\n          background-color: ", ";\n          transition: ease-in-out .2s;\n\n        }\n      \n        /* When the checkbox is checked, add a background color */\n        & input:checked ~ .slider, & input:indeterminate ~ .slider {\n          background-color: ", ";\n          border-color: ", ";\n        }\n      \n        & input:focus ~ .slider {\n          ", "\n        }\n      \n        /* Create the slider/indicator (hidden when not checked) */\n        & .slider::after, .slider::before {\n          content: '';\n          position: absolute;\n        }\n      \n        /* Show the slider when checked */\n        & input:checked ~ .slider::before, input:indeterminate ~ .slider::before {\n          display: block;\n          transform: translateX(18px);\n        }\n      \n        /* Style the slider/indicator */\n\n        & .slider::before {\n          left: 2px;\n          top: calc(50% - 10px);\n          height: ", ";\n          width: ", ";\n          border-radius: 50%;\n          background-color: ", ";\n          box-shadow: ", ";\n          transition: ease-in-out .2s;\n        }\n\n      "])), (0, mixins_1.height)(theme), theme.spacingLarge, theme.spacingLarge, (0, mixins_1.overlayHoverMixin)(theme, 'colorHover', 'colorActive'), theme.spacingLarge, theme.spacingLarge, disabled ? 'none' : 'auto', disabled && 'transparent', theme.spacingLarge, theme.spacingLarge, variant === 'primary' ? theme.colorDivider : theme.colorDividerHc, (0, mixins_1.disabledMixin)(theme, !!disabled, variant), variant === 'primary' ? theme.colorSurfaceLc : theme.colorSurfaceHc, theme.colorPrimary, theme.colorPrimary, (0, mixins_1.focusOutlineMixin)(theme), theme.fontLineHeight, theme.fontLineHeight, variant === 'primary' ? theme.colorSurfaceHc : theme.colorSurfaceLc, theme.shadowSmall), children: [(0, jsx_runtime_1.jsx)("input", __assign({ type: 'checkbox', id: props.name }, rest, { 
                    // TODO: find a better way to handle this
                    ref: function (ref) { return ref && (ref.indeterminate = !!indeterminate); } })), (0, jsx_runtime_1.jsx)("span", { className: 'slider' })] }) })));
};
exports.SwitchInput = SwitchInput;
var templateObject_1;
