import { FC } from 'react';
import { InputContainerProps } from '../InputContainer';
export type TextInputProps = InputContainerProps & React.InputHTMLAttributes<HTMLInputElement> & {
    /**
     * Value of the text input.
     */
    value: string;
    /**
     * More specific type of the text input depending on the text.
     * @default text
     */
    type?: 'text' | 'password' | 'email' | 'tel' | 'url';
};
/**
  ### Import using Formik

  ```
  import { FormikTextInput } from '@impargo/components/Input/TextInput'
  ```

  ### Import

  ```
  import { TextInput } from '@impargo/components/Input/TextInput'
  ```
 */
export declare const TextInput: FC<TextInputProps>;
//# sourceMappingURL=TextInput.d.ts.map