import { FieldValidator } from 'formik';
import { FC } from 'react';
import { WithoutFieldInputProps } from '../helpers';
import { TextareaInputProps } from './TextareaInput';
export interface FormikTextareaInputProps extends WithoutFieldInputProps<TextareaInputProps, string> {
    /**
     * Name of the underlying input component.
     */
    name: string;
    /**
     * [Formik Field Validation](https://formik.org/docs/guides/validation#field-level-validation),
     * if a string is returned by this function, validation errors will be shown below the field.
     */
    validate?: FieldValidator;
}
export declare const FormikTextareaInput: FC<FormikTextareaInputProps>;
//# sourceMappingURL=FormikTextareaInput.d.ts.map