import { FC } from 'react';
import { InputContainerProps } from '../InputContainer';
export type TextareaInputProps = Omit<InputContainerProps, 'type' | 'slotLeft' | 'slotRight' | 'suffix'> & React.TextareaHTMLAttributes<HTMLTextAreaElement> & {
    /**
     * Value of the underlying input component.
     */
    value: string;
};
/**
  ### Import using Formik

  ```
  import { FormikTextareaInput } from '@impargo/components/Input/TextareaInput'
  ```

  ### Import

  ```
  import { TextareaInput } from '@impargo/components/Input/TextareaInput'
  ```
 */
export declare const TextareaInput: FC<TextareaInputProps>;
//# sourceMappingURL=TextareaInput.d.ts.map