"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TimeInput = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("react");
var helpers_1 = require("../../helpers");
var InputContainer_1 = require("../../InputContainer");
var SliderInput_1 = require("../../SliderInput");
var helpers_2 = require("../helpers");
var styles_1 = require("./styles");
var minutesToFormattedHoursAndMinutes = function (value) {
    var _a = (0, helpers_2.minutesToHoursAndMinutes)(value), h = _a.h, m = _a.m;
    return h ? "".concat(h, " h ").concat(m, " m") : "".concat(m, " m");
};
var handleInvalidValues = function (textValue, onChange) {
    var timeInMinutes = (0, helpers_2.formattedTimeToMinutes)(textValue);
    if (textValue.length !== 5 && timeInMinutes)
        onChange(timeInMinutes);
};
/**
  ### Import using Formik

  ```
  import { FormikTimeInput } from '@impargo/components/Input/TimeInput'
  ```

  ### Import

  ```
  import { TimeInput } from '@impargo/components/Input/TimeInput'
  ```
 */
var TimeInput = function (_a) {
    var _b;
    var _c = _a.sliderInput, sliderInput = _c === void 0 ? false : _c, _d = _a.disabled, disabled = _d === void 0 ? false : _d, onChange = _a.onChange, onBlur = _a.onBlur, value = _a.value, _e = _a.closeOnClickOutside, closeOnClickOutside = _e === void 0 ? true : _e, modalTitle = _a.modalTitle, _f = _a.sliderStep, sliderStep = _f === void 0 ? 15 : _f, _g = _a.max, max = _g === void 0 ? 960 : _g, // 16 hours
    minWidth = _a.minWidth, props = __rest(_a, ["sliderInput", "disabled", "onChange", "onBlur", "value", "closeOnClickOutside", "modalTitle", "sliderStep", "max", "minWidth"]);
    var ref = (0, react_1.useRef)(null);
    var _h = (0, react_1.useState)(false), visible = _h[0], setVisible = _h[1];
    var _j = (0, react_1.useState)(function () { return (0, helpers_2.minutesToFormattedTime)(value); }), textValue = _j[0], setTextValue = _j[1];
    var _k = (0, react_1.useState)(0), selectionStart = _k[0], setSelectionStart = _k[1];
    var input = (_b = ref.current) === null || _b === void 0 ? void 0 : _b.firstChild;
    (0, helpers_2.useHandleInputCursor)(input, selectionStart, textValue);
    (0, react_1.useEffect)(function () {
        var handleClick = function (e) {
            var _a;
            if (!((_a = ref.current) === null || _a === void 0 ? void 0 : _a.contains(e.target)) && closeOnClickOutside) {
                setVisible(false);
            }
        };
        document.addEventListener('mousedown', handleClick, false);
        document.addEventListener('touchstart', handleClick, false);
        return function () {
            document.removeEventListener('mousedown', handleClick, false);
            document.removeEventListener('touchstart', handleClick, false);
        };
    }, []);
    (0, react_1.useEffect)(function () {
        setTextValue((0, helpers_2.minutesToFormattedTime)(value));
    }, [value]);
    var containerProps = (0, helpers_1.pickContainerProps)(props).containerProps;
    var onKeyDown = function (e) {
        var timeInMinutes = (0, helpers_2.formattedTimeToMinutes)(textValue);
        var changeHours = selectionStart === 0;
        var validKeys = e.key === 'ArrowUp' || e.key === 'ArrowDown';
        if (!validKeys || !(0, helpers_2.isValidTime)(textValue))
            return;
        var newValue = (0, helpers_2.changeTime)(timeInMinutes, changeHours, e, max);
        onChange(newValue);
    };
    return ((0, jsx_runtime_1.jsx)(InputContainer_1.InputContainer, __assign({ textAlign: 'center' }, containerProps, { type: 'TimeInput', disabled: disabled, children: (0, jsx_runtime_1.jsxs)("div", { className: 'TimeInput-input-container', ref: ref, css: function (theme) { return (0, styles_1.getStyle)(theme, sliderInput, minWidth); }, children: [(0, jsx_runtime_1.jsx)("input", { disabled: disabled, name: props.name, value: textValue, onBlur: function (e) {
                        setTextValue((0, helpers_2.minutesToFormattedTime)(value));
                        onBlur === null || onBlur === void 0 ? void 0 : onBlur(e);
                        handleInvalidValues(textValue, onChange);
                    }, onChange: function (e) {
                        var inputValue = e.target.value;
                        setTextValue(inputValue);
                        if ((0, helpers_2.isValidTime)(inputValue)) {
                            onChange(Math.min(max, (0, helpers_2.formattedTimeToMinutes)(inputValue)));
                        }
                    }, onClick: function () {
                        setVisible(!visible);
                        setTextValue((0, helpers_2.minutesToFormattedTime)(value));
                        handleInvalidValues(textValue, onChange);
                    }, onSelect: function (e) { return (0, helpers_2.select)(e, setSelectionStart, textValue.length === 5); }, onKeyDown: onKeyDown, style: { caretColor: 'transparent' } }), visible && sliderInput &&
                    (0, jsx_runtime_1.jsxs)("div", { className: 'floating', children: [modalTitle && (0, jsx_runtime_1.jsx)("div", { className: 'header', children: (0, jsx_runtime_1.jsx)("h1", { children: modalTitle }) }), (0, jsx_runtime_1.jsx)("div", { className: 'body', children: (0, jsx_runtime_1.jsx)(SliderInput_1.SliderInput, { sliderLabel: function (value) { return minutesToFormattedHoursAndMinutes(value); }, value: value, min: 0, max: max, step: sliderStep, valueLabelDisplay: 'off', smallLabel: true, valueLabelFormat: function (v) {
                                        return (0, helpers_2.minutesToFormattedTime)(v);
                                    }, enableFormMargins: false, onChangeCommitted: function (newValue) {
                                        if (typeof newValue === 'number') {
                                            onChange(newValue);
                                        }
                                    } }) })] })] }) })));
};
exports.TimeInput = TimeInput;
