import { FieldValidator } from 'formik';
import { FC } from 'react';
import { WithoutFieldInputProps } from '../../helpers';
import { TimerangeInputProps, TimerangeValueType } from './TimerangeInput';
export interface FormikTimerangeInputProps extends WithoutFieldInputProps<TimerangeInputProps, TimerangeValueType> {
    /**
     * Name of the underlying input component.
     */
    name: string;
    /**
     * [Formik Field Validation](https://formik.org/docs/guides/validation#field-level-validation),
     * if a string is returned by this function, validation errors will be shown below the field.
     */
    validate?: FieldValidator;
}
export declare const FormikTimerangeInput: FC<FormikTimerangeInputProps>;
//# sourceMappingURL=FormikTimerangeInput.d.ts.map