"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TimerangeInput = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("react");
var helpers_1 = require("../../helpers");
var InputContainer_1 = require("../../InputContainer");
var SliderInput_1 = require("../../SliderInput");
var helpers_2 = require("../helpers");
var styles_1 = require("./styles");
var minMaxTicksToTime = function (value) {
    var from = value[0], to = value[1];
    return { from: (0, helpers_2.minutesToFormattedTime)(from), to: (0, helpers_2.minutesToFormattedTime)(to) };
};
var minMaxTimeToTicks = function (value) {
    var from = value.from, to = value.to;
    return [(0, helpers_2.formattedTimeToMinutes)(from), (0, helpers_2.formattedTimeToMinutes)(to)];
};
var handleInvalidValues = function (textValue, value, onChange) {
    var _a = textValue.split(' - '), from = _a[0], to = _a[1];
    var _b = minMaxTimeToTicks({ from: from, to: to }), fromTimeInMinutes = _b[0], toTimeInMinutes = _b[1];
    if (textValue.length !== 13 && fromTimeInMinutes && toTimeInMinutes) {
        onChange(minMaxTicksToTime([fromTimeInMinutes, toTimeInMinutes]));
    }
    else {
        onChange(value);
    }
};
/**
  ### Import using Formik

  ```
  import { FormikTimerangeInput } from '@impargo/components/Input/TimerangeInput'
  ```

  ### Import

  ```
  import { TimerangeInput } from '@impargo/components/Input/TimerangeInput'
  ```
 */
var TimerangeInput = function (_a) {
    var _b;
    var _c = _a.textInput, textInput = _c === void 0 ? true : _c, _d = _a.sliderInput, sliderInput = _d === void 0 ? false : _d, _e = _a.disabled, disabled = _e === void 0 ? false : _e, onChange = _a.onChange, onBlur = _a.onBlur, value = _a.value, _f = _a.closeOnClickOutside, closeOnClickOutside = _f === void 0 ? true : _f, _g = _a.timeWindowTitle, timeWindowTitle = _g === void 0 ? 'Time window' : _g, _h = _a.openTimeLabel, openTimeLabel = _h === void 0 ? 'From:' : _h, _j = _a.closeTimeLabel, closeTimeLabel = _j === void 0 ? 'To:' : _j, minWidth = _a.minWidth, props = __rest(_a, ["textInput", "sliderInput", "disabled", "onChange", "onBlur", "value", "closeOnClickOutside", "timeWindowTitle", "openTimeLabel", "closeTimeLabel", "minWidth"]);
    var ref = (0, react_1.useRef)(null);
    var _k = (0, react_1.useState)(false), visible = _k[0], setVisible = _k[1];
    var from = (value === null || value === void 0 ? void 0 : value.from) || '';
    var to = (value === null || value === void 0 ? void 0 : value.to) || '';
    var _l = (0, react_1.useState)("".concat(from, " - ").concat(to)), textValue = _l[0], setTextValue = _l[1];
    var containerProps = (0, helpers_1.pickContainerProps)(props).containerProps;
    var _m = (0, react_1.useState)(0), selectionStart = _m[0], setSelectionStart = _m[1];
    var input = (_b = ref.current) === null || _b === void 0 ? void 0 : _b.firstChild;
    (0, helpers_2.useHandleInputCursor)(input, selectionStart, textValue);
    (0, react_1.useEffect)(function () {
        var handleClick = function (e) {
            var _a;
            if (!((_a = ref.current) === null || _a === void 0 ? void 0 : _a.contains(e.target)) && closeOnClickOutside) {
                setVisible(false);
            }
        };
        document.addEventListener('mousedown', handleClick, false);
        document.addEventListener('touchstart', handleClick, false);
        return function () {
            document.removeEventListener('mousedown', handleClick, false);
            document.removeEventListener('touchstart', handleClick, false);
        };
    }, []);
    (0, react_1.useEffect)(function () {
        setTextValue("".concat(from, " - ").concat(to));
    }, [from, to]);
    var onKeyDown = function (e) {
        var _a = textValue.split(' - '), from = _a[0], to = _a[1];
        var newValue = { from: from, to: to };
        var changeHours = selectionStart === 0 || selectionStart === 8;
        var validKeys = e.key === 'ArrowUp' || e.key === 'ArrowDown';
        if (!validKeys || !(0, helpers_2.isValidTime)(from) || !(0, helpers_2.isValidTime)(to))
            return;
        if (selectionStart < 6) {
            var fromTimeInMinutes = (0, helpers_2.formattedTimeToMinutes)(from);
            newValue.from = (0, helpers_2.minutesToFormattedTime)((0, helpers_2.changeTime)(fromTimeInMinutes, changeHours, e));
        }
        else {
            var toTimeInMinutes = (0, helpers_2.formattedTimeToMinutes)(to);
            newValue.to = (0, helpers_2.minutesToFormattedTime)((0, helpers_2.changeTime)(toTimeInMinutes, changeHours, e));
        }
        onChange(newValue);
    };
    return ((0, jsx_runtime_1.jsx)(InputContainer_1.InputContainer, __assign({}, containerProps, { type: 'timerange', disabled: disabled, children: (0, jsx_runtime_1.jsxs)("div", { className: 'timerange-input-container', ref: ref, css: function (theme) { return (0, styles_1.getStyle)(theme, sliderInput, minWidth); }, children: [(0, jsx_runtime_1.jsx)("input", { disabled: disabled, name: props.name, value: textValue, onBlur: function (e) {
                        setTextValue("".concat(from, " - ").concat(to));
                        handleInvalidValues(textValue, value, onChange);
                        onBlur === null || onBlur === void 0 ? void 0 : onBlur(e);
                    }, onChange: function (e) {
                        var inputValue = e.target.value;
                        setTextValue(inputValue);
                        var _a = inputValue.split(' - '), timeMin = _a[0], timeMax = _a[1];
                        if ((0, helpers_2.isValidTime)(timeMin) && (0, helpers_2.isValidTime)(timeMax)) {
                            var newValue = {
                                from: timeMin,
                                to: timeMax,
                            };
                            onChange(newValue);
                        }
                    }, onClick: function () {
                        setTextValue("".concat(from, " - ").concat(to));
                        setVisible(!visible);
                        handleInvalidValues(textValue, value, onChange);
                    }, onSelect: function (e) { return (0, helpers_2.select)(e, setSelectionStart, textValue.length === 13); }, onKeyDown: onKeyDown, style: { caretColor: 'transparent' } }), visible &&
                    (0, jsx_runtime_1.jsx)("div", { className: 'floating', children: (0, jsx_runtime_1.jsxs)("div", { className: 'rel', children: [(0, jsx_runtime_1.jsx)("div", { className: 'header', children: (0, jsx_runtime_1.jsx)("h1", { children: timeWindowTitle }) }), (0, jsx_runtime_1.jsx)("div", { className: 'body', children: (0, jsx_runtime_1.jsxs)("div", { className: 'inputs', children: [sliderInput && ((0, jsx_runtime_1.jsx)(SliderInput_1.SliderInput, { sliderLabel: function () { return ''; }, value: minMaxTimeToTicks(value), min: (0, helpers_2.formattedTimeToMinutes)('00:00'), valueLabelDisplay: 'on', smallLabel: true, valueLabelFormat: function (v) {
                                                    return (0, helpers_2.minutesToFormattedTime)(v);
                                                }, max: (0, helpers_2.formattedTimeToMinutes)('23:59'), onChangeCommitted: function (ticks) {
                                                    if (Array.isArray(ticks)) {
                                                        var newValue = minMaxTicksToTime(ticks);
                                                        onChange(newValue);
                                                    }
                                                } })), textInput &&
                                                ((0, jsx_runtime_1.jsxs)("div", { className: 'textInputs', children: [(0, jsx_runtime_1.jsxs)("div", { className: 'timeField', children: [(0, jsx_runtime_1.jsx)("label", { children: openTimeLabel }), (0, jsx_runtime_1.jsx)("input", { disabled: disabled, value: from, onChange: function (e) {
                                                                        if ((0, helpers_2.isValidTime)(e.target.value)) {
                                                                            var newValue = { from: e.target.value, to: value.to };
                                                                            onChange(newValue);
                                                                        }
                                                                    }, type: 'time' })] }), (0, jsx_runtime_1.jsxs)("div", { className: 'timeField', children: [(0, jsx_runtime_1.jsx)("label", { children: closeTimeLabel }), (0, jsx_runtime_1.jsx)("input", { disabled: disabled, value: to, onChange: function (e) {
                                                                        if ((0, helpers_2.isValidTime)(e.target.value)) {
                                                                            var newValue = { from: value.from, to: e.target.value };
                                                                            onChange(newValue);
                                                                        }
                                                                    }, type: 'time' })] })] }))] }) })] }) })] }) })));
};
exports.TimerangeInput = TimerangeInput;
