import { FieldInputProps } from 'formik';
import { InputContainerProps } from './InputContainer';
export declare const pickContainerProps: <T extends InputContainerProps>(props: T) => Pick<T, Exclude<keyof T, keyof InputContainerProps>> & {
    containerProps: InputContainerProps;
};
/**
 * Excludes 'FieldInputProps' from the provided type <Props>
 * @description These props 'FieldInputProps' are provided by formik, we don't want the user to manually specify them.
 */
export type WithoutFieldInputProps<Props, ValueType> = Pick<Props, Exclude<keyof Props, keyof FieldInputProps<ValueType> | 'error' | 'touched'>>;
//# sourceMappingURL=helpers.d.ts.map