"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReadableList2 = exports.ReadableList = exports.HorizontalList = exports.NavList = exports.DataDisplay = exports.BasicUsage = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var free_brands_svg_icons_1 = require("@fortawesome/free-brands-svg-icons");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var Badge_1 = __importDefault(require("../Badge"));
var Divider_1 = __importDefault(require("../Divider"));
var Icon_1 = __importDefault(require("../Icon"));
var Sheet_1 = __importDefault(require("../Sheet"));
var Tag_1 = __importDefault(require("../Tag"));
var Text_1 = __importDefault(require("../Text"));
var impargo_1 = __importDefault(require("../Themes/impargo"));
var storybook_1 = require("../utils/storybook");
var _1 = require(".");
var ListItem_1 = require("./ListItem");
var theme = impargo_1.default;
var faGalacticRepublic = free_brands_svg_icons_1.faGalacticRepublic;
var faJediOrder = free_brands_svg_icons_1.faJediOrder;
exports.default = {
    title: 'Components/Data/List',
    component: _1.List,
    argTypes: {
        orientation: { control: { type: 'select' } },
        theme: { table: { disable: true } },
    },
    args: {},
};
var BasicUsage = function (args) { return ((0, jsx_runtime_1.jsxs)(_1.List, __assign({}, args, { children: [(0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { hasBorder: true, label: 'Item number 1' }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { hasBorder: true, label: 'Item number 3' }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { hasBorder: false, label: 'Item number 2' })] }))); };
exports.BasicUsage = BasicUsage;
var DataDisplay = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(Sheet_1.default, { children: (0, jsx_runtime_1.jsxs)(_1.List, { py: '0', children: [(0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { hasBorder: true, label: 'Pilot', slotRight: 'Luke Skywalker', py: theme.spacingMedium }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { hasBorder: true, label: 'Co-Pilot', slotRight: 'R2-D2', py: theme.spacingMedium }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { hasBorder: false, label: 'Spacecraft', slotRight: 'X-wing Starfighter', py: theme.spacingMedium })] }) }), (0, jsx_runtime_1.jsx)(Sheet_1.default, { variant: 'medium', css: {
                marginTop: theme.spacingMedium,
            }, children: (0, jsx_runtime_1.jsxs)(_1.List, { py: '0', children: [(0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { hasBorder: true, px: '0', label: 'Pilot', slotRight: 'Han Solo', py: theme.spacingMedium }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { hasBorder: true, px: '0', label: 'Co-Pilot', slotRight: 'Chewbacca', py: theme.spacingMedium }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { hasBorder: true, px: '0', label: 'Spacecraft', slotRight: 'Millennium Falcon', py: theme.spacingMedium }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { hasBorder: false, px: '0', label: 'Darth Vader', slotRight: 'Death Start', py: theme.spacingMedium, disabled: true })] }) })] })); };
exports.DataDisplay = DataDisplay;
(0, storybook_1.addDescription)(exports.DataDisplay, "A common use case is to display data using a list and list items, either a sheet component or inside other UI elements.");
var NavList = function () { return ((0, jsx_runtime_1.jsxs)(_1.List, { children: [(0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { subtitle: true, label: 'Dark side' }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { label: 'Galactic Republic', slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faGalacticRepublic }) }), onClick: function () { return undefined; }, isActive: true }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { subtitle: true, label: 'Light side' }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { label: 'Jedi Council', slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faJediOrder }) }), onClick: function () { return undefined; }, slotRight: (0, jsx_runtime_1.jsx)(Badge_1.default, { overlap: 'inline', badgeCount: 3 }) })] })); };
exports.NavList = NavList;
(0, storybook_1.addDescription)(exports.NavList, "Another common use case is to display a nav list either inside a sidebar, a dropdown menu or inside a master list.");
var HorizontalList = function () { return ((0, jsx_runtime_1.jsx)(Sheet_1.default, { children: (0, jsx_runtime_1.jsxs)(_1.List, { orientation: 'horizontal', children: [(0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { orientation: 'vertical', hasBorder: false, py: theme.spacingMedium, label: (0, jsx_runtime_1.jsx)(Text_1.default, { variant: 'small', secondary: true, children: "Gains" }), slotRight: (0, jsx_runtime_1.jsx)(Text_1.default, { children: "42 %" }) }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { orientation: 'vertical', hasBorder: false, label: (0, jsx_runtime_1.jsx)(Text_1.default, { variant: 'small', secondary: true, children: "Gains" }), slotRight: (0, jsx_runtime_1.jsx)(Text_1.default, { children: "42 %" }), py: theme.spacingMedium }), (0, jsx_runtime_1.jsx)(Divider_1.default, { orientation: 'vertical', flexItem: true }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { orientation: 'vertical', label: (0, jsx_runtime_1.jsx)(Text_1.default, { variant: 'small', secondary: true, children: "Gains" }), hasBorder: false, slotRight: (0, jsx_runtime_1.jsx)(Text_1.default, { children: "42 %" }), py: theme.spacingMedium })] }) })); };
exports.HorizontalList = HorizontalList;
(0, storybook_1.addDescription)(exports.HorizontalList, "The `List` component can also be used in a horizontal layout using the `orientation` prop with `horizontal` layout. When using the list in a horizontal layout, the list item should also contain an `orientation` prop with a `horizontal` value.");
var ReadableList = function () { return ((0, jsx_runtime_1.jsxs)(_1.List, { children: [(0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { onClick: function () { return null; }, hasBorder: true, py: theme.spacingMedium, type: 'readable', unread: true, label: (0, jsx_runtime_1.jsxs)("div", { children: [(0, jsx_runtime_1.jsxs)("div", { css: (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n                  display: flex;\n                  justify-content: space-between;\n                  align-items: center;\n                "], ["\n                  display: flex;\n                  justify-content: space-between;\n                  align-items: center;\n                "]))), children: [(0, jsx_runtime_1.jsx)(Text_1.default, { color: theme.colorTextLink, children: "Have you read this?" }), (0, jsx_runtime_1.jsx)(Tag_1.default, { label: 'Assigned' })] }), (0, jsx_runtime_1.jsxs)("div", { children: [(0, jsx_runtime_1.jsx)(Text_1.default, { variant: 'small', children: "Have you read this?" }), (0, jsx_runtime_1.jsx)(Text_1.default, { variant: 'small', children: "Have you read this?" })] })] }), slotRightAlign: 'start' }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { onClick: function () { return null; }, hasBorder: true, py: theme.spacingMedium, type: 'readable', unread: false, label: 'Have you read this?', secondaryLabel: 'This is already read, nice!', slotRight: (0, jsx_runtime_1.jsx)(Tag_1.default, { label: 'Assigned' }) }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { onClick: function () { return null; }, hasBorder: true, py: theme.spacingMedium, type: 'readable', unread: true, label: 'Have you read this?', slotRight: (0, jsx_runtime_1.jsx)(Tag_1.default, { label: 'Assigned' }) })] })); };
exports.ReadableList = ReadableList;
(0, storybook_1.addDescription)(exports.ReadableList, "An unread prop is supported out of the box when using list items by passing the `unread` prop and the `type` prop with `readable` value.");
var ReadableList2 = function () { return ((0, jsx_runtime_1.jsxs)(_1.List, { children: [(0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { onClick: function () { return null; }, py: theme.spacingMedium, type: 'readable', unread: true, slotLeft: (0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n                width: 40px;\n                height: 40px;\n                background-color: ", ";\n                border-radius: ", ";\n              "], ["\n                width: 40px;\n                height: 40px;\n                background-color: ", ";\n                border-radius: ", ";\n              "])), theme.colorSurfaceLc, theme.borderRadiusCircular) }), label: (0, jsx_runtime_1.jsx)("div", { children: (0, jsx_runtime_1.jsx)(Text_1.default, { children: "Have you read this?" }) }), slotLeftAlign: 'center', slotRightAlign: 'flex-start', labelAlign: 'center', slotRight: (0, jsx_runtime_1.jsx)(Text_1.default, { variant: 'small', secondary: true, children: "11:25" }), badgeAlign: 'center' }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { onClick: function () { return null; }, py: theme.spacingMedium, type: 'readable', unread: false, slotLeft: (0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n                width: 40px;\n                height: 40px;\n                background-color: ", ";\n                border-radius: ", ";\n              "], ["\n                width: 40px;\n                height: 40px;\n                background-color: ", ";\n                border-radius: ", ";\n              "])), theme.colorSurfaceLc, theme.borderRadiusCircular) }), label: (0, jsx_runtime_1.jsxs)("div", { children: [(0, jsx_runtime_1.jsx)(Text_1.default, { children: "Have you read this?" }), (0, jsx_runtime_1.jsx)("div", { children: (0, jsx_runtime_1.jsx)(Text_1.default, { variant: 'small', children: "Have you read this?" }) })] }), slotLeftAlign: 'center', slotRightAlign: 'flex-start', labelAlign: 'center', slotRight: (0, jsx_runtime_1.jsx)(Text_1.default, { variant: 'small', secondary: true, children: "11:25" }), badgeAlign: 'center' }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { onClick: function () { return null; }, py: theme.spacingMedium, type: 'readable', unread: true, slotLeft: (0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n                width: 40px;\n                height: 40px;\n                background-color: ", ";\n                border-radius: ", ";\n              "], ["\n                width: 40px;\n                height: 40px;\n                background-color: ", ";\n                border-radius: ", ";\n              "])), theme.colorSurfaceLc, theme.borderRadiusCircular) }), label: (0, jsx_runtime_1.jsxs)("div", { children: [(0, jsx_runtime_1.jsx)(Text_1.default, { children: "Have you read this?" }), (0, jsx_runtime_1.jsxs)("div", { children: [(0, jsx_runtime_1.jsx)(Text_1.default, { variant: 'small', children: "Have you read this?" }), (0, jsx_runtime_1.jsx)(Text_1.default, { variant: 'small', children: "Have you read this?" })] })] }), slotLeftAlign: 'center', slotRightAlign: 'flex-start', labelAlign: 'center', slotRight: (0, jsx_runtime_1.jsx)(Text_1.default, { variant: 'small', secondary: true, children: "11:25" }), badgeAlign: 'center' })] })); };
exports.ReadableList2 = ReadableList2;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4;
