"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListItem = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var styled_1 = __importDefault(require("@emotion/styled"));
var react_2 = require("react");
var Badge_1 = __importDefault(require("../Badge"));
var Context_1 = require("../Dropdown/Context");
var Text_1 = __importDefault(require("../Text"));
var mixins_1 = require("../Themes/mixins");
var ListItemComponent = (0, react_2.forwardRef)(function (_a, ref) {
    var className = _a.className, label = _a.label, slotLeft = _a.slotLeft, slotRight = _a.slotRight, onClick = _a.onClick, _b = _a.disabled, disabled = _b === void 0 ? false : _b, whiteSpace = _a.whiteSpace, _c = _a.truncated, truncated = _c === void 0 ? false : _c, _d = _a.notAllowed, notAllowed = _d === void 0 ? false : _d, as = _a.as, secondaryLabel = _a.secondaryLabel, subtitle = _a.subtitle, _isActive = _a.isActive, _hasBorder = _a.hasBorder, _isSelected = _a.isSelected, unread = _a.unread, _slotLeftAlign = _a.slotLeftAlign, _slotRightAlign = _a.slotRightAlign, _labelAlign = _a.labelAlign, px = _a.px, py = _a.py, _e = _a.orientation, orientation = _e === void 0 ? 'horizontal' : _e, _f = _a.closeDropdownOnClick, closeDropdownOnClick = _f === void 0 ? true : _f, _g = _a.type, type = _g === void 0 ? 'default' : _g, _badgeAlign = _a.badgeAlign, rest = __rest(_a, ["className", "label", "slotLeft", "slotRight", "onClick", "disabled", "whiteSpace", "truncated", "notAllowed", "as", "secondaryLabel", "subtitle", "isActive", "hasBorder", "isSelected", "unread", "slotLeftAlign", "slotRightAlign", "labelAlign", "px", "py", "orientation", "closeDropdownOnClick", "type", "badgeAlign"]);
    var Element = as || 'li';
    var _h = (0, react_2.useContext)(Context_1.DropdownContext), isMounted = _h.isMounted, toggle = _h.toggle;
    var handleOnClick = (0, react_2.useCallback)(function (event) {
        onClick === null || onClick === void 0 ? void 0 : onClick(event);
        if (isMounted && closeDropdownOnClick) {
            toggle();
        }
    }, [onClick, isMounted, toggle, closeDropdownOnClick]);
    return ((0, jsx_runtime_1.jsxs)(Element, __assign({ ref: ref, className: "".concat(className, " list-item ").concat(orientation, " ").concat(isMounted && !px && !py ? 'list-item--is-dropdown' : ''), onClick: (disabled || notAllowed) ? undefined : handleOnClick, disabled: disabled }, rest, { children: [type === 'readable' &&
                (0, jsx_runtime_1.jsx)("div", { className: 'list-item__badge-spacer', children: unread &&
                        (0, jsx_runtime_1.jsx)(Badge_1.default, { shape: 'dot', overlap: 'inline', variant: 'primary' }) }), (0, jsx_runtime_1.jsxs)("div", { className: "list-item__label-container list-item__label-container--".concat(orientation), children: [slotLeft &&
                        (0, jsx_runtime_1.jsx)("span", { className: "list-item__slot list-item__slot--left list-item__slot--left--".concat(orientation), children: slotLeft }), label &&
                        (0, jsx_runtime_1.jsxs)(Text_1.default, { truncated: truncated, whiteSpace: whiteSpace, el: 'div', className: "list-item__text list-item__text--".concat(orientation), variant: subtitle ? 'subtitle' : 'body', children: [label, secondaryLabel &&
                                    (0, jsx_runtime_1.jsx)(Text_1.default, { secondary: true, el: 'span', className: 'list-item__text__secondary', children: secondaryLabel })] })] }), slotRight &&
                (0, jsx_runtime_1.jsx)("span", { className: "list-item__slot list-item__slot--right list-item__slot--right--".concat(orientation), children: slotRight })] })));
});
/**
 * The `ListItem` component is used to display data inside a list, display a nav list with nav items and display a items inside a menu in a dropdown.
 */
exports.ListItem = (0, styled_1.default)(ListItemComponent)(templateObject_13 || (templateObject_13 = __makeTemplateObject(["\n/* Basic styles */\n  display: flex;\n  width: 100%;\n  position: relative;\n  align-items: center;\n  justify-content: flex-start;\n  overflow: hidden;\n  font-family: ", ";\n  color: ", ";\n  line-height: ", ";\n  padding: ", ";\n  transition: background-color .3s ease-in-out;\n  text-decoration: none;\n\n  &.horizontal {\n    flex-direction: row;\n  }\n  &.vertical {\n    flex-direction: column;\n  }\n\n  ", "\n\n  ", "\n\n  ", "\n\n  ", "\n\n  &:last-child {\n    border: 0;\n  }\n\n  ", "\n\n/* Theming */\n\n  ", "\n  \n  ", "\n\n  ", "\n\n  ", "\n\n  ", "\n\n  @media only screen and (max-width: ", ") {\n    &.list-item--is-dropdown {\n      padding: ", ";\n    }\n  }\n\n/* Readable ListItem */\n  .list-item__badge-spacer {\n    width: ", ";\n    min-width: ", ";\n    height: ", ";\n    align-self: ", ";\n    margin-right: ", ";\n    padding-left: ", ";\n    display: flex;\n    align-items: center;\n    justify-content: center;\n  }\n\n/* Children */\n  .list-item__label-container {\n    display: flex;\n    &--vertical {\n      width: auto;\n      height: ", ";\n      min-height: ", ";\n    }\n    &--horizontal {\n      width: 100%;\n      flex: 1 1 auto;\n    }\n  }\n\n  .list-item__text {\n    width: 100%;\n    ", "\n\n    ", "\n  }\n\n  .list-item__slot {\n    min-width: ", ";\n    display: flex;\n    align-items: center;\n    justify-content: center;\n    color: ", ";\n    font-size: ", ";\n    flex: 0 0 auto;\n    \n    &--left {\n      margin-right: ", ";\n      align-self: ", ";\n    }\n    &--right {\n      justify-content: flex-end;\n      align-self: ", ";\n      &--vertical {\n        width: auto;\n        height: ", ";\n        min-height: ", ";\n      }\n      &--horizontal {\n        margin-left: auto;\n        padding-left: ", ";\n      }\n    }\n\n    ", "\n  }\n"], ["\n/* Basic styles */\n  display: flex;\n  width: 100%;\n  position: relative;\n  align-items: center;\n  justify-content: flex-start;\n  overflow: hidden;\n  font-family: ", ";\n  color: ", ";\n  line-height: ", ";\n  padding: ", ";\n  transition: background-color .3s ease-in-out;\n  text-decoration: none;\n\n  &.horizontal {\n    flex-direction: row;\n  }\n  &.vertical {\n    flex-direction: column;\n  }\n\n  ", "\n\n  ", "\n\n  ", "\n\n  ", "\n\n  &:last-child {\n    border: 0;\n  }\n\n  ", "\n\n/* Theming */\n\n  ", "\n  \n  ", "\n\n  ", "\n\n  ", "\n\n  ", "\n\n  @media only screen and (max-width: ", ") {\n    &.list-item--is-dropdown {\n      padding: ", ";\n    }\n  }\n\n/* Readable ListItem */\n  .list-item__badge-spacer {\n    width: ", ";\n    min-width: ", ";\n    height: ", ";\n    align-self: ", ";\n    margin-right: ", ";\n    padding-left: ", ";\n    display: flex;\n    align-items: center;\n    justify-content: center;\n  }\n\n/* Children */\n  .list-item__label-container {\n    display: flex;\n    &--vertical {\n      width: auto;\n      height: ", ";\n      min-height: ", ";\n    }\n    &--horizontal {\n      width: 100%;\n      flex: 1 1 auto;\n    }\n  }\n\n  .list-item__text {\n    width: 100%;\n    ", "\n\n    ", "\n  }\n\n  .list-item__slot {\n    min-width: ", ";\n    display: flex;\n    align-items: center;\n    justify-content: center;\n    color: ", ";\n    font-size: ", ";\n    flex: 0 0 auto;\n    \n    &--left {\n      margin-right: ", ";\n      align-self: ", ";\n    }\n    &--right {\n      justify-content: flex-end;\n      align-self: ", ";\n      &--vertical {\n        width: auto;\n        height: ", ";\n        min-height: ", ";\n      }\n      &--horizontal {\n        margin-left: auto;\n        padding-left: ", ";\n      }\n    }\n\n    ", "\n  }\n"])), function (_a) {
    var theme = _a.theme;
    return theme.fontFamily;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorText;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontLineHeight;
}, function (_a) {
    var theme = _a.theme;
    return "".concat(theme.spacingSmall, " ").concat(theme.spacingMedium);
}, function (_a) {
    var subtitle = _a.subtitle;
    return subtitle && (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["pointer-events: none;"], ["pointer-events: none;"])));
}, function (_a) {
    var hasBorder = _a.hasBorder, subtitle = _a.subtitle, theme = _a.theme;
    return (hasBorder && !subtitle) && (0, react_1.css)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n    border-bottom: 1px solid ", ";\n  "], ["\n    border-bottom: 1px solid ", ";\n  "])), theme.colorDivider);
}, function (_a) {
    var onClick = _a.onClick, as = _a.as, theme = _a.theme;
    return (onClick || as) && (0, react_1.css)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n    ", "\n  "], ["\n    ", "\n  "])), (0, mixins_1.overlayHoverMixin)(theme, 'colorHover', 'colorActive'));
}, function (_a) {
    var disabled = _a.disabled, notAllowed = _a.notAllowed;
    return (disabled || notAllowed) && (0, react_1.css)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n    ", "\n    cursor: not-allowed;\n    &::before {\n      display: none;\n    }\n    &:hover,\n    &:focus,\n    &:active {\n      cursor: not-allowed;\n    }\n  "], ["\n    ", "\n    cursor: not-allowed;\n    &::before {\n      display: none;\n    }\n    &:hover,\n    &:focus,\n    &:active {\n      cursor: not-allowed;\n    }\n  "])), disabled && (0, react_1.css)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["opacity: 0.65;"], ["opacity: 0.65;"]))));
}, function (_a) {
    var slotRight = _a.slotRight, orientation = _a.orientation, theme = _a.theme;
    return (!slotRight && orientation === 'horizontal') && (0, react_1.css)(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n    padding-right: ", ";\n  "], ["\n    padding-right: ", ";\n  "])), theme.spacingLarge);
}, function (_a) {
    var isActive = _a.isActive, theme = _a.theme, isSelected = _a.isSelected;
    return isActive && (0, react_1.css)(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n    background-color: ", ";\n    background-color: ", ";\n    &::after {\n      position: absolute;\n      content: '';\n      top: 0;\n      left: 0;\n      bottom: 0;\n      width: ", ";\n      background-color: ", ";\n      border-radius: ", ";\n    }\n  "], ["\n    background-color: ", ";\n    background-color: ", ";\n    &::after {\n      position: absolute;\n      content: '';\n      top: 0;\n      left: 0;\n      bottom: 0;\n      width: ", ";\n      background-color: ", ";\n      border-radius: ", ";\n    }\n  "])), isActive && theme.colorHover, isSelected && theme.colorPrimaryA4, theme.spacingXSmall, theme.colorPrimary, theme.borderRadius);
}, function (_a) {
    var type = _a.type;
    return type === 'readable' && (0, react_1.css)(templateObject_8 || (templateObject_8 = __makeTemplateObject(["\n    padding-left: 0;\n  "], ["\n    padding-left: 0;\n  "])));
}, function (_a) {
    var isSelected = _a.isSelected, theme = _a.theme;
    return isSelected && (0, react_1.css)(templateObject_9 || (templateObject_9 = __makeTemplateObject(["\n    background-color: ", ";\n  "], ["\n    background-color: ", ";\n  "])), theme.colorPrimaryA4);
}, function (_a) {
    var py = _a.py;
    return py && (0, react_1.css)(templateObject_10 || (templateObject_10 = __makeTemplateObject(["\n    padding-top: ", ";\n    padding-bottom: ", ";\n  "], ["\n    padding-top: ", ";\n    padding-bottom: ", ";\n  "])), py, py);
}, function (_a) {
    var px = _a.px;
    return px && (0, react_1.css)(templateObject_11 || (templateObject_11 = __makeTemplateObject(["\n    padding-right: ", ";\n    padding-left: ", ";\n  "], ["\n    padding-right: ", ";\n    padding-left: ", ";\n  "])), px, px);
}, function (_a) {
    var theme = _a.theme;
    return theme.breakpointMobile;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingMedium;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontLineHeight;
}, function (_a) {
    var badgeAlign = _a.badgeAlign;
    return badgeAlign || 'flex-start';
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingSmall;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingSmall;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontLineHeight;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontLineHeight;
}, function (_a) {
    var labelAlign = _a.labelAlign;
    return labelAlign && "\n      display: flex;\n      align-items: ".concat(labelAlign, ";\n    ");
}, function (_a) {
    var secondaryLabel = _a.secondaryLabel;
    return secondaryLabel && "\n      display: flex;\n      flex-direction: column;\n    ";
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingMedium;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorTextMc;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontSizeBody;
}, function (_a) {
    var label = _a.label, theme = _a.theme;
    return label && theme.spacingSmall;
}, function (_a) {
    var slotLeftAlign = _a.slotLeftAlign;
    return slotLeftAlign || 'center';
}, function (_a) {
    var slotRightAlign = _a.slotRightAlign;
    return slotRightAlign || 'center';
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingMedium;
}, function (_a) {
    var notAllowed = _a.notAllowed;
    return notAllowed && (0, react_1.css)(templateObject_12 || (templateObject_12 = __makeTemplateObject(["\n      opacity: 0.65;\n    "], ["\n      opacity: 0.65;\n    "])));
});
exports.default = exports.ListItem;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8, templateObject_9, templateObject_10, templateObject_11, templateObject_12, templateObject_13;
