"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TooltipWithinListItem = exports.DisabledAndNotAllowed = exports.SecondaryLabel = exports.Spacing = exports.AsLink = exports.Subtitle = exports.Readable = exports.ActiveAndSelected = exports.Selected = exports.Border = exports.Active = exports.OnClick = exports.WithSlots = exports.Label = exports.BasicUsage = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var Divider_1 = __importDefault(require("@impargo/components/Divider"));
var Icon_1 = __importDefault(require("@impargo/components/Icon"));
var InfoIcon_1 = __importDefault(require("../InfoIcon"));
var Text_1 = __importDefault(require("../Text"));
var impargo_1 = __importDefault(require("../Themes/impargo"));
var storybook_1 = require("../utils/storybook");
var ListItem_1 = require("./ListItem");
var theme = impargo_1.default;
var faClipboard = free_solid_svg_icons_1.faSearch;
var faShare = free_solid_svg_icons_1.faShare;
var faCheck = free_solid_svg_icons_1.faCheck;
exports.default = {
    title: 'Components/Data/List/ListItem',
    component: ListItem_1.ListItem,
    argTypes: {
        slotLeft: { control: false },
        slotRight: { control: false },
        onClick: { control: false },
        type: { control: { type: 'select' } },
        orientation: { control: { type: 'select' } },
        theme: { table: { disable: true } },
    },
    args: {
        label: 'Some label',
    },
};
var BasicUsage = function (args) { return ((0, jsx_runtime_1.jsx)(ListItem_1.ListItem, __assign({}, args))); };
exports.BasicUsage = BasicUsage;
exports.BasicUsage.args = {
    label: 'Some label',
};
var Label = function () { return ((0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { label: 'Item number 1' })); };
exports.Label = Label;
(0, storybook_1.addDescription)(exports.Label, "A simple list item displays a label with no other props needed to be passed.");
var WithSlots = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { label: 'Item number 1', slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faClipboard }) }) }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { label: 'Item number 2', slotRight: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faShare }) }) }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { label: 'Item number 3', disabled: true, slotRight: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faCheck }) }) })] })); };
exports.WithSlots = WithSlots;
(0, storybook_1.addDescription)(exports.WithSlots, "Icons can give extra context when displaying a list of items. The `slotLeft` and `slotRight` props are available to add icons to the left and/or right of the list item.");
var OnClick = function () { return ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { label: 'Item number 1', slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faClipboard }) }), slotRight: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faShare }) }), onClick: function () { return undefined; } }) })); };
exports.OnClick = OnClick;
(0, storybook_1.addDescription)(exports.OnClick, "We can add an on click handler to allow performing action when clicking on the list item.");
var Active = function () { return ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { label: 'Item number 1', isActive: true, slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faClipboard }) }), slotRight: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faShare }) }), onClick: function () { return undefined; } }) })); };
exports.Active = Active;
(0, storybook_1.addDescription)(exports.Active, "When the list item is used as a navigation item we can add the `isActive` prop to specify that the list item is the current selected item. Only one lis item should be active inside a list.");
var Border = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { label: 'Item number 1', hasBorder: true }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { label: 'Item number 2' })] })); };
exports.Border = Border;
(0, storybook_1.addDescription)(exports.Border, "When displaying multiple list items, the `hasBorder` prop adds a border bottom to add a visual separator between them.");
var Selected = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { label: 'Item number 1', isSelected: false, slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { text: ' ' }), onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { label: 'Item number 2', isSelected: true, slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faCheck }) }), onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { label: 'Item number 3', isSelected: true, slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faCheck }) }), onClick: function () { return undefined; } })] })); };
exports.Selected = Selected;
(0, storybook_1.addDescription)(exports.Selected, "With the `isSelected` prop we can specify if one or multiple list items are currently selected. This can be useful if we want to perform batch actions over the selected list items.");
var ActiveAndSelected = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { label: 'Item number 1', isSelected: false, slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { text: ' ' }), onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { label: 'Item number 2', isSelected: true, slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faCheck }) }), onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { label: 'Item number 3', isActive: true, isSelected: true, slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faCheck }) }), onClick: function () { return undefined; } })] })); };
exports.ActiveAndSelected = ActiveAndSelected;
(0, storybook_1.addDescription)(exports.Selected, 'An active list item can also be selected by passing both `isActive` and `isSelected` props to the component. A use case for this is when the component is used in a master detail view where the list items can also be selected to perform batch actions.');
var Readable = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { label: 'Item number 1', unread: true, type: 'readable', slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faClipboard }) }), slotRight: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faShare }) }), onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { label: 'Item number 2', type: 'readable', slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faClipboard }) }), slotRight: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faShare }) }), onClick: function () { return undefined; } })] })); };
exports.Readable = Readable;
(0, storybook_1.addDescription)(exports.Readable, "Depending on the use case the list item can have an unread state, this is a native implementation of unread state, that requires the use of the `type` with value `readable` and the  `unread`  props. This implementation will add styles to all the list items displayed together so they all have consistent styling.");
var Subtitle = function () { return ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { label: 'Nex items', subtitle: true }) })); };
exports.Subtitle = Subtitle;
(0, storybook_1.addDescription)(exports.Subtitle, "The `subtitle` prop specifies if the list items is a subtitle or not. The subtitle is used as a separator between sets of list items.");
var AsLink = function () { return ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { label: 'Link to link story', as: 'a', href: 'https://impargo.github.io/impargo-design-system/?path=/docs/components-data-list-listitem--as-link#as-link', target: '_blank', slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faClipboard }) }), slotRight: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faShare }) }) }) })); };
exports.AsLink = AsLink;
(0, storybook_1.addDescription)(exports.AsLink, "We can also specify what type of element is going to be rendered in the component using the `as` prop. The component provides props for target and href with the `target` and `href` prop.");
var Spacing = function () { return ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { label: 'Item number 1', px: '0', py: theme.spacingMedium }) })); };
exports.Spacing = Spacing;
(0, storybook_1.addDescription)(exports.Spacing, "We can specify different spacing around the list item with the `px` and `py` props.");
var SecondaryLabel = function () { return ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { label: 'Download this', secondaryLabel: 'PDF, CSV', onClick: function () { return undefined; } }) })); };
exports.SecondaryLabel = SecondaryLabel;
(0, storybook_1.addDescription)(exports.SecondaryLabel, "With the `secondaryLabel` we can add more context to the list item without overcrowding the UI..");
var DisabledAndNotAllowed = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { label: 'Download this', secondaryLabel: 'PDF, CSV', onClick: function () { return undefined; }, disabled: true }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { label: 'Download that', secondaryLabel: 'PDF, CSV', onClick: function () { return undefined; }, notAllowed: true }), (0, jsx_runtime_1.jsx)(Divider_1.default, { my: theme.spacingSmall }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faClipboard }) }), label: 'Look at this', disabled: true }), (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faClipboard }) }), label: 'Look at that', notAllowed: true })] })); };
exports.DisabledAndNotAllowed = DisabledAndNotAllowed;
(0, storybook_1.addDescription)(exports.DisabledAndNotAllowed, 'The `disabled` and `notAllowed` prop are available in case the list item should not be allowed to be clicked or interacted with.');
var TooltipWithinListItem = function () { return ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: (0, jsx_runtime_1.jsx)(ListItem_1.ListItem, { label: (0, jsx_runtime_1.jsxs)(Text_1.default, { children: ["Hover over slot left ", (0, jsx_runtime_1.jsx)(InfoIcon_1.default, { infoText: 'This will show the tooltip.' })] }), onClick: console.log, slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { className: 'grab-icon', size: 'xs', "data-tooltip-content": 'Drag to reorder', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faGripLines, color: theme.colorSmoke }) }) }) })); };
exports.TooltipWithinListItem = TooltipWithinListItem;
(0, storybook_1.addDescription)(exports.TooltipWithinListItem, 'In order to show tooltips within slotLeft or slotRight while keeping the onClick handler the z-index of the slot might need to be adapted.');
