import { CSSProperties } from 'react';
export type Orientation = 'vertical' | 'horizontal';
export interface ListProps extends React.HTMLAttributes<HTMLUListElement> {
    /**
     * Class name assigned to the component. Should be used sparingly.
     */
    className?: string;
    /**
     * Specifies margin top.
     */
    mt?: CSSProperties['marginTop'];
    /**
     * Specifies margin right.
     */
    mr?: CSSProperties['marginRight'];
    /**
     * Specifies margin bottom.
     */
    mb?: CSSProperties['marginBottom'];
    /**
     * Specifies margin left.
     */
    ml?: CSSProperties['marginLeft'];
    /**
     * Specifies padding left and right.
     */
    px?: CSSProperties['paddingLeft'];
    /**
     * Specifies padding top and bottom.
     */
    py?: CSSProperties['paddingTop'];
    /**
     * Specifies the width of the component.
     * @default 100%
     */
    width?: CSSProperties['width'];
    /**
     * Specifies the overflow property of the list.
     */
    overflow?: CSSProperties['overflow'];
    /**
     * Specifies the height of the component.
     * @default 100%
     */
    height?: CSSProperties['height'];
    /**
     * Specifies the orientation of the component.
     * @default vertical
     */
    orientation?: Orientation;
}
/**
 * The `List` component can be used to display data using `ListItem`s, a nav list in a sidebar, a menu list inside a dropdown and other used cases that requires displaying similar information either vertically or horizontally.
 */
export declare const List: import("@emotion/styled").StyledComponent<ListProps & {
    theme?: import("@emotion/react").Theme | undefined;
}, {}, {}>;
export default List;
//# sourceMappingURL=index.d.ts.map