"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NormalModalWithForm = exports.NormalModal = exports.MobileModal = exports.FullScreenModal = exports.BasicUsage = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var react_1 = require("react");
var Button_1 = __importDefault(require("../Button"));
var SubmitButton_1 = require("../Button/SubmitButton");
var Form_1 = __importDefault(require("../Form"));
var CheckboxInput_1 = require("../Input/CheckboxInput");
var Select_1 = require("../Input/Select");
var TextareaInput_1 = require("../Input/TextareaInput");
var List_1 = __importDefault(require("../List"));
var ListItem_1 = __importDefault(require("../List/ListItem"));
var Text_1 = __importDefault(require("../Text"));
var impargo_1 = __importDefault(require("../Themes/impargo"));
var storybook_1 = require("../utils/storybook");
var _1 = require(".");
var ModalBody_1 = __importDefault(require("./ModalBody"));
var ModalFooter_1 = __importDefault(require("./ModalFooter"));
var ModalHeader_1 = __importDefault(require("./ModalHeader"));
var faSearch = free_solid_svg_icons_1.faSearch;
var faTimes = free_solid_svg_icons_1.faTimes;
var theme = impargo_1.default;
exports.default = {
    title: 'Components/Overlay/Modal/Modal',
    component: _1.Modal,
    argTypes: {
        isOpen: { control: false },
        onClose: { control: false },
        theme: { table: { disable: true } },
    },
};
var BasicUsage = function (args) {
    var _a = (0, react_1.useState)(false), isOpen = _a[0], setIsOpen = _a[1];
    return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(Button_1.default, { onClick: function () { return setIsOpen(!isOpen); }, children: "Open modal" }), (0, jsx_runtime_1.jsxs)(_1.Modal, __assign({}, args, { isOpen: isOpen, onClose: function () { return setIsOpen(false); }, children: [(0, jsx_runtime_1.jsx)(ModalHeader_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), closeIcon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faTimes }), title: 'Modal title', onClose: function () { return setIsOpen(!isOpen); } }), (0, jsx_runtime_1.jsx)(ModalBody_1.default, { withPadding: true, children: (0, jsx_runtime_1.jsx)(Text_1.default, { children: "Modal content" }) }), (0, jsx_runtime_1.jsx)(ModalFooter_1.default, { successMessage: 'This was successful', successIcon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), children: (0, jsx_runtime_1.jsx)(Button_1.default, { shape: 'flat', onClick: function () { return setIsOpen(!isOpen); }, children: "Close" }) })] }))] }));
};
exports.BasicUsage = BasicUsage;
var FullScreenModal = function () {
    var _a = (0, react_1.useState)(false), isOpen = _a[0], setIsOpen = _a[1];
    return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(Button_1.default, { onClick: function () { return setIsOpen(!isOpen); }, children: "Open fullscreen modal" }), (0, jsx_runtime_1.jsxs)(_1.Modal, { isOpen: isOpen, onClose: function () { return setIsOpen(!isOpen); }, fullScreen: true, children: [(0, jsx_runtime_1.jsx)(ModalHeader_1.default, { fullScreen: true, closeText: 'Cancel', title: 'Modal title', onClose: function () { return setIsOpen(!isOpen); }, icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }) }), (0, jsx_runtime_1.jsx)(ModalBody_1.default, { withPadding: true, fullScreen: true, children: (0, jsx_runtime_1.jsx)(Text_1.default, { children: "Modal content" }) }), (0, jsx_runtime_1.jsx)(ModalFooter_1.default, { children: (0, jsx_runtime_1.jsx)(Button_1.default, { shape: 'flat', onClick: function () { return setIsOpen(!isOpen); }, children: "Close" }) })] })] }));
};
exports.FullScreenModal = FullScreenModal;
(0, storybook_1.addDescription)(exports.FullScreenModal, 'By passing `fullScreen` prop the modal always fills the full screen. The fill screen modal is used when more complex layouts or actions are being displayed or done that would feel cramped when using a regular modal.');
var MobileModal = function () {
    var _a = (0, react_1.useState)(false), isOpen = _a[0], setIsOpen = _a[1];
    return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(Button_1.default, { onClick: function () { return setIsOpen(!isOpen); }, children: "Open modal on mobile" }), (0, jsx_runtime_1.jsxs)(_1.Modal, { isOpen: isOpen, onClose: function () { return setIsOpen(!isOpen); }, children: [(0, jsx_runtime_1.jsx)(ModalHeader_1.default, { title: 'Edit transport', helperText: ' - 123456', onClose: function () { return setIsOpen(!isOpen); }, closeIcon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faTimes }) }), (0, jsx_runtime_1.jsx)(ModalBody_1.default, { children: (0, jsx_runtime_1.jsxs)(List_1.default, { children: [(0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Option 1', px: theme.spacingLarge, py: theme.spacingMedium, slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: 'star' }), onClick: function () { return null; } }, 1), (0, jsx_runtime_1.jsx)(ListItem_1.default, { label: 'Option 1', px: theme.spacingLarge, py: theme.spacingMedium, slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), onClick: function () { return null; } }, 2)] }) }), (0, jsx_runtime_1.jsxs)(ModalFooter_1.default, { children: [(0, jsx_runtime_1.jsx)(Button_1.default, { shape: 'flat', onClick: function () { return setIsOpen(!isOpen); }, children: "Close" }), (0, jsx_runtime_1.jsx)(Button_1.default, { shape: 'default', ml: theme.spacingMedium, onClick: function () { return setIsOpen(!isOpen); }, children: "Close" })] })] })] }));
};
exports.MobileModal = MobileModal;
(0, storybook_1.addDescription)(exports.MobileModal, 'On mobile the modal will open from the bottom making interactions easier to reach.');
var NormalModal = function () {
    var _a = (0, react_1.useState)(false), isOpen = _a[0], setIsOpen = _a[1];
    return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(Button_1.default, { onClick: function () { return setIsOpen(!isOpen); }, children: "Open Normal modal" }), (0, jsx_runtime_1.jsxs)(_1.Modal, { isOpen: isOpen, onClose: function () { return setIsOpen(!isOpen); }, children: [(0, jsx_runtime_1.jsx)(ModalHeader_1.default, { closeText: 'Cancel', title: 'Modal title', onClose: function () { return setIsOpen(!isOpen); }, icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }) }), (0, jsx_runtime_1.jsx)(ModalBody_1.default, { withPadding: true, children: (0, jsx_runtime_1.jsx)(Text_1.default, { children: "The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works.The norml modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works. The normal modal case shows how the modal behaves in normal cases, Also it\\'s filled with multiple lines to test how the scrolling behavior works." }) }), (0, jsx_runtime_1.jsx)(ModalFooter_1.default, { children: (0, jsx_runtime_1.jsx)(Button_1.default, { shape: 'flat', onClick: function () { return setIsOpen(!isOpen); }, children: "Close" }) })] })] }));
};
exports.NormalModal = NormalModal;
var NormalModalWithForm = function () {
    var _a = (0, react_1.useState)(false), isOpen = _a[0], setIsOpen = _a[1];
    return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(Button_1.default, { onClick: function () { return setIsOpen(!isOpen); }, children: "Open Normal modal With Form" }), (0, jsx_runtime_1.jsxs)(_1.Modal, { isOpen: isOpen, onClose: function () { return setIsOpen(!isOpen); }, children: [(0, jsx_runtime_1.jsx)(ModalHeader_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), title: 'Modal with Form Example', closeIcon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faTimes }), 
                        // eslint-disable-next-line @typescript-eslint/no-empty-function
                        onClose: function () { return setIsOpen(!isOpen); } }), (0, jsx_runtime_1.jsxs)(Form_1.default, { initialValues: {}, 
                        // eslint-disable-next-line @typescript-eslint/no-empty-function
                        onSubmit: function () {
                        }, children: [(0, jsx_runtime_1.jsxs)(ModalBody_1.default, { withPadding: true, children: [(0, jsx_runtime_1.jsx)(TextareaInput_1.FormikTextareaInput, { name: 'decliningComment', label: 'Label1', placeholder: 'Text here...', "data-testid": 'comment-field', rows: 3, isVertical: true }), (0, jsx_runtime_1.jsx)(TextareaInput_1.FormikTextareaInput, { name: 'decliningComment', label: 'Label2', placeholder: 'Text here...', "data-testid": 'comment-field', rows: 3, isVertical: true }), (0, jsx_runtime_1.jsx)(TextareaInput_1.FormikTextareaInput, { name: 'decliningComment', label: 'Label3', placeholder: 'Text here...', "data-testid": 'comment-field', rows: 3, isVertical: true }), (0, jsx_runtime_1.jsx)(TextareaInput_1.FormikTextareaInput, { name: 'decliningComment', label: 'Label4', placeholder: 'Text here...', "data-testid": 'comment-field', rows: 3, isVertical: true }), (0, jsx_runtime_1.jsx)(TextareaInput_1.FormikTextareaInput, { name: 'decliningComment', label: 'Label4', placeholder: 'Text here...', "data-testid": 'comment-field', rows: 3, isVertical: true }), (0, jsx_runtime_1.jsx)(CheckboxInput_1.FormikCheckboxInput, { reversed: true, label: 'Option1', secondaryLabel: true, name: 'missingFeatures.truckOverview' }), (0, jsx_runtime_1.jsx)(CheckboxInput_1.FormikCheckboxInput, { reversed: true, label: 'Option2', secondaryLabel: true, name: 'missingFeatures.routeDriver' }), (0, jsx_runtime_1.jsx)(Select_1.FormikSelect, { multi: true, label: 'Multi-select', dropup: true, options: [
                                            { label: 'Cars', value: 'cars' },
                                            { label: 'Trucks', value: 'trucks' },
                                            { label: 'Busses', value: 'busses' },
                                            { label: 'Trains', value: 'trains' },
                                            { label: 'Trains', value: 'trains' },
                                            { label: 'Trains', value: 'trains' },
                                            { label: 'Trains', value: 'trains' },
                                            { label: 'Trains', value: 'trains' },
                                            { label: 'Trains', value: 'trains' },
                                            { label: 'Trains', value: 'trains' },
                                            { label: 'Trains', value: 'trains' },
                                        ], name: 'vehicles' })] }), (0, jsx_runtime_1.jsxs)(ModalFooter_1.default, { className: 'modal-footer', children: [(0, jsx_runtime_1.jsx)(Button_1.default, { shape: 'default', disabled: true, 
                                        // eslint-disable-next-line @typescript-eslint/no-empty-function
                                        onClick: function () {
                                            // eslint-disable-next-line no-trailing-spaces
                                        }, "data-testid": 'cancel-button', children: 'cancel' }), (0, jsx_runtime_1.jsx)(SubmitButton_1.SubmitButton, { "data-tooltip-content": 'reasonForDecliningMissing', variant: 'danger', shape: 'flat', loading: false, "data-testid": 'decline-button', children: 'decline' })] })] })] })] }));
};
exports.NormalModalWithForm = NormalModalWithForm;
(0, storybook_1.addDescription)(exports.NormalModal, 'The normal modal case shows how the modal behaves in normal cases, Also it\'s filled with multiple lines to test how the scrolling behavior works.');
(0, storybook_1.addDescription)(exports.NormalModalWithForm, 'The normal modal case shows how the modal behaves in normal cases, Also it\'s filled with multiple lines to test how the scrolling behavior works.');
