import { CSSProperties } from '@material-ui/core/styles/withStyles';
import { ReactNode } from 'react';
export interface ModalBodyProps {
    /**
     * Class name assigned to the component. Should be used sparingly.
     */
    className?: string;
    /**
      * Specifies if the modal will cover the full screen of the browser.
      * Changes the background color of the modal body when it's full screen. When full screen `colorSurfaceMc` otherwise it's `colorSurfaceHc`.
      * @default false
      */
    fullScreen?: boolean;
    /**
     * Adds padding `spacingLarge` to the modal body.
     * @default false
     */
    withPadding?: boolean;
    /**
     * Indicates the overflow behaviour of the modal.
     * @default auto
     */
    overflow?: CSSProperties['overflow'];
    /**
     * Content of the modal.
     */
    children?: ReactNode;
}
/**
 * Layout component used for the bodies in modals.

  ### Import

  ```
  import ModalBody from '@impargo/components/Modal/ModalBody'
  ```
 */
export declare const ModalBody: import("@emotion/styled").StyledComponent<ModalBodyProps & {
    theme?: import("@emotion/react").Theme | undefined;
}, {}, {}>;
export default ModalBody;
//# sourceMappingURL=ModalBody.d.ts.map