import { ReactNode } from 'react';
export interface ModalFooterProps {
    /**
     * Class name assigned to the component. Should be used sparingly.
     */
    className?: string;
    /**
     * @deprecated Can not be used if slotLeft is provided
     * Success message that will be shown in the footer.
     */
    successMessage?: string;
    /**
     * @deprecated Can not be used if slotLeft is provided
     * Icon that accompanies the success message.
     */
    successIcon?: string | JSX.Element;
    /**
     * Elements that will appear in the primary place of the footer.
     * Should contain buttons and actions.
     */
    children?: ReactNode;
    /**
     * Elements to appear in the left of the footer
     */
    slotLeft?: ReactNode;
}
/**
 * Layout component used for the footer in modals. Usually used to add actions to modals.

  ### Import

  ```
  import ModalFooter from '@impargo/components/Modal/ModalFooter'
  ```
 */
export declare const ModalFooter: import("@emotion/styled").StyledComponent<ModalFooterProps & {
    theme?: import("@emotion/react").Theme | undefined;
}, {}, {}>;
export default ModalFooter;
//# sourceMappingURL=ModalFooter.d.ts.map