"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ModalFooter = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var styled_1 = __importDefault(require("@emotion/styled"));
var Text_1 = __importDefault(require("../Text"));
var Component = function (_a) {
    var className = _a.className, successMessage = _a.successMessage, successIcon = _a.successIcon, children = _a.children, slotLeft = _a.slotLeft;
    return ((0, jsx_runtime_1.jsxs)("div", { className: className, children: [slotLeft && (0, jsx_runtime_1.jsx)("span", { className: 'modal-footer-slot__left', children: slotLeft }), !slotLeft && successMessage &&
                (0, jsx_runtime_1.jsxs)(Text_1.default, { className: 'modal-footer-success', children: [successIcon &&
                            (0, jsx_runtime_1.jsx)("span", { className: 'modal-footer-success__icon', children: successIcon }), successMessage] }), (0, jsx_runtime_1.jsx)("div", { className: 'modal-footer__actions', children: children })] }));
};
/**
 * Layout component used for the footer in modals. Usually used to add actions to modals.

  ### Import

  ```
  import ModalFooter from '@impargo/components/Modal/ModalFooter'
  ```
 */
exports.ModalFooter = (0, styled_1.default)(Component)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  position: sticky;\n  display: flex;\n  flex: 0 1 auto;\n  height: auto;\n  align-items: center;\n  justify-content: space-between;\n  width: 100%;\n  border-top: 1px solid ", ";\n  padding: ", " ", ";\n  position: sticky;\n  bottom: 0;\n  background-color: ", ";\n  z-index: 1;\n  .modal-footer-success {\n    margin-right: auto;\n    color: ", ";\n\n    &__icon {\n      margin-right: ", ";\n      font-size: ", ";\n    }\n  }\n\n  .modal-footer__actions {\n    display: flex;\n    margin-left: auto;\n  }\n  \n  .modal-footer__slot-left {\n    display: flex;\n    margin-right: auto;\n  }\n\n"], ["\n  position: sticky;\n  display: flex;\n  flex: 0 1 auto;\n  height: auto;\n  align-items: center;\n  justify-content: space-between;\n  width: 100%;\n  border-top: 1px solid ", ";\n  padding: ", " ", ";\n  position: sticky;\n  bottom: 0;\n  background-color: ", ";\n  z-index: 1;\n  .modal-footer-success {\n    margin-right: auto;\n    color: ", ";\n\n    &__icon {\n      margin-right: ", ";\n      font-size: ", ";\n    }\n  }\n\n  .modal-footer__actions {\n    display: flex;\n    margin-left: auto;\n  }\n  \n  .modal-footer__slot-left {\n    display: flex;\n    margin-right: auto;\n  }\n\n"])), function (_a) {
    var theme = _a.theme;
    return theme.colorDivider;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingMedium;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorSurfaceHc;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorTextSuccess;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingSmall;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontSizeBody;
});
exports.default = exports.ModalFooter;
var templateObject_1;
