"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ModalHeader = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var styled_1 = __importDefault(require("@emotion/styled"));
var ActionButton_1 = __importDefault(require("../ActionButton"));
var Button_1 = __importDefault(require("../Button"));
var Text_1 = __importDefault(require("../Text"));
var Component = function (_a) {
    var className = _a.className, icon = _a.icon, closeIcon = _a.closeIcon, closeText = _a.closeText, title = _a.title, helperText = _a.helperText, onClose = _a.onClose;
    return ((0, jsx_runtime_1.jsxs)("div", { className: className, children: [(0, jsx_runtime_1.jsxs)("div", { className: 'modal-header', children: [icon && (0, jsx_runtime_1.jsx)("span", { className: 'modal-header__icon ', children: icon }), (0, jsx_runtime_1.jsx)(Text_1.default, { bold: true, el: 'span', className: 'modal-header__title', children: title }), helperText &&
                        (0, jsx_runtime_1.jsx)(Text_1.default, { className: 'modal-header__helper-text', el: 'span', secondary: true, children: helperText })] }), onClose &&
                (0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [closeText &&
                            (0, jsx_runtime_1.jsx)(Button_1.default, { onClick: onClose, shape: 'flat', children: closeText }), closeIcon &&
                            (0, jsx_runtime_1.jsx)(ActionButton_1.default, { onClick: onClose, className: 'modal-header__close-button', variant: 'secondary', children: closeIcon })] })] }));
};
/**
 * Layout component used for the header of modals. Containing the  title and possibly a close button.

  ### Import

  ```
  import ModalHeader from '@impargo/components/Modal/ModalHeader'
  ```
 */
exports.ModalHeader = (0, styled_1.default)(Component)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  display: flex;\n  flex-direction: row;\n  width: 100%;\n  align-content: center;\n  justify-content: space-between;\n  border-bottom: 1px solid ", ";\n  padding: ", " ", ";\n  position: sticky;\n  top: 0;\n  background-color: ", ";\n  z-index: 1;\n  .modal-header {\n    display: flex;\n    align-items: center;\n    align-self: center;\n\n    &__icon {\n      width: ", ";\n      height: ", ";\n      display: inline-flex;\n      align-items: center;\n      align-self: flex-start;\n      justify-content: center;\n      position: sticky;\n      margin-right: ", ";\n      font-size: ", ";\n      color: ", ";\n      @media (min-width: ", ") {\n        margin-right: ", ";\n        font-size: ", ";\n      }\n    }\n\n    &__title {\n      font-size: ", ";\n      @media (min-width: ", ") {\n        font-size: ", ";\n      }\n    }\n\n    &__helper-text {\n      margin-left: ", ";\n      font-size: ", ";\n      @media (min-width: ", ") {\n        font-size: ", ";\n      }\n    }\n  }\n\n  .modal-header__close-button {\n    margin-right: -", ";\n  }\n"], ["\n  display: flex;\n  flex-direction: row;\n  width: 100%;\n  align-content: center;\n  justify-content: space-between;\n  border-bottom: 1px solid ", ";\n  padding: ", " ", ";\n  position: sticky;\n  top: 0;\n  background-color: ", ";\n  z-index: 1;\n  .modal-header {\n    display: flex;\n    align-items: center;\n    align-self: center;\n\n    &__icon {\n      width: ", ";\n      height: ", ";\n      display: inline-flex;\n      align-items: center;\n      align-self: flex-start;\n      justify-content: center;\n      position: sticky;\n      margin-right: ", ";\n      font-size: ", ";\n      color: ", ";\n      @media (min-width: ", ") {\n        margin-right: ", ";\n        font-size: ", ";\n      }\n    }\n\n    &__title {\n      font-size: ", ";\n      @media (min-width: ", ") {\n        font-size: ", ";\n      }\n    }\n\n    &__helper-text {\n      margin-left: ", ";\n      font-size: ", ";\n      @media (min-width: ", ") {\n        font-size: ", ";\n      }\n    }\n  }\n\n  .modal-header__close-button {\n    margin-right: -", ";\n  }\n"])), function (_a) {
    var theme = _a.theme;
    return theme.colorDivider;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingMedium;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorSurfaceHc;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingSmall;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontSizeSmall;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorText;
}, function (_a) {
    var theme = _a.theme;
    return theme.breakpointTablet;
}, function (_a) {
    var fullScreen = _a.fullScreen, theme = _a.theme;
    return fullScreen ? theme.spacingMedium : theme.spacingSmall;
}, function (_a) {
    var fullScreen = _a.fullScreen, theme = _a.theme;
    return fullScreen ? theme.fontSizeBody : theme.fontSizeSmall;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontSizeBody;
}, function (_a) {
    var theme = _a.theme;
    return theme.breakpointTablet;
}, function (_a) {
    var fullScreen = _a.fullScreen, theme = _a.theme;
    return fullScreen ? theme.fontSizeH3 : theme.fontSizeBody;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingSmall;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontSizeBody;
}, function (_a) {
    var theme = _a.theme;
    return theme.breakpointTablet;
}, function (_a) {
    var fullScreen = _a.fullScreen, theme = _a.theme;
    return fullScreen ? theme.fontSizeH3 : theme.fontSizeBody;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingSmall;
});
exports.default = exports.ModalHeader;
var templateObject_1;
