"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Modal = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var styled_1 = __importDefault(require("@emotion/styled"));
var no_scroll_1 = __importDefault(require("no-scroll"));
var react_modal_1 = __importDefault(require("react-modal"));
var ModalGlobalStyles_1 = require("./ModalGlobalStyles");
var Component = function (_a) {
    var isOpen = _a.isOpen, onClose = _a.onClose, children = _a.children, className = _a.className, fullScreen = _a.fullScreen, _b = _a.shouldCloseOnOverlayClick, shouldCloseOnOverlayClick = _b === void 0 ? true : _b;
    return ((0, jsx_runtime_1.jsxs)(react_modal_1.default, { isOpen: isOpen, ariaHideApp: false, onRequestClose: onClose, shouldCloseOnOverlayClick: shouldCloseOnOverlayClick, onAfterOpen: no_scroll_1.default.on, onAfterClose: no_scroll_1.default.off, closeTimeoutMS: 200, className: {
            base: className,
            afterOpen: 'modal--after-open',
            beforeClose: 'modal--before-close',
        }, overlayClassName: 'modal__overlay', children: [children, (0, jsx_runtime_1.jsx)(ModalGlobalStyles_1.ModalGlobalStyles, { fullScreen: fullScreen })] }));
};
var sizes = {
    small: {
        tablet: '392px',
        desktop: '440px',
    },
    medium: {
        tablet: '592px',
        desktop: '640px',
    },
    large: {
        tablet: '704px',
        desktop: '952px',
    },
};
var getSize = function (props) {
    if (props.small)
        return sizes.small;
    if (props.medium)
        return sizes.medium;
    return sizes.large;
};
/**
 * Flexible modal component with different sizes `small` `medium` `large` or `fullscreen`.
 * Can be used in combination with `ModalHeader`, `ModalFooter` or `ModalBody` depending on the use-case.
 * The modals are used when the user is required to interact with the application without the need to open a different page or view and interrupting the users workflow.

  ### Import

  ```
  import Modal from '@impargo/components/Modal'
  import ModalHeader from '@impargo/components/Modal/ModalHeader'
  import ModalBody from '@impargo/components/Modal/ModalBody'
  ```
 */
exports.Modal = (0, styled_1.default)(Component)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  background: ", ";\n  border-radius: ", ";\n  box-shadow: ", ";\n  align-self: center;\n  justify-self: center;\n  display: flex;\n  flex-direction: column;\n  max-height: ", ";\n  min-height: ", ";\n  width: 100vw;\n  position: relative;\n  align-self: flex-end;\n  ", "\n  opacity: 0;\n  transition: opacity 300ms ease-in-out;\n  overflow: auto;\n  &.modal--after-open {\n    opacity: 1;\n  }\n  &.modal--before-close {\n    opacity: 0;\n  }\n\n  &&:focus {\n    outline: none;\n  }\n\n  @media (min-width: ", ") {\n    width: ", ";\n    align-self: center;\n  }\n  @media (min-width: ", ") {\n    width: ", ";\n    align-self: center;\n  }\n\n"], ["\n  background: ", ";\n  border-radius: ", ";\n  box-shadow: ", ";\n  align-self: center;\n  justify-self: center;\n  display: flex;\n  flex-direction: column;\n  max-height: ", ";\n  min-height: ", ";\n  width: 100vw;\n  position: relative;\n  align-self: flex-end;\n  ", "\n  opacity: 0;\n  transition: opacity 300ms ease-in-out;\n  overflow: auto;\n  &.modal--after-open {\n    opacity: 1;\n  }\n  &.modal--before-close {\n    opacity: 0;\n  }\n\n  &&:focus {\n    outline: none;\n  }\n\n  @media (min-width: ", ") {\n    width: ", ";\n    align-self: center;\n  }\n  @media (min-width: ", ") {\n    width: ", ";\n    align-self: center;\n  }\n\n"])), function (_a) {
    var theme = _a.theme;
    return theme.colorSurfaceHc;
}, function (_a) {
    var theme = _a.theme;
    return theme.borderRadius;
}, function (_a) {
    var theme = _a.theme;
    return theme.shadowLarge;
}, function (props) { return props.fullScreen ? '100vh' : 'calc(100vh - 48px);'; }, function (props) { return props.fullScreen ? '-webkit-fill-available' : ''; }, function (props) { return props.fullScreen ? 'height: 100%;' : ''; }, function (_a) {
    var theme = _a.theme;
    return theme.breakpointTablet;
}, function (props) { return props.fullScreen ? '100vw' : getSize(props).tablet; }, function (_a) {
    var theme = _a.theme;
    return theme.breakpointDesktop;
}, function (props) { return props.fullScreen ? '100vw' : getSize(props).desktop; });
exports.default = exports.Modal;
var templateObject_1;
