"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Highlight = exports.BackButton = exports.WithoutBorder = exports.BasicUsage = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var Badge_1 = __importDefault(require("../Badge"));
var Button_1 = __importDefault(require("../Button"));
var impargo_1 = __importDefault(require("../Themes/impargo"));
var storybook_1 = require("../utils/storybook");
var _1 = require(".");
var theme = impargo_1.default;
var faAngleLeft = free_solid_svg_icons_1.faAngleLeft;
var faSearch = free_solid_svg_icons_1.faSearch;
exports.default = {
    title: 'Components/Layout/PageHeader',
    component: _1.PageHeader,
    argTypes: {
        slotRight: { control: false },
        backButton: { control: false },
        tooltipPlace: { control: 'select' },
        theme: { table: { disable: true } },
    },
    args: {
        title: 'Page header',
        infoText: 'This is the title of the page',
    },
    parameters: {
        layout: 'padded',
    },
};
var BasicUsage = function (args) { return ((0, jsx_runtime_1.jsx)(_1.PageHeader, __assign({}, args, { slotRight: (0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(Button_1.default, { variant: 'primary', slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), children: "Primary action" }), (0, jsx_runtime_1.jsx)(Button_1.default, { ml: theme.spacingSmall, variant: 'secondary', slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), children: "Secondary action 1" }), (0, jsx_runtime_1.jsx)(Button_1.default, { ml: theme.spacingSmall, variant: 'secondary', slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), children: "Secondary action 2" })] }) }))); };
exports.BasicUsage = BasicUsage;
exports.BasicUsage.args = {};
var WithoutBorder = function () { return ((0, jsx_runtime_1.jsx)(_1.PageHeader, { title: 'Without border', infoText: 'This is the title of the page', hasBorder: false, slotRight: (0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(Button_1.default, { variant: 'primary', slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), children: "Primary action" }), (0, jsx_runtime_1.jsx)(Button_1.default, { ml: theme.spacingSmall, variant: 'secondary', slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), children: "Secondary action 1" }), (0, jsx_runtime_1.jsx)(Button_1.default, { ml: theme.spacingSmall, variant: 'secondary', slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), children: "Secondary action 2" })] }) })); };
exports.WithoutBorder = WithoutBorder;
(0, storybook_1.addDescription)(exports.WithoutBorder, "Some common use cases requires the page `PageHeader` component to not display a border bottom. This can be achieved by passing `false` to the `hasBorder` prop. One of the most common use cases is when a `Tabs` component is going to be rendered right below the `PageHeader` component. ");
var BackButton = function () { return ((0, jsx_runtime_1.jsx)(_1.PageHeader, { title: 'Page header without border', infoText: 'This is the title of the page', backButton: (0, jsx_runtime_1.jsx)(Button_1.default, { shape: 'flat', slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faAngleLeft }), children: "Back button" }), slotRight: (0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(Button_1.default, { variant: 'primary', slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), children: "Primary action" }), (0, jsx_runtime_1.jsx)(Button_1.default, { ml: theme.spacingSmall, variant: 'secondary', slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), children: "Secondary action 1" }), (0, jsx_runtime_1.jsx)(Button_1.default, { ml: theme.spacingSmall, variant: 'secondary', slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), children: "Secondary action 2" })] }) })); };
exports.BackButton = BackButton;
(0, storybook_1.addDescription)(exports.BackButton, "The `backButton` can be used to tell the users that they can go pack to a different state of the same page.");
var Highlight = function () { return ((0, jsx_runtime_1.jsx)(_1.PageHeader, { title: 'Page header', infoText: 'This is the title of the page', highlight: (0, jsx_runtime_1.jsx)(Badge_1.default, { shape: 'dot', overlap: 'rectangle', children: (0, jsx_runtime_1.jsx)(Button_1.default, { variant: 'secondary', size: 's', slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faBolt }), children: "What's new!" }) }), slotRight: (0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(Button_1.default, { variant: 'primary', slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), children: "Primary action" }), (0, jsx_runtime_1.jsx)(Button_1.default, { ml: theme.spacingSmall, variant: 'secondary', slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), children: "Secondary action 1" }), (0, jsx_runtime_1.jsx)(Button_1.default, { ml: theme.spacingSmall, variant: 'secondary', slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), children: "Secondary action 2" })] }) })); };
exports.Highlight = Highlight;
(0, storybook_1.addDescription)(exports.Highlight, "The `highlight` can be used to add an element or an action right next to the title.");
