"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PageHeader = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var styled_1 = __importDefault(require("@emotion/styled"));
var Flex_1 = __importDefault(require("../Flex"));
var InfoIcon_1 = __importDefault(require("../InfoIcon"));
var Text_1 = __importDefault(require("../Text"));
var Component = function (_a) {
    var className = _a.className, title = _a.title, highlight = _a.highlight, backButton = _a.backButton, slotRight = _a.slotRight, infoText = _a.infoText, _b = _a.tooltipPlace, tooltipPlace = _b === void 0 ? 'bottom' : _b, _c = _a.hasBorder, hasBorder = _c === void 0 ? true : _c, rest = __rest(_a, ["className", "title", "highlight", "backButton", "slotRight", "infoText", "tooltipPlace", "hasBorder"]);
    return ((0, jsx_runtime_1.jsxs)("div", __assign({ className: "".concat(className, " ").concat(hasBorder ? 'page-header--has-border' : '') }, rest, { children: [backButton ||
                (0, jsx_runtime_1.jsxs)(Flex_1.default, { gap: 'xsmall', alignItems: 'center', children: [(0, jsx_runtime_1.jsx)(Text_1.default, { variant: 'heading3', el: 'div', className: 'page-header__title', children: title }), infoText && (0, jsx_runtime_1.jsx)(InfoIcon_1.default, { className: 'page-header__title__info', infoText: infoText, place: tooltipPlace }), highlight] }), slotRight &&
                (0, jsx_runtime_1.jsx)("div", { className: 'page-header__slot-right', children: slotRight })] })));
};
/**
 * The `PageHeader` component is used as the header of a page. It displays a title and different actions depending on the purpose of the page.

  ### Import

  ```
  import PageHeader from '@impargo/components/PageHeader'
  ```
 */
exports.PageHeader = (0, styled_1.default)(Component)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  width: 100%;\n  height: 56px;\n  min-height: 56px;\n  padding: ", " ", ";\n  ", "\n  display: flex;\n  align-items: center;\n  justify-content: space-between;\n  background-color: ", ";\n  grid-area: ", ";\n\n  /* Use inset box shadow instead of border for conditional render. */\n  &.page-header--has-border {\n    box-shadow: inset 0px -1px 0px ", ";\n  }\n\n  .page-header__title {\n    display: flex;\n\n    &__info {\n      align-self: center;\n      width: 20px;\n      height: 20px;\n      margin-left: 0px;\n    }\n  }\n\n\n  .page-header__slot-right {\n    margin-left: auto;\n    display: flex;\n    align-items: center;\n  }\n"], ["\n  width: 100%;\n  height: 56px;\n  min-height: 56px;\n  padding: ", " ", ";\n  ", "\n  display: flex;\n  align-items: center;\n  justify-content: space-between;\n  background-color: ", ";\n  grid-area: ", ";\n\n  /* Use inset box shadow instead of border for conditional render. */\n  &.page-header--has-border {\n    box-shadow: inset 0px -1px 0px ", ";\n  }\n\n  .page-header__title {\n    display: flex;\n\n    &__info {\n      align-self: center;\n      width: 20px;\n      height: 20px;\n      margin-left: 0px;\n    }\n  }\n\n\n  .page-header__slot-right {\n    margin-left: auto;\n    display: flex;\n    align-items: center;\n  }\n"])), function (_a) {
    var theme = _a.theme;
    return theme.spacingMedium;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingLarge;
}, function (_a) {
    var backButton = _a.backButton, theme = _a.theme;
    return backButton && (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n    padding-left: ", ";\n  "], ["\n    padding-left: ", ";\n  "])), theme.spacingSmall);
}, function (_a) {
    var theme = _a.theme;
    return theme.colorSurfaceHc;
}, function (_a) {
    var gridArea = _a.gridArea;
    return gridArea;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorDivider;
});
exports.default = exports.PageHeader;
var templateObject_1, templateObject_2;
