# Impargo Components
[![Coverage Status](https://coveralls.io/repos/github/impargo/impargo-design-system/badge.svg?branch=master&t=5CFOtZ)](https://coveralls.io/github/impargo/impargo-design-system?branch=master)

This package contains all the components used by Impargo GmbH

## Usage


### Storybook
The storybook contains examples of all the components supported by the design system. You can run it using:
```
yarn start
```

### Install
```
yarn add @impargo/components
```

### Build
We use multiple build steps to prepare the package for release:
- Build the theme files
- Transpile TypeScript using `tsc`
- Organize the necessary files in the `./build` folder

To do all that, simply run:
```
yarn build
```

> Note: storybook uses a separate build workflow: using `webpack` instead of `tsc`. Check .storybook/main and the storybook documentation for more information.

### Publishing
We automatically publish new version of the npm package when new commits are merged to the `master` branch. To merge new changes to the `master` branch, we can use the `Release PR` GitHub action to create a release candidate. Merging this branch to `master` should automatically trigger the release as long as one of the merged commits is a `fix` or `feat`.

### Pre-release
we can automatically publish a github package from a pull request by running `/publish`
command on the pull request(PR) as a comment, then an action will be triggered and you will
get the new package version as a comment on the same PR, it will be like that `PACKAGE VERSION: 7.10.0-pre-119`
then you can install it by running `yarn add @impargo/components@7.10.0-pre-119`.
