"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WithShadow = exports.WithSheetHeaderAndBody = exports.BackgroundColor = exports.Variants = exports.BasicUsage = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var ActionButton_1 = __importDefault(require("@impargo/components/ActionButton"));
var Flex_1 = __importDefault(require("@impargo/components/Flex"));
var Icon_1 = __importDefault(require("@impargo/components/Icon"));
var Sheet_1 = __importDefault(require("@impargo/components/Sheet"));
var SheetBody_1 = __importDefault(require("@impargo/components/Sheet/SheetBody"));
var SheetHeader_1 = __importDefault(require("@impargo/components/Sheet/SheetHeader"));
var Text_1 = __importDefault(require("@impargo/components/Text"));
var impargo_1 = __importDefault(require("../Themes/impargo"));
var storybook_1 = require("../utils/storybook");
var theme = impargo_1.default;
var faAngleDown = free_solid_svg_icons_1.faAngleDown;
var faJedi = free_solid_svg_icons_1.faJedi;
exports.default = {
    title: 'Components/Layout/Sheet',
    component: Sheet_1.default,
    argTypes: {
        variant: { control: { type: 'select' } },
        shadow: { control: { type: 'select' } },
        bgColor: { control: 'color' },
    },
};
var BasicUsage = function (args) { return ((0, jsx_runtime_1.jsx)(Sheet_1.default, __assign({}, args, { children: (0, jsx_runtime_1.jsx)(Text_1.default, { children: "May the Force be with you" }) }))); };
exports.BasicUsage = BasicUsage;
exports.BasicUsage.args = {
    variant: 'medium',
};
var Variants = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(Sheet_1.default, { css: (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n        margin: ", " auto;\n        @media (min-width: ", ") {\n          min-width: 400px;\n        }\n      "], ["\n        margin: ", " auto;\n        @media (min-width: ", ") {\n          min-width: 400px;\n        }\n      "])), theme.spacingMedium, theme.breakpointTablet), children: (0, jsx_runtime_1.jsx)(Text_1.default, { children: "May the Force be with you" }) }), (0, jsx_runtime_1.jsx)(Sheet_1.default, { variant: 'small', css: {
                marginBottom: theme.spacingMedium,
            }, children: (0, jsx_runtime_1.jsx)(Text_1.default, { children: "May the Force be with you" }) }), (0, jsx_runtime_1.jsx)(Sheet_1.default, { variant: 'medium', css: {
                marginBottom: theme.spacingMedium,
            }, children: (0, jsx_runtime_1.jsx)(Text_1.default, { children: "May the Force be with you" }) }), (0, jsx_runtime_1.jsx)(Sheet_1.default, { variant: 'large', css: {
                marginBottom: theme.spacingMedium,
            }, children: (0, jsx_runtime_1.jsx)(Text_1.default, { children: "May the Force be with you" }) }), (0, jsx_runtime_1.jsx)(Sheet_1.default, { variant: 'xlarge', children: (0, jsx_runtime_1.jsx)(Text_1.default, { children: "May the Force be with you" }) })] })); };
exports.Variants = Variants;
(0, storybook_1.addDescription)(exports.Variants, "Variant defines the spacing inside the `Sheet` component. When no variant is passed, the spacing inside is `0`.");
var BackgroundColor = function () { return ((0, jsx_runtime_1.jsx)(Sheet_1.default, { bgColor: theme.colorSurfaceMc, children: (0, jsx_runtime_1.jsx)(Text_1.default, { children: "May the Force be with you" }) })); };
exports.BackgroundColor = BackgroundColor;
(0, storybook_1.addDescription)(exports.BackgroundColor, "Some use cases require a custom background color, although this is not recommended, a `bgColor` prop is provided to customize the component.\nIf this use case is repeated in multiple places and across projects, it can be added as an additional prop to cover these commonly used custom component.");
var WithSheetHeaderAndBody = function () { return ((0, jsx_runtime_1.jsxs)(Sheet_1.default, { children: [(0, jsx_runtime_1.jsx)(SheetHeader_1.default, { variant: 'medium', hasBorder: true, title: 'May the Force', subtitle: 'be with you', slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faJedi }) }), slotLeftAlign: 'flex-start', slotRight: (0, jsx_runtime_1.jsx)(ActionButton_1.default, { children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faAngleDown }) }), onClick: function () { return undefined; } }), (0, jsx_runtime_1.jsx)(SheetBody_1.default, { variant: 'medium', children: (0, jsx_runtime_1.jsx)(Text_1.default, { children: "May the Force be with you" }) })] })); };
exports.WithSheetHeaderAndBody = WithSheetHeaderAndBody;
(0, storybook_1.addDescription)(exports.WithSheetHeaderAndBody, "Using with `SheetHeader` and `SheetBody`.");
var WithShadow = function () { return ((0, jsx_runtime_1.jsxs)(Flex_1.default, { width: '100%', justify: 'center', gap: 'large', children: [(0, jsx_runtime_1.jsxs)(Sheet_1.default, { variant: 'large', shadow: 'none', children: [(0, jsx_runtime_1.jsx)(Text_1.default, { children: "none" }), (0, jsx_runtime_1.jsx)(Text_1.default, { secondary: true, children: "none" })] }), (0, jsx_runtime_1.jsxs)(Sheet_1.default, { variant: 'large', shadow: 'small', children: [(0, jsx_runtime_1.jsx)(Text_1.default, { children: "small" }), (0, jsx_runtime_1.jsx)(Text_1.default, { secondary: true, children: "shadowSmall" })] }), (0, jsx_runtime_1.jsxs)(Sheet_1.default, { variant: 'large', shadow: 'medium', children: [(0, jsx_runtime_1.jsx)(Text_1.default, { children: "medium" }), (0, jsx_runtime_1.jsx)(Text_1.default, { secondary: true, children: "shadowMedium" })] }), (0, jsx_runtime_1.jsxs)(Sheet_1.default, { variant: 'large', shadow: 'large', children: [(0, jsx_runtime_1.jsx)(Text_1.default, { children: "large" }), (0, jsx_runtime_1.jsx)(Text_1.default, { secondary: true, children: "shadowLarge" })] })] })); };
exports.WithShadow = WithShadow;
(0, storybook_1.addDescription)(exports.WithShadow, 'We can add shadows to the sheet component with the `shadow` prop. For more information about the shadows go to `Foundation/Shadows`.');
var templateObject_1;
