import { FC, ReactNode } from 'react';
import { SheetVariant } from '.';
export interface SheetBodyProps extends React.HTMLAttributes<HTMLDivElement> {
    /**
    * Class name assigned to the component. Should be use sparingly.
    */
    className?: string;
    /**
     * Elements to be rendered inside the component.
     */
    children: ReactNode;
    /**
    * Specifies the different variants.
    */
    variant?: SheetVariant;
}
/**
  The `SheetBody` component is used inside the `Sheet` and together with the `SheetHeader` component. THe `SheetBody` contains the elements displayed inside the `Sheet` and below the `SheetHeader`.
*/
export declare const SheetBody: FC<SheetBodyProps>;
export default SheetBody;
//# sourceMappingURL=SheetBody.d.ts.map