"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SheetHeader = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var Text_1 = __importDefault(require("../Text"));
var mixins_1 = require("../Themes/mixins");
/**
 The `SheetHeader` component can be used inside a `Sheet` component to add more structure with title and additional props for icons and interactivity, it is used together with the `SheetBody`.

  ### Import

  ```
  import SheetHeader from '@impargo/components/Sheet/SheetHeader'
  ```
*/
var SheetHeader = function (_a) {
    var className = _a.className, subtitle = _a.subtitle, hasBorder = _a.hasBorder, onClick = _a.onClick, slotRight = _a.slotRight, slotLeft = _a.slotLeft, slotLeftAlign = _a.slotLeftAlign, slotRightAlign = _a.slotRightAlign, title = _a.title, _b = _a.variant, variant = _b === void 0 ? 'medium' : _b, rest = __rest(_a, ["className", "subtitle", "hasBorder", "onClick", "slotRight", "slotLeft", "slotLeftAlign", "slotRightAlign", "title", "variant"]);
    var theme = (0, react_1.useTheme)();
    var variantMap = {
        'small': theme.spacingSmall,
        'medium': theme.spacingMedium,
        'large': "".concat(theme.spacingMedium, " ").concat(theme.spacingLarge, ";"),
        'xlarge': "".concat(theme.spacingLarge, " ").concat(theme.spacingXLarge, ";"),
    };
    return ((0, jsx_runtime_1.jsxs)("div", __assign({ className: className }, rest, { onClick: onClick, css: (0, react_1.css)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n        display: flex;\n        width: 100%;\n        position: relative;\n        align-items: center;\n        justify-content: flex-start;\n        border-radius: ", " ", " 0 0;\n\n        /* Variants */\n        padding: ", ";\n\n        ", "\n\n        ", "\n\n        /* Children */\n        .sheet-header__slot {\n          min-width: ", ";\n          display: flex;\n          align-items: center;\n          justify-content: center;\n          color: ", ";\n          font-size: ", ";\n          flex: 0 0 auto;\n        }\n\n        .sheet-header__subtitle {\n          margin-top: ", ";\n        }\n        \n        .sheet-header__content {\n          overflow: hidden;\n        }\n      "], ["\n        display: flex;\n        width: 100%;\n        position: relative;\n        align-items: center;\n        justify-content: flex-start;\n        border-radius: ", " ", " 0 0;\n\n        /* Variants */\n        padding: ", ";\n\n        ", "\n\n        ", "\n\n        /* Children */\n        .sheet-header__slot {\n          min-width: ", ";\n          display: flex;\n          align-items: center;\n          justify-content: center;\n          color: ", ";\n          font-size: ", ";\n          flex: 0 0 auto;\n        }\n\n        .sheet-header__subtitle {\n          margin-top: ", ";\n        }\n        \n        .sheet-header__content {\n          overflow: hidden;\n        }\n      "])), theme.borderRadius, theme.borderRadius, variantMap[variant], onClick && (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n          ", "\n        "], ["\n          ", "\n        "])), (0, mixins_1.overlayHoverMixin)(theme, 'colorHover', 'colorActive')), hasBorder && (0, react_1.css)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n          border-bottom: 1px solid ", "\n        "], ["\n          border-bottom: 1px solid ", "\n        "])), theme.colorDivider), theme.spacingMedium, theme.colorTextMc, theme.fontSizeBody, theme.spacingXSmall), children: [slotLeft &&
                (0, jsx_runtime_1.jsx)("span", { className: 'sheet-header__slot sheet-header__slot--left', css: (0, react_1.css)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n            margin-right: ", ";\n            align-self: flex-start;\n            height: ", ";\n            align-self: ", ";\n          "], ["\n            margin-right: ", ";\n            align-self: flex-start;\n            height: ", ";\n            align-self: ", ";\n          "])), theme.spacingMedium, theme.fontLineHeight, slotLeftAlign || 'center'), children: slotLeft }), (0, jsx_runtime_1.jsxs)("div", { className: 'sheet-header__content', children: [(0, jsx_runtime_1.jsx)(Text_1.default, { el: 'div', bold: true, className: 'sheet-header__title', children: title }), subtitle && (0, jsx_runtime_1.jsx)(Text_1.default, { secondary: true, className: 'sheet-header__subtitle', children: subtitle })] }), slotRight &&
                (0, jsx_runtime_1.jsx)("span", { className: 'sheet-header__slot sheet-header__slot--right', css: (0, react_1.css)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n            margin-left: auto;\n            padding-left: ", ";\n            justify-content: flex-end;\n            align-self: ", ";\n          "], ["\n            margin-left: auto;\n            padding-left: ", ";\n            justify-content: flex-end;\n            align-self: ", ";\n          "])), theme.spacingMedium, slotRightAlign || 'center'), children: slotRight })] })));
};
exports.SheetHeader = SheetHeader;
exports.default = exports.SheetHeader;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5;
