"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OnClick = exports.WithSlots = exports.Subtitle = exports.Variants = exports.BasicUsage = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var ActionButton_1 = __importDefault(require("@impargo/components/ActionButton"));
var Icon_1 = __importDefault(require("@impargo/components/Icon"));
var Sheet_1 = __importDefault(require("@impargo/components/Sheet"));
var SheetHeader_1 = __importDefault(require("@impargo/components/Sheet/SheetHeader"));
var impargo_1 = __importDefault(require("../Themes/impargo"));
var storybook_1 = require("../utils/storybook");
var theme = impargo_1.default;
var faSearch = free_solid_svg_icons_1.faSearch;
var faAngleDown = free_solid_svg_icons_1.faAngleDown;
var faPen = free_solid_svg_icons_1.faPen;
var faJedi = free_solid_svg_icons_1.faJedi;
exports.default = {
    title: 'Components/Layout/Sheet/SheetHeader',
    component: SheetHeader_1.default,
    argTypes: {
        variant: { control: { type: 'select' } },
    },
};
var BasicUsage = function (args) { return ((0, jsx_runtime_1.jsx)(SheetHeader_1.default, __assign({}, args))); };
exports.BasicUsage = BasicUsage;
exports.BasicUsage.args = {
    variant: 'medium',
    title: 'Bicycle road',
};
var Variants = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(Sheet_1.default, { css: {
                marginBottom: theme.spacingMedium,
            }, children: (0, jsx_runtime_1.jsx)(SheetHeader_1.default, { variant: 'small', title: 'May the Force be with you' }) }), (0, jsx_runtime_1.jsx)(Sheet_1.default, { css: {
                marginBottom: theme.spacingMedium,
            }, children: (0, jsx_runtime_1.jsx)(SheetHeader_1.default, { variant: 'medium', title: 'May the Force be with you' }) }), (0, jsx_runtime_1.jsx)(Sheet_1.default, { css: {
                marginBottom: theme.spacingMedium,
            }, children: (0, jsx_runtime_1.jsx)(SheetHeader_1.default, { variant: 'large', title: 'May the Force be with you' }) }), (0, jsx_runtime_1.jsx)(Sheet_1.default, { children: (0, jsx_runtime_1.jsx)(SheetHeader_1.default, { variant: 'xlarge', title: 'May the Force be with you' }) })] })); };
exports.Variants = Variants;
(0, storybook_1.addDescription)(exports.Variants, "Variant defines the spacing inside the `Sheet` component.");
var Subtitle = function () { return ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: (0, jsx_runtime_1.jsx)(Sheet_1.default, { css: {
            marginBottom: theme.spacingMedium,
        }, children: (0, jsx_runtime_1.jsx)(SheetHeader_1.default, { variant: 'small', title: 'May the Force', subtitle: 'be with you' }) }) })); };
exports.Subtitle = Subtitle;
(0, storybook_1.addDescription)(exports.Subtitle, "We can add a subtitle to add extra context.");
var WithSlots = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(Sheet_1.default, { css: {
                marginBottom: theme.spacingMedium,
            }, children: (0, jsx_runtime_1.jsx)(SheetHeader_1.default, { variant: 'large', title: 'May the Force', subtitle: 'be with you', slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }) }), slotLeftAlign: 'flex-start' }) }), (0, jsx_runtime_1.jsx)(Sheet_1.default, { css: {
                marginBottom: theme.spacingMedium,
            }, children: (0, jsx_runtime_1.jsx)(SheetHeader_1.default, { variant: 'large', title: 'May the Force', subtitle: 'be with you', slotLeftAlign: 'flex-start', slotRight: (0, jsx_runtime_1.jsx)(ActionButton_1.default, { children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faPen }) }) }) })] })); };
exports.WithSlots = WithSlots;
(0, storybook_1.addDescription)(exports.WithSlots, "Adding icons and actions is done with the `slotLeft` and `slotRight` props. Additionally we can align the slots with the `slotLeftAlign` and `slotRightAlign` props.");
var OnClick = function () { return ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: (0, jsx_runtime_1.jsx)(Sheet_1.default, { css: {
            marginBottom: theme.spacingMedium,
        }, children: (0, jsx_runtime_1.jsx)(SheetHeader_1.default, { variant: 'medium', title: 'May the Force', subtitle: 'be with you', slotLeft: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faJedi }) }), slotLeftAlign: 'flex-start', slotRight: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faAngleDown }) }), onClick: function () { return undefined; } }) }) })); };
exports.OnClick = OnClick;
(0, storybook_1.addDescription)(exports.OnClick, "We can also add an on click handler with the `onClick` prop to allow performing actions with the `SheetHeader` itself. We can also add icons to indicate an actionable sheet header.");
