"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Sheet = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
/**
 The `Sheet` component is used to display similar information together. It can be used inside other `Sheet`s components.

  ### Import

  ```
  import Sheet from '@impargo/components/Sheet'
  ```
*/
var Sheet = function (_a) {
    var className = _a.className, children = _a.children, variant = _a.variant, bgColor = _a.bgColor, _b = _a.width, width = _b === void 0 ? 'auto' : _b, _c = _a.height, height = _c === void 0 ? 'auto' : _c, shadow = _a.shadow, rest = __rest(_a, ["className", "children", "variant", "bgColor", "width", "height", "shadow"]);
    var theme = (0, react_1.useTheme)();
    var variantMap = {
        'small': theme.spacingSmall,
        'medium': theme.spacingMedium,
        'large': theme.spacingLarge,
        'xlarge': theme.spacingXLarge,
    };
    var shadowMap = {
        'small': theme.shadowSmall,
        'medium': theme.shadowMedium,
        'large': theme.shadowLarge,
        'none': 'none',
    };
    return ((0, jsx_runtime_1.jsx)("div", __assign({ className: className }, rest, { css: (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n        width: ", ";\n        height: ", ";\n        background-color: ", ";\n        border: 1px solid ", ";\n        border-radius: ", ";\n\n        /* Variants */\n        padding: ", ";\n\n        /* Shadow */\n        box-shadow: ", ";\n      "], ["\n        width: ", ";\n        height: ", ";\n        background-color: ", ";\n        border: 1px solid ", ";\n        border-radius: ", ";\n\n        /* Variants */\n        padding: ", ";\n\n        /* Shadow */\n        box-shadow: ", ";\n      "])), width, height, bgColor || theme.colorSurfaceHc, theme.colorDivider, theme.borderRadius, variant && variantMap[variant], shadow && shadowMap[shadow]), children: children })));
};
exports.Sheet = Sheet;
exports.default = exports.Sheet;
var templateObject_1;
