import { CSSProperties, DetailedHTMLProps, FC, HTMLAttributes } from 'react';
export type SpinnerVariant = 'primary' | 'inverse' | 'dark';
export interface SpinnerProps extends DetailedHTMLProps<HTMLAttributes<HTMLDivElement>, HTMLDivElement> {
    /**
     * Size of the spinner.
     * @default 10
     */
    size?: number;
    /**
     * Color of the spinner.
     * @default primary
     */
    variant?: SpinnerVariant;
    /**
     * Margin added to the spinner wrapper.
     * @default auto
     */
    margin?: CSSProperties['margin'];
}
/**
 * The `Spinner` is used to specify wait time. They are used to give users feedback regarding the status of a process, such as when the interface is loading, when saving data or interacting with forms.

  ### Import

  ```
  import Spinner from '@impargo/components/Spinner'
  ```
 */
export declare const Spinner: FC<SpinnerProps>;
export default Spinner;
//# sourceMappingURL=index.d.ts.map