import { DetailedHTMLProps, HTMLAttributes } from 'react';
import { SpinnerVariant } from '../Spinner';
export interface SplashProps extends DetailedHTMLProps<HTMLAttributes<HTMLDivElement>, HTMLDivElement> {
    /**
     * Class name assigned to the component. Should be used sparingly.
     */
    className?: string;
    /**
     * Defines the Spinner variant.
     * @default primary
     */
    variant?: SpinnerVariant;
    /**
     * Size of the spinner.
     * @default 10
     */
    size?: number;
}
/**
 * The `Splash` component displays a full-screen loading indicator using the `Spinner`. It ensures that users are aware of ongoing activity like data loading by occupying the entire screen (Its parent component). `Splash` is particularly useful during transitions or when users are waiting for data to be processed.

  ### Import

  ```
  import { Splash } from '@impargo/components/Splash'
  ```
 */
export declare const Splash: import("@emotion/styled").StyledComponent<SplashProps & {
    theme?: import("@emotion/react").Theme | undefined;
}, {}, {}>;
//# sourceMappingURL=index.d.ts.map