"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Splash = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var styled_1 = __importDefault(require("@emotion/styled"));
var Spinner_1 = __importDefault(require("../Spinner"));
var SplashComponent = function (_a) {
    var className = _a.className, _b = _a.variant, variant = _b === void 0 ? 'primary' : _b, _c = _a.size, size = _c === void 0 ? 10 : _c, props = __rest(_a, ["className", "variant", "size"]);
    return ((0, jsx_runtime_1.jsx)("div", __assign({ className: className }, props, { children: (0, jsx_runtime_1.jsx)(Spinner_1.default, { variant: variant, size: size, margin: '0px' }) })));
};
/**
 * The `Splash` component displays a full-screen loading indicator using the `Spinner`. It ensures that users are aware of ongoing activity like data loading by occupying the entire screen (Its parent component). `Splash` is particularly useful during transitions or when users are waiting for data to be processed.

  ### Import

  ```
  import { Splash } from '@impargo/components/Splash'
  ```
 */
exports.Splash = (0, styled_1.default)(SplashComponent)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  width: 100%;\n  height: 100%;\n  overflow: hidden;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n\n  @media (max-width: ", ") {\n    position: fixed;\n    top: 50%;\n    transform: translateY(-50%);\n    background-color: ", ";\n  }\n"], ["\n  width: 100%;\n  height: 100%;\n  overflow: hidden;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n\n  @media (max-width: ", ") {\n    position: fixed;\n    top: 50%;\n    transform: translateY(-50%);\n    background-color: ", ";\n  }\n"])), function (_a) {
    var theme = _a.theme;
    return theme.breakpointDesktop;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorSurfaceHc;
});
var templateObject_1;
