"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SuccessVariant = exports.EmptyVariant = exports.BasicUsage = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var Flex_1 = __importDefault(require("@impargo/components/Flex"));
var State_1 = __importDefault(require("@impargo/components/State"));
var storybook_1 = require("../utils/storybook");
var faJedi = free_solid_svg_icons_1.faJedi;
exports.default = {
    title: 'Components/Feedback/State',
    component: State_1.default,
    argTypes: {
        variant: { control: { type: 'select' } },
        size: { control: { type: 'select' } },
    },
};
var BasicUsage = function (args) { return ((0, jsx_runtime_1.jsx)(State_1.default, __assign({}, args))); };
exports.BasicUsage = BasicUsage;
exports.BasicUsage.args = {
    variant: 'empty',
    title: 'No Time Crystals found',
    description: 'Steal more crystals to stop time',
    icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faJedi }),
};
var EmptyVariant = function () { return ((0, jsx_runtime_1.jsxs)(Flex_1.default, { children: [(0, jsx_runtime_1.jsx)(State_1.default, { variant: 'empty', width: '50%', title: 'No Time Crystals found', description: 'Steal more Tim Crystals to control time', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faJedi }), mainCTA: {
                onClick: function () { return null; },
                label: 'Crystallized Xanthenite',
            }, cta1: {
                onClick: function () { },
                label: 'Secondary cta',
            } }), (0, jsx_runtime_1.jsx)(State_1.default, { variant: 'empty', size: 'small', width: '50%', title: 'No Time Crystals found', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faJedi }) }), (0, jsx_runtime_1.jsx)(State_1.default, { variant: 'empty', size: 'small', width: '50%', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faJedi }) })] })); };
exports.EmptyVariant = EmptyVariant;
(0, storybook_1.addDescription)(exports.EmptyVariant, 'The `empty` variant is used to represent an empty search or when there is no data to display. A `large` size is mostly used in empty views where the `State` component replaces the main element the user sees, such as a table. The `small` size is mostly used inside of other components such as modals and sheets. The `empty` variant can provide a `mainCTA` to give the user an action to perform, such as create a new table entry. An empty state with a small size can be used without title in unique situations, such as in the details part of a master details view.');
var SuccessVariant = function () { return ((0, jsx_runtime_1.jsx)(Flex_1.default, { children: (0, jsx_runtime_1.jsx)(State_1.default, { variant: 'success', width: '50%', title: 'You have successfully stolen 5 Time Crystals', description: 'is a material capable of interacting with the flow of time and bypassing split timelines', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faJedi }), mainCTA: {
            onClick: function () { return null; },
            label: 'See all  collected Crystallized Xanthenite',
        }, cta1: {
            onClick: function () { return null; },
            label: 'See Time Crystals applications',
        }, cta2: {
            onClick: function () { return null; },
            label: 'Sell Time Crystals',
        } }) })); };
exports.SuccessVariant = SuccessVariant;
(0, storybook_1.addDescription)(exports.SuccessVariant, 'The `success` variant is shown to draw the attention of the user after a specific action such as booking a subscription or cancelling a plan, where additional context and ctas are displayed to the user. A `mainCTA` can be passed for a primary action and additional `cta1`, `cta2`, `cta3` are provided for supporting actions. A `large` size is mostly used in a success screen, where only the success state is shown. The `small` size is mostly used inside of other components such as modals and sheets.');
