"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.State = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var Button_1 = __importDefault(require("@impargo/components/Button"));
var Flex_1 = __importDefault(require("@impargo/components/Flex"));
var Icon_1 = __importDefault(require("@impargo/components/Icon"));
var Text_1 = __importDefault(require("@impargo/components/Text"));
/**
 The `State` component is used to display either the successful result of an action (`variant="success") or no results in data view (`variant="empty"`).

  ### Import

  ```
  import State from '@impargo/components/State'
  ```
*/
var State = function (_a) {
    var className = _a.className, _b = _a.variant, variant = _b === void 0 ? 'empty' : _b, _c = _a.size, size = _c === void 0 ? 'large' : _c, title = _a.title, description = _a.description, _d = _a.width, width = _d === void 0 ? '424px' : _d, mainCTA = _a.mainCTA, cta1 = _a.cta1, cta2 = _a.cta2, cta3 = _a.cta3, icon = _a.icon, rest = __rest(_a, ["className", "variant", "size", "title", "description", "width", "mainCTA", "cta1", "cta2", "cta3", "icon"]);
    var theme = (0, react_1.useTheme)();
    var imageSizeMap = {
        'small': theme.spacingXxxLarge,
        'large': theme.spacingHuge,
    };
    return ((0, jsx_runtime_1.jsxs)(Flex_1.default, __assign({ width: width, className: className, direction: 'column', justify: 'center', gap: 'xlarge' }, rest, { children: [(0, jsx_runtime_1.jsxs)(Flex_1.default, { direction: 'column', width: '100%', alignItems: 'center', gap: 'large', children: [(0, jsx_runtime_1.jsxs)(Flex_1.default, { direction: 'column', width: '100%', alignItems: 'center', gap: 'medium', children: [(0, jsx_runtime_1.jsx)(Flex_1.default, { width: imageSizeMap[size], height: imageSizeMap[size], justify: 'center', alignItems: 'center', css: (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n              background-color: ", ";\n              border-radius: ", ";\n            "], ["\n              background-color: ", ";\n              border-radius: ", ";\n            "])), variant === 'empty' ? theme.colorSurfaceLc : theme.colorGreenLight2, theme.borderRadiusCircular), children: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: icon, color: variant === 'empty' ? theme.colorTextMc : theme.colorTextSuccess, size: 'm' }) }), title &&
                                (0, jsx_runtime_1.jsx)(Text_1.default, { variant: size === 'large' ? 'heading3' : 'body', secondary: size === 'small', textAlign: 'center', children: title })] }), description &&
                        (0, jsx_runtime_1.jsx)(Text_1.default, { secondary: true, textAlign: 'center', children: description }), mainCTA && size === 'large' &&
                        (0, jsx_runtime_1.jsx)(Flex_1.default, { width: '100%', justify: 'center', children: (0, jsx_runtime_1.jsx)(Button_1.default, { onClick: mainCTA.onClick, slotLeft: mainCTA === null || mainCTA === void 0 ? void 0 : mainCTA.slotLeft, slotRight: mainCTA === null || mainCTA === void 0 ? void 0 : mainCTA.slotRight, "data-testid": mainCTA.dataTestid, disabled: mainCTA === null || mainCTA === void 0 ? void 0 : mainCTA.disabled, "data-tooltip-content": mainCTA === null || mainCTA === void 0 ? void 0 : mainCTA.tooltip, children: mainCTA.label }) })] }), (cta1 || cta2 || cta3) &&
                (0, jsx_runtime_1.jsxs)(Flex_1.default, { direction: 'column', width: '100%', alignItems: 'center', gap: 'small', children: [cta1 &&
                            (0, jsx_runtime_1.jsx)(Button_1.default, { shape: 'flat', onClick: cta1 === null || cta1 === void 0 ? void 0 : cta1.onClick, slotLeft: cta1 === null || cta1 === void 0 ? void 0 : cta1.slotLeft, slotRight: cta1 === null || cta1 === void 0 ? void 0 : cta1.slotRight, "data-testid": cta1.dataTestid, children: cta1 === null || cta1 === void 0 ? void 0 : cta1.label }), variant === 'success' && cta2 &&
                            (0, jsx_runtime_1.jsx)(Button_1.default, { shape: 'flat', onClick: cta2 === null || cta2 === void 0 ? void 0 : cta2.onClick, slotLeft: cta2 === null || cta2 === void 0 ? void 0 : cta2.slotLeft, slotRight: cta2 === null || cta2 === void 0 ? void 0 : cta2.slotRight, "data-testid": cta2.dataTestid, children: cta2 === null || cta2 === void 0 ? void 0 : cta2.label }), variant === 'success' && cta3 &&
                            (0, jsx_runtime_1.jsx)(Button_1.default, { shape: 'flat', onClick: cta3 === null || cta3 === void 0 ? void 0 : cta3.onClick, slotLeft: cta3 === null || cta3 === void 0 ? void 0 : cta3.slotLeft, slotRight: cta3 === null || cta3 === void 0 ? void 0 : cta3.slotRight, "data-testid": cta3.dataTestid, children: cta3 === null || cta3 === void 0 ? void 0 : cta3.label })] })] })));
};
exports.State = State;
exports.default = exports.State;
var templateObject_1;
