"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WithControlledRowSelection = exports.WithColumnOrder = exports.WithPinnedColumns = exports.EmptyTable = exports.WithRowBadges = exports.Pagination = exports.LoadingState = exports.WithHoverAndSelect = exports.SelectableTable = exports.BasicUsage = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var moment_1 = __importDefault(require("moment"));
var react_1 = require("react");
var Button_1 = __importDefault(require("../Button"));
var Flex_1 = __importDefault(require("../Flex"));
var State_1 = __importDefault(require("../State"));
var storybook_1 = require("../utils/storybook");
var _1 = require(".");
var data_1 = require("./dummy/data");
var faSearch = free_solid_svg_icons_1.faSearch;
var mappedData = data_1.data.map(function (_a) {
    var node = _a.node;
    return node;
});
var customRenderer = {
    custom: function (row) { return (0, jsx_runtime_1.jsxs)("div", { style: { overflow: 'visible' }, children: [row.id, " is the id"] }); },
    date: function (row) { return ((0, jsx_runtime_1.jsxs)("div", { children: ["Loading: ", row.tour.tourStops[0].fromDate, (0, jsx_runtime_1.jsx)("br", {}), "Delivery: ", row.tour.tourStops[1].toDate] })); },
    status: function (row) { return "".concat(row.status, " Status"); },
    actions: function () {
        return (0, jsx_runtime_1.jsx)(Button_1.default, { "data-tooltip-content": 'Disabled', disabled: true, children: "Click Here" });
    },
    startDate: function (row) { return (0, moment_1.default)(row.tour.tourStops[0].fromDate).format('DD.MM'); },
};
var customHeaderRenderer = {
    actions: (0, jsx_runtime_1.jsx)("div", { children: "Actions" }),
};
exports.default = {
    title: 'Components/Data/Table',
    component: _1.Table,
    argTypes: {
        data: { control: false },
        columns: { control: false },
        onHoverRow: { control: false },
        customRenderer: { control: false },
        customHeaderRenderer: { control: false },
        rowExpansion: { control: false },
        pagination: { control: false },
        batch: { control: false },
        theme: { table: { disable: true } },
    },
    args: {},
    parameters: {
        layout: 'padded',
    },
};
var BasicUsage = function (args) { return ((0, jsx_runtime_1.jsx)(_1.Table, __assign({}, args))); };
exports.BasicUsage = BasicUsage;
exports.BasicUsage.args = {
    data: mappedData,
    columns: ['id', {
            name: 'status',
            disableSortBy: true,
        }, {
            name: 'startDate',
            width: 30,
            accessor: function (row) { return new Date(row.tour.tourStops[0].fromDate); },
            sortType: 'datetime',
        }],
    customRenderer: {
        startDate: function (_a) {
            var tour = _a.tour;
            return tour.tourStops[0].fromDate.toString();
        },
    },
    sortable: true,
};
var SelectableTable = function () { return ((0, jsx_runtime_1.jsx)("div", { style: {
        fontFamily: 'Roboto, sans-serif', height: '400px',
    }, children: (0, jsx_runtime_1.jsx)(_1.Table, { data: mappedData, customRenderer: customRenderer, customHeaderRenderer: customHeaderRenderer, columns: [{ name: 'id', width: 500 }, 'status', 'date'], selectable: true, batch: function (selected) { return ((0, jsx_runtime_1.jsxs)(Button_1.default, { shape: 'flat', onClick: function () { return console.log(selected); }, slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), children: ["Selected: ", selected.length] })); } }) })); };
exports.SelectableTable = SelectableTable;
(0, storybook_1.addDescription)(exports.SelectableTable, "The `Table` component allows for users to select to perform actions based on the selected data, a `selectable` prop is then provided.");
var WithHoverAndSelect = function () { return ((0, jsx_runtime_1.jsx)("div", { style: { fontFamily: 'Roboto, sans-serif', height: '500px' }, children: (0, jsx_runtime_1.jsx)(_1.Table, { data: mappedData, customRenderer: customRenderer, customHeaderRenderer: customHeaderRenderer, columns: ['id', 'status'], selectable: true, batch: function (selected) { return ((0, jsx_runtime_1.jsxs)(Button_1.default, { shape: 'flat', onClick: function () { return console.log(selected); }, slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), children: ["Selected: ", selected.length] })); }, onHoverRow: function () { return undefined; } }) })); };
exports.WithHoverAndSelect = WithHoverAndSelect;
(0, storybook_1.addDescription)(exports.WithHoverAndSelect, "The `Table` rows also support hover and pressed states, when the `onHoverRow` and `onPressRow` props are passed.");
var LoadingState = function () { return ((0, jsx_runtime_1.jsx)("div", { style: { fontFamily: 'Roboto, sans-serif', height: '500px' }, children: (0, jsx_runtime_1.jsx)(_1.Table, { data: mappedData, customRenderer: customRenderer, customHeaderRenderer: customHeaderRenderer, columns: ['id', 'status'], loading: true, selectable: true, pagination: {
            hasNext: true,
            hasPrev: true,
            hasFirst: true,
            page: 1,
            onFirst: function () { return undefined; },
            onNext: function () { return undefined; },
            onPrev: function () { return undefined; },
        } }) })); };
exports.LoadingState = LoadingState;
(0, storybook_1.addDescription)(exports.LoadingState, "The `Table` supports loading states which can be useful when fetching data for the next page, for example.");
var Pagination = function () {
    var _a = (0, react_1.useState)(20), rowsPerPage = _a[0], setRowsPerPage = _a[1];
    var data = (0, react_1.useMemo)(function () {
        return __spreadArray(__spreadArray(__spreadArray(__spreadArray([], mappedData, true), mappedData, true), mappedData, true), mappedData, true).map(function (_, index) { return ({ id: index + 1 }); })
            .slice(0, rowsPerPage);
    }, [rowsPerPage]);
    return ((0, jsx_runtime_1.jsx)("div", { style: { fontFamily: 'Roboto, sans-serif', height: '500px' }, children: (0, jsx_runtime_1.jsx)(_1.Table, { data: data, customRenderer: customRenderer, customHeaderRenderer: customHeaderRenderer, columns: ['id'], selectable: true, pagination: {
                hasNext: true,
                hasPrev: true,
                hasFirst: true,
                page: 1,
                onFirst: function () { return undefined; },
                onNext: function () { return undefined; },
                onPrev: function () { return undefined; },
                rowsPerPage: rowsPerPage,
                setRowsPerPage: setRowsPerPage,
                rowsPerPageLabel: 'Rows per page',
            } }) }));
};
exports.Pagination = Pagination;
(0, storybook_1.addDescription)(exports.Pagination, "The `Table` supports pagination options, including a select option for the number of rows per page.");
var WithRowBadges = function () { return ((0, jsx_runtime_1.jsx)("div", { style: {
        fontFamily: 'Roboto, sans-serif', height: '400px',
    }, children: (0, jsx_runtime_1.jsx)(_1.Table, { data: mappedData, customRenderer: customRenderer, customHeaderRenderer: customHeaderRenderer, columns: [{ name: 'id', width: 500 }, 'status', 'date'], showRowBadge: function (row) { return ['1', '3'].includes(row.id); }, selectable: true, batch: function (selected) { return ((0, jsx_runtime_1.jsxs)(Button_1.default, { shape: 'flat', onClick: function () { return console.log(selected); }, slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), children: ["Selected: ", selected.length] })); } }) })); };
exports.WithRowBadges = WithRowBadges;
(0, storybook_1.addDescription)(exports.WithRowBadges, "The `Table` component allows for users to put a badge in the row start for indicating something for specific row.");
var EmptyTable = function () { return ((0, jsx_runtime_1.jsx)("div", { style: {
        fontFamily: 'Roboto, sans-serif', height: '400px',
    }, children: (0, jsx_runtime_1.jsx)(_1.Table, { data: [], customRenderer: customRenderer, customHeaderRenderer: customHeaderRenderer, columns: [{ name: 'id', width: 500 }, 'status', 'date'], emptyTableMessage: (0, jsx_runtime_1.jsx)(Flex_1.default, { pt: '32px', pb: '32px', justify: 'center', alignItems: 'center', children: (0, jsx_runtime_1.jsx)(State_1.default, { variant: 'empty', size: 'large', icon: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), description: 'No match found' }) }) }) })); };
exports.EmptyTable = EmptyTable;
(0, storybook_1.addDescription)(exports.EmptyTable, "The `Table` component allows you to pass an element that can be shown when the table is empty, maybe as a result of filtering or specific search strings. If the table is empty because no data is created yet, consider instead completely hiding the table and directly using a state component.");
var WithPinnedColumns = function () { return ((0, jsx_runtime_1.jsx)("div", { style: {
        fontFamily: 'Roboto, sans-serif', height: '400px',
    }, children: (0, jsx_runtime_1.jsx)(_1.Table, { data: mappedData, customRenderer: customRenderer, customHeaderRenderer: customHeaderRenderer, selectable: true, onPressRow: function () { }, columns: [
            'id',
            'status',
            { name: 'product', accessor: function (row) { return row.load.productType; } },
            { name: 'weight', accessor: function (row) { return row.load.weight; } },
            { name: 'type', accessor: function (row) { return row.tour.type; } },
            { name: 'proceeded', accessor: function (row) { return row.tour.proceedDeadline; } },
            { name: 'awarded', accessor: function (row) { return row.tour.awardedDeadline; } },
            'date',
            'actions',
        ], columnPinning: {
            left: ['selection', 'id'],
            right: ['actions'],
        } }) })); };
exports.WithPinnedColumns = WithPinnedColumns;
(0, storybook_1.addDescription)(exports.WithPinnedColumns, "The `Table` component allows you to pin certain columns in their places (left or right of the table) so that they are not scrolled with the rest of the table. Make sure to also pin 'badge' and 'selection' columns if applicable.");
var WithColumnOrder = function () {
    var columns = (0, react_1.useMemo)(function () { return [
        'id',
        'status',
        { name: 'product', accessor: function (row) { return row.load.productType; } },
        { name: 'weight', accessor: function (row) { return row.load.weight; } },
        { name: 'type', accessor: function (row) { return row.tour.type; } },
        { name: 'proceeded', accessor: function (row) { return row.tour.proceedDeadline; } },
        { name: 'awarded', accessor: function (row) { return row.tour.awardedDeadline; } },
        'date',
        'actions',
    ]; }, []);
    var _a = (0, react_1.useState)(function () {
        return columns.map(function (c) { return typeof c === 'object' ? c.name : c; });
    }), columnOrder = _a[0], setColumnOrder = _a[1];
    var shuffle = (0, react_1.useCallback)(function () {
        setColumnOrder(function (order) { return __spreadArray([], order, true).sort(function () { return Math.random() - 0.5; }); });
    }, []);
    return ((0, jsx_runtime_1.jsxs)(Flex_1.default, { direction: 'column', gap: 'medium', children: [(0, jsx_runtime_1.jsx)(Button_1.default, { onClick: shuffle, children: "Shuffle!" }), (0, jsx_runtime_1.jsx)("div", { style: {
                    fontFamily: 'Roboto, sans-serif', height: '400px',
                }, children: (0, jsx_runtime_1.jsx)(_1.Table, { data: mappedData, customRenderer: customRenderer, customHeaderRenderer: customHeaderRenderer, columns: columns, columnOrder: columnOrder }) })] }));
};
exports.WithColumnOrder = WithColumnOrder;
(0, storybook_1.addDescription)(exports.WithColumnOrder, "The `Table` component allows you to change the order of columns without changing the data array or the columns array. You only need to supply the columnOrder array.");
var WithControlledRowSelection = function () {
    var columns = (0, react_1.useMemo)(function () { return [
        'id',
        'status',
        { name: 'product', accessor: function (row) { return row.load.productType; } },
        { name: 'weight', accessor: function (row) { return row.load.weight; } },
        { name: 'type', accessor: function (row) { return row.tour.type; } },
        { name: 'proceeded', accessor: function (row) { return row.tour.proceedDeadline; } },
        { name: 'awarded', accessor: function (row) { return row.tour.awardedDeadline; } },
        'date',
        'actions',
    ]; }, []);
    var _a = (0, react_1.useState)(mappedData.slice(3, 5)), selectedRows = _a[0], setSelectedRows = _a[1];
    var shuffle = (0, react_1.useCallback)(function () {
        setSelectedRows(mappedData.sort(function () { return 0.5 - Math.random(); }).slice(0, 3));
    }, []);
    var clear = (0, react_1.useCallback)(function () {
        setSelectedRows([]);
    }, []);
    return ((0, jsx_runtime_1.jsxs)(Flex_1.default, { direction: 'column', gap: 'medium', children: [(0, jsx_runtime_1.jsx)(Button_1.default, { onClick: shuffle, children: "Select at random!" }), (0, jsx_runtime_1.jsx)(Button_1.default, { onClick: clear, children: "Clear selection!" }), (0, jsx_runtime_1.jsx)("div", { style: {
                    fontFamily: 'Roboto, sans-serif', height: '400px',
                }, children: (0, jsx_runtime_1.jsx)(_1.Table, { data: mappedData, customRenderer: customRenderer, customHeaderRenderer: customHeaderRenderer, columns: columns, selectedRows: selectedRows, onSelectedRowsChanged: setSelectedRows, selectable: true }) })] }));
};
exports.WithControlledRowSelection = WithControlledRowSelection;
(0, storybook_1.addDescription)(exports.WithControlledRowSelection, "While the `Table` component can handle the row selection state by itself, it also gives you the option to control the row selection from the parent, using the props `selectedRows` and `onSelectedRowsChanged`.");
