"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useStateOrProps = exports.removeSelectedRows = exports.removeRowsFromRowSelection = exports.addRowsToRowSelection = exports.getRowsNotSelected = exports.transformSortingToSortingState = exports.columnPinningMixin = exports.columnPinningMixinRight = exports.columnPinningMixinLeft = exports.tableCellMixin = exports.getColumns = exports.getRowId = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var react_2 = require("react");
var Badge_1 = __importDefault(require("../Badge"));
var CheckboxInput_1 = require("../Input/CheckboxInput");
function getRowId(originalRow, index) {
    var _a, _b;
    return (_b = (_a = originalRow._id) !== null && _a !== void 0 ? _a : originalRow.id) !== null && _b !== void 0 ? _b : index.toString();
}
exports.getRowId = getRowId;
function getColumns(_a) {
    var keys = _a.keys, _b = _a.customRenderer, customRenderer = _b === void 0 ? {} : _b, _c = _a.customHeaderRenderer, customHeaderRenderer = _c === void 0 ? {} : _c, selectable = _a.selectable, loading = _a.loading, showRowBadge = _a.showRowBadge, selectAllItems = _a.selectAllItems, unSelectAllItems = _a.unSelectAllItems, isSomeRowsSelected = _a.isSomeRowsSelected, isAllRowsSelected = _a.isAllRowsSelected;
    var columns = [];
    if (showRowBadge) {
        columns.push({
            id: 'badge',
            header: function () { return null; },
            cell: function (_a) {
                var row = _a.row;
                if (!showRowBadge(row.original)) {
                    return null;
                }
                return ((0, jsx_runtime_1.jsx)(Badge_1.default, { showBadge: true, shape: 'dot', inline: false, overlap: 'inline' }));
            },
            enableSorting: false,
            // Size accounts for padding + badge size
            size: 32,
            minSize: 32,
        });
    }
    if (selectable) {
        columns.push({
            id: 'selection',
            header: function (_a) {
                var table = _a.table;
                return ((0, jsx_runtime_1.jsx)(CheckboxInput_1.CheckboxInput, { "data-testid": 'table-batch-select-checkbox', checked: isAllRowsSelected, indeterminate: isSomeRowsSelected, onChange: function (event) {
                        if (event.target.checked) {
                            selectAllItems();
                        }
                        else {
                            unSelectAllItems();
                        }
                        table.getToggleAllRowsSelectedHandler();
                    }, smallLabel: true, disabled: loading }));
            },
            cell: function (_a) {
                var row = _a.row;
                return ((0, jsx_runtime_1.jsx)(CheckboxInput_1.CheckboxInput, { "data-testid": "table-row-selection-checkbox-".concat(row.id), checked: row.getIsSelected(), indeterminate: row.getIsSomeSelected(), onChange: row.getToggleSelectedHandler(), smallLabel: true, disabled: loading }));
            },
            enableSorting: false,
            size: 48,
            minSize: 48,
            meta: {
                ignoreClickEvents: true,
            },
        });
    }
    keys.forEach(function (column) {
        var _a;
        var key = typeof column === 'string' ? column : column.name;
        var rest = typeof column === 'string' ? {} : column;
        var columnProps = {
            accessorKey: key !== null && key !== void 0 ? key : (typeof rest.accessor === 'string' ? rest.accessor : undefined),
            accessorFn: typeof rest.accessor === 'function' ? rest.accessor : undefined,
            sortingFn: (_a = rest.sortType) !== null && _a !== void 0 ? _a : 'auto',
            enableSorting: !rest.disableSortBy,
            size: rest.width,
            minSize: rest.minWidth,
            maxSize: rest.maxWidth,
            id: key,
            meta: rest,
        };
        if (customRenderer[key]) {
            columnProps.cell = function (_a) {
                var row = _a.row;
                return customRenderer[key](row.original);
            };
        }
        columns.push(__assign(__assign({}, columnProps), { header: customHeaderRenderer[key] || key }));
    });
    return columns;
}
exports.getColumns = getColumns;
function tableCellMixin(theme, column) {
    var _a;
    var meta = column === null || column === void 0 ? void 0 : column.meta;
    return (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n    padding: ", ";\n    &:first-of-type {\n      padding-left: ", ";\n    }\n    &:last-of-type {\n      padding-right: ", ";\n    }\n    vertical-align: middle;\n    text-align: ", ";\n    ", "\n    ", "\n    ", "\n    overflow: ", ";\n    white-space: nowrap;\n    text-overflow: ellipsis;\n    font-family: ", ";\n    font-size: ", ";\n  "], ["\n    padding: ", ";\n    &:first-of-type {\n      padding-left: ", ";\n    }\n    &:last-of-type {\n      padding-right: ", ";\n    }\n    vertical-align: middle;\n    text-align: ", ";\n    ", "\n    ", "\n    ", "\n    overflow: ", ";\n    white-space: nowrap;\n    text-overflow: ellipsis;\n    font-family: ", ";\n    font-size: ", ";\n  "])), theme.spacingSmall, theme.spacingMedium, theme.spacingMedium, (_a = meta === null || meta === void 0 ? void 0 : meta.align) !== null && _a !== void 0 ? _a : 'center', (column === null || column === void 0 ? void 0 : column.size) ? "width: ".concat(column.size, "px;") : '', (column === null || column === void 0 ? void 0 : column.maxSize) ? "max-width: ".concat(column.maxSize, "px;") : '', (column === null || column === void 0 ? void 0 : column.minSize) ? "min-width: ".concat(column.minSize, "px;") : '', (meta === null || meta === void 0 ? void 0 : meta.allowCellOverflow) ? 'visible' : 'hidden', theme.fontFamily, theme.fontSizeBody);
}
exports.tableCellMixin = tableCellMixin;
function columnPinningMixinLeft(theme, isLastLeftPinnedColumn, left, zIndex) {
    return (0, react_1.css)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n    position: sticky;\n    z-index: ", ";\n    left: ", "px;\n    ", "\n  "], ["\n    position: sticky;\n    z-index: ", ";\n    left: ", "px;\n    ", "\n  "])), zIndex, left, isLastLeftPinnedColumn && "border-right: 1px solid ".concat(theme.colorDivider, ";"));
}
exports.columnPinningMixinLeft = columnPinningMixinLeft;
function columnPinningMixinRight(theme, isFirstRightPinnedColumn, right, zIndex) {
    return (0, react_1.css)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n    position: sticky;\n    z-index: ", ";\n    right: ", "px;\n    ", "\n  "], ["\n    position: sticky;\n    z-index: ", ";\n    right: ", "px;\n    ", "\n  "])), zIndex, right, isFirstRightPinnedColumn && "border-left: 1px solid ".concat(theme.colorDivider, ";"));
}
exports.columnPinningMixinRight = columnPinningMixinRight;
function columnPinningMixin(theme, column, zIndex) {
    if (zIndex === void 0) { zIndex = 2; }
    var pinning = column.getIsPinned();
    if (pinning === 'left') {
        var isLastLeftPinnedColumn = column.getIsLastColumn('left');
        return columnPinningMixinLeft(theme, isLastLeftPinnedColumn, column.getStart('left'), zIndex);
    }
    else if (pinning === 'right') {
        var isFirstRightPinnedColumn = column.getIsFirstColumn('right');
        return columnPinningMixinRight(theme, isFirstRightPinnedColumn, column.getAfter('right'), zIndex);
    }
    return null;
}
exports.columnPinningMixin = columnPinningMixin;
var transformSortingToSortingState = function (sortingKey) {
    var result = [];
    if (sortingKey) {
        result = Object.keys(sortingKey).map(function (key) {
            return { id: key, desc: sortingKey[key] === -1 };
        });
    }
    return result;
};
exports.transformSortingToSortingState = transformSortingToSortingState;
/**
 *
 * @param data Data which we need to get which rows aren't selected
 * @param rowSelection Current row selection
 * @returns Filtered data not in current row selection
 */
function getRowsNotSelected(data, rowSelection) {
    var rowSelectionIds = Object.keys(rowSelection);
    return data.filter(function (row) {
        var rowId = getRowId(row, 0);
        return !rowSelectionIds.includes(rowId);
    });
}
exports.getRowsNotSelected = getRowsNotSelected;
/**
 *
 * @param rowsToBeAdded Rows to be added to row selection to be selected
 * @param rowSelection Current row selection
 * @returns New row selection after adding new rows
 */
function addRowsToRowSelection(rowsToBeAdded, rowSelection) {
    var rowsIds = rowsToBeAdded.map(function (row) { return getRowId(row, 0); });
    return rowsIds.reduce(function (acc, rowId) {
        acc[rowId] = true;
        return acc;
    }, rowSelection);
}
exports.addRowsToRowSelection = addRowsToRowSelection;
/**
 *
 * @param rowsIdsToBeRemoved Rows Ids to be removed from current selection
 * @param rowSelection Current row selection
 * @returns New row selection after removing rows
 */
function removeRowsFromRowSelection(rowsIdsToBeRemoved, rowSelection) {
    var rowSelectionIds = Object.keys(rowSelection);
    return rowSelectionIds.reduce(function (acc, rowSelectionId) {
        var isRowInCurrentPage = rowsIdsToBeRemoved.includes(rowSelectionId);
        if (!isRowInCurrentPage)
            acc[rowSelectionId] = true;
        return acc;
    }, {});
}
exports.removeRowsFromRowSelection = removeRowsFromRowSelection;
/**
 *
 * @param selectedRows The objects passed to the batch actions
 * @param rowSelection The rows currently selected
 * @returns The objects to be passed after removing rows not currently selected
 */
function removeSelectedRows(selectedRows, data) {
    var currentPageRowsIds = data.map(function (row) { return getRowId(row, 0); });
    return selectedRows.filter(function (selectedRow) {
        var selectedRowId = getRowId(selectedRow, 0);
        return !currentPageRowsIds.includes(selectedRowId);
    });
}
exports.removeSelectedRows = removeSelectedRows;
function useStateOrProps(defaultValue, valueFromProps, setValueFomProps) {
    var _a = (0, react_2.useState)(defaultValue), stateValue = _a[0], setStateValue = _a[1];
    return [valueFromProps !== null && valueFromProps !== void 0 ? valueFromProps : stateValue, setValueFomProps !== null && setValueFomProps !== void 0 ? setValueFomProps : setStateValue];
}
exports.useStateOrProps = useStateOrProps;
var templateObject_1, templateObject_2, templateObject_3;
