"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
var helpers_1 = require("./helpers");
describe('Row Selection', function () {
    var rowSelection;
    beforeEach(function () {
        rowSelection = {
            '6563cbb6ffcc822b651cc3d8': true,
            '6563cbbc5b847ce583d56ddd': true,
        };
    });
    var data = [
        { _id: '6563cbb6ffcc822b651cc3d8', field1: 'Value1' },
        { _id: '6563cbbc5b847ce583d56ddd', field1: 'Value2' },
        { _id: '6563cbbfc68dd126b2a9e897', field1: 'Value3' },
    ];
    it('should get rows not selected', function () {
        var rowsNotSelected = (0, helpers_1.getRowsNotSelected)(data, rowSelection);
        expect(rowsNotSelected).toHaveLength(1);
        expect(rowsNotSelected[0]).toEqual({ _id: '6563cbbfc68dd126b2a9e897', field1: 'Value3' });
    });
    it('should add rows to row selection', function () {
        var rowsToBeAdded = [{ _id: '6563cf834e838c2af8448563', field1: 'Value4' }];
        var newRowSelection = (0, helpers_1.addRowsToRowSelection)(rowsToBeAdded, rowSelection);
        var newRowSelectionIds = Object.keys(newRowSelection);
        expect(Object.keys(newRowSelectionIds)).toHaveLength(3);
        expect(newRowSelectionIds).toContain('6563cf834e838c2af8448563');
    });
    it('should remove rows from row selection', function () {
        var rowsIdsToBeRemoved = ['6563cbbc5b847ce583d56ddd'];
        var newRowSelection = (0, helpers_1.removeRowsFromRowSelection)(rowsIdsToBeRemoved, rowSelection);
        var newRowSelectionIds = Object.keys(newRowSelection);
        expect(newRowSelectionIds).toHaveLength(1);
        expect(newRowSelectionIds).not.toContain('6563cbbc5b847ce583d56ddd');
    });
    it('should remove rows from selected rows', function () {
        var selectedRows = __spreadArray([], data, true);
        var newSelectedRows = (0, helpers_1.removeSelectedRows)(selectedRows, data);
        expect(newSelectedRows).toHaveLength(0);
    });
});
