"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Table = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var react_table_1 = require("@tanstack/react-table");
var react_2 = require("react");
var EmptyRowContainer_1 = require("./EmptyRowContainer");
var helpers_1 = require("./helpers");
var Loading_1 = require("./Loading");
var TableFooter_1 = require("./TableFooter");
var TableHeader_1 = require("./TableHeader");
var TableRow_1 = require("./TableRow");
function Table(_a) {
    var keys = _a.columns, columnOrder = _a.columnOrder, customRenderer = _a.customRenderer, customHeaderRenderer = _a.customHeaderRenderer, InitialSorting = _a.InitialSorting, selectable = _a.selectable, data = _a.data, batch = _a.batch, pagination = _a.pagination, loading = _a.loading, onHoverRow = _a.onHoverRow, onPressRow = _a.onPressRow, _b = _a.manualSortBy, manualSortBy = _b === void 0 ? false : _b, onSortChange = _a.onSortChange, sortable = _a.sortable, showRowBadge = _a.showRowBadge, autoResetSelectedRows = _a.autoResetSelectedRows, emptyTableMessage = _a.emptyTableMessage, _c = _a.columnPinning, columnPinning = _c === void 0 ? {} : _c, selectedRowsProp = _a.selectedRows, onSelectedRowsChangedProp = _a.onSelectedRowsChanged, containerProps = __rest(_a, ["columns", "columnOrder", "customRenderer", "customHeaderRenderer", "InitialSorting", "selectable", "data", "batch", "pagination", "loading", "onHoverRow", "onPressRow", "manualSortBy", "onSortChange", "sortable", "showRowBadge", "autoResetSelectedRows", "emptyTableMessage", "columnPinning", "selectedRows", "onSelectedRowsChanged"]);
    var theme = (0, react_1.useTheme)();
    var _d = (0, react_2.useState)((0, helpers_1.transformSortingToSortingState)(InitialSorting)), sorting = _d[0], setSorting = _d[1];
    var _e = (0, helpers_1.useStateOrProps)([], selectedRowsProp, onSelectedRowsChangedProp), selectedRows = _e[0], setSelectedRows = _e[1];
    var rowSelection = (0, react_2.useMemo)(function () {
        return selectedRows.reduce(function (selection, row) {
            var _a;
            return __assign(__assign({}, selection), (_a = {}, _a[(0, helpers_1.getRowId)(row, 0)] = true, _a));
        }, {});
    }, [selectedRows]);
    var rowsIds = (0, react_2.useMemo)(function () {
        return data.map(function (row) {
            return (0, helpers_1.getRowId)(row, 0);
        });
    }, [data]);
    var selectAllItems = function () {
        var rowsNotSelected = (0, helpers_1.getRowsNotSelected)(data, rowSelection);
        setSelectedRows(function (previous) { return __spreadArray(__spreadArray([], previous, true), rowsNotSelected, true); });
    };
    var unSelectAllItems = function () {
        var newSelectedRows = (0, helpers_1.removeSelectedRows)(selectedRows, data);
        setSelectedRows(newSelectedRows);
    };
    var isAllRowsSelected = rowsIds.every(function (rowId) {
        return Object.keys(rowSelection).includes(rowId);
    });
    var isSomeRowsSelected = !!Object.keys(rowSelection).length && !isAllRowsSelected;
    var columns = (0, react_2.useMemo)(function () { return (0, helpers_1.getColumns)({
        keys: keys,
        customRenderer: customRenderer,
        customHeaderRenderer: customHeaderRenderer,
        selectable: selectable,
        loading: loading,
        showRowBadge: showRowBadge,
        selectAllItems: selectAllItems,
        unSelectAllItems: unSelectAllItems,
        isSomeRowsSelected: isSomeRowsSelected,
        isAllRowsSelected: isAllRowsSelected,
    }); }, [keys, customRenderer, customHeaderRenderer, selectable, loading, showRowBadge, rowSelection, isSomeRowsSelected, isAllRowsSelected]);
    var onTableSortingChange = (0, react_2.useCallback)(function (newSorting) {
        if (onSortChange) {
            var sortingObject_1 = {};
            newSorting.forEach(function (column) {
                sortingObject_1[column.id] = column.desc ? -1 : 1;
            });
            onSortChange(sortingObject_1);
        }
        setSorting(newSorting);
    }, [onSortChange]);
    var onTableRowSelectionChange = (0, react_2.useCallback)(function (newRowSelection) {
        var newRowSelectionIds = Object.keys(newRowSelection);
        var rowSelectionIds = Object.keys(rowSelection);
        // SELECTING NEW ROW
        if (newRowSelectionIds.length > rowSelectionIds.length) {
            var newRowSelectedId_1 = newRowSelectionIds[newRowSelectionIds.length - 1];
            var newSelectedRow_1 = data.find(function (row) {
                var rowId = (0, helpers_1.getRowId)(row, 0);
                return rowId === newRowSelectedId_1;
            });
            setSelectedRows(function (previous) { return __spreadArray(__spreadArray([], previous, true), [newSelectedRow_1], false); });
        }
        else { // UNSELECTING OLD ROW
            var removedRowId_1 = rowSelectionIds.find(function (rowId) { return !newRowSelectionIds.includes(rowId); });
            setSelectedRows(function (previous) {
                return previous.filter(function (item) {
                    return (0, helpers_1.getRowId)(item, 0) !== removedRowId_1;
                });
            });
        }
    }, [rowSelection, data]);
    var table = (0, react_table_1.useReactTable)({
        columns: columns,
        data: data,
        manualSorting: manualSortBy,
        enableSorting: sortable,
        enableRowSelection: selectable,
        getCoreRowModel: (0, react_table_1.getCoreRowModel)(),
        getSortedRowModel: (0, react_table_1.getSortedRowModel)(),
        sortDescFirst: true,
        state: {
            sorting: sorting,
            rowSelection: rowSelection,
            columnOrder: columnOrder,
        },
        initialState: {
            sorting: sorting,
            rowSelection: rowSelection,
            columnPinning: columnPinning,
        },
        onSortingChange: function (updaterOrValue) {
            if (typeof updaterOrValue === 'function') {
                onTableSortingChange(updaterOrValue(sorting));
            }
            else {
                onTableSortingChange(updaterOrValue);
            }
        },
        getRowId: helpers_1.getRowId,
        onRowSelectionChange: function (updaterOrValue) {
            if (typeof updaterOrValue === 'function') {
                onTableRowSelectionChange(updaterOrValue(rowSelection));
            }
        },
    });
    (0, react_2.useEffect)(function () {
        // This could happen because: https://github.com/TanStack/table/issues/4369
        var inconsistentTable = table.getIsSomeRowsSelected() && table.getSelectedRowModel().rows.length === 0;
        if (autoResetSelectedRows || inconsistentTable) {
            table.resetRowSelection();
        }
    }, [data]);
    var clearSelectedRows = function () {
        setSelectedRows([]);
    };
    var batchComponent = (0, react_2.useMemo)(function () {
        return selectable && batch ? batch(selectedRows, clearSelectedRows) : null;
    }, [selectable, batch, selectedRows]);
    return ((0, jsx_runtime_1.jsxs)("div", __assign({}, containerProps, { css: (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n        width: 100%;\n        max-height: 100%;\n        display: flex;\n        flex-direction: column;\n        position: relative;\n        background-color: ", ";\n        border-radius: ", ";\n        border: 1px solid ", ";\n      "], ["\n        width: 100%;\n        max-height: 100%;\n        display: flex;\n        flex-direction: column;\n        position: relative;\n        background-color: ", ";\n        border-radius: ", ";\n        border: 1px solid ", ";\n      "])), theme.colorSurfaceHc, theme.borderRadius, theme.colorDivider), children: [(0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n          width: 100%;\n          overflow-y: auto;\n          flex: 1 1 auto;\n        "], ["\n          width: 100%;\n          overflow-y: auto;\n          flex: 1 1 auto;\n        "]))), children: (0, jsx_runtime_1.jsxs)("table", { css: (0, react_1.css)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n            border-collapse: separate;\n            width: 100%;\n          "], ["\n            border-collapse: separate;\n            width: 100%;\n          "]))), children: [(0, jsx_runtime_1.jsx)(TableHeader_1.TableHeader, { headers: table.getLeafHeaders() }), (0, jsx_runtime_1.jsxs)("tbody", { children: [data.length === 0 && emptyTableMessage &&
                                    (0, jsx_runtime_1.jsx)(EmptyRowContainer_1.EmptyRowContainer, { colSpan: columns.length, children: emptyTableMessage }), table.getRowModel().rows.map(function (row) {
                                    return ((0, jsx_runtime_1.jsx)(TableRow_1.TableRow, { row: row, onHoverRow: onHoverRow, onPressRow: onPressRow }, row.id));
                                }), loading && (0, jsx_runtime_1.jsx)(Loading_1.Loading, {})] })] }) }), (batch || pagination) && ((0, jsx_runtime_1.jsx)(TableFooter_1.TableFooter, { batchComponent: batchComponent, pagination: pagination, loading: loading }))] })));
}
exports.Table = Table;
/**
 * @deprecated use named export `Table` instead.
 */
exports.default = Table;
var templateObject_1, templateObject_2, templateObject_3;
