"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
require("@testing-library/jest-dom/extend-expect");
var react_1 = require("@testing-library/react");
var moment_1 = __importDefault(require("moment"));
var _1 = __importDefault(require("."));
var data_1 = require("./dummy/data");
var mappedData = data_1.data.map(function (_a) {
    var node = _a.node;
    return node;
});
afterEach(react_1.cleanup);
it('should render table without problems', function () {
    var container = (0, react_1.render)((0, jsx_runtime_1.jsx)(_1.default, { data: mappedData, columns: [
            'id',
            'status', {
                name: 'startDate',
                accessor: function (row) { return row.tour.tourStops[0].fromDate; },
            },
        ] })).container;
    expect(container).toHaveTextContent(/2018-06-18T09:01:01.275Z/);
});
it('should render table with custom renderers', function () {
    var getAllByTestId = (0, react_1.render)((0, jsx_runtime_1.jsx)(_1.default, { data: mappedData, customRenderer: {
            startDate: function (row) {
                return (0, jsx_runtime_1.jsx)("span", { "data-testid": 'date', children: (0, moment_1.default)(row.tour.tourStops[0].fromDate).format('DD.MM') });
            },
        }, columns: [
            'id',
            'status',
            {
                name: 'startDate',
                accessor: function (row) { return row.tour.tourStops[0].fromDate; },
            },
        ] })).getAllByTestId;
    expect(getAllByTestId('date')[0]).toHaveTextContent('18.06');
});
