"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OverflowTabs = exports.Spacing = exports.BasicUsage = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var Badge_1 = require("../Badge");
var Sheet_1 = __importDefault(require("../Sheet"));
var impargo_1 = __importDefault(require("../Themes/impargo"));
var storybook_1 = require("../utils/storybook");
var _1 = require(".");
var theme = impargo_1.default;
exports.default = {
    title: 'Components/Navigation/Tabs',
    component: _1.Tabs,
    argTypes: {},
    args: {},
    parameters: {
        layout: 'padded',
    },
};
var BasicUsage = function () { return ((0, jsx_runtime_1.jsxs)(_1.Tabs, { css: (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n      width: 800px;\n    "], ["\n      width: 800px;\n    "]))), children: [(0, jsx_runtime_1.jsxs)(_1.TabList, { children: [(0, jsx_runtime_1.jsx)(_1.Tab, { children: "First Step" }), (0, jsx_runtime_1.jsxs)(_1.Tab, { children: ["Second Step", (0, jsx_runtime_1.jsx)(Badge_1.Badge, { overlap: 'inline', variant: 'secondary', badgeCount: 3, ml: theme.spacingSmall })] }), (0, jsx_runtime_1.jsx)(_1.Tab, { disabled: true, children: "Third Step (disabled)" })] }), (0, jsx_runtime_1.jsx)(_1.TabPanel, { children: (0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_2 || (templateObject_2 = __makeTemplateObject([" padding: 24px; "], [" padding: 24px; "]))), children: (0, jsx_runtime_1.jsx)(Sheet_1.default, { variant: 'medium', children: "First panel" }) }) }), (0, jsx_runtime_1.jsx)(_1.TabPanel, { children: (0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_3 || (templateObject_3 = __makeTemplateObject([" padding: 24px; "], [" padding: 24px; "]))), children: (0, jsx_runtime_1.jsx)(Sheet_1.default, { variant: 'medium', children: "Second panel" }) }) }), (0, jsx_runtime_1.jsx)(_1.TabPanel, { children: (0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_4 || (templateObject_4 = __makeTemplateObject([" padding: 24px; "], [" padding: 24px; "]))), children: (0, jsx_runtime_1.jsx)(Sheet_1.default, { variant: 'medium', children: "Third panel" }) }) })] })); };
exports.BasicUsage = BasicUsage;
var Spacing = function () { return ((0, jsx_runtime_1.jsxs)(_1.Tabs, { px: '16px', css: (0, react_1.css)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n      width: 800px;\n    "], ["\n      width: 800px;\n    "]))), children: [(0, jsx_runtime_1.jsxs)(_1.TabList, { children: [(0, jsx_runtime_1.jsx)(_1.Tab, { children: "Home" }), (0, jsx_runtime_1.jsxs)(_1.Tab, { children: ["Repair shops", (0, jsx_runtime_1.jsx)(Badge_1.Badge, { overlap: 'inline', variant: 'secondary', badgeCount: 3, ml: theme.spacingSmall })] }), (0, jsx_runtime_1.jsx)(_1.Tab, { disabled: true, children: "Mr. Meeseeks Box" })] }), (0, jsx_runtime_1.jsx)(_1.TabPanel, { children: (0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_6 || (templateObject_6 = __makeTemplateObject([" padding: 16px; "], [" padding: 16px; "]))), children: (0, jsx_runtime_1.jsx)(Sheet_1.default, { variant: 'medium', children: "Welcome home" }) }) }), (0, jsx_runtime_1.jsx)(_1.TabPanel, { children: (0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_7 || (templateObject_7 = __makeTemplateObject([" padding: 16px; "], [" padding: 16px; "]))), children: (0, jsx_runtime_1.jsx)(Sheet_1.default, { variant: 'medium', children: "What can we do you for" }) }) }), (0, jsx_runtime_1.jsx)(_1.TabPanel, { children: (0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_8 || (templateObject_8 = __makeTemplateObject([" padding: 16px; "], [" padding: 16px; "]))), children: (0, jsx_runtime_1.jsx)(Sheet_1.default, { variant: 'medium', children: "I'm Mr. Meeseeks look at me!" }) }) })] })); };
exports.Spacing = Spacing;
(0, storybook_1.addDescription)(exports.Spacing, "A padding prop can be passed to specify the horizontal padding of the tab list, this will move the tab list closer or farther awy from the edge of the tabs container. This prop is used for aligning the tabs with the rest of the content below in the layout. Use `px` prop to add padding left and right.");
var OverflowTabs = function () { return ((0, jsx_runtime_1.jsxs)(_1.Tabs, { css: (0, react_1.css)(templateObject_9 || (templateObject_9 = __makeTemplateObject(["\n      width: 800px;\n    "], ["\n      width: 800px;\n    "]))), children: [(0, jsx_runtime_1.jsxs)(_1.TabList, { children: [(0, jsx_runtime_1.jsx)(_1.Tab, { children: "First Step" }), (0, jsx_runtime_1.jsxs)(_1.Tab, { children: ["Second Step", (0, jsx_runtime_1.jsx)(Badge_1.Badge, { overlap: 'inline', variant: 'secondary', badgeCount: 3, ml: theme.spacingSmall })] }), (0, jsx_runtime_1.jsx)(_1.Tab, { disabled: true, children: "Third Step (disabled)" }), (0, jsx_runtime_1.jsx)(_1.Tab, { children: "Fourth Step" }), (0, jsx_runtime_1.jsx)(_1.Tab, { children: "Fifth Step" }), (0, jsx_runtime_1.jsx)(_1.Tab, { children: "Sixth Step" }), (0, jsx_runtime_1.jsx)(_1.Tab, { children: "Seventh Step" }), (0, jsx_runtime_1.jsx)(_1.Tab, { children: "Eighth Step" }), (0, jsx_runtime_1.jsx)(_1.Tab, { children: "Ninth Step" }), (0, jsx_runtime_1.jsx)(_1.Tab, { children: "Tenth Step" })] }), (0, jsx_runtime_1.jsx)(_1.TabPanel, { children: (0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_10 || (templateObject_10 = __makeTemplateObject([" padding: 24px; "], [" padding: 24px; "]))), children: (0, jsx_runtime_1.jsx)(Sheet_1.default, { variant: 'medium', children: "First panel" }) }) }), (0, jsx_runtime_1.jsx)(_1.TabPanel, { children: (0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_11 || (templateObject_11 = __makeTemplateObject([" padding: 24px; "], [" padding: 24px; "]))), children: (0, jsx_runtime_1.jsx)(Sheet_1.default, { variant: 'medium', children: "Second panel" }) }) }), (0, jsx_runtime_1.jsx)(_1.TabPanel, { children: (0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_12 || (templateObject_12 = __makeTemplateObject([" padding: 24px; "], [" padding: 24px; "]))), children: (0, jsx_runtime_1.jsx)(Sheet_1.default, { variant: 'medium', children: "Third panel" }) }) }), (0, jsx_runtime_1.jsx)(_1.TabPanel, { children: (0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_13 || (templateObject_13 = __makeTemplateObject([" padding: 24px; "], [" padding: 24px; "]))), children: (0, jsx_runtime_1.jsx)(Sheet_1.default, { variant: 'medium', children: "Fourth panel" }) }) }), (0, jsx_runtime_1.jsx)(_1.TabPanel, { children: (0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_14 || (templateObject_14 = __makeTemplateObject([" padding: 24px; "], [" padding: 24px; "]))), children: (0, jsx_runtime_1.jsx)(Sheet_1.default, { variant: 'medium', children: "Fifth panel" }) }) }), (0, jsx_runtime_1.jsx)(_1.TabPanel, { children: (0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_15 || (templateObject_15 = __makeTemplateObject([" padding: 24px; "], [" padding: 24px; "]))), children: (0, jsx_runtime_1.jsx)(Sheet_1.default, { variant: 'medium', children: "Sixth panel" }) }) }), (0, jsx_runtime_1.jsx)(_1.TabPanel, { children: (0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_16 || (templateObject_16 = __makeTemplateObject([" padding: 24px; "], [" padding: 24px; "]))), children: (0, jsx_runtime_1.jsx)(Sheet_1.default, { variant: 'medium', children: "Seventh panel" }) }) }), (0, jsx_runtime_1.jsx)(_1.TabPanel, { children: (0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_17 || (templateObject_17 = __makeTemplateObject([" padding: 24px; "], [" padding: 24px; "]))), children: (0, jsx_runtime_1.jsx)(Sheet_1.default, { variant: 'medium', children: "Eighth panel" }) }) }), (0, jsx_runtime_1.jsx)(_1.TabPanel, { children: (0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_18 || (templateObject_18 = __makeTemplateObject([" padding: 24px; "], [" padding: 24px; "]))), children: (0, jsx_runtime_1.jsx)(Sheet_1.default, { variant: 'medium', children: "Ninth panel" }) }) }), (0, jsx_runtime_1.jsx)(_1.TabPanel, { children: (0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_19 || (templateObject_19 = __makeTemplateObject([" padding: 24px; "], [" padding: 24px; "]))), children: (0, jsx_runtime_1.jsx)(Sheet_1.default, { variant: 'medium', children: "Tenth panel" }) }) })] })); };
exports.OverflowTabs = OverflowTabs;
(0, storybook_1.addDescription)(exports.OverflowTabs, "The tabs will be horizontally scroll-able if they overflow without the need to passing any prop.");
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8, templateObject_9, templateObject_10, templateObject_11, templateObject_12, templateObject_13, templateObject_14, templateObject_15, templateObject_16, templateObject_17, templateObject_18, templateObject_19;
