import { FC, ReactNode } from 'react';
import { TabsProps as RTTabsProps } from 'react-tabs';
export { Tab, TabList, TabPanel } from 'react-tabs';
export interface TabsProps extends RTTabsProps {
    px?: string;
    children: ReactNode;
}
/**
 * The `Tabs` component is used to witch between views easily and provides a more structured layout.
 * The component works out of the box without the need to specify many props props.
 * For advanced usage, refer to [react-tabs documentation](https://reactcommunity.org/react-tabs/).

  ### Import

  ```
  import { Tabs, Tab, TabList, TabPanel } from '@impargo/components/Tabs'
  ```
 */
export declare const Tabs: FC<TabsProps>;
//# sourceMappingURL=index.d.ts.map