"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Tabs = exports.TabPanel = exports.TabList = exports.Tab = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var react_tabs_1 = require("react-tabs");
var mixins_1 = require("../Themes/mixins");
var react_tabs_2 = require("react-tabs");
Object.defineProperty(exports, "Tab", { enumerable: true, get: function () { return react_tabs_2.Tab; } });
Object.defineProperty(exports, "TabList", { enumerable: true, get: function () { return react_tabs_2.TabList; } });
Object.defineProperty(exports, "TabPanel", { enumerable: true, get: function () { return react_tabs_2.TabPanel; } });
/**
 * The `Tabs` component is used to witch between views easily and provides a more structured layout.
 * The component works out of the box without the need to specify many props props.
 * For advanced usage, refer to [react-tabs documentation](https://reactcommunity.org/react-tabs/).

  ### Import

  ```
  import { Tabs, Tab, TabList, TabPanel } from '@impargo/components/Tabs'
  ```
 */
var Tabs = function (props) {
    var _a, _b;
    var theme = (0, react_1.useTheme)();
    return (0, jsx_runtime_1.jsx)(react_tabs_1.Tabs, __assign({ css: (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n      min-height: 0;\n      display: flex;\n      flex-direction: column;\n      font-family: ", ";\n      ", "\n      & .react-tabs {\n        &__tab-list {\n          display: flex;\n          background-color: ", ";\n          border-bottom: 1px solid ", ";\n          flex: 1 0 auto;\n          margin: 0;\n          overflow-y: hidden;\n          overflow-x: auto;\n          padding-right: ", ";\n          padding-left: ", ";\n          -webkit-overflow-scrolling: touch;\n          @media only screen and (max-width: ", ") {\n            /* Hide scrollbar for IE, Edge and Firefox */\n            -ms-overflow-style: none;  /* IE and Edge */\n            scrollbar-width: none;  /* Firefox */\n            /* Hide scrollbar for Chrome, Safari and Opera */\n            &::-webkit-scrollbar {\n              display: none;\n            }\n          }\n        }\n        &__tab {\n          cursor: pointer;\n          text-align: center;\n          height: ", ";\n          min-height: ", ";\n          color: ", ";\n          font-size: ", ";\n          line-height: ", ";\n          color: ", ";\n          border: none;\n          position: relative;\n          padding: 0 ", ";\n          display: flex;\n          align-items: center;\n          justify-content: center;\n          position: relative;\n          white-space: nowrap;\n          &:focus {\n            box-shadow: none;\n            outline: none;\n          }\n          ", "\n          &--selected {\n            color: ", ";\n            background: transparent;\n            &::after {\n              position: absolute;\n              bottom: 0;\n              left: 0;\n              content: '';\n              width: 100%;\n              height: ", ";\n              border-radius: ", ";\n              background-color: ", ";\n            }\n          }\n          &--disabled {\n            cursor: not-allowed;\n            opacity: 0.65;\n            &:hover,\n            &:active {\n              &::before {\n                opacity: 0;\n                cursor: not-allowed;\n              }\n            }\n          }\n          &-panel--selected {\n            overflow: auto;\n            height: 100%;\n          }\n        }\n      }\n    "], ["\n      min-height: 0;\n      display: flex;\n      flex-direction: column;\n      font-family: ", ";\n      ", "\n      & .react-tabs {\n        &__tab-list {\n          display: flex;\n          background-color: ", ";\n          border-bottom: 1px solid ", ";\n          flex: 1 0 auto;\n          margin: 0;\n          overflow-y: hidden;\n          overflow-x: auto;\n          padding-right: ", ";\n          padding-left: ", ";\n          -webkit-overflow-scrolling: touch;\n          @media only screen and (max-width: ", ") {\n            /* Hide scrollbar for IE, Edge and Firefox */\n            -ms-overflow-style: none;  /* IE and Edge */\n            scrollbar-width: none;  /* Firefox */\n            /* Hide scrollbar for Chrome, Safari and Opera */\n            &::-webkit-scrollbar {\n              display: none;\n            }\n          }\n        }\n        &__tab {\n          cursor: pointer;\n          text-align: center;\n          height: ", ";\n          min-height: ", ";\n          color: ", ";\n          font-size: ", ";\n          line-height: ", ";\n          color: ", ";\n          border: none;\n          position: relative;\n          padding: 0 ", ";\n          display: flex;\n          align-items: center;\n          justify-content: center;\n          position: relative;\n          white-space: nowrap;\n          &:focus {\n            box-shadow: none;\n            outline: none;\n          }\n          ", "\n          &--selected {\n            color: ", ";\n            background: transparent;\n            &::after {\n              position: absolute;\n              bottom: 0;\n              left: 0;\n              content: '';\n              width: 100%;\n              height: ", ";\n              border-radius: ", ";\n              background-color: ", ";\n            }\n          }\n          &--disabled {\n            cursor: not-allowed;\n            opacity: 0.65;\n            &:hover,\n            &:active {\n              &::before {\n                opacity: 0;\n                cursor: not-allowed;\n              }\n            }\n          }\n          &-panel--selected {\n            overflow: auto;\n            height: 100%;\n          }\n        }\n      }\n    "])), theme.fontFamily, props.height ? "height: ".concat(props.height, ";") : '', theme.colorSurfaceHc, theme.colorDivider, (_a = props.px) !== null && _a !== void 0 ? _a : theme.spacingLarge, (_b = props.px) !== null && _b !== void 0 ? _b : theme.spacingLarge, theme.breakpointMobile, theme.spacingXxLarge, theme.spacingXxLarge, theme.colorText, theme.fontSizeBody, theme.fontLineHeight, theme.colorTextMc, theme.spacingMedium, (0, mixins_1.overlayHoverMixin)(theme, 'colorHover', 'colorActive'), theme.colorText, theme.spacingTiny, theme.borderRadius, theme.colorPrimary) }, props));
};
exports.Tabs = Tabs;
var templateObject_1;
