"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
require("@testing-library/jest-dom/extend-expect");
var react_1 = require("@testing-library/react");
var Sheet_1 = __importDefault(require("../Sheet"));
var index_1 = require("./index");
var renderDummyTabs = function () { return (0, react_1.render)((0, jsx_runtime_1.jsxs)(index_1.Tabs, { children: [(0, jsx_runtime_1.jsxs)(index_1.TabList, { children: [(0, jsx_runtime_1.jsx)(index_1.Tab, { children: "First Step" }), (0, jsx_runtime_1.jsx)(index_1.Tab, { children: "Second Step" }), (0, jsx_runtime_1.jsx)(index_1.Tab, { disabled: true, children: "Third Step" })] }), (0, jsx_runtime_1.jsx)(index_1.TabPanel, { children: (0, jsx_runtime_1.jsx)(Sheet_1.default, { variant: 'medium', children: "First panel" }) }), (0, jsx_runtime_1.jsx)(index_1.TabPanel, { children: (0, jsx_runtime_1.jsx)(Sheet_1.default, { variant: 'medium', children: "Second panel" }) }), (0, jsx_runtime_1.jsx)(index_1.TabPanel, { children: (0, jsx_runtime_1.jsx)(Sheet_1.default, { variant: 'medium', children: "Third panel" }) })] })); };
describe('Tabs', function () {
    it('should render first tab by default', function () {
        var queryByText = renderDummyTabs().queryByText;
        expect(queryByText('First panel')).toBeInTheDocument();
    });
    it('should not show any of the other tabs', function () {
        var queryByText = renderDummyTabs().queryByText;
        expect(queryByText('Second panel')).not.toBeInTheDocument();
    });
    it('should change tabs', function () {
        var _a = renderDummyTabs(), getByText = _a.getByText, queryByText = _a.queryByText;
        react_1.fireEvent.click(getByText('Second Step'));
        expect(queryByText('First panel')).not.toBeInTheDocument();
        expect(queryByText('Second panel')).toBeInTheDocument();
    });
    it('should not change to disabled tabs', function () {
        var _a = renderDummyTabs(), getByText = _a.getByText, queryByText = _a.queryByText;
        react_1.fireEvent.click(getByText('Third Step'));
        expect(queryByText('Third panel')).not.toBeInTheDocument();
        expect(queryByText('First panel')).toBeInTheDocument();
    });
});
