"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OverflowTags = exports.CustomTags = exports.SlotsAndButtonsAndIcons = exports.OnClick = exports.Sizes = exports.WithTooltip = exports.Variants = exports.BasicUsage = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var Flex_1 = require("@impargo/components/Flex");
var ActionButton_1 = __importDefault(require("../ActionButton"));
var impargo_1 = __importDefault(require("../Themes/impargo"));
var storybook_1 = require("../utils/storybook");
var _1 = require(".");
var theme = impargo_1.default;
var faSearch = free_solid_svg_icons_1.faSearch;
exports.default = {
    title: 'Components/Data/Tag',
    component: _1.Tag,
    argTypes: {
        label: { control: 'text' },
        variant: { control: 'select' },
        size: { control: 'select' },
        onClick: { control: false },
        buttonRight: { control: false },
        color: { control: 'color' },
        bgColor: { control: 'color' },
        slotLeft: { control: 'text' },
        slotRight: { control: 'text' },
        theme: { table: { disable: true } },
        border: { control: false },
        cursor: { control: false },
        mt: { control: false },
        mr: { control: false },
        mb: { control: false },
        ml: { control: false },
        mx: { control: false },
        my: { control: false },
    },
    args: {
        label: 'Label',
    },
};
var BasicUsage = function (args) { return ((0, jsx_runtime_1.jsx)(_1.Tag, __assign({}, args))); };
exports.BasicUsage = BasicUsage;
exports.BasicUsage.args = {
    'data-tooltip-content': 'This is a tag!',
};
var Variants = function () { return ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: (0, jsx_runtime_1.jsxs)(Flex_1.Flex, { gap: 'medium', children: [(0, jsx_runtime_1.jsx)(_1.Tag, { label: 'Primary', "data-tooltip-content": 'This is a tag', "data-tooltip-place": 'top', "data-tooltip-variant": 'info' }), (0, jsx_runtime_1.jsx)(_1.Tag, { variant: 'secondary', label: 'Secondary', "data-tooltip-content": 'This is a tag', "data-tooltip-place": 'top', "data-tooltip-variant": 'info' }), (0, jsx_runtime_1.jsx)(_1.Tag, { variant: 'brand', label: 'Brand' }), (0, jsx_runtime_1.jsx)(_1.Tag, { variant: 'accent', label: 'Accent' }), (0, jsx_runtime_1.jsx)(_1.Tag, { variant: 'success', label: 'Success' }), (0, jsx_runtime_1.jsx)(_1.Tag, { variant: 'danger', label: 'Danger' }), (0, jsx_runtime_1.jsx)(_1.Tag, { variant: 'warning', label: 'Warning' })] }) })); };
exports.Variants = Variants;
(0, storybook_1.addDescription)(exports.Variants, "Variant defines the color and use case of the `Tag`. Default value: `primary`.");
var WithTooltip = function () { return ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: (0, jsx_runtime_1.jsxs)(Flex_1.Flex, { gap: 'medium', children: [(0, jsx_runtime_1.jsx)(_1.Tag, { label: 'Option', "data-tooltip-content": 'This is a tag', "data-tooltip-place": 'top', "data-tooltip-variant": 'normal' }), (0, jsx_runtime_1.jsx)(_1.Tag, { variant: 'danger', label: 'Attention', "data-tooltip-content": 'This is a tag', "data-tooltip-place": 'left', "data-tooltip-variant": 'info' }), (0, jsx_runtime_1.jsx)(_1.Tag, { variant: 'brand', label: 'Brand stuff', "data-tooltip-content": 'This is a tag', "data-tooltip-place": 'right', "data-tooltip-variant": 'primary' })] }) })); };
exports.WithTooltip = WithTooltip;
(0, storybook_1.addDescription)(exports.WithTooltip, "Tooltips can be added to Tags, similar to buttons.");
var Sizes = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(_1.Tag, { label: 'Small', size: 's' }), (0, jsx_runtime_1.jsx)(_1.Tag, { label: 'Small', size: 's', buttonRight: (0, jsx_runtime_1.jsx)(ActionButton_1.default, { size: 's', variant: 'secondary', children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { color: theme.colorTextMc, icon: faSearch }) }), ml: theme.spacingLarge }), (0, jsx_runtime_1.jsx)(_1.Tag, { variant: 'accent', label: 'Medium', size: 'm', ml: theme.spacingMedium }), (0, jsx_runtime_1.jsx)(_1.Tag, { variant: 'accent', label: 'Medium', size: 'm', buttonRight: (0, jsx_runtime_1.jsx)(ActionButton_1.default, { size: 'm', children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { color: theme.colorAccent, icon: faSearch }) }), ml: theme.spacingLarge })] })); };
exports.Sizes = Sizes;
(0, storybook_1.addDescription)(exports.Sizes, "We can specify different sizes for the `Tag`. The Default size is `m`.");
var OnClick = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(_1.Tag, { label: 'Click me!', variant: 'accent', onClick: function () { return alert('Yaaaayyyy!!!'); } }), (0, jsx_runtime_1.jsx)(_1.Tag, { label: 'Custom cursor', variant: 'accent', cursor: 'move', slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }), ml: theme.spacingLarge }), (0, jsx_runtime_1.jsx)(_1.Tag, { label: 'Click me!', ml: theme.spacingLarge, onClick: function () { return alert('Yaaaayyyy!!!'); }, slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }) }), (0, jsx_runtime_1.jsx)(_1.Tag, { label: 'Active', variant: 'success', onClick: function () { return null; }, ml: theme.spacingLarge })] })); };
exports.OnClick = OnClick;
(0, storybook_1.addDescription)(exports.OnClick, "We can also pass an `onClick` handler to perform any action when clicking the component. Additionally we can also add a `cursor` prop to change the cursor when hovering over the tag. This is useful whe we want a specific behavior such as drag and drop.");
var SlotsAndButtonsAndIcons = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(_1.Tag, { label: 'Small', size: 's', slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }) }), (0, jsx_runtime_1.jsx)(_1.Tag, { label: 'Small', ml: theme.spacingLarge, size: 's', slotRight: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }) }), (0, jsx_runtime_1.jsx)(_1.Tag, { variant: 'accent', label: 'Medium', size: 'm', buttonRight: (0, jsx_runtime_1.jsx)(ActionButton_1.default, { size: 'm', variant: 'secondary', children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { color: theme.colorTextLink, icon: faSearch }) }), ml: theme.spacingLarge })] })); };
exports.SlotsAndButtonsAndIcons = SlotsAndButtonsAndIcons;
(0, storybook_1.addDescription)(exports.SlotsAndButtonsAndIcons, "We can add icons and button inside the component via the `slotLeft`, `slotRight` and `buttonRight` when using the tag component. To match the color of the icon when using the `FontAwesomeIcon` component, a color prop can be passed to the `FontAwesomeIcon` component.");
var CustomTags = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(_1.Tag, { label: 'Custom tag 1', bgColor: theme.colorRed, color: theme.colorTextInverse, slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { color: theme.colorTextInverse, icon: faSearch }), onClick: function () { return alert('Yaaaayyyy!!!'); } }), (0, jsx_runtime_1.jsx)(_1.Tag, { label: 'Custom tag 2', bgColor: theme.colorPrimary, color: theme.colorText, slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { color: theme.colorText, icon: faSearch }), cursor: 'move', ml: theme.spacingLarge }), (0, jsx_runtime_1.jsx)(_1.Tag, { label: 'Custom tag 3', bgColor: theme.colorAccentLight, color: theme.colorText, ml: theme.spacingLarge, onClick: function () { return alert('Yaaaayyyy!!!'); }, slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch }) }), (0, jsx_runtime_1.jsx)(_1.Tag, { label: 'FREE', bgColor: theme.colorSurfaceHc, color: theme.colorTextMc, border: "1px solid ".concat(theme.colorDivider), ml: theme.spacingLarge })] })); };
exports.CustomTags = CustomTags;
(0, storybook_1.addDescription)(exports.CustomTags, "\nIn some use cases a custom `Tag` can be created, although this is not recommended, a `bgColor`, `color` and `border` props are provided to customize the component.\nIf this use case is repeated in multiple places and across projects, a new `variant` can be added to cover these commonly used custom component.\n");
var OverflowTags = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(_1.Tag, { label: 'Text ellipsissssss', bgColor: theme.colorRed, color: theme.colorTextInverse, slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { color: theme.colorTextInverse, icon: faSearch }), onClick: function () { return alert('Yaaaayyyy!!!'); }, maxWidth: '120px' }), (0, jsx_runtime_1.jsx)("div", { style: { width: '120px', display: 'inline-block' }, children: (0, jsx_runtime_1.jsx)(_1.Tag, { label: 'Very long tag name', bgColor: theme.colorPrimary, color: theme.colorText, slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { color: theme.colorText, icon: faSearch }), cursor: 'move', ml: theme.spacingLarge, whiteSpace: 'normal' }) }), (0, jsx_runtime_1.jsx)(_1.Tag, { label: 'Another long tag name', bgColor: theme.colorAccentLight, color: theme.colorText, slotLeft: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { color: theme.colorText, icon: faSearch }), cursor: 'move', ml: theme.spacingLarge, maxWidth: '120px', whiteSpace: 'normal' })] })); };
exports.OverflowTags = OverflowTags;
(0, storybook_1.addDescription)(exports.OverflowTags, "Let me improve the wording of this text to make it clearer:\nIn cases where you prefer `Tag` text to wrap instead of using ellipsis, you can control text wrapping with the `whiteSpace` prop. By default, this prop is set to `nowrap`.\nCombine this with the `maxWidth` prop or wrap the tag in a container to define specific width constraints.\n");
