"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Tag = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var styled_1 = __importDefault(require("@emotion/styled"));
var Text_1 = __importDefault(require("../Text"));
var mixins_1 = require("../Themes/mixins");
var TagComponent = function (_a) {
    var className = _a.className, _b = _a.variant, variant = _b === void 0 ? 'primary' : _b, label = _a.label, slotLeft = _a.slotLeft, slotRight = _a.slotRight, buttonRight = _a.buttonRight, _c = _a.size, size = _c === void 0 ? 'm' : _c, onClick = _a.onClick, bgColor = _a.bgColor, color = _a.color, _cursor = _a.cursor, _mt = _a.mt, _mr = _a.mr, _mb = _a.mb, _ml = _a.ml, _mx = _a.mx, _my = _a.my, _maxWidth = _a.maxWidth, rest = __rest(_a, ["className", "variant", "label", "slotLeft", "slotRight", "buttonRight", "size", "onClick", "bgColor", "color", "cursor", "mt", "mr", "mb", "ml", "mx", "my", "maxWidth"]);
    var isCustom = color || bgColor;
    return ((0, jsx_runtime_1.jsxs)("span", __assign({ className: "".concat(className, " ").concat(size, " ").concat(isCustom ? 'custom' : variant), onClick: onClick }, rest, { children: [slotLeft &&
                (0, jsx_runtime_1.jsx)("span", { className: "tag__slot tag__slot--left tag__slot--".concat(size), children: slotLeft }), (0, jsx_runtime_1.jsx)(Text_1.default, { el: 'span', variant: 'small', color: 'inherit', className: 'tag__text', children: label }), (slotRight || buttonRight) &&
                (0, jsx_runtime_1.jsx)("span", { className: "".concat(slotRight ? 'tag__slot tag__slot--right' : '', " ").concat(buttonRight ? 'tag__button tag__button--right' : '', " tag__slot--").concat(size), children: slotRight || buttonRight })] })));
};
/**
 * The `Tag` component is used to categorize data, add attributes or add actions.
 */
exports.Tag = (0, styled_1.default)(TagComponent)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  width: auto;\n  max-width: ", ";\n  border-radius: ", ";\n  display: inline-flex;\n  align-items: center;\n\n  ", "\n\n  ", "\n\n  margin-top: ", ";\n  margin-right: ", ";\n  margin-bottom: ", ";\n  margin-left: ", ";\n\n  ", "\n  \n  ", "\n\n/* variant */\n  &.primary {\n    background-color: ", ";\n    color: ", ";\n  }\n  &.secondary {\n    background-color: transparent;\n    color: ", ";\n    border: 1px solid ", ";\n  }\n  &.brand {\n    background-color: ", ";\n    color: ", ";\n  }\n  &.accent {\n    background-color: ", ";\n    color: ", ";\n  }\n  &.danger {\n    background-color: ", ";\n    color: ", ";\n  }\n  &.success {\n    background-color: ", ";\n    color: ", ";\n  }\n  &.warning {\n    background-color: ", ";\n    color: ", ";\n  }\n  &.custom {\n    background-color: ", ";\n    color: ", ";\n    border: ", ";\n  }\n\n/* size */\n  &.s {\n    min-height: ", ";\n  }\n  &.m {\n    min-height: ", ";\n  }\n\n/* Children */\n\n  .tag__text {\n    padding: 0 ", ";\n    white-space: ", ";\n    color: inherit;     \n    overflow: hidden; \n    text-overflow: ellipsis;\n\n    ", "\n    ", "\n  }\n\n\n  .tag__slot {\n    display: flex;\n    align-items: center;\n    padding: 0 ", ";\n    color: inherit;\n    font-size: ", ";\n    flex: 0 0 auto;\n\n    &--s {\n      height: ", ";\n    }\n    &--m {\n      height: ", ";\n    }\n  }\n  \n  .tag__button {\n    width: auto;\n  }\n"], ["\n  width: auto;\n  max-width: ", ";\n  border-radius: ", ";\n  display: inline-flex;\n  align-items: center;\n\n  ", "\n\n  ", "\n\n  margin-top: ", ";\n  margin-right: ", ";\n  margin-bottom: ", ";\n  margin-left: ", ";\n\n  ", "\n  \n  ", "\n\n/* variant */\n  &.primary {\n    background-color: ", ";\n    color: ", ";\n  }\n  &.secondary {\n    background-color: transparent;\n    color: ", ";\n    border: 1px solid ", ";\n  }\n  &.brand {\n    background-color: ", ";\n    color: ", ";\n  }\n  &.accent {\n    background-color: ", ";\n    color: ", ";\n  }\n  &.danger {\n    background-color: ", ";\n    color: ", ";\n  }\n  &.success {\n    background-color: ", ";\n    color: ", ";\n  }\n  &.warning {\n    background-color: ", ";\n    color: ", ";\n  }\n  &.custom {\n    background-color: ", ";\n    color: ", ";\n    border: ", ";\n  }\n\n/* size */\n  &.s {\n    min-height: ", ";\n  }\n  &.m {\n    min-height: ", ";\n  }\n\n/* Children */\n\n  .tag__text {\n    padding: 0 ", ";\n    white-space: ", ";\n    color: inherit;     \n    overflow: hidden; \n    text-overflow: ellipsis;\n\n    ", "\n    ", "\n  }\n\n\n  .tag__slot {\n    display: flex;\n    align-items: center;\n    padding: 0 ", ";\n    color: inherit;\n    font-size: ", ";\n    flex: 0 0 auto;\n\n    &--s {\n      height: ", ";\n    }\n    &--m {\n      height: ", ";\n    }\n  }\n  \n  .tag__button {\n    width: auto;\n  }\n"])), function (_a) {
    var maxWidth = _a.maxWidth;
    return maxWidth && maxWidth;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingHuge;
}, function (_a) {
    var mx = _a.mx;
    return mx && (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n    margin-right: ", ";\n    margin-left: ", ";\n  "], ["\n    margin-right: ", ";\n    margin-left: ", ";\n  "])), mx, mx);
}, function (_a) {
    var my = _a.my;
    return my && (0, react_1.css)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n    margin-top: ", ";\n    margin-bottom: ", ";\n  "], ["\n    margin-top: ", ";\n    margin-bottom: ", ";\n  "])), my, my);
}, function (_a) {
    var mt = _a.mt;
    return mt && mt;
}, function (_a) {
    var mr = _a.mr;
    return mr && mr;
}, function (_a) {
    var mb = _a.mb;
    return mb && mb;
}, function (_a) {
    var ml = _a.ml;
    return ml && ml;
}, function (_a) {
    var cursor = _a.cursor;
    return cursor && (0, react_1.css)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n    &:hover {\n      cursor: ", ";\n      user-select: none;\n    }\n  "], ["\n    &:hover {\n      cursor: ", ";\n      user-select: none;\n    }\n  "])), cursor);
}, function (_a) {
    var onClick = _a.onClick, theme = _a.theme;
    return onClick && (0, react_1.css)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n    position: relative;\n    ", "\n  "], ["\n    position: relative;\n    ", "\n  "])), (0, mixins_1.overlayHoverMixin)(theme, 'colorHover', 'colorActive', 'spacingHuge'));
}, function (_a) {
    var theme = _a.theme;
    return theme.colorSurfaceLc;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorTextMc;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorTextMc;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorDivider;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorPrimaryLight;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorPrimaryDark;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorAccentLight2;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorTextLink;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorRedLight2;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorTextDanger;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorGreenLight2;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorTextSuccess;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorOrangeLight2;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorOrange;
}, function (_a) {
    var bgColor = _a.bgColor;
    return bgColor;
}, function (_a) {
    var color = _a.color;
    return color;
}, function (_a) {
    var border = _a.border;
    return border;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontLineHeight;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingSmall;
}, function (_a) {
    var whiteSpace = _a.whiteSpace;
    return whiteSpace || 'nowrap';
}, function (_a) {
    var slotLeft = _a.slotLeft;
    return slotLeft && "\n      padding-left: 0;\n    ";
}, function (_a) {
    var slotRight = _a.slotRight, buttonRight = _a.buttonRight;
    return (slotRight || buttonRight) && "\n      padding-right: 0;\n    ";
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingSmall;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontSizeSmall;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontLineHeight;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingLarge;
});
exports.default = exports.Tag;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5;
