"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OnClickHandler = exports.LineHeight = exports.Various = exports.Color = exports.Link = exports.Subtitle = exports.Secondary = exports.Bold = exports.Variants = exports.BasicUsage = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
/* eslint-disable max-len */
var Alert_1 = require("@impargo/components/Alert");
var Flex_1 = require("@impargo/components/Flex");
var impargo_1 = __importDefault(require("../Themes/impargo"));
var storybook_1 = require("../utils/storybook");
var _1 = require(".");
var theme = impargo_1.default;
exports.default = {
    title: 'Components/General/Text',
    component: _1.Text,
    argTypes: {
        color: { control: 'color' },
        style: { table: { disable: true } },
        theme: { table: { disable: true } },
    },
    args: {},
};
var BasicUsage = function (args) { return ((0, jsx_runtime_1.jsx)(_1.Text, __assign({}, args, { children: "Some text" }))); };
exports.BasicUsage = BasicUsage;
var Variants = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(_1.Text, { variant: 'heading1', children: "Heading 1" }), (0, jsx_runtime_1.jsx)(_1.Text, { variant: 'heading2', children: "Heading 2" }), (0, jsx_runtime_1.jsx)(_1.Text, { variant: 'heading3', children: "Heading 3" }), (0, jsx_runtime_1.jsx)(_1.Text, { variant: 'subtitle', children: "Subtitle" }), (0, jsx_runtime_1.jsx)(_1.Text, { variant: 'body', children: "Body default" }), (0, jsx_runtime_1.jsx)(_1.Text, { variant: 'small', children: "Small text" }), (0, jsx_runtime_1.jsx)(_1.Text, { variant: 'smallest', children: "Smallest text" })] })); };
exports.Variants = Variants;
(0, storybook_1.addDescription)(exports.Variants, "The `variant` prop defines the styling and HTML element that will be rendered.");
var Bold = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(_1.Text, { bold: true, children: "The Empire Strikes Back." }), (0, jsx_runtime_1.jsxs)(_1.Text, { children: ["You have been invited by ", (0, jsx_runtime_1.jsx)("strong", { children: "Master Yoda" }), " to join the Jedi High Council."] })] })); };
exports.Bold = Bold;
(0, storybook_1.addDescription)(exports.Bold, "The `bold` prop specifies if the text rendered will have a heavier font weight than the default behavior. The `<strong>` HTML tag can be used inside a text component to change the font weight in specific parts of the sentence, useful for highlighting words such as user's names, or company's names.");
var Secondary = function () { return ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: (0, jsx_runtime_1.jsxs)(_1.Text, { children: ["The Empire Strikes Back , ", (0, jsx_runtime_1.jsx)(_1.Text, { el: 'span', secondary: true, children: "Episode V" })] }) })); };
exports.Secondary = Secondary;
(0, storybook_1.addDescription)(exports.Secondary, "The `secondary` text can be used to add more context without drawing too much attention to what it's written. Used in as secondary labels in headers ans list items.");
var Subtitle = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(_1.Text, { variant: 'subtitle', children: "Dark side" }), (0, jsx_runtime_1.jsx)(_1.Text, { children: "Darth Vader, Darth Maul, Darth Sidious, Count Dooku, etc..." }), (0, jsx_runtime_1.jsx)(_1.Text, { variant: 'subtitle', children: "light side" }), (0, jsx_runtime_1.jsx)(_1.Text, { children: "Master Yoda, Obi-Wan Kenobi, Luke Skywalker, Qui-Gon Jinn, Mace Windu, etc..." })] })); };
exports.Subtitle = Subtitle;
(0, storybook_1.addDescription)(exports.Subtitle, "The `subtitle` variant is useful to separate content in the layout.");
var Link = function () { return ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: (0, jsx_runtime_1.jsxs)(_1.Text, { children: ["Documentation for ", (0, jsx_runtime_1.jsx)(_1.Text, { el: 'a', href: 'https://impargo.github.io/impargo-design-system/?path=/docs/components-general-text--secondary#link', target: '_blank', children: "creating links with the text component." })] }) })); };
exports.Link = Link;
(0, storybook_1.addDescription)(exports.Link, "To create a link with the `Text` component we can use the `el`, `href`, `target` and `rel` props. [Learn more about the `rel` prop](https://developer.mozilla.org/en-US/docs/Web/HTML/Attributes/rel).");
var Color = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(_1.Text, { el: 'span', color: theme.colorTextDanger, children: "I am you father" }), " ", (0, jsx_runtime_1.jsx)(_1.Text, { el: 'span', color: theme.colorTextSuccess, children: "NOOOOO!!!!" })] })); };
exports.Color = Color;
(0, storybook_1.addDescription)(exports.Color, "In some use cases we can change the color of the text component via the `color` prop, although this is not recommended. If this use case is repeated in multiple places and across projects, a new prop can be added to cover this common use. Use colors specified in the theme to maintain consistency across the product.\n");
var Various = function () { return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsxs)(_1.Text, { children: ["This is a link to", ' ', (0, jsx_runtime_1.jsx)(_1.Text, { el: 'a', variant: 'body', href: 'https://impargo.de/', target: '_blank', children: "IMPARGO" })] }), (0, jsx_runtime_1.jsx)(_1.Text, { truncated: true, width: '130px', children: "This text is truncated" }), (0, jsx_runtime_1.jsx)(_1.Text, { fontStyle: 'italic', children: "Text on it's side." }), (0, jsx_runtime_1.jsx)(_1.Text, { css: { width: '60ch' }, children: "Paragraph with a width of 60 characters added via the css prop. Cupidatat quis occaecat minim eu et veniam labore cupidatat elit quis aliquip non pariatur. Excepteur nisi eu mollit minim dolor occaecat et. Velit aliquip eiusmod consectetur sit ipsum dolore officia commodo qui est amet commodo tempor ullamco." })] })); };
exports.Various = Various;
(0, storybook_1.addDescription)(exports.Various, "Various example of the usage of the text component. We can add links, we can truncate text and we can set the text italic.");
var LineHeight = function () { return ((0, jsx_runtime_1.jsx)(_1.Text, { lineHeight: theme.fontLineHeightM, css: { width: '60ch' }, children: "Paragraph with medium line height (24px). Cupidatat quis occaecat minim eu et veniam labore cupidatat elit quis aliquip non pariatur. Excepteur nisi eu mollit minim dolor occaecat et. Velit aliquip eiusmod consectetur sit ipsum dolore officia commodo qui est amet commodo tempor ullamco." })); };
exports.LineHeight = LineHeight;
(0, storybook_1.addDescription)(exports.LineHeight, "The text component accepts a `lineHeight` prop to change the line height of the paragraph. This prop only takes effect when the text is render in a `<p>` tag. Use the theme variables for line height: `fontLineHeight` and `fontLineHeightM`. The `fontLineHeightM` is mostly used in marketing copy as it renders a higher line height that makes the text easier to read.");
var OnClickHandler = function () { return ((0, jsx_runtime_1.jsxs)(Flex_1.Flex, { direction: 'column', gap: 'medium', children: [(0, jsx_runtime_1.jsx)(_1.Text, { onClick: function () { return null; }, children: "Click me and you get 3 wishes." }), (0, jsx_runtime_1.jsx)(_1.Text, { onClick: function () { return null; }, textDecoration: 'underline', children: "Click me and you get 3 wishes but underlined." }), (0, jsx_runtime_1.jsx)(Alert_1.Alert, { variant: 'info', text: (0, jsx_runtime_1.jsxs)(_1.Text, { color: theme.colorTextLink, children: ["It's going to be sunny today with 0 change of rain. ", (0, jsx_runtime_1.jsx)(_1.Text, { el: 'span', onClick: function () { return null; }, textDecoration: 'underline', children: "See weather for tomorrow" }), ". ", (0, jsx_runtime_1.jsx)(_1.Text, { el: 'a', href: 'https://weather.com/?Goto=Redirected', target: '_blank', textDecoration: 'underline', children: "See weather for the rest of the week." }), " "] }) })] })); };
exports.OnClickHandler = OnClickHandler;
(0, storybook_1.addDescription)(exports.OnClickHandler, 'An `onclick` handler can also be passed to the component. An additional `textDecoration` prop is used in cases where it is required that the text has an underline, such as including a link inside an info alert. The `textDecoration` prop also works when using the text component as a link.');
