"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Text = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var styled_1 = __importDefault(require("@emotion/styled"));
var react_2 = require("react");
var mixins_1 = require("../Themes/mixins");
var variantMap = {
    heading1: 'h1',
    heading2: 'h2',
    heading3: 'h3',
    subtitle: 'h4',
    body: 'p',
    small: 'p',
    smallest: 'p',
};
var Component = (0, react_2.forwardRef)(function (_a, ref) {
    var className = _a.className, children = _a.children, el = _a.el, _b = _a.variant, variant = _b === void 0 ? 'body' : _b, _bold = _a.bold, _seconday = _a.secondary, _whiteSpace = _a.whiteSpace, _truncated = _a.truncated, _width = _a.width, _disabled = _a.disabled, _fontWeight = _a.fontWeight, _fontStyle = _a.fontStyle, _textAlign = _a.textAlign, _lineHeight = _a.lineHeight, _textDecoration = _a.textDecoration, onClick = _a.onClick, rest = __rest(_a, ["className", "children", "el", "variant", "bold", "secondary", "whiteSpace", "truncated", "width", "disabled", "fontWeight", "fontStyle", "textAlign", "lineHeight", "textDecoration", "onClick"]);
    var Element = el || variantMap[variant];
    return ((0, jsx_runtime_1.jsx)(Element, __assign({ ref: ref, className: "".concat(className, " ").concat(variant), onClick: onClick }, rest, { children: children })));
});
/**
 * The `Text` component is used to render text.
 * The font used is `Source Sans Pro`.
 *
 * ### Variant map
 * Depending on the prop `variant` different HTLML elements are rendered:
 *
 *  - heading1: `h1`
 *  - heading2: `h2`
 *  - heading3: `h3`
 *  - subtitle: `h4`
 *  - body: `p`
 *  - small: `p`
 *  - smallest: `p`

  ### Import

  ```
  import Text from '@impargo/components/Text'
  ```
 */
exports.Text = (0, styled_1.default)(Component)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  font-family: ", ";\n  font-weight: ", ";\n  font-style: ", ";\n  color: ", ";\n  text-align: ", ";\n  white-space: ", ";\n  ", ";\n  strong {\n    font-weight: ", ";\n  }\n\n  /* Base styles */\n  &.heading1 {\n    font-size: ", ";\n    letter-spacing: 0.25px;\n    line-height: 36px;\n  }\n  &.heading2 {\n    font-size: ", ";\n    letter-spacing: 0.15px;\n    line-height: 32px;\n  }\n  &.heading3 {\n    font-size: ", ";\n    letter-spacing: 0.5px;\n    line-height: 24px;\n  }\n  &.subtitle {\n    font-size: ", ";\n    letter-spacing: 0.75px;\n    line-height: 20px;\n    text-transform: uppercase;\n    color: ", ";\n  }\n  &.body {\n    font-size: ", ";\n    letter-spacing: 0.25px;\n    line-height: ", ";\n  }\n  &.small {\n    font-size: ", ";\n    letter-spacing: 0.4px;\n    line-height: 20px;\n  }\n  &.smallest {\n    font-size: ", ";\n    letter-spacing: 0.3px;\n    line-height: 20px;\n  }\n\n  ", "\n\n  ", "\n\n  ", ";\n"], ["\n  font-family: ", ";\n  font-weight: ", ";\n  font-style: ", ";\n  color: ", ";\n  text-align: ", ";\n  white-space: ", ";\n  ", ";\n  strong {\n    font-weight: ", ";\n  }\n\n  /* Base styles */\n  &.heading1 {\n    font-size: ", ";\n    letter-spacing: 0.25px;\n    line-height: 36px;\n  }\n  &.heading2 {\n    font-size: ", ";\n    letter-spacing: 0.15px;\n    line-height: 32px;\n  }\n  &.heading3 {\n    font-size: ", ";\n    letter-spacing: 0.5px;\n    line-height: 24px;\n  }\n  &.subtitle {\n    font-size: ", ";\n    letter-spacing: 0.75px;\n    line-height: 20px;\n    text-transform: uppercase;\n    color: ", ";\n  }\n  &.body {\n    font-size: ", ";\n    letter-spacing: 0.25px;\n    line-height: ", ";\n  }\n  &.small {\n    font-size: ", ";\n    letter-spacing: 0.4px;\n    line-height: 20px;\n  }\n  &.smallest {\n    font-size: ", ";\n    letter-spacing: 0.3px;\n    line-height: 20px;\n  }\n\n  ", "\n\n  ", "\n\n  ", ";\n"])), function (_a) {
    var theme = _a.theme;
    return theme.fontFamily;
}, function (_a) {
    var fontWeight = _a.fontWeight, theme = _a.theme;
    return fontWeight || theme.fontWeightNormal;
}, function (_a) {
    var fontStyle = _a.fontStyle;
    return fontStyle || 'normal';
}, function (_a) {
    var secondary = _a.secondary, color = _a.color, theme = _a.theme;
    return secondary ? theme.colorTextMc : (color || theme.colorText);
}, function (_a) {
    var textAlign = _a.textAlign;
    return textAlign || 'left';
}, function (_a) {
    var whiteSpace = _a.whiteSpace;
    return whiteSpace || 'normal';
}, function (_a) {
    var bold = _a.bold, theme = _a.theme;
    return bold && "\n    font-weight: ".concat(theme.fontWeightSemibold, ";\n  ");
}, function (_a) {
    var theme = _a.theme;
    return theme.fontWeightSemibold;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontSizeH1;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontSizeH2;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontSizeH3;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontSizeSmall;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorTextMc;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontSizeBody;
}, function (_a) {
    var lineHeight = _a.lineHeight, theme = _a.theme;
    return lineHeight || theme.fontLineHeight;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontSizeSmall;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontSizeSmallest;
}, function (_a) {
    var el = _a.el, onClick = _a.onClick, textDecoration = _a.textDecoration, color = _a.color, theme = _a.theme;
    return (el === 'a' || onClick) && (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n    text-decoration: none;\n    color: ", ";\n    cursor: pointer;\n    text-decoration: ", ";\n    &:hover {\n      text-decoration: underline;\n    }\n  "], ["\n    text-decoration: none;\n    color: ", ";\n    cursor: pointer;\n    text-decoration: ", ";\n    &:hover {\n      text-decoration: underline;\n    }\n  "])), color || theme.colorTextLink, textDecoration || 'none');
}, function (_a) {
    var truncated = _a.truncated, width = _a.width;
    return truncated && "\n    ".concat((0, mixins_1.truncatedMixin)(width), "\n  ");
}, function (_a) {
    var disabled = _a.disabled;
    return disabled && "\n    opacity: 0.65;\n  ";
});
exports.default = exports.Text;
var templateObject_1, templateObject_2;
