"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.truncatedMixin = exports.tooltipMixin = exports.focusOutlineMixin = exports.overlayHoverMixin = exports.height = exports.disabledMixin = exports.borderMixin = void 0;
var impargo_1 = __importDefault(require("./impargo"));
var Impargo = impargo_1.default;
var borderMixin = function (theme) { return "\n  border: 1px solid ".concat(theme.colorDivider, ";\n  border-radius: ").concat(theme.borderRadius, ";\n"); };
exports.borderMixin = borderMixin;
var disabledMixin = function (theme, disabled, variant) { return "\n  background-color: ".concat(variant === 'primary' ? theme.colorSurfaceMc : theme.colorSurfaceHc, ";\n  ").concat(disabled && "\n    background-color: ".concat(variant === 'primary' ? theme.colorSurfaceLc : theme.colorSurfaceHc, ";\n    cursor: not-allowed;\n    opacity: 0.56;\n  "), "\n"); };
exports.disabledMixin = disabledMixin;
var height = function (theme) { return "\n  ".concat(theme.spacingXLarge, "\n"); };
exports.height = height;
var overlayHoverMixin = function (theme, bgColor, focus, radius) {
    if (radius === void 0) { radius = 'borderRadius'; }
    return "\n  &::before {\n    content: \"\";\n    position: absolute;\n    z-index: 0;\n    top:  0;\n    left: 0;\n    width: 100%;\n    height: 100%;\n    border-radius: ".concat(theme[radius] || '0px', ";\n    opacity: 0;\n    background-color: ").concat(theme[bgColor], ";\n    transition: opacity 0.3s ease-in-out, background-color 0.3s ease-in-out;\n    pointer-events: none;\n  }\n\n  &:hover {\n    cursor: pointer;\n  }\n\n  &:hover,\n  &:focus {\n    outline: none;\n    &::before {\n      opacity: 1;\n    }\n  }\n\n  &:focus,\n  &:active {\n    outline: none;\n    &::before {\n      background-color: ").concat(theme[focus] || 'transparent', ";\n    }\n  }\n");
};
exports.overlayHoverMixin = overlayHoverMixin;
var focusOutlineMixin = function (theme) { return "\n  outline: none;\n  box-shadow: 0 0 0 1px ".concat(theme.colorPrimaryLight2, ";\n"); };
exports.focusOutlineMixin = focusOutlineMixin;
var tooltipVariantToColor = function (theme) { return ({
    normal: theme.colorSurfaceInverse,
    info: theme.colorAccent,
    primary: theme.colorPrimary,
}); };
var tooltipMixin = function (theme, variant) { return "\n  &&&& {\n    max-width: 200px;\n    font-family: ".concat(theme.fontFamily, ";\n    font-size: ").concat(theme.fontSizeSmall, ";\n    line-height: 18px;\n    letter-spacing: 0.25px;\n    color: ").concat(theme.colorTextInverse, ";\n    white-space: pre-wrap;\n    text-align: left;\n    text-transform: initial;\n    padding: ").concat(theme.spacingSmall, " ").concat(theme.spacingMedium, ";\n    border-radius: ").concat(theme.borderRadius, ";\n    z-index: 1000;\n    background-color: ").concat(tooltipVariantToColor(theme)[variant], ";\n  }\n"); };
exports.tooltipMixin = tooltipMixin;
var truncatedMixin = function (width) {
    if (width === void 0) { width = '100%'; }
    return "\n  white-space: nowrap;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  width: ".concat(width, ";\n");
};
exports.truncatedMixin = truncatedMixin;
