import { FC } from 'react';
import { TagProps } from '../Tag';
export interface TierIndicatorProps extends Omit<TagProps, 'variant'> {
    /**
     * Class name assigned to the component. Should be used sparingly.
     */
    className?: string;
    /**
     * Sets the variant of the tier indicator.
     * @default pro
     */
    variant?: 'pro' | 'free';
}
/**
 *  Specialized tag to indicate in which tier (free or pro) a specific feature is.
 *  Additionally, accepts all props from `Tag` component.

  ### Import

  ```
  import TierIndicator from '@impargo/components/TierIndicator'
  ```
 */
export declare const TierIndicator: FC<TierIndicatorProps>;
export default TierIndicator;
//# sourceMappingURL=index.d.ts.map