"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TierIndicator = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var Tag_1 = __importDefault(require("../Tag"));
/**
 *  Specialized tag to indicate in which tier (free or pro) a specific feature is.
 *  Additionally, accepts all props from `Tag` component.

  ### Import

  ```
  import TierIndicator from '@impargo/components/TierIndicator'
  ```
 */
var TierIndicator = function (_a) {
    var className = _a.className, _b = _a.variant, variant = _b === void 0 ? 'pro' : _b, label = _a.label, rest = __rest(_a, ["className", "variant", "label"]);
    var theme = (0, react_1.useTheme)();
    return ((0, jsx_runtime_1.jsx)(Tag_1.default, __assign({ className: className, css: rest['data-tooltip-content'] && (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n        &:hover {\n          cursor: help;\n        }\n      "], ["\n        &:hover {\n          cursor: help;\n        }\n      "]))), size: 's', bgColor: variant === 'pro' ? theme.colorSurfaceInverse : theme.colorSurfaceHc, color: variant === 'pro' ? theme.colorPrimary : theme.colorTextMc, border: variant === 'free' ? "1px solid ".concat(theme.colorDivider) : '0', label: label }, rest)));
};
exports.TierIndicator = TierIndicator;
exports.default = exports.TierIndicator;
var templateObject_1;
