"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Toast = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
require("react-toastify/dist/ReactToastify.min.css");
var styled_1 = __importDefault(require("@emotion/styled"));
var react_toastify_1 = require("react-toastify");
var mixins_1 = require("../Themes/mixins");
var Component = function (_a) {
    var className = _a.className;
    return ((0, jsx_runtime_1.jsx)("div", { className: className, children: (0, jsx_runtime_1.jsx)(react_toastify_1.ToastContainer, { autoClose: 3000, position: 'bottom-center', draggable: false, hideProgressBar: true, transition: react_toastify_1.Slide }) }));
};
/**
 * The toast displays a global message based on the user's action.
 * Place the `Toast` component at the root level.
 * Call functions `success`, `info` and `failure` when suitable.
 * As first argument specify message to display.
 * The second argument contains options.

  ### Import Toast component:
  ```
  import Toast from '@impargo/components/Toast/Container'
  ```

  ### Import call functions:
  ```
  import { info, success, failure } from '@impargo/components/Toast'
  ```

 */
exports.Toast = (0, styled_1.default)(Component)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n.Toastify__toast-container {\n  width: 100%;\n  max-width: 600px;\n}\n.Toastify__toast {\n  height: auto;\n  min-height: ", ";\n  padding: ", ";\n  border-radius: ", ";\n  box-shadow: ", ";\n}\n.Toastify__toast-body {\n  display: flex;\n  padding: 0;\n}\n.Toastify__toast--default {\n  background: ", ";\n  color: ", ";\n}\n.Toastify__toast-container--bottom-center {\n  left: 50%;\n  margin-left: 0;\n  transform: translateX(-50%);\n}\n.Toastify__close-button {\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  font-size: ", ";\n  align-self: center;\n  color: ", ";\n  min-width: ", ";\n  width: ", ";\n  height: ", ";\n  position: relative;\n  ", "\n\n  &--default {\n    opacity: 1;\n  }\n}"], ["\n.Toastify__toast-container {\n  width: 100%;\n  max-width: 600px;\n}\n.Toastify__toast {\n  height: auto;\n  min-height: ", ";\n  padding: ", ";\n  border-radius: ", ";\n  box-shadow: ", ";\n}\n.Toastify__toast-body {\n  display: flex;\n  padding: 0;\n}\n.Toastify__toast--default {\n  background: ", ";\n  color: ", ";\n}\n.Toastify__toast-container--bottom-center {\n  left: 50%;\n  margin-left: 0;\n  transform: translateX(-50%);\n}\n.Toastify__close-button {\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  font-size: ", ";\n  align-self: center;\n  color: ", ";\n  min-width: ", ";\n  width: ", ";\n  height: ", ";\n  position: relative;\n  ", "\n\n  &--default {\n    opacity: 1;\n  }\n}"])), function (_a) {
    var theme = _a.theme;
    return theme.spacingXxxLarge;
}, function (_a) {
    var theme = _a.theme;
    return "".concat(theme.spacingSmall, " ").concat(theme.spacingMedium);
}, function (_a) {
    var theme = _a.theme;
    return theme.borderRadius;
}, function (_a) {
    var theme = _a.theme;
    return theme.shadowMedium;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorSurfaceInverse;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorTextInverse;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontSizeH3;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorTextInverse;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingXLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingXLarge;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingXLarge;
}, function (_a) {
    var theme = _a.theme;
    return (0, mixins_1.overlayHoverMixin)(theme, 'colorHoverInverse', 'colorActiveInverse', 'borderRadiusCircular');
});
exports.default = exports.Toast;
var templateObject_1;
