"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.update = exports.failure = exports.success = exports.info = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var styled_1 = __importDefault(require("@emotion/styled"));
var react_toastify_1 = require("react-toastify");
var Icon_1 = __importDefault(require("./Icon"));
var Toast = function (_a) {
    var className = _a.className, message = _a.message, icon = _a.icon, id = _a.id, callToAction = _a.callToAction;
    var theme = (0, react_1.useTheme)();
    return ((0, jsx_runtime_1.jsxs)("div", { className: className, id: id, children: [(0, jsx_runtime_1.jsx)(Icon_1.default, { className: 'icon', icon: icon }), (0, jsx_runtime_1.jsx)("p", { className: 'message', children: message }), callToAction &&
                (0, jsx_runtime_1.jsx)("div", { css: (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n            margin-left: ", ";\n        "], ["\n            margin-left: ", ";\n        "])), theme.spacingMedium), children: callToAction })] }));
};
var StyledToast = (0, styled_1.default)(Toast)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  margin-right: ", ";\n  display: flex;\n  align-items: center;\n  .message {\n    font-size: ", ";\n    color: ", ";\n    line-height: ", ";\n    text-align: left;\n  }\n  .icon {\n    margin-right: ", ";\n  }\n"], ["\n  margin-right: ", ";\n  display: flex;\n  align-items: center;\n  .message {\n    font-size: ", ";\n    color: ", ";\n    line-height: ", ";\n    text-align: left;\n  }\n  .icon {\n    margin-right: ", ";\n  }\n"])), function (_a) {
    var theme = _a.theme;
    return theme.spacingMedium;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontSizeBody;
}, function (_a) {
    var theme = _a.theme;
    return theme.colorTextInverse;
}, function (_a) {
    var theme = _a.theme;
    return theme.fontLineHeight;
}, function (_a) {
    var theme = _a.theme;
    return theme.spacingMedium;
});
var Success = (0, styled_1.default)(StyledToast)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  .icon {\n    color: ", ";\n  }\n"], ["\n  .icon {\n    color: ", ";\n  }\n"])), function (_a) {
    var theme = _a.theme;
    return theme.colorTextInverseSuccess;
});
var Failure = (0, styled_1.default)(StyledToast)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  .icon {\n    color: ", ";\n  }\n"], ["\n  .icon {\n    color: ", ";\n  }\n"])), function (_a) {
    var theme = _a.theme;
    return theme.colorTextInverseDanger;
});
var Info = (0, styled_1.default)(StyledToast)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  .icon {\n    color: ", ";\n  }\n"], ["\n  .icon {\n    color: ", ";\n  }\n"])), function (_a) {
    var theme = _a.theme;
    return theme.colorPrimary;
});
var info = function (msg, options) { (0, react_toastify_1.toast)((0, jsx_runtime_1.jsx)(Info, { message: msg, icon: 'info', id: options && options.analytics, callToAction: options === null || options === void 0 ? void 0 : options.callToAction }), options); };
exports.info = info;
var success = function (msg, options) { (0, react_toastify_1.toast)((0, jsx_runtime_1.jsx)(Success, { message: msg, icon: 'check', id: options && options.analytics, callToAction: options === null || options === void 0 ? void 0 : options.callToAction }), options); };
exports.success = success;
var failure = function (msg, options) { (0, react_toastify_1.toast)((0, jsx_runtime_1.jsx)(Failure, { message: msg, icon: 'times', id: options && options.analytics, callToAction: options === null || options === void 0 ? void 0 : options.callToAction }), options); };
exports.failure = failure;
var update = function (id, type, msg, options) {
    var Component = null;
    if (type === 'success') {
        Component = (0, jsx_runtime_1.jsx)(Success, { icon: 'check', message: msg });
    }
    else if (type === 'info') {
        Component = (0, jsx_runtime_1.jsx)(Info, { icon: 'info', message: msg });
    }
    else if (type === 'failure') {
        Component = (0, jsx_runtime_1.jsx)(Failure, { icon: 'times', message: msg });
    }
    react_toastify_1.toast.update(id, __assign({ render: Component }, options));
};
exports.update = update;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5;
