"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ToastWithButton = exports.AdaptingClosingBehavior = exports.Info = exports.Failure = exports.Success = exports.BasicUsage = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var Button_1 = __importDefault(require("../Button"));
var Flex_1 = __importDefault(require("../Flex"));
var storybook_1 = require("../utils/storybook");
var _1 = require(".");
var longText = 'Lorem ipsum dolor sit amet consectetur adipisicing elit. Rerum, eum ipsam illo inventore ullam sint ut, eos Rerum, eum ipsam illo inventore ullam sint ut, eosRerum, eum ipsam illo inventore ullam sint ut, eos.';
exports.default = {
    title: 'Components/Feedback/Toast',
    component: _1.Toast,
    argTypes: {
        theme: { table: { disable: true } },
    },
    args: {},
};
var BasicUsage = function () { return ((0, jsx_runtime_1.jsx)(Button_1.default, { onClick: function () { return (0, _1.success)('The data was shared successfully'); }, children: "Share this awesome data" })); };
exports.BasicUsage = BasicUsage;
var Success = function () { return ((0, jsx_runtime_1.jsx)(Button_1.default, { onClick: function () { return (0, _1.success)('Data saved successfully'); }, children: "Save date" })); };
exports.Success = Success;
(0, storybook_1.addDescription)(exports.Success, "The success toast represents a successful action that the user has perform: saving data, sharing information, etc...");
var Failure = function () { return ((0, jsx_runtime_1.jsx)(Button_1.default, { onClick: function () { return (0, _1.failure)('Data could not be saved, there is probably an error in the form.'); }, children: "Save data" })); };
exports.Failure = Failure;
(0, storybook_1.addDescription)(exports.Failure, "The failure toast represents an error after an action has been done or a general error in the application.");
var Info = function () { return ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: (0, jsx_runtime_1.jsx)(Button_1.default, { onClick: function () { return (0, _1.info)(longText, { autoClose: 100000, analytics: 'someid' }); }, children: "Save data" }) })); };
exports.Info = Info;
(0, storybook_1.addDescription)(exports.Info, "The info toast is used to display relevant information after a user has perform an action.");
var AdaptingClosingBehavior = function () { return ((0, jsx_runtime_1.jsxs)(Flex_1.default, { gap: 'medium', children: [(0, jsx_runtime_1.jsx)(Button_1.default, { onClick: function () { return (0, _1.success)('Quick!', { autoClose: 1000 }); }, children: "Toast closing after 1 second." }), (0, jsx_runtime_1.jsx)(Button_1.default, { onClick: function () { return (0, _1.failure)('Should not auto close at all', { autoClose: false }); }, children: "Auto close disabled" })] })); };
exports.AdaptingClosingBehavior = AdaptingClosingBehavior;
var ToastWithButton = function () { return ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: (0, jsx_runtime_1.jsx)(Button_1.default, { onClick: function () { return (0, _1.success)('Quick!', {
            callToAction: (0, jsx_runtime_1.jsx)(Button_1.default, { size: 's', shape: 'flat', inverse: true, onClick: function () { return alert('CTA clicked'); }, children: "Toast button" }),
        }); }, children: "Toast with button" }) })); };
exports.ToastWithButton = ToastWithButton;
