"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomContent = exports.Place = exports.Variants = exports.BasicUsage = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var Button_1 = __importDefault(require("@impargo/components/Button"));
var Flex_1 = __importDefault(require("@impargo/components/Flex"));
var Tag_1 = __importDefault(require("@impargo/components/Tag"));
var Text_1 = __importDefault(require("@impargo/components/Text"));
var TierIndicator_1 = __importDefault(require("@impargo/components/TierIndicator"));
var Container_1 = __importDefault(require("../Container"));
var impargo_1 = __importDefault(require("../Themes/impargo"));
var storybook_1 = require("../utils/storybook");
var _1 = require(".");
var theme = impargo_1.default;
var faQuestionCircle = free_solid_svg_icons_1.faQuestionCircle;
var faPaperPlane = free_solid_svg_icons_1.faPaperPlane;
exports.default = {
    title: 'Components/Feedback/Tooltip',
    component: _1.Tooltip,
    argTypes: {
        variant: { control: 'select' },
    },
    args: {},
};
var BasicUsage = function (args) { return ((0, jsx_runtime_1.jsxs)(Container_1.default, { height: '80px', children: [(0, jsx_runtime_1.jsx)(Text_1.default, { "data-tooltip-id": args.id, "data-tooltip-place": 'bottom', children: "Hover over me" }), (0, jsx_runtime_1.jsx)(_1.Tooltip, __assign({}, args))] })); };
exports.BasicUsage = BasicUsage;
exports.BasicUsage.args = {
    variant: 'normal',
    id: 'textTooltip',
    content: 'Info tooltip',
};
var Variants = function () { return ((0, jsx_runtime_1.jsxs)(Flex_1.default, { gap: 'medium', alignItems: 'center', width: '100%', justify: 'center', height: '80px', children: [(0, jsx_runtime_1.jsx)(Tag_1.default, { label: 'Data', "data-tooltip-content": 'Share data' }), (0, jsx_runtime_1.jsxs)(Text_1.default, { "data-tooltip-content": "I'm Mr. Meeseeks look at me", "data-tooltip-variant": 'info', children: ["Hey!! ", (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faQuestionCircle })] }), (0, jsx_runtime_1.jsx)(TierIndicator_1.default, { variant: 'pro', label: 'PRO', cursor: 'help', "data-tooltip-content": 'You are a Pro user', "data-tooltip-variant": 'primary' })] })); };
exports.Variants = Variants;
(0, storybook_1.addDescription)(exports.Variants, "Variant defines the color and use case of the `Tooltip`. The `primary` is used for showing information related to a plan or user status. The `normal` is the default tooltip shown in buttons and action buttons. The `info` is used in conjunction with the info icon, mostly for explanation on certain topics and pages. The variant can be set using `data-tooltip-variant` when using the default tooltips.");
var Place = function () { return ((0, jsx_runtime_1.jsxs)(Flex_1.default, { gap: 'medium', alignItems: 'center', width: '100%', justify: 'center', height: '96px', children: [(0, jsx_runtime_1.jsx)(Tag_1.default, { label: 'Top', "data-tooltip-content": 'Top', "data-tooltip-place": 'top' }), (0, jsx_runtime_1.jsx)(Tag_1.default, { label: 'Right', "data-tooltip-content": 'Right', "data-tooltip-place": 'right' }), (0, jsx_runtime_1.jsx)(Tag_1.default, { label: 'Bottom', "data-tooltip-content": 'Bottom', "data-tooltip-place": 'bottom' }), (0, jsx_runtime_1.jsx)(Tag_1.default, { label: 'Left', "data-tooltip-content": 'Left', "data-tooltip-place": 'left' })] })); };
exports.Place = Place;
(0, storybook_1.addDescription)(exports.Place, "With the `place` prop, we can specify the location of the tooltip. The place can be set using `data-tooltip-place` when using the default tooltips.");
var CustomContent = function () { return ((0, jsx_runtime_1.jsxs)(Flex_1.default, { height: '104px', children: [(0, jsx_runtime_1.jsx)(Button_1.default, { "data-tooltip-id": 'shareData', alwaysShowTooltip: true, slotRight: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faPaperPlane }), children: "Share with your friends" }), (0, jsx_runtime_1.jsx)(_1.Tooltip, { variant: 'normal', id: 'shareData', place: 'bottom', clickable: true, children: (0, jsx_runtime_1.jsxs)(Flex_1.default, { direction: 'column', gap: 'small', children: [(0, jsx_runtime_1.jsx)(Text_1.default, { color: theme.colorTextInverse, children: "You need to refresh the data." }), (0, jsx_runtime_1.jsx)(Button_1.default, { shape: 'flat', size: 's', inverse: true, ml: "-".concat(theme.spacingSmall), children: "Refresh data" })] }) })] })); };
exports.CustomContent = CustomContent;
(0, storybook_1.addDescription)(exports.CustomContent, "Custom content and behavior can be added inside the tooltip by adding elements as children. In this case, the `data-tooltip-id` prop needs to be set on the component that you would like to show the tooltip on.");
