"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DefaultTooltip = exports.Tooltip = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var react_dom_1 = require("react-dom");
var react_tooltip_1 = require("react-tooltip");
var mixins_1 = require("../Themes/mixins");
/**
 * Tooltips display information text when users hover over, or tap an element. They display information identifying an element, or a description of its function.
 *
 * There are two ways to use tooltips:
 * - Use the default tooltips by rendering `DefaultTooltip` at the root of your application and then using `data-tooltip-content` on your different components to provide tooltips.
 * - Implement custom tooltips by using the Tooltip component in combination with `data-tooltip-id`. This is useful when creating more complex or interactive tooltips.
 *
 * The tooltip component is implemented under the hood using `react-tooltip`.
 * More information about the library and the props accepted by the component can be found [here](https://react-tooltip.com/docs/getting-started).
 *
  ### Import

  ```
  import Tooltip from '@impargo/components/Tooltip'
  ```
 */
var Tooltip = function (_a) {
    var className = _a.className, content = _a.content, children = _a.children, _b = _a.variant, variant = _b === void 0 ? 'normal' : _b, 
    // Use global resize event to fix POS-2115 (see dicussion: https://github.com/ReactTooltip/react-tooltip/discussions/1125).
    _c = _a.globalCloseEvents, 
    // Use global resize event to fix POS-2115 (see dicussion: https://github.com/ReactTooltip/react-tooltip/discussions/1125).
    globalCloseEvents = _c === void 0 ? { resize: true } : _c, rest = __rest(_a, ["className", "content", "children", "variant", "globalCloseEvents"]);
    return (0, react_dom_1.createPortal)((0, jsx_runtime_1.jsx)(react_tooltip_1.Tooltip, __assign({ className: className, css: function (theme) { return (0, react_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["", ""], ["", ""])), (0, mixins_1.tooltipMixin)(theme, variant)); }, delayShow: 0, delayHide: 0, opacity: 1, place: 'bottom', globalCloseEvents: globalCloseEvents }, rest, { variant: 'dark', children: children || content })), document.body);
};
exports.Tooltip = Tooltip;
/**
 * Enables the use of default tooltips in various components (Button, ActionButton, Tag, Text, etc).
 * Needs to be rendered only once at the root of your application.
 */
var DefaultTooltip = function () { return (0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(exports.Tooltip, { variant: 'normal', anchorSelect: "[data-tooltip-content]:not([data-tooltip-id]):not([data-tooltip-variant]), [data-tooltip-content][data-tooltip-variant=\"normal\"]:not([data-tooltip-id])" }), (0, jsx_runtime_1.jsx)(exports.Tooltip, { variant: 'info', anchorSelect: "[data-tooltip-variant=\"info\"]:not([data-tooltip-id])" }), (0, jsx_runtime_1.jsx)(exports.Tooltip, { variant: 'primary', anchorSelect: "[data-tooltip-variant=\"primary\"]:not([data-tooltip-id])" })] }); };
exports.DefaultTooltip = DefaultTooltip;
exports.default = exports.Tooltip;
var templateObject_1;
