import { CSSProperties, FC, ReactNode } from 'react';
export interface WrapperProps {
    /**
     * Class name assigned to the component. Should be used sparingly.
     */
    className?: string;
    /**
     * Class name assigned to the component. Should be used sparingly.
     */
    height?: string;
    /**
     * Specifies the flex direction property.
     */
    flexDirection?: CSSProperties['flexDirection'];
    /**
     * Elements to display inside the component.
     */
    children: ReactNode;
    /**
     * Specifies the width of the component.
     */
    width?: CSSProperties['width'];
    /**
     * Sets overflow property.
     */
    overflow?: CSSProperties['overflow'];
}
/**
 * Thw `Wrapper` component is used as a top level element, it contains the rest of the elements of a page.

  ### Import

  ```
  import Wrapper from '@impargo/components/Wrapper'
  ```
 */
export declare const Wrapper: FC<WrapperProps>;
export default Wrapper;
//# sourceMappingURL=index.d.ts.map